
/*  This file is part of the program psim.

    Copyright (C) 1994-1995, Andrew Cagney <cagney@highland.com.au>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, see <http://www.gnu.org/licenses/>.

    --

    This file was generated by the program igen */

#ifndef _ICACHE_C_
#define _ICACHE_C_


#include "cpu.h"
#include "idecode.h"
#include "semantics.h"
#include "icache.h"
#ifdef HAVE_COMMON_FPU
#include "sim-inline.h"
#include "sim-fpu.h"
#endif
#include "support.h"


PSIM_INLINE_ICACHE\
(unsigned_word)
icache_illegal
(cpu *processor,
 instruction_word instruction,
 unsigned_word cia,
 idecode_cache *cache_entry)
{
  /* semantic routine */
#line 982 "../../../sim/ppc/powerpc.igen"
  program_interrupt(processor, cia,
                    illegal_instruction_program_interrupt);
  error("Internal function must longjump\n");
  return 0;
#line 53 "icache.c"
}

PSIM_INLINE_ICACHE\
(unsigned_word)
icache_floating_point_unavailable
(cpu *processor,
 instruction_word instruction,
 unsigned_word cia,
 idecode_cache *cache_entry)
{
  /* semantic routine */
#line 990 "../../../sim/ppc/powerpc.igen"
  floating_point_unavailable_interrupt(processor, cia);
  error("Internal function must longjump\n");
  return 0;
#line 69 "icache.c"
}


EXTERN_ICACHE\
(unsigned_word)
icache_instruction_call(cpu *processor,
                        instruction_word instruction,
                        unsigned_word cia,
                        idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_instruction_call
#undef MY_PREFIX
#define MY_PREFIX instruction_call
#line 1493 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode instruction_call\n"));
#line 86 "icache.c"

  /* validate: 0.0,6./,11./,16./,21./,31.1 */
  if (WITH_RESERVED_BITS && (instruction & 0xffffffff) != 0x1)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.0,6./,11./,16./,21./,31.1 #define get-values-from-icache|put-values-in-icache */
#line 95 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_instruction_call;

    /* semantic routine */
#line 1493 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics instruction_call\n"));
#line 105 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_instruction_call, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1493 "../../../sim/ppc/powerpc.igen"
    {
      if (!os_emul_instruction_call(processor, cia, real_addr(cia, 1)))
        program_interrupt(processor, cia,
                          illegal_instruction_program_interrupt);
    }
#line 120 "icache.c"
    return nia;
    /* extraction: 0.0,6./,11./,16./,21./,31.1 #undef get-values-from-icache|put-values-in-icache */
#line 123 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Trap_Word_Immediate(cpu *processor,
                           instruction_word instruction,
                           unsigned_word cia,
                           idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Trap_Word_Immediate
#undef MY_PREFIX
#define MY_PREFIX Trap_Word_Immediate
#line 2897 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Trap Word Immediate\n"));
#line 142 "icache.c"

  /* validate: 0.3,6.TO,11.RA,16.SI */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0xc000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.3,6.TO,11.RA,16.SI #define get-values-from-icache|put-values-in-icache */
#line 2897 "../../../sim/ppc/powerpc.igen"
    unsigned const TO ATTRIBUTE_UNUSED = cache_entry->crack.D.TO = EXTRACTED32(instruction, 6, 10); /* default in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.D.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.D.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 64 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_SI ATTRIBUTE_UNUSED = cache_entry->crack.D.EXTS_SI = ((signed_word)(int16_t)instruction); /* in icache - extraction */
#line 162 "icache.c"

#define insn cache_entry->crack.D.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Trap_Word_Immediate;

    /* semantic routine */
#line 2897 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Trap Word Immediate\n"));
#line 172 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Trap_Word_Immediate, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2897 "../../../sim/ppc/powerpc.igen"
    {
      signed_word a = EXTENDED(*rA);
      signed_word b = EXTS(SI);
      if ((a < b && TO_0_)
          || (a > b && TO_1_)
          || (a == b && TO_2_)
          || ((unsigned_word)a < (unsigned_word)b && TO_3_)
          || ((unsigned_word)a > (unsigned_word)b && TO_4_)
          )
        program_interrupt(processor, cia,
                          trap_program_interrupt);
    }
#line 194 "icache.c"
    return nia;
    /* extraction: 0.3,6.TO,11.RA,16.SI #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 198 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Multiply_Low_Immediate(cpu *processor,
                              instruction_word instruction,
                              unsigned_word cia,
                              idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Multiply_Low_Immediate
#undef MY_PREFIX
#define MY_PREFIX Multiply_Low_Immediate
#line 2687 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Multiply Low Immediate\n"));
#line 217 "icache.c"

  /* validate: 0.7,6.RT,11.RA,16.SI */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x1c000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.7,6.RT,11.RA,16.SI #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.D.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.D.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.D.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.D.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 64 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_SI ATTRIBUTE_UNUSED = cache_entry->crack.D.EXTS_SI = ((signed_word)(int16_t)instruction); /* in icache - extraction */
#line 241 "icache.c"

#define insn cache_entry->crack.D.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Multiply_Low_Immediate;

    /* semantic routine */
#line 2687 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Multiply Low Immediate\n"));
#line 251 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Multiply_Low_Immediate, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2687 "../../../sim/ppc/powerpc.igen"
    {
      signed_word prod = *rA * EXTS(SI);
      *rT = prod;
      PPC_INSN_INT(RT_BITMASK, RA_BITMASK, 0/*Rc*/);
    }
#line 266 "icache.c"
    return nia;
    /* extraction: 0.7,6.RT,11.RA,16.SI #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 270 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Subtract_From_Immediate_Carrying(cpu *processor,
                                        instruction_word instruction,
                                        unsigned_word cia,
                                        idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Subtract_From_Immediate_Carrying
#undef MY_PREFIX
#define MY_PREFIX Subtract_From_Immediate_Carrying
#line 2574 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Subtract From Immediate Carrying\n"));
#line 289 "icache.c"

  /* validate: 0.8,6.RT,11.RA,16.SI */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x20000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.8,6.RT,11.RA,16.SI #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.D.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.D.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.D.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.D.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 64 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_SI ATTRIBUTE_UNUSED = cache_entry->crack.D.EXTS_SI = ((signed_word)(int16_t)instruction); /* in icache - extraction */
#line 313 "icache.c"

#define insn cache_entry->crack.D.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Subtract_From_Immediate_Carrying;

    /* semantic routine */
#line 2574 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Subtract From Immediate Carrying\n"));
#line 323 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Subtract_From_Immediate_Carrying, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2574 "../../../sim/ppc/powerpc.igen"
    {
      ALU_BEGIN(*rA);
      ALU_NOT;
      ALU_ADD(EXTS(SI));
      ALU_ADD(1);
      ALU_END(*rT, 1/*CA*/, 0/*OE*/, 0/*Rc*/);
      PPC_INSN_INT(RT_BITMASK, RA_BITMASK, 0/*Rc*/);
    }
#line 341 "icache.c"
    return nia;
    /* extraction: 0.8,6.RT,11.RA,16.SI #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 345 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Compare_Logical_Immediate(cpu *processor,
                                 instruction_word instruction,
                                 unsigned_word cia,
                                 idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Compare_Logical_Immediate
#undef MY_PREFIX
#define MY_PREFIX Compare_Logical_Immediate
#line 2833 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Compare Logical Immediate\n"));
#line 364 "icache.c"

  /* validate: 0.10,6.BF,9./,10.L,11.RA,16.UI */
  if (WITH_RESERVED_BITS && (instruction & 0xfc400000) != 0x28000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.10,6.BF,9./,10.L,11.RA,16.UI #define get-values-from-icache|put-values-in-icache */
#line 67 "../../../sim/ppc/powerpc.igen"
    unsigned const BF ATTRIBUTE_UNUSED = cache_entry->crack.D.BF = EXTRACTED32(instruction, 6, 8); /* in icache - extraction */
#line 68 "../../../sim/ppc/powerpc.igen"
    uint32_t const BF_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.BF_BITMASK = (1 << BF); /* in icache - extraction */
#line 2833 "../../../sim/ppc/powerpc.igen"
    unsigned const L ATTRIBUTE_UNUSED = cache_entry->crack.D.L = EXTRACTED32(instruction, 10, 10); /* default in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.D.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.D.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 2833 "../../../sim/ppc/powerpc.igen"
    unsigned const UI ATTRIBUTE_UNUSED = cache_entry->crack.D.UI = EXTRACTED32(instruction, 16, 31); /* default in icache - extraction */
#line 388 "icache.c"

#define insn cache_entry->crack.D.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Compare_Logical_Immediate;

    /* semantic routine */
#line 2833 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Compare Logical Immediate\n"));
#line 398 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Compare_Logical_Immediate, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2833 "../../../sim/ppc/powerpc.igen"
    {
      if (!is_64bit_mode && L)
        program_interrupt(processor, cia,
                          illegal_instruction_program_interrupt);
      else {
        unsigned_word a;
        unsigned_word b = UI;
        if (L == 0)
          a = MASKED(*rA, 32, 63);
        else
          a = *rA;
        CR_COMPARE(BF, a, b);
      }
      PPC_INSN_INT_CR(0, RA_BITMASK, BF_BITMASK);
    }
#line 423 "icache.c"
    return nia;
    /* extraction: 0.10,6.BF,9./,10.L,11.RA,16.UI #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 427 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Compare_Immediate(cpu *processor,
                         instruction_word instruction,
                         unsigned_word cia,
                         idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Compare_Immediate
#undef MY_PREFIX
#define MY_PREFIX Compare_Immediate
#line 2791 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Compare Immediate\n"));
#line 446 "icache.c"

  /* validate: 0.11,6.BF,9./,10.L,11.RA,16.SI */
  if (WITH_RESERVED_BITS && (instruction & 0xfc400000) != 0x2c000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.11,6.BF,9./,10.L,11.RA,16.SI #define get-values-from-icache|put-values-in-icache */
#line 67 "../../../sim/ppc/powerpc.igen"
    unsigned const BF ATTRIBUTE_UNUSED = cache_entry->crack.D.BF = EXTRACTED32(instruction, 6, 8); /* in icache - extraction */
#line 68 "../../../sim/ppc/powerpc.igen"
    uint32_t const BF_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.BF_BITMASK = (1 << BF); /* in icache - extraction */
#line 2791 "../../../sim/ppc/powerpc.igen"
    unsigned const L ATTRIBUTE_UNUSED = cache_entry->crack.D.L = EXTRACTED32(instruction, 10, 10); /* default in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.D.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.D.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 64 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_SI ATTRIBUTE_UNUSED = cache_entry->crack.D.EXTS_SI = ((signed_word)(int16_t)instruction); /* in icache - extraction */
#line 470 "icache.c"

#define insn cache_entry->crack.D.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Compare_Immediate;

    /* semantic routine */
#line 2791 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Compare Immediate\n"));
#line 480 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Compare_Immediate, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2791 "../../../sim/ppc/powerpc.igen"
    {
      if (!is_64bit_mode && L)
        program_interrupt(processor, cia,
                          illegal_instruction_program_interrupt);
      else {
        signed_word a;
        signed_word b = EXTS(SI);
        if (L == 0)
          a = EXTENDED(*rA);
        else
          a = *rA;
        CR_COMPARE(BF, a, b);
      }
      PPC_INSN_INT_CR(0, RA_BITMASK, BF_BITMASK);
    }
#line 505 "icache.c"
    return nia;
    /* extraction: 0.11,6.BF,9./,10.L,11.RA,16.SI #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 509 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Add_Immediate_Carrying(cpu *processor,
                              instruction_word instruction,
                              unsigned_word cia,
                              idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Add_Immediate_Carrying
#undef MY_PREFIX
#define MY_PREFIX Add_Immediate_Carrying
#line 2554 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Add Immediate Carrying\n"));
#line 528 "icache.c"

  /* validate: 0.12,6.RT,11.RA,16.SI */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x30000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.12,6.RT,11.RA,16.SI #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.D.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.D.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.D.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.D.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 64 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_SI ATTRIBUTE_UNUSED = cache_entry->crack.D.EXTS_SI = ((signed_word)(int16_t)instruction); /* in icache - extraction */
#line 552 "icache.c"

#define insn cache_entry->crack.D.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Add_Immediate_Carrying;

    /* semantic routine */
#line 2554 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Add Immediate Carrying\n"));
#line 562 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Add_Immediate_Carrying, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2554 "../../../sim/ppc/powerpc.igen"
    {
      ALU_BEGIN(*rA);
      ALU_ADD(EXTS(SI));
      ALU_END(*rT, 1/*CA*/, 0/*OE*/, 0/*Rc*/);
      PPC_INSN_INT(RT_BITMASK, RA_BITMASK, 0/*Rc*/);
    }
#line 578 "icache.c"
    return nia;
    /* extraction: 0.12,6.RT,11.RA,16.SI #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 582 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Add_Immediate_Carrying_and_Record(cpu *processor,
                                         instruction_word instruction,
                                         unsigned_word cia,
                                         idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Add_Immediate_Carrying_and_Record
#undef MY_PREFIX
#define MY_PREFIX Add_Immediate_Carrying_and_Record
#line 2564 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Add Immediate Carrying and Record\n"));
#line 601 "icache.c"

  /* validate: 0.13,6.RT,11.RA,16.SI */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x34000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.13,6.RT,11.RA,16.SI #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.D.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.D.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.D.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.D.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 64 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_SI ATTRIBUTE_UNUSED = cache_entry->crack.D.EXTS_SI = ((signed_word)(int16_t)instruction); /* in icache - extraction */
#line 625 "icache.c"

#define insn cache_entry->crack.D.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Add_Immediate_Carrying_and_Record;

    /* semantic routine */
#line 2564 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Add Immediate Carrying and Record\n"));
#line 635 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Add_Immediate_Carrying_and_Record, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2564 "../../../sim/ppc/powerpc.igen"
    {
      ALU_BEGIN(*rA);
      ALU_ADD(EXTS(SI));
      ALU_END(*rT, 1/*CA*/, 0/*OE*/, 1/*Rc*/);
      PPC_INSN_INT(RT_BITMASK, RA_BITMASK, 1/*Rc*/);
    }
#line 651 "icache.c"
    return nia;
    /* extraction: 0.13,6.RT,11.RA,16.SI #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 655 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Add_Immediate_RA0(cpu *processor,
                         instruction_word instruction,
                         unsigned_word cia,
                         idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Add_Immediate
#undef MY_PREFIX
#define MY_PREFIX Add_Immediate_RA0
#line 2512 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Add Immediate\n"));
#line 674 "icache.c"

  /* validate: 0.14,6.RT,11.RA,16.SI */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x38000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.14,6.RT,11.RA,16.SI #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.D.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.D.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = 0; /* in icache - constant field */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.D.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 1 /* RA == 0 */ /* semantic compute - constant compare */
#line 64 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_SI ATTRIBUTE_UNUSED = cache_entry->crack.D.EXTS_SI = ((signed_word)(int16_t)instruction); /* in icache - extraction */
#line 698 "icache.c"

#define insn cache_entry->crack.D.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Add_Immediate_RA0;

    /* semantic routine */
#line 2512 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Add Immediate\n"));
#line 708 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Add_Immediate, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2512 "../../../sim/ppc/powerpc.igen"
    {
      if (RA_is_0)	*rT = EXTS(SI);
      else		*rT = *rA + EXTS(SI);
      ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rT, (long)*rT));
      PPC_INSN_INT(RT_BITMASK, (RA_BITMASK & ~1), 0);
    }
#line 724 "icache.c"
    return nia;
    /* extraction: 0.14,6.RT,11.RA,16.SI #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 728 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Add_Immediate_RA(cpu *processor,
                        instruction_word instruction,
                        unsigned_word cia,
                        idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Add_Immediate
#undef MY_PREFIX
#define MY_PREFIX Add_Immediate_RA
#line 2512 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Add Immediate\n"));
#line 747 "icache.c"

  /* validate: 0.14,6.RT,11.RA,16.SI */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x38000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.14,6.RT,11.RA,16.SI #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.D.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.D.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.D.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.D.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 0 /* RA == 0 */ /* semantic compute - constant compare */
#line 64 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_SI ATTRIBUTE_UNUSED = cache_entry->crack.D.EXTS_SI = ((signed_word)(int16_t)instruction); /* in icache - extraction */
#line 771 "icache.c"

#define insn cache_entry->crack.D.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Add_Immediate_RA;

    /* semantic routine */
#line 2512 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Add Immediate\n"));
#line 781 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Add_Immediate, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2512 "../../../sim/ppc/powerpc.igen"
    {
      if (RA_is_0)	*rT = EXTS(SI);
      else		*rT = *rA + EXTS(SI);
      ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rT, (long)*rT));
      PPC_INSN_INT(RT_BITMASK, (RA_BITMASK & ~1), 0);
    }
#line 797 "icache.c"
    return nia;
    /* extraction: 0.14,6.RT,11.RA,16.SI #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 801 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Add_Immediate_Shifted_RA0(cpu *processor,
                                 instruction_word instruction,
                                 unsigned_word cia,
                                 idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Add_Immediate_Shifted
#undef MY_PREFIX
#define MY_PREFIX Add_Immediate_Shifted_RA0
#line 2522 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Add Immediate Shifted\n"));
#line 820 "icache.c"

  /* validate: 0.15,6.RT,11.RA,16.SI */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x3c000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.15,6.RT,11.RA,16.SI #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.D.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.D.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = 0; /* in icache - constant field */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.D.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 1 /* RA == 0 */ /* semantic compute - constant compare */
#line 64 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_SI ATTRIBUTE_UNUSED = cache_entry->crack.D.EXTS_SI = ((signed_word)(int16_t)instruction); /* in icache - extraction */
#line 844 "icache.c"

#define insn cache_entry->crack.D.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Add_Immediate_Shifted_RA0;

    /* semantic routine */
#line 2522 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Add Immediate Shifted\n"));
#line 854 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Add_Immediate_Shifted, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2522 "../../../sim/ppc/powerpc.igen"
    {
      if (RA_is_0)	*rT = EXTS(SI) << 16;
      else		*rT = *rA + (EXTS(SI) << 16);
      ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rT, (long)*rT));
      PPC_INSN_INT(RT_BITMASK, (RA_BITMASK & ~1), 0);
    }
#line 870 "icache.c"
    return nia;
    /* extraction: 0.15,6.RT,11.RA,16.SI #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 874 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Add_Immediate_Shifted_RA(cpu *processor,
                                instruction_word instruction,
                                unsigned_word cia,
                                idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Add_Immediate_Shifted
#undef MY_PREFIX
#define MY_PREFIX Add_Immediate_Shifted_RA
#line 2522 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Add Immediate Shifted\n"));
#line 893 "icache.c"

  /* validate: 0.15,6.RT,11.RA,16.SI */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x3c000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.15,6.RT,11.RA,16.SI #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.D.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.D.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.D.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.D.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 0 /* RA == 0 */ /* semantic compute - constant compare */
#line 64 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_SI ATTRIBUTE_UNUSED = cache_entry->crack.D.EXTS_SI = ((signed_word)(int16_t)instruction); /* in icache - extraction */
#line 917 "icache.c"

#define insn cache_entry->crack.D.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Add_Immediate_Shifted_RA;

    /* semantic routine */
#line 2522 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Add Immediate Shifted\n"));
#line 927 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Add_Immediate_Shifted, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2522 "../../../sim/ppc/powerpc.igen"
    {
      if (RA_is_0)	*rT = EXTS(SI) << 16;
      else		*rT = *rA + (EXTS(SI) << 16);
      ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rT, (long)*rT));
      PPC_INSN_INT(RT_BITMASK, (RA_BITMASK & ~1), 0);
    }
#line 943 "icache.c"
    return nia;
    /* extraction: 0.15,6.RT,11.RA,16.SI #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 947 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA0_LK0_BO0(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO0
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 966 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 986 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA0_LK0_BO0;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 996 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 1045 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 1049 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA0_LK0_BO1(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO1
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 1068 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 1088 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA0_LK0_BO1;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 1098 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 1147 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 1151 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA0_LK0_BO2(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO2
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 1170 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 2; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 1190 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA0_LK0_BO2;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 1200 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 1249 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 1253 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA0_LK0_BO3(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO3
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 1272 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 3; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 1292 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA0_LK0_BO3;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 1302 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 1351 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 1355 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA0_LK0_BO4(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO4
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 1374 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 4; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 1394 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA0_LK0_BO4;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 1404 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 1453 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 1457 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA0_LK0_BO5(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO5
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 1476 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 5; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 1496 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA0_LK0_BO5;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 1506 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 1555 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 1559 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA0_LK0_BO6(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO6
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 1578 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 6; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 1598 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA0_LK0_BO6;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 1608 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 1657 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 1661 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA0_LK0_BO7(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO7
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 1680 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 7; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 1700 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA0_LK0_BO7;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 1710 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 1759 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 1763 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA0_LK0_BO8(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO8
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 1782 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 8; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 1802 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA0_LK0_BO8;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 1812 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 1861 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 1865 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA0_LK0_BO9(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO9
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 1884 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 9; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 1904 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA0_LK0_BO9;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 1914 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 1963 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 1967 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA0_LK0_BO10(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO10
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 1986 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 10; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 2006 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA0_LK0_BO10;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 2016 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 2065 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 2069 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA0_LK0_BO11(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO11
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 2088 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 11; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 2108 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA0_LK0_BO11;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 2118 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 2167 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 2171 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA0_LK0_BO12(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO12
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 2190 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 12; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 2210 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA0_LK0_BO12;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 2220 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 2269 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 2273 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA0_LK0_BO13(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO13
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 2292 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 13; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 2312 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA0_LK0_BO13;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 2322 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 2371 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 2375 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA0_LK0_BO14(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO14
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 2394 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 14; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 2414 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA0_LK0_BO14;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 2424 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 2473 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 2477 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA0_LK0_BO15(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO15
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 2496 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 15; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 2516 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA0_LK0_BO15;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 2526 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 2575 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 2579 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA0_LK0_BO16(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO16
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 2598 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 16; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 2618 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA0_LK0_BO16;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 2628 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 2677 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 2681 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA0_LK0_BO17(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO17
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 2700 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 17; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 2720 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA0_LK0_BO17;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 2730 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 2779 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 2783 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA0_LK0_BO18(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO18
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 2802 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 18; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 2822 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA0_LK0_BO18;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 2832 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 2881 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 2885 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA0_LK0_BO19(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO19
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 2904 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 19; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 2924 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA0_LK0_BO19;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 2934 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 2983 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 2987 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA0_LK0_BO20(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO20
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 3006 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 20; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 3026 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA0_LK0_BO20;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 3036 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 3085 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 3089 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA0_LK0_BO21(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO21
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 3108 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 21; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 3128 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA0_LK0_BO21;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 3138 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 3187 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 3191 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA0_LK0_BO22(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO22
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 3210 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 22; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 3230 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA0_LK0_BO22;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 3240 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 3289 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 3293 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA0_LK0_BO23(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO23
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 3312 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 23; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 3332 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA0_LK0_BO23;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 3342 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 3391 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 3395 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA0_LK0_BO24(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO24
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 3414 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 24; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 3434 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA0_LK0_BO24;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 3444 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 3493 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 3497 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA0_LK0_BO25(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO25
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 3516 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 25; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 3536 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA0_LK0_BO25;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 3546 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 3595 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 3599 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA0_LK0_BO26(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO26
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 3618 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 26; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 3638 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA0_LK0_BO26;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 3648 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 3697 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 3701 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA0_LK0_BO27(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO27
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 3720 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 27; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 3740 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA0_LK0_BO27;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 3750 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 3799 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 3803 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA0_LK0_BO28(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO28
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 3822 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 28; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 3842 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA0_LK0_BO28;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 3852 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 3901 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 3905 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA0_LK0_BO29(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO29
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 3924 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 29; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 3944 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA0_LK0_BO29;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 3954 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 4003 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 4007 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA0_LK0_BO30(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO30
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 4026 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 30; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 4046 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA0_LK0_BO30;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 4056 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 4105 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 4109 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA0_LK0_BO31(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO31
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 4128 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 31; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 4148 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA0_LK0_BO31;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 4158 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 4207 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 4211 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA0_LK1_BO0(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO0
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 4230 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 4250 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA0_LK1_BO0;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 4260 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 4309 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 4313 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA0_LK1_BO1(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO1
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 4332 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 4352 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA0_LK1_BO1;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 4362 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 4411 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 4415 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA0_LK1_BO2(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO2
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 4434 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 2; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 4454 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA0_LK1_BO2;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 4464 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 4513 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 4517 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA0_LK1_BO3(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO3
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 4536 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 3; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 4556 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA0_LK1_BO3;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 4566 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 4615 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 4619 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA0_LK1_BO4(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO4
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 4638 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 4; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 4658 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA0_LK1_BO4;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 4668 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 4717 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 4721 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA0_LK1_BO5(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO5
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 4740 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 5; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 4760 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA0_LK1_BO5;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 4770 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 4819 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 4823 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA0_LK1_BO6(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO6
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 4842 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 6; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 4862 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA0_LK1_BO6;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 4872 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 4921 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 4925 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA0_LK1_BO7(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO7
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 4944 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 7; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 4964 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA0_LK1_BO7;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 4974 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 5023 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 5027 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA0_LK1_BO8(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO8
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 5046 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 8; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 5066 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA0_LK1_BO8;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 5076 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 5125 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 5129 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA0_LK1_BO9(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO9
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 5148 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 9; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 5168 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA0_LK1_BO9;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 5178 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 5227 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 5231 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA0_LK1_BO10(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO10
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 5250 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 10; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 5270 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA0_LK1_BO10;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 5280 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 5329 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 5333 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA0_LK1_BO11(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO11
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 5352 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 11; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 5372 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA0_LK1_BO11;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 5382 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 5431 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 5435 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA0_LK1_BO12(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO12
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 5454 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 12; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 5474 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA0_LK1_BO12;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 5484 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 5533 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 5537 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA0_LK1_BO13(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO13
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 5556 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 13; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 5576 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA0_LK1_BO13;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 5586 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 5635 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 5639 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA0_LK1_BO14(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO14
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 5658 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 14; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 5678 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA0_LK1_BO14;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 5688 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 5737 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 5741 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA0_LK1_BO15(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO15
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 5760 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 15; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 5780 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA0_LK1_BO15;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 5790 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 5839 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 5843 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA0_LK1_BO16(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO16
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 5862 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 16; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 5882 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA0_LK1_BO16;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 5892 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 5941 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 5945 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA0_LK1_BO17(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO17
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 5964 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 17; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 5984 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA0_LK1_BO17;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 5994 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 6043 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 6047 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA0_LK1_BO18(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO18
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 6066 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 18; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 6086 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA0_LK1_BO18;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 6096 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 6145 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 6149 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA0_LK1_BO19(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO19
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 6168 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 19; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 6188 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA0_LK1_BO19;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 6198 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 6247 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 6251 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA0_LK1_BO20(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO20
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 6270 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 20; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 6290 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA0_LK1_BO20;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 6300 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 6349 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 6353 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA0_LK1_BO21(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO21
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 6372 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 21; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 6392 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA0_LK1_BO21;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 6402 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 6451 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 6455 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA0_LK1_BO22(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO22
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 6474 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 22; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 6494 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA0_LK1_BO22;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 6504 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 6553 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 6557 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA0_LK1_BO23(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO23
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 6576 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 23; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 6596 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA0_LK1_BO23;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 6606 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 6655 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 6659 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA0_LK1_BO24(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO24
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 6678 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 24; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 6698 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA0_LK1_BO24;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 6708 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 6757 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 6761 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA0_LK1_BO25(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO25
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 6780 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 25; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 6800 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA0_LK1_BO25;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 6810 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 6859 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 6863 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA0_LK1_BO26(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO26
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 6882 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 26; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 6902 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA0_LK1_BO26;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 6912 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 6961 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 6965 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA0_LK1_BO27(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO27
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 6984 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 27; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 7004 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA0_LK1_BO27;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 7014 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 7063 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 7067 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA0_LK1_BO28(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO28
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 7086 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 28; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 7106 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA0_LK1_BO28;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 7116 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 7165 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 7169 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA0_LK1_BO29(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO29
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 7188 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 29; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 7208 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA0_LK1_BO29;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 7218 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 7267 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 7271 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA0_LK1_BO30(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO30
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 7290 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 30; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 7310 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA0_LK1_BO30;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 7320 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 7369 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 7373 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA0_LK1_BO31(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO31
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 7392 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 31; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 7412 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA0_LK1_BO31;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 7422 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 7471 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 7475 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA1_LK0_BO0(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO0
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 7494 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 7514 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA1_LK0_BO0;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 7524 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 7573 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 7577 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA1_LK0_BO1(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO1
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 7596 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 7616 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA1_LK0_BO1;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 7626 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 7675 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 7679 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA1_LK0_BO2(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO2
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 7698 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 2; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 7718 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA1_LK0_BO2;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 7728 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 7777 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 7781 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA1_LK0_BO3(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO3
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 7800 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 3; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 7820 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA1_LK0_BO3;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 7830 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 7879 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 7883 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA1_LK0_BO4(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO4
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 7902 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 4; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 7922 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA1_LK0_BO4;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 7932 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 7981 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 7985 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA1_LK0_BO5(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO5
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 8004 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 5; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 8024 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA1_LK0_BO5;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 8034 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 8083 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 8087 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA1_LK0_BO6(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO6
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 8106 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 6; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 8126 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA1_LK0_BO6;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 8136 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 8185 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 8189 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA1_LK0_BO7(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO7
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 8208 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 7; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 8228 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA1_LK0_BO7;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 8238 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 8287 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 8291 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA1_LK0_BO8(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO8
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 8310 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 8; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 8330 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA1_LK0_BO8;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 8340 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 8389 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 8393 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA1_LK0_BO9(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO9
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 8412 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 9; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 8432 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA1_LK0_BO9;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 8442 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 8491 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 8495 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA1_LK0_BO10(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO10
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 8514 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 10; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 8534 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA1_LK0_BO10;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 8544 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 8593 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 8597 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA1_LK0_BO11(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO11
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 8616 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 11; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 8636 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA1_LK0_BO11;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 8646 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 8695 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 8699 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA1_LK0_BO12(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO12
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 8718 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 12; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 8738 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA1_LK0_BO12;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 8748 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 8797 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 8801 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA1_LK0_BO13(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO13
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 8820 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 13; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 8840 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA1_LK0_BO13;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 8850 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 8899 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 8903 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA1_LK0_BO14(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO14
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 8922 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 14; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 8942 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA1_LK0_BO14;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 8952 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 9001 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 9005 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA1_LK0_BO15(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO15
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 9024 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 15; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 9044 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA1_LK0_BO15;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 9054 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 9103 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 9107 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA1_LK0_BO16(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO16
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 9126 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 16; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 9146 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA1_LK0_BO16;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 9156 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 9205 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 9209 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA1_LK0_BO17(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO17
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 9228 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 17; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 9248 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA1_LK0_BO17;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 9258 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 9307 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 9311 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA1_LK0_BO18(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO18
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 9330 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 18; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 9350 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA1_LK0_BO18;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 9360 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 9409 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 9413 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA1_LK0_BO19(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO19
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 9432 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 19; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 9452 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA1_LK0_BO19;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 9462 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 9511 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 9515 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA1_LK0_BO20(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO20
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 9534 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 20; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 9554 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA1_LK0_BO20;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 9564 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 9613 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 9617 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA1_LK0_BO21(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO21
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 9636 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 21; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 9656 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA1_LK0_BO21;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 9666 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 9715 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 9719 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA1_LK0_BO22(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO22
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 9738 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 22; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 9758 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA1_LK0_BO22;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 9768 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 9817 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 9821 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA1_LK0_BO23(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO23
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 9840 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 23; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 9860 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA1_LK0_BO23;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 9870 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 9919 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 9923 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA1_LK0_BO24(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO24
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 9942 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 24; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 9962 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA1_LK0_BO24;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 9972 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 10021 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 10025 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA1_LK0_BO25(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO25
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 10044 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 25; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 10064 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA1_LK0_BO25;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 10074 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 10123 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 10127 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA1_LK0_BO26(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO26
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 10146 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 26; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 10166 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA1_LK0_BO26;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 10176 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 10225 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 10229 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA1_LK0_BO27(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO27
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 10248 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 27; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 10268 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA1_LK0_BO27;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 10278 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 10327 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 10331 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA1_LK0_BO28(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO28
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 10350 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 28; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 10370 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA1_LK0_BO28;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 10380 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 10429 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 10433 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA1_LK0_BO29(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO29
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 10452 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 29; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 10472 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA1_LK0_BO29;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 10482 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 10531 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 10535 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA1_LK0_BO30(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO30
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 10554 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 30; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 10574 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA1_LK0_BO30;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 10584 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 10633 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 10637 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA1_LK0_BO31(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO31
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 10656 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 31; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 10676 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA1_LK0_BO31;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 10686 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 10735 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 10739 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA1_LK1_BO0(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO0
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 10758 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 10778 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA1_LK1_BO0;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 10788 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 10837 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 10841 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA1_LK1_BO1(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO1
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 10860 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 10880 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA1_LK1_BO1;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 10890 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 10939 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 10943 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA1_LK1_BO2(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO2
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 10962 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 2; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 10982 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA1_LK1_BO2;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 10992 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 11041 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 11045 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA1_LK1_BO3(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO3
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 11064 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 3; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 11084 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA1_LK1_BO3;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 11094 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 11143 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 11147 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA1_LK1_BO4(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO4
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 11166 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 4; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 11186 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA1_LK1_BO4;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 11196 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 11245 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 11249 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA1_LK1_BO5(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO5
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 11268 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 5; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 11288 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA1_LK1_BO5;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 11298 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 11347 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 11351 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA1_LK1_BO6(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO6
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 11370 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 6; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 11390 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA1_LK1_BO6;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 11400 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 11449 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 11453 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA1_LK1_BO7(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO7
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 11472 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 7; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 11492 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA1_LK1_BO7;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 11502 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 11551 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 11555 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA1_LK1_BO8(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO8
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 11574 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 8; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 11594 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA1_LK1_BO8;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 11604 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 11653 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 11657 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA1_LK1_BO9(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO9
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 11676 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 9; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 11696 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA1_LK1_BO9;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 11706 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 11755 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 11759 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA1_LK1_BO10(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO10
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 11778 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 10; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 11798 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA1_LK1_BO10;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 11808 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 11857 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 11861 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA1_LK1_BO11(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO11
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 11880 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 11; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 11900 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA1_LK1_BO11;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 11910 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 11959 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 11963 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA1_LK1_BO12(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO12
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 11982 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 12; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 12002 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA1_LK1_BO12;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 12012 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 12061 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 12065 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA1_LK1_BO13(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO13
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 12084 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 13; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 12104 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA1_LK1_BO13;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 12114 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 12163 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 12167 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA1_LK1_BO14(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO14
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 12186 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 14; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 12206 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA1_LK1_BO14;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 12216 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 12265 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 12269 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA1_LK1_BO15(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO15
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 12288 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 15; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 12308 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA1_LK1_BO15;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 12318 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 12367 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 12371 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA1_LK1_BO16(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO16
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 12390 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 16; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 12410 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA1_LK1_BO16;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 12420 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 12469 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 12473 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA1_LK1_BO17(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO17
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 12492 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 17; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 12512 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA1_LK1_BO17;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 12522 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 12571 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 12575 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA1_LK1_BO18(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO18
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 12594 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 18; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 12614 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA1_LK1_BO18;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 12624 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 12673 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 12677 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA1_LK1_BO19(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO19
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 12696 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 19; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 12716 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA1_LK1_BO19;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 12726 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 12775 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 12779 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA1_LK1_BO20(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO20
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 12798 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 20; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 12818 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA1_LK1_BO20;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 12828 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 12877 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 12881 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA1_LK1_BO21(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO21
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 12900 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 21; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 12920 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA1_LK1_BO21;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 12930 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 12979 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 12983 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA1_LK1_BO22(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO22
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 13002 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 22; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 13022 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA1_LK1_BO22;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 13032 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 13081 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 13085 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA1_LK1_BO23(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO23
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 13104 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 23; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 13124 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA1_LK1_BO23;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 13134 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 13183 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 13187 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA1_LK1_BO24(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO24
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 13206 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 24; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 13226 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA1_LK1_BO24;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 13236 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 13285 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 13289 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA1_LK1_BO25(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO25
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 13308 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 25; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 13328 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA1_LK1_BO25;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 13338 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 13387 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 13391 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA1_LK1_BO26(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO26
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 13410 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 26; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 13430 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA1_LK1_BO26;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 13440 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 13489 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 13493 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA1_LK1_BO27(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO27
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 13512 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 27; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 13532 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA1_LK1_BO27;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 13542 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 13591 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 13595 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA1_LK1_BO28(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO28
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 13614 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 28; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 13634 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA1_LK1_BO28;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 13644 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 13693 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 13697 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA1_LK1_BO29(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO29
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 13716 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 29; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 13736 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA1_LK1_BO29;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 13746 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 13795 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 13799 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA1_LK1_BO30(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO30
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 13818 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 30; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 13838 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA1_LK1_BO30;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 13848 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 13897 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 13901 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_AA1_LK1_BO31(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO31
#line 1518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional\n"));
#line 13920 "icache.c"

  /* validate: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x40000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = 31; /* default in icache - constant field */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.B.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 77 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_BD_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.B.EXTS_BD_0b00 = (((signed_word)(int16_t)instruction) & ~3); /* in icache - extraction */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 1518 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 13940 "icache.c"

#define insn cache_entry->crack.B.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_AA1_LK1_BO31;

    /* semantic routine */
#line 1518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 13950 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1518 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
      cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
      if (ctr_ok && cond_ok) {
        if (AA) NIA = IEA(EXTS(BD_0b00));
        else    NIA = IEA(CIA + EXTS(BD_0b00));
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as "normal".
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_) {
        int reverse;
        if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
          reverse = EXTS(BD_0b00) < 0;
        } else {	/* branch prediction bit not set */
          reverse = EXTS(BD_0b00) >= 0;
        }
        if (CURRENT_MODEL_ISSUE > 0)
          model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
      }
    }
#line 13999 "icache.c"
    return nia;
    /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 14003 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_System_Call(cpu *processor,
                   instruction_word instruction,
                   unsigned_word cia,
                   idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_System_Call
#undef MY_PREFIX
#define MY_PREFIX System_Call
#line 1630 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode System Call\n"));
#line 14022 "icache.c"

  /* validate: 0.17,6./,11./,16./,30.1,31./ */
  if (WITH_RESERVED_BITS && (instruction & 0xffffffff) != 0x44000002)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.17,6./,11./,16./,30.1,31./ #define get-values-from-icache|put-values-in-icache */
#line 14031 "icache.c"

#define insn cache_entry->crack.SC.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_System_Call;

    /* semantic routine */
#line 1630 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics System Call\n"));
#line 14041 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_System_Call, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1630 "../../../sim/ppc/powerpc.igen"
    {
      if (CURRENT_MODEL_ISSUE > 0)
        model_serialize(MY_INDEX, cpu_model(processor));
      system_call_interrupt(processor, cia);
    }
#line 14056 "icache.c"
    return nia;
    /* extraction: 0.17,6./,11./,16./,30.1,31./ #undef get-values-from-icache|put-values-in-icache */
#line 14059 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_AA0_LK0(cpu *processor,
                      instruction_word instruction,
                      unsigned_word cia,
                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch
#undef MY_PREFIX
#define MY_PREFIX Branch_AA0_LK0
#line 1505 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch\n"));
#line 14078 "icache.c"

  /* validate: 0.18,6.LI,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x48000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.18,6.LI,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 78 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_LI_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.I.EXTS_LI_0b00 = ((((signed_word)(int32_t)(instruction << 6)) >> 6) & ~0x3); /* in icache - extraction */
#line 1505 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 1505 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 14093 "icache.c"

#define insn cache_entry->crack.I.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_AA0_LK0;

    /* semantic routine */
#line 1505 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch\n"));
#line 14103 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1505 "../../../sim/ppc/powerpc.igen"
    {
      /* option_mpc860c0:
      No problem here because this branch is predicted taken (unconditional). */
      if (AA) NIA = IEA(EXTS(LI_0b00));
      else    NIA = IEA(CIA + EXTS(LI_0b00));
      if (LK) LR = (spreg)CIA+4;
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), 1, -1);
    }
#line 14122 "icache.c"
    return nia;
    /* extraction: 0.18,6.LI,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#line 14125 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_AA0_LK1(cpu *processor,
                      instruction_word instruction,
                      unsigned_word cia,
                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch
#undef MY_PREFIX
#define MY_PREFIX Branch_AA0_LK1
#line 1505 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch\n"));
#line 14144 "icache.c"

  /* validate: 0.18,6.LI,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x48000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.18,6.LI,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 78 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_LI_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.I.EXTS_LI_0b00 = ((((signed_word)(int32_t)(instruction << 6)) >> 6) & ~0x3); /* in icache - extraction */
#line 1505 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 1505 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 14159 "icache.c"

#define insn cache_entry->crack.I.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_AA0_LK1;

    /* semantic routine */
#line 1505 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch\n"));
#line 14169 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1505 "../../../sim/ppc/powerpc.igen"
    {
      /* option_mpc860c0:
      No problem here because this branch is predicted taken (unconditional). */
      if (AA) NIA = IEA(EXTS(LI_0b00));
      else    NIA = IEA(CIA + EXTS(LI_0b00));
      if (LK) LR = (spreg)CIA+4;
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), 1, -1);
    }
#line 14188 "icache.c"
    return nia;
    /* extraction: 0.18,6.LI,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#line 14191 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_AA1_LK0(cpu *processor,
                      instruction_word instruction,
                      unsigned_word cia,
                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch
#undef MY_PREFIX
#define MY_PREFIX Branch_AA1_LK0
#line 1505 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch\n"));
#line 14210 "icache.c"

  /* validate: 0.18,6.LI,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x48000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.18,6.LI,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 78 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_LI_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.I.EXTS_LI_0b00 = ((((signed_word)(int32_t)(instruction << 6)) >> 6) & ~0x3); /* in icache - extraction */
#line 1505 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 1505 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 14225 "icache.c"

#define insn cache_entry->crack.I.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_AA1_LK0;

    /* semantic routine */
#line 1505 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch\n"));
#line 14235 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1505 "../../../sim/ppc/powerpc.igen"
    {
      /* option_mpc860c0:
      No problem here because this branch is predicted taken (unconditional). */
      if (AA) NIA = IEA(EXTS(LI_0b00));
      else    NIA = IEA(CIA + EXTS(LI_0b00));
      if (LK) LR = (spreg)CIA+4;
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), 1, -1);
    }
#line 14254 "icache.c"
    return nia;
    /* extraction: 0.18,6.LI,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#line 14257 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_AA1_LK1(cpu *processor,
                      instruction_word instruction,
                      unsigned_word cia,
                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch
#undef MY_PREFIX
#define MY_PREFIX Branch_AA1_LK1
#line 1505 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch\n"));
#line 14276 "icache.c"

  /* validate: 0.18,6.LI,30.AA,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x48000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.18,6.LI,30.AA,31.LK #define get-values-from-icache|put-values-in-icache */
#line 78 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_LI_0b00 ATTRIBUTE_UNUSED = cache_entry->crack.I.EXTS_LI_0b00 = ((((signed_word)(int32_t)(instruction << 6)) >> 6) & ~0x3); /* in icache - extraction */
#line 1505 "../../../sim/ppc/powerpc.igen"
    unsigned const AA ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 1505 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 14291 "icache.c"

#define insn cache_entry->crack.I.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_AA1_LK1;

    /* semantic routine */
#line 1505 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch\n"));
#line 14301 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1505 "../../../sim/ppc/powerpc.igen"
    {
      /* option_mpc860c0:
      No problem here because this branch is predicted taken (unconditional). */
      if (AA) NIA = IEA(EXTS(LI_0b00));
      else    NIA = IEA(CIA + EXTS(LI_0b00));
      if (LK) LR = (spreg)CIA+4;
      if (CURRENT_MODEL_ISSUE > 0)
        model_branches(cpu_model(processor), 1, -1);
    }
#line 14320 "icache.c"
    return nia;
    /* extraction: 0.18,6.LI,30.AA,31.LK #undef get-values-from-icache|put-values-in-icache */
#line 14323 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Move_Condition_Register_Field(cpu *processor,
                                     instruction_word instruction,
                                     unsigned_word cia,
                                     idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Move_Condition_Register_Field
#undef MY_PREFIX
#define MY_PREFIX Move_Condition_Register_Field
#line 1709 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Move Condition Register Field\n"));
#line 14342 "icache.c"

  /* validate: 0.19,6.BF,9./,11.BFA,14./,16./,21.0,31./ */
  if (WITH_RESERVED_BITS && (instruction & 0xfc63ffff) != 0x4c000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.19,6.BF,9./,11.BFA,14./,16./,21.0,31./ #define get-values-from-icache|put-values-in-icache */
#line 67 "../../../sim/ppc/powerpc.igen"
    unsigned const BF ATTRIBUTE_UNUSED = cache_entry->crack.XL.BF = EXTRACTED32(instruction, 6, 8); /* in icache - extraction */
#line 68 "../../../sim/ppc/powerpc.igen"
    uint32_t const BF_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XL.BF_BITMASK = (1 << BF); /* in icache - extraction */
#line 1709 "../../../sim/ppc/powerpc.igen"
    unsigned const BFA ATTRIBUTE_UNUSED = cache_entry->crack.XL.BFA = EXTRACTED32(instruction, 11, 13); /* default in icache - extraction */
#line 14357 "icache.c"

#define insn cache_entry->crack.XL.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Move_Condition_Register_Field;

    /* semantic routine */
#line 1709 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Move Condition Register Field\n"));
#line 14367 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Move_Condition_Register_Field, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1709 "../../../sim/ppc/powerpc.igen"
    {
      MBLIT32(CR, 4*BF, 4*BF+3, EXTRACTED32(CR, 4*BFA, 4*BFA+3));
      PPC_INSN_CR(BF_BITMASK, 1 << BFA);
    }
#line 14381 "icache.c"
    return nia;
    /* extraction: 0.19,6.BF,9./,11.BFA,14./,16./,21.0,31./ #undef get-values-from-icache|put-values-in-icache */
#line 14384 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_to_Link_Register_LK0(cpu *processor,
                                               instruction_word instruction,
                                               unsigned_word cia,
                                               idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional_to_Link_Register
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_to_Link_Register_LK0
#line 1561 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional to Link Register\n"));
#line 14403 "icache.c"

  /* validate: 0.19,6.BO,11.BI,16./,21.16,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00fffe) != 0x4c000020)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.19,6.BO,11.BI,16./,21.16,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1561 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = cache_entry->crack.XL.BO = EXTRACTED32(instruction, 6, 10); /* default in icache - extraction */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.XL.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 1561 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 14419 "icache.c"

#define insn cache_entry->crack.XL.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_to_Link_Register_LK0;

    /* semantic routine */
#line 1561 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional to Link Register\n"));
#line 14429 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional_to_Link_Register, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1561 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != BO_3_);
      cond_ok = BO_0_ || (CR_BI_ == BO_1_);
      if (ctr_ok && cond_ok) {
        NIA = IEA(LR_0b00);
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as not-taken.
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0) {
        model_branches(cpu_model(processor), succeed, BO);
        if (! BO_0_)
          model_branch_predict(cpu_model(processor), BO_4_ ? !succeed : succeed);
      }
    }
#line 14470 "icache.c"
    return nia;
    /* extraction: 0.19,6.BO,11.BI,16./,21.16,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 14474 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_to_Link_Register_LK1(cpu *processor,
                                               instruction_word instruction,
                                               unsigned_word cia,
                                               idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional_to_Link_Register
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_to_Link_Register_LK1
#line 1561 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional to Link Register\n"));
#line 14493 "icache.c"

  /* validate: 0.19,6.BO,11.BI,16./,21.16,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00fffe) != 0x4c000020)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.19,6.BO,11.BI,16./,21.16,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1561 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = cache_entry->crack.XL.BO = EXTRACTED32(instruction, 6, 10); /* default in icache - extraction */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.XL.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 1561 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 14509 "icache.c"

#define insn cache_entry->crack.XL.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_to_Link_Register_LK1;

    /* semantic routine */
#line 1561 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional to Link Register\n"));
#line 14519 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional_to_Link_Register, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1561 "../../../sim/ppc/powerpc.igen"
    {
      int M, ctr_ok, cond_ok, succeed;
      if (is_64bit_implementation && is_64bit_mode) M = 0;
      else                                          M = 32;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      if (!BO_2_) CTR = CTR - 1;
      ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != BO_3_);
      cond_ok = BO_0_ || (CR_BI_ == BO_1_);
      if (ctr_ok && cond_ok) {
        NIA = IEA(LR_0b00);
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as not-taken.
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0) {
        model_branches(cpu_model(processor), succeed, BO);
        if (! BO_0_)
          model_branch_predict(cpu_model(processor), BO_4_ ? !succeed : succeed);
      }
    }
#line 14560 "icache.c"
    return nia;
    /* extraction: 0.19,6.BO,11.BI,16./,21.16,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 14564 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Condition_Register_NOR(cpu *processor,
                              instruction_word instruction,
                              unsigned_word cia,
                              idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Condition_Register_NOR
#undef MY_PREFIX
#define MY_PREFIX Condition_Register_NOR
#line 1674 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Condition Register NOR\n"));
#line 14583 "icache.c"

  /* validate: 0.19,6.BT,11.BA,16.BB,21.33,31./ */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007ff) != 0x4c000042)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.19,6.BT,11.BA,16.BB,21.33,31./ #define get-values-from-icache|put-values-in-icache */
#line 75 "../../../sim/ppc/powerpc.igen"
    unsigned const BT ATTRIBUTE_UNUSED = cache_entry->crack.XL.BT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 76 "../../../sim/ppc/powerpc.igen"
    uint32_t const BT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XL.BT_BITMASK = (1 << BT); /* in icache - extraction */
#define BA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 70 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BA ATTRIBUTE_UNUSED = cache_entry->crack.XL.BIT32_BA = BIT32(BA); /* in icache - extraction */
#line 71 "../../../sim/ppc/powerpc.igen"
    uint32_t const BA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XL.BA_BITMASK = (1 << BA); /* in icache - extraction */
#define BB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 73 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BB ATTRIBUTE_UNUSED = cache_entry->crack.XL.BIT32_BB = BIT32(BB); /* in icache - extraction */
#line 74 "../../../sim/ppc/powerpc.igen"
    uint32_t const BB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XL.BB_BITMASK = (1 << BB); /* in icache - extraction */
#line 14606 "icache.c"

#define insn cache_entry->crack.XL.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Condition_Register_NOR;

    /* semantic routine */
#line 1674 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Condition Register NOR\n"));
#line 14616 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Condition_Register_NOR, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1674 "../../../sim/ppc/powerpc.igen"
    {
      BLIT32(CR, BT, !(CR_BA_ || CR_BB_));
      PPC_INSN_CR(BT_BITMASK, BA_BITMASK | BB_BITMASK);
    }
#line 14630 "icache.c"
    return nia;
    /* extraction: 0.19,6.BT,11.BA,16.BB,21.33,31./ #undef get-values-from-icache|put-values-in-icache */
#undef BA
#undef BB
#line 14635 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Return_From_Interrupt(cpu *processor,
                             instruction_word instruction,
                             unsigned_word cia,
                             idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Return_From_Interrupt
#undef MY_PREFIX
#define MY_PREFIX Return_From_Interrupt
#line 4861 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Return From Interrupt\n"));
#line 14654 "icache.c"

  /* validate: 0.19,6./,11./,16./,21.50,31./ */
  if (WITH_RESERVED_BITS && (instruction & 0xffffffff) != 0x4c000064)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.19,6./,11./,16./,21.50,31./ #define get-values-from-icache|put-values-in-icache */
#line 14663 "icache.c"

#define insn cache_entry->crack.XL.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Return_From_Interrupt;

    /* semantic routine */
#line 4861 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Return From Interrupt\n"));
#line 14673 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Return_From_Interrupt, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4861 "../../../sim/ppc/powerpc.igen"
    {
      if (IS_PROBLEM_STATE(processor)) {
        program_interrupt(processor, cia,
                          privileged_instruction_program_interrupt);
      }
      else {
        MSR = (MASKED(SRR1, 0, 32)
               | MASKED(SRR1, 37, 41)
               | MASKED(SRR1, 48, 63));
        NIA = MASKED(SRR0, 0, 61);
        cpu_synchronize_context(processor, cia);
        check_masked_interrupts(processor);
      }
    }
#line 14697 "icache.c"
    return nia;
    /* extraction: 0.19,6./,11./,16./,21.50,31./ #undef get-values-from-icache|put-values-in-icache */
#line 14700 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Condition_Register_AND_with_Complement(cpu *processor,
                                              instruction_word instruction,
                                              unsigned_word cia,
                                              idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Condition_Register_AND_with_Complement
#undef MY_PREFIX
#define MY_PREFIX Condition_Register_AND_with_Complement
#line 1690 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Condition Register AND with Complement\n"));
#line 14719 "icache.c"

  /* validate: 0.19,6.BT,11.BA,16.BB,21.129,31./ */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007ff) != 0x4c000102)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.19,6.BT,11.BA,16.BB,21.129,31./ #define get-values-from-icache|put-values-in-icache */
#line 75 "../../../sim/ppc/powerpc.igen"
    unsigned const BT ATTRIBUTE_UNUSED = cache_entry->crack.XL.BT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 76 "../../../sim/ppc/powerpc.igen"
    uint32_t const BT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XL.BT_BITMASK = (1 << BT); /* in icache - extraction */
#define BA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 70 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BA ATTRIBUTE_UNUSED = cache_entry->crack.XL.BIT32_BA = BIT32(BA); /* in icache - extraction */
#line 71 "../../../sim/ppc/powerpc.igen"
    uint32_t const BA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XL.BA_BITMASK = (1 << BA); /* in icache - extraction */
#define BB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 73 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BB ATTRIBUTE_UNUSED = cache_entry->crack.XL.BIT32_BB = BIT32(BB); /* in icache - extraction */
#line 74 "../../../sim/ppc/powerpc.igen"
    uint32_t const BB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XL.BB_BITMASK = (1 << BB); /* in icache - extraction */
#line 14742 "icache.c"

#define insn cache_entry->crack.XL.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Condition_Register_AND_with_Complement;

    /* semantic routine */
#line 1690 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Condition Register AND with Complement\n"));
#line 14752 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Condition_Register_AND_with_Complement, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1690 "../../../sim/ppc/powerpc.igen"
    {
      BLIT32(CR, BT, CR_BA_ && !CR_BB_);
      PPC_INSN_CR(BT_BITMASK, BA_BITMASK | BB_BITMASK);
    }
#line 14766 "icache.c"
    return nia;
    /* extraction: 0.19,6.BT,11.BA,16.BB,21.129,31./ #undef get-values-from-icache|put-values-in-icache */
#undef BA
#undef BB
#line 14771 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Instruction_Synchronize(cpu *processor,
                               instruction_word instruction,
                               unsigned_word cia,
                               idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Instruction_Synchronize
#undef MY_PREFIX
#define MY_PREFIX Instruction_Synchronize
#line 4774 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Instruction Synchronize\n"));
#line 14790 "icache.c"

  /* validate: 0.19,6./,11./,16./,21.150,31./ */
  if (WITH_RESERVED_BITS && (instruction & 0xffffffff) != 0x4c00012c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.19,6./,11./,16./,21.150,31./ #define get-values-from-icache|put-values-in-icache */
#line 14799 "icache.c"

#define insn cache_entry->crack.XL.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Instruction_Synchronize;

    /* semantic routine */
#line 4774 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Instruction Synchronize\n"));
#line 14809 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Instruction_Synchronize, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4774 "../../../sim/ppc/powerpc.igen"
    {
      cpu_synchronize_context(processor, cia);
      PPC_INSN_INT(0, 0, 0);
    }
#line 14823 "icache.c"
    return nia;
    /* extraction: 0.19,6./,11./,16./,21.150,31./ #undef get-values-from-icache|put-values-in-icache */
#line 14826 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Condition_Register_XOR(cpu *processor,
                              instruction_word instruction,
                              unsigned_word cia,
                              idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Condition_Register_XOR
#undef MY_PREFIX
#define MY_PREFIX Condition_Register_XOR
#line 1658 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Condition Register XOR\n"));
#line 14845 "icache.c"

  /* validate: 0.19,6.BT,11.BA,16.BB,21.193,31./ */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007ff) != 0x4c000182)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.19,6.BT,11.BA,16.BB,21.193,31./ #define get-values-from-icache|put-values-in-icache */
#line 75 "../../../sim/ppc/powerpc.igen"
    unsigned const BT ATTRIBUTE_UNUSED = cache_entry->crack.XL.BT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 76 "../../../sim/ppc/powerpc.igen"
    uint32_t const BT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XL.BT_BITMASK = (1 << BT); /* in icache - extraction */
#define BA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 70 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BA ATTRIBUTE_UNUSED = cache_entry->crack.XL.BIT32_BA = BIT32(BA); /* in icache - extraction */
#line 71 "../../../sim/ppc/powerpc.igen"
    uint32_t const BA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XL.BA_BITMASK = (1 << BA); /* in icache - extraction */
#define BB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 73 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BB ATTRIBUTE_UNUSED = cache_entry->crack.XL.BIT32_BB = BIT32(BB); /* in icache - extraction */
#line 74 "../../../sim/ppc/powerpc.igen"
    uint32_t const BB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XL.BB_BITMASK = (1 << BB); /* in icache - extraction */
#line 14868 "icache.c"

#define insn cache_entry->crack.XL.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Condition_Register_XOR;

    /* semantic routine */
#line 1658 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Condition Register XOR\n"));
#line 14878 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Condition_Register_XOR, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1658 "../../../sim/ppc/powerpc.igen"
    {
      BLIT32(CR, BT, CR_BA_ != CR_BB_);
      PPC_INSN_CR(BT_BITMASK, BA_BITMASK | BB_BITMASK);
    }
#line 14892 "icache.c"
    return nia;
    /* extraction: 0.19,6.BT,11.BA,16.BB,21.193,31./ #undef get-values-from-icache|put-values-in-icache */
#undef BA
#undef BB
#line 14897 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Condition_Register_NAND(cpu *processor,
                               instruction_word instruction,
                               unsigned_word cia,
                               idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Condition_Register_NAND
#undef MY_PREFIX
#define MY_PREFIX Condition_Register_NAND
#line 1666 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Condition Register NAND\n"));
#line 14916 "icache.c"

  /* validate: 0.19,6.BT,11.BA,16.BB,21.225,31./ */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007ff) != 0x4c0001c2)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.19,6.BT,11.BA,16.BB,21.225,31./ #define get-values-from-icache|put-values-in-icache */
#line 75 "../../../sim/ppc/powerpc.igen"
    unsigned const BT ATTRIBUTE_UNUSED = cache_entry->crack.XL.BT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 76 "../../../sim/ppc/powerpc.igen"
    uint32_t const BT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XL.BT_BITMASK = (1 << BT); /* in icache - extraction */
#define BA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 70 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BA ATTRIBUTE_UNUSED = cache_entry->crack.XL.BIT32_BA = BIT32(BA); /* in icache - extraction */
#line 71 "../../../sim/ppc/powerpc.igen"
    uint32_t const BA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XL.BA_BITMASK = (1 << BA); /* in icache - extraction */
#define BB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 73 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BB ATTRIBUTE_UNUSED = cache_entry->crack.XL.BIT32_BB = BIT32(BB); /* in icache - extraction */
#line 74 "../../../sim/ppc/powerpc.igen"
    uint32_t const BB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XL.BB_BITMASK = (1 << BB); /* in icache - extraction */
#line 14939 "icache.c"

#define insn cache_entry->crack.XL.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Condition_Register_NAND;

    /* semantic routine */
#line 1666 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Condition Register NAND\n"));
#line 14949 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Condition_Register_NAND, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1666 "../../../sim/ppc/powerpc.igen"
    {
      BLIT32(CR, BT, !(CR_BA_ && CR_BB_));
      PPC_INSN_CR(BT_BITMASK, BA_BITMASK | BB_BITMASK);
    }
#line 14963 "icache.c"
    return nia;
    /* extraction: 0.19,6.BT,11.BA,16.BB,21.225,31./ #undef get-values-from-icache|put-values-in-icache */
#undef BA
#undef BB
#line 14968 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Condition_Register_AND(cpu *processor,
                              instruction_word instruction,
                              unsigned_word cia,
                              idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Condition_Register_AND
#undef MY_PREFIX
#define MY_PREFIX Condition_Register_AND
#line 1642 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Condition Register AND\n"));
#line 14987 "icache.c"

  /* validate: 0.19,6.BT,11.BA,16.BB,21.257,31./ */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007ff) != 0x4c000202)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.19,6.BT,11.BA,16.BB,21.257,31./ #define get-values-from-icache|put-values-in-icache */
#line 75 "../../../sim/ppc/powerpc.igen"
    unsigned const BT ATTRIBUTE_UNUSED = cache_entry->crack.XL.BT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 76 "../../../sim/ppc/powerpc.igen"
    uint32_t const BT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XL.BT_BITMASK = (1 << BT); /* in icache - extraction */
#define BA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 70 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BA ATTRIBUTE_UNUSED = cache_entry->crack.XL.BIT32_BA = BIT32(BA); /* in icache - extraction */
#line 71 "../../../sim/ppc/powerpc.igen"
    uint32_t const BA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XL.BA_BITMASK = (1 << BA); /* in icache - extraction */
#define BB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 73 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BB ATTRIBUTE_UNUSED = cache_entry->crack.XL.BIT32_BB = BIT32(BB); /* in icache - extraction */
#line 74 "../../../sim/ppc/powerpc.igen"
    uint32_t const BB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XL.BB_BITMASK = (1 << BB); /* in icache - extraction */
#line 15010 "icache.c"

#define insn cache_entry->crack.XL.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Condition_Register_AND;

    /* semantic routine */
#line 1642 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Condition Register AND\n"));
#line 15020 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Condition_Register_AND, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1642 "../../../sim/ppc/powerpc.igen"
    {
      BLIT32(CR, BT, CR_BA_ && CR_BB_);
      PPC_INSN_CR(BT_BITMASK, BA_BITMASK | BB_BITMASK);
    }
#line 15034 "icache.c"
    return nia;
    /* extraction: 0.19,6.BT,11.BA,16.BB,21.257,31./ #undef get-values-from-icache|put-values-in-icache */
#undef BA
#undef BB
#line 15039 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Condition_Register_Equivalent(cpu *processor,
                                     instruction_word instruction,
                                     unsigned_word cia,
                                     idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Condition_Register_Equivalent
#undef MY_PREFIX
#define MY_PREFIX Condition_Register_Equivalent
#line 1682 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Condition Register Equivalent\n"));
#line 15058 "icache.c"

  /* validate: 0.19,6.BT,11.BA,16.BB,21.289,31./ */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007ff) != 0x4c000242)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.19,6.BT,11.BA,16.BB,21.289,31./ #define get-values-from-icache|put-values-in-icache */
#line 75 "../../../sim/ppc/powerpc.igen"
    unsigned const BT ATTRIBUTE_UNUSED = cache_entry->crack.XL.BT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 76 "../../../sim/ppc/powerpc.igen"
    uint32_t const BT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XL.BT_BITMASK = (1 << BT); /* in icache - extraction */
#define BA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 70 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BA ATTRIBUTE_UNUSED = cache_entry->crack.XL.BIT32_BA = BIT32(BA); /* in icache - extraction */
#line 71 "../../../sim/ppc/powerpc.igen"
    uint32_t const BA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XL.BA_BITMASK = (1 << BA); /* in icache - extraction */
#define BB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 73 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BB ATTRIBUTE_UNUSED = cache_entry->crack.XL.BIT32_BB = BIT32(BB); /* in icache - extraction */
#line 74 "../../../sim/ppc/powerpc.igen"
    uint32_t const BB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XL.BB_BITMASK = (1 << BB); /* in icache - extraction */
#line 15081 "icache.c"

#define insn cache_entry->crack.XL.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Condition_Register_Equivalent;

    /* semantic routine */
#line 1682 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Condition Register Equivalent\n"));
#line 15091 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Condition_Register_Equivalent, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1682 "../../../sim/ppc/powerpc.igen"
    {
      BLIT32(CR, BT, CR_BA_ == CR_BB_);
      PPC_INSN_CR(BT_BITMASK, BA_BITMASK | BB_BITMASK);
    }
#line 15105 "icache.c"
    return nia;
    /* extraction: 0.19,6.BT,11.BA,16.BB,21.289,31./ #undef get-values-from-icache|put-values-in-icache */
#undef BA
#undef BB
#line 15110 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Condition_Register_OR_with_Complement(cpu *processor,
                                             instruction_word instruction,
                                             unsigned_word cia,
                                             idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Condition_Register_OR_with_Complement
#undef MY_PREFIX
#define MY_PREFIX Condition_Register_OR_with_Complement
#line 1698 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Condition Register OR with Complement\n"));
#line 15129 "icache.c"

  /* validate: 0.19,6.BT,11.BA,16.BB,21.417,31./ */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007ff) != 0x4c000342)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.19,6.BT,11.BA,16.BB,21.417,31./ #define get-values-from-icache|put-values-in-icache */
#line 75 "../../../sim/ppc/powerpc.igen"
    unsigned const BT ATTRIBUTE_UNUSED = cache_entry->crack.XL.BT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 76 "../../../sim/ppc/powerpc.igen"
    uint32_t const BT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XL.BT_BITMASK = (1 << BT); /* in icache - extraction */
#define BA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 70 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BA ATTRIBUTE_UNUSED = cache_entry->crack.XL.BIT32_BA = BIT32(BA); /* in icache - extraction */
#line 71 "../../../sim/ppc/powerpc.igen"
    uint32_t const BA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XL.BA_BITMASK = (1 << BA); /* in icache - extraction */
#define BB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 73 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BB ATTRIBUTE_UNUSED = cache_entry->crack.XL.BIT32_BB = BIT32(BB); /* in icache - extraction */
#line 74 "../../../sim/ppc/powerpc.igen"
    uint32_t const BB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XL.BB_BITMASK = (1 << BB); /* in icache - extraction */
#line 15152 "icache.c"

#define insn cache_entry->crack.XL.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Condition_Register_OR_with_Complement;

    /* semantic routine */
#line 1698 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Condition Register OR with Complement\n"));
#line 15162 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Condition_Register_OR_with_Complement, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1698 "../../../sim/ppc/powerpc.igen"
    {
      BLIT32(CR, BT, CR_BA_ || !CR_BB_);
      PPC_INSN_CR(BT_BITMASK, BA_BITMASK | BB_BITMASK);
    }
#line 15176 "icache.c"
    return nia;
    /* extraction: 0.19,6.BT,11.BA,16.BB,21.417,31./ #undef get-values-from-icache|put-values-in-icache */
#undef BA
#undef BB
#line 15181 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Condition_Register_OR(cpu *processor,
                             instruction_word instruction,
                             unsigned_word cia,
                             idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Condition_Register_OR
#undef MY_PREFIX
#define MY_PREFIX Condition_Register_OR
#line 1650 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Condition Register OR\n"));
#line 15200 "icache.c"

  /* validate: 0.19,6.BT,11.BA,16.BB,21.449,31./ */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007ff) != 0x4c000382)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.19,6.BT,11.BA,16.BB,21.449,31./ #define get-values-from-icache|put-values-in-icache */
#line 75 "../../../sim/ppc/powerpc.igen"
    unsigned const BT ATTRIBUTE_UNUSED = cache_entry->crack.XL.BT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 76 "../../../sim/ppc/powerpc.igen"
    uint32_t const BT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XL.BT_BITMASK = (1 << BT); /* in icache - extraction */
#define BA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 70 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BA ATTRIBUTE_UNUSED = cache_entry->crack.XL.BIT32_BA = BIT32(BA); /* in icache - extraction */
#line 71 "../../../sim/ppc/powerpc.igen"
    uint32_t const BA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XL.BA_BITMASK = (1 << BA); /* in icache - extraction */
#define BB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 73 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BB ATTRIBUTE_UNUSED = cache_entry->crack.XL.BIT32_BB = BIT32(BB); /* in icache - extraction */
#line 74 "../../../sim/ppc/powerpc.igen"
    uint32_t const BB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XL.BB_BITMASK = (1 << BB); /* in icache - extraction */
#line 15223 "icache.c"

#define insn cache_entry->crack.XL.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Condition_Register_OR;

    /* semantic routine */
#line 1650 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Condition Register OR\n"));
#line 15233 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Condition_Register_OR, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1650 "../../../sim/ppc/powerpc.igen"
    {
      BLIT32(CR, BT, CR_BA_ || CR_BB_);
      PPC_INSN_CR(BT_BITMASK, BA_BITMASK | BB_BITMASK);
    }
#line 15247 "icache.c"
    return nia;
    /* extraction: 0.19,6.BT,11.BA,16.BB,21.449,31./ #undef get-values-from-icache|put-values-in-icache */
#undef BA
#undef BB
#line 15252 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_to_Count_Register_LK0(cpu *processor,
                                                instruction_word instruction,
                                                unsigned_word cia,
                                                idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional_to_Count_Register
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_to_Count_Register_LK0
#line 1596 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional to Count Register\n"));
#line 15271 "icache.c"

  /* validate: 0.19,6.BO,11.BI,16./,21.528,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00fffe) != 0x4c000420)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.19,6.BO,11.BI,16./,21.528,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1596 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = cache_entry->crack.XL.BO = EXTRACTED32(instruction, 6, 10); /* default in icache - extraction */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.XL.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 1596 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 15287 "icache.c"

#define insn cache_entry->crack.XL.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_to_Count_Register_LK0;

    /* semantic routine */
#line 1596 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional to Count Register\n"));
#line 15297 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional_to_Count_Register, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1596 "../../../sim/ppc/powerpc.igen"
    {
      int cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      cond_ok = BO_0_ || (CR_BI_ == BO_1_);
      if (cond_ok) {
        NIA = IEA(CTR_0b00);
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as not-taken.
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0) {
        model_branches(cpu_model(processor), succeed, BO);
        if (! BO_0_)
          model_branch_predict(cpu_model(processor), BO_4_ ? !succeed : succeed);
      }
    }
#line 15334 "icache.c"
    return nia;
    /* extraction: 0.19,6.BO,11.BI,16./,21.528,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 15338 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Branch_Conditional_to_Count_Register_LK1(cpu *processor,
                                                instruction_word instruction,
                                                unsigned_word cia,
                                                idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional_to_Count_Register
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_to_Count_Register_LK1
#line 1596 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Branch Conditional to Count Register\n"));
#line 15357 "icache.c"

  /* validate: 0.19,6.BO,11.BI,16./,21.528,31.LK */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00fffe) != 0x4c000420)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.19,6.BO,11.BI,16./,21.528,31.LK #define get-values-from-icache|put-values-in-icache */
#line 1596 "../../../sim/ppc/powerpc.igen"
    unsigned const BO ATTRIBUTE_UNUSED = cache_entry->crack.XL.BO = EXTRACTED32(instruction, 6, 10); /* default in icache - extraction */
#define BI EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 66 "../../../sim/ppc/powerpc.igen"
    unsigned const BIT32_BI ATTRIBUTE_UNUSED = cache_entry->crack.XL.BIT32_BI = BIT32(BI); /* in icache - extraction */
#line 1596 "../../../sim/ppc/powerpc.igen"
    unsigned const LK ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 15373 "icache.c"

#define insn cache_entry->crack.XL.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Branch_Conditional_to_Count_Register_LK1;

    /* semantic routine */
#line 1596 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Branch Conditional to Count Register\n"));
#line 15383 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Branch_Conditional_to_Count_Register, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1596 "../../../sim/ppc/powerpc.igen"
    {
      int cond_ok, succeed;
      if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
        model_wait_for_cr(cpu_model(processor), BIT32_BI);
      cond_ok = BO_0_ || (CR_BI_ == BO_1_);
      if (cond_ok) {
        NIA = IEA(CTR_0b00);
        succeed = 1;
      }
      else
        succeed = 0;
      if (LK) LR = (spreg)IEA(CIA + 4);
      if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
        /* This branch is predicted as not-taken.
        If this is a forward branch and it is near the end of a page,
        we've detected a problematic branch. */
        if (succeed && NIA > CIA) {
          if (MPC860C0_PAGE_SIZE - (CIA & (MPC860C0_PAGE_SIZE-1)) <= option_mpc860c0)
            program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
        }
      }
      if (CURRENT_MODEL_ISSUE > 0) {
        model_branches(cpu_model(processor), succeed, BO);
        if (! BO_0_)
          model_branch_predict(cpu_model(processor), BO_4_ ? !succeed : succeed);
      }
    }
#line 15420 "icache.c"
    return nia;
    /* extraction: 0.19,6.BO,11.BI,16./,21.528,31.LK #undef get-values-from-icache|put-values-in-icache */
#undef BI
#line 15424 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Rotate_Left_Word_Immediate_then_Mask_Insert_Rc0(cpu *processor,
                                                       instruction_word instruction,
                                                       unsigned_word cia,
                                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Rotate_Left_Word_Immediate_then_Mask_Insert
#undef MY_PREFIX
#define MY_PREFIX Rotate_Left_Word_Immediate_then_Mask_Insert_Rc0
#line 3231 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Rotate Left Word Immediate then Mask Insert\n"));
#line 15443 "icache.c"

  /* validate: 0.20,6.RS,11.RA,16.SH,21.MB,26.ME,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x50000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.20,6.RS,11.RA,16.SH,21.MB,26.ME,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 43 "../../../sim/ppc/powerpc.igen"
    unsigned const RS ATTRIBUTE_UNUSED = cache_entry->crack.M.RS = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 44 "../../../sim/ppc/powerpc.igen"
    signed_word * const rS ATTRIBUTE_UNUSED = cache_entry->crack.M.rS = (cpu_registers(processor)->gpr + RS); /* in icache - extraction */
#line 45 "../../../sim/ppc/powerpc.igen"
    uint32_t const RS_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.M.RS_BITMASK = (1 << RS); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.M.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.M.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.M.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 3231 "../../../sim/ppc/powerpc.igen"
    unsigned const SH ATTRIBUTE_UNUSED = cache_entry->crack.M.SH = EXTRACTED32(instruction, 16, 20); /* default in icache - extraction */
#line 3231 "../../../sim/ppc/powerpc.igen"
    unsigned const MB ATTRIBUTE_UNUSED = cache_entry->crack.M.MB = EXTRACTED32(instruction, 21, 25); /* default in icache - extraction */
#line 3231 "../../../sim/ppc/powerpc.igen"
    unsigned const ME ATTRIBUTE_UNUSED = cache_entry->crack.M.ME = EXTRACTED32(instruction, 26, 30); /* default in icache - extraction */
#line 3231 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 15473 "icache.c"

#define insn cache_entry->crack.M.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Rotate_Left_Word_Immediate_then_Mask_Insert_Rc0;

    /* semantic routine */
#line 3231 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Rotate Left Word Immediate then Mask Insert\n"));
#line 15483 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Rotate_Left_Word_Immediate_then_Mask_Insert, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3231 "../../../sim/ppc/powerpc.igen"
    {
      long n = SH;
      uint32_t r = ROTL32(*rS, n);
      uint32_t m = MASK(MB+32, ME+32);
      signed_word result = (r & m) | (*rA & ~m);
      *rA = result;
      ITRACE(trace_alu, (": n=%ld *rS=0x%lx r=0x%lx m=0x%lx result=0x%lx\n",
                         n, (unsigned long)*rS, (unsigned long)r, (unsigned long)m,
      		   (unsigned long)result));
      CR0_COMPARE(result, 0, Rc);
      PPC_INSN_INT(RA_BITMASK, RS_BITMASK, Rc);
    }
#line 15505 "icache.c"
    return nia;
    /* extraction: 0.20,6.RS,11.RA,16.SH,21.MB,26.ME,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 15509 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Rotate_Left_Word_Immediate_then_Mask_Insert_Rc1(cpu *processor,
                                                       instruction_word instruction,
                                                       unsigned_word cia,
                                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Rotate_Left_Word_Immediate_then_Mask_Insert
#undef MY_PREFIX
#define MY_PREFIX Rotate_Left_Word_Immediate_then_Mask_Insert_Rc1
#line 3231 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Rotate Left Word Immediate then Mask Insert\n"));
#line 15528 "icache.c"

  /* validate: 0.20,6.RS,11.RA,16.SH,21.MB,26.ME,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x50000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.20,6.RS,11.RA,16.SH,21.MB,26.ME,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 43 "../../../sim/ppc/powerpc.igen"
    unsigned const RS ATTRIBUTE_UNUSED = cache_entry->crack.M.RS = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 44 "../../../sim/ppc/powerpc.igen"
    signed_word * const rS ATTRIBUTE_UNUSED = cache_entry->crack.M.rS = (cpu_registers(processor)->gpr + RS); /* in icache - extraction */
#line 45 "../../../sim/ppc/powerpc.igen"
    uint32_t const RS_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.M.RS_BITMASK = (1 << RS); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.M.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.M.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.M.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 3231 "../../../sim/ppc/powerpc.igen"
    unsigned const SH ATTRIBUTE_UNUSED = cache_entry->crack.M.SH = EXTRACTED32(instruction, 16, 20); /* default in icache - extraction */
#line 3231 "../../../sim/ppc/powerpc.igen"
    unsigned const MB ATTRIBUTE_UNUSED = cache_entry->crack.M.MB = EXTRACTED32(instruction, 21, 25); /* default in icache - extraction */
#line 3231 "../../../sim/ppc/powerpc.igen"
    unsigned const ME ATTRIBUTE_UNUSED = cache_entry->crack.M.ME = EXTRACTED32(instruction, 26, 30); /* default in icache - extraction */
#line 3231 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 15558 "icache.c"

#define insn cache_entry->crack.M.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Rotate_Left_Word_Immediate_then_Mask_Insert_Rc1;

    /* semantic routine */
#line 3231 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Rotate Left Word Immediate then Mask Insert\n"));
#line 15568 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Rotate_Left_Word_Immediate_then_Mask_Insert, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3231 "../../../sim/ppc/powerpc.igen"
    {
      long n = SH;
      uint32_t r = ROTL32(*rS, n);
      uint32_t m = MASK(MB+32, ME+32);
      signed_word result = (r & m) | (*rA & ~m);
      *rA = result;
      ITRACE(trace_alu, (": n=%ld *rS=0x%lx r=0x%lx m=0x%lx result=0x%lx\n",
                         n, (unsigned long)*rS, (unsigned long)r, (unsigned long)m,
      		   (unsigned long)result));
      CR0_COMPARE(result, 0, Rc);
      PPC_INSN_INT(RA_BITMASK, RS_BITMASK, Rc);
    }
#line 15590 "icache.c"
    return nia;
    /* extraction: 0.20,6.RS,11.RA,16.SH,21.MB,26.ME,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 15594 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Rotate_Left_Word_Immediate_then_AND_with_Mask_Rc0(cpu *processor,
                                                         instruction_word instruction,
                                                         unsigned_word cia,
                                                         idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Rotate_Left_Word_Immediate_then_AND_with_Mask
#undef MY_PREFIX
#define MY_PREFIX Rotate_Left_Word_Immediate_then_AND_with_Mask_Rc0
#line 3178 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Rotate Left Word Immediate then AND with Mask\n"));
#line 15613 "icache.c"

  /* validate: 0.21,6.RS,11.RA,16.SH,21.MB,26.ME,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x54000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.21,6.RS,11.RA,16.SH,21.MB,26.ME,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 43 "../../../sim/ppc/powerpc.igen"
    unsigned const RS ATTRIBUTE_UNUSED = cache_entry->crack.M.RS = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 44 "../../../sim/ppc/powerpc.igen"
    signed_word * const rS ATTRIBUTE_UNUSED = cache_entry->crack.M.rS = (cpu_registers(processor)->gpr + RS); /* in icache - extraction */
#line 45 "../../../sim/ppc/powerpc.igen"
    uint32_t const RS_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.M.RS_BITMASK = (1 << RS); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.M.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.M.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.M.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 3178 "../../../sim/ppc/powerpc.igen"
    unsigned const SH ATTRIBUTE_UNUSED = cache_entry->crack.M.SH = EXTRACTED32(instruction, 16, 20); /* default in icache - extraction */
#line 3178 "../../../sim/ppc/powerpc.igen"
    unsigned const MB ATTRIBUTE_UNUSED = cache_entry->crack.M.MB = EXTRACTED32(instruction, 21, 25); /* default in icache - extraction */
#line 3178 "../../../sim/ppc/powerpc.igen"
    unsigned const ME ATTRIBUTE_UNUSED = cache_entry->crack.M.ME = EXTRACTED32(instruction, 26, 30); /* default in icache - extraction */
#line 3178 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 15643 "icache.c"

#define insn cache_entry->crack.M.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Rotate_Left_Word_Immediate_then_AND_with_Mask_Rc0;

    /* semantic routine */
#line 3178 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Rotate Left Word Immediate then AND with Mask\n"));
#line 15653 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Rotate_Left_Word_Immediate_then_AND_with_Mask, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3178 "../../../sim/ppc/powerpc.igen"
    {
      long n = SH;
      uint32_t s = *rS;
      uint32_t r = ROTL32(s, n);
      uint32_t m = MASK(MB+32, ME+32);
      signed_word result = r & m;
      *rA = result;
      CR0_COMPARE(result, 0, Rc);
      ITRACE(trace_alu,
             ("n=%ld, s=0x%lx, r=0x%lx, m=0x%lx, result=0x%lx, cr=0x%lx\n",
              n, (unsigned long)s, (unsigned long)r, (unsigned long)m,
      	(unsigned long)result, (unsigned long)CR));
      PPC_INSN_INT(RA_BITMASK, RS_BITMASK, Rc);
    }
#line 15677 "icache.c"
    return nia;
    /* extraction: 0.21,6.RS,11.RA,16.SH,21.MB,26.ME,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 15681 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Rotate_Left_Word_Immediate_then_AND_with_Mask_Rc1(cpu *processor,
                                                         instruction_word instruction,
                                                         unsigned_word cia,
                                                         idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Rotate_Left_Word_Immediate_then_AND_with_Mask
#undef MY_PREFIX
#define MY_PREFIX Rotate_Left_Word_Immediate_then_AND_with_Mask_Rc1
#line 3178 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Rotate Left Word Immediate then AND with Mask\n"));
#line 15700 "icache.c"

  /* validate: 0.21,6.RS,11.RA,16.SH,21.MB,26.ME,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x54000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.21,6.RS,11.RA,16.SH,21.MB,26.ME,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 43 "../../../sim/ppc/powerpc.igen"
    unsigned const RS ATTRIBUTE_UNUSED = cache_entry->crack.M.RS = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 44 "../../../sim/ppc/powerpc.igen"
    signed_word * const rS ATTRIBUTE_UNUSED = cache_entry->crack.M.rS = (cpu_registers(processor)->gpr + RS); /* in icache - extraction */
#line 45 "../../../sim/ppc/powerpc.igen"
    uint32_t const RS_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.M.RS_BITMASK = (1 << RS); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.M.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.M.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.M.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 3178 "../../../sim/ppc/powerpc.igen"
    unsigned const SH ATTRIBUTE_UNUSED = cache_entry->crack.M.SH = EXTRACTED32(instruction, 16, 20); /* default in icache - extraction */
#line 3178 "../../../sim/ppc/powerpc.igen"
    unsigned const MB ATTRIBUTE_UNUSED = cache_entry->crack.M.MB = EXTRACTED32(instruction, 21, 25); /* default in icache - extraction */
#line 3178 "../../../sim/ppc/powerpc.igen"
    unsigned const ME ATTRIBUTE_UNUSED = cache_entry->crack.M.ME = EXTRACTED32(instruction, 26, 30); /* default in icache - extraction */
#line 3178 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 15730 "icache.c"

#define insn cache_entry->crack.M.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Rotate_Left_Word_Immediate_then_AND_with_Mask_Rc1;

    /* semantic routine */
#line 3178 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Rotate Left Word Immediate then AND with Mask\n"));
#line 15740 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Rotate_Left_Word_Immediate_then_AND_with_Mask, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3178 "../../../sim/ppc/powerpc.igen"
    {
      long n = SH;
      uint32_t s = *rS;
      uint32_t r = ROTL32(s, n);
      uint32_t m = MASK(MB+32, ME+32);
      signed_word result = r & m;
      *rA = result;
      CR0_COMPARE(result, 0, Rc);
      ITRACE(trace_alu,
             ("n=%ld, s=0x%lx, r=0x%lx, m=0x%lx, result=0x%lx, cr=0x%lx\n",
              n, (unsigned long)s, (unsigned long)r, (unsigned long)m,
      	(unsigned long)result, (unsigned long)CR));
      PPC_INSN_INT(RA_BITMASK, RS_BITMASK, Rc);
    }
#line 15764 "icache.c"
    return nia;
    /* extraction: 0.21,6.RS,11.RA,16.SH,21.MB,26.ME,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 15768 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Rotate_Left_Word_then_AND_with_Mask_Rc0(cpu *processor,
                                               instruction_word instruction,
                                               unsigned_word cia,
                                               idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Rotate_Left_Word_then_AND_with_Mask
#undef MY_PREFIX
#define MY_PREFIX Rotate_Left_Word_then_AND_with_Mask_Rc0
#line 3210 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Rotate Left Word then AND with Mask\n"));
#line 15787 "icache.c"

  /* validate: 0.23,6.RS,11.RA,16.RB,21.MB,26.ME,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x5c000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.23,6.RS,11.RA,16.RB,21.MB,26.ME,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 43 "../../../sim/ppc/powerpc.igen"
    unsigned const RS ATTRIBUTE_UNUSED = cache_entry->crack.M.RS = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 44 "../../../sim/ppc/powerpc.igen"
    signed_word * const rS ATTRIBUTE_UNUSED = cache_entry->crack.M.rS = (cpu_registers(processor)->gpr + RS); /* in icache - extraction */
#line 45 "../../../sim/ppc/powerpc.igen"
    uint32_t const RS_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.M.RS_BITMASK = (1 << RS); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.M.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.M.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.M.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.M.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.M.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.M.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 3210 "../../../sim/ppc/powerpc.igen"
    unsigned const MB ATTRIBUTE_UNUSED = cache_entry->crack.M.MB = EXTRACTED32(instruction, 21, 25); /* default in icache - extraction */
#line 3210 "../../../sim/ppc/powerpc.igen"
    unsigned const ME ATTRIBUTE_UNUSED = cache_entry->crack.M.ME = EXTRACTED32(instruction, 26, 30); /* default in icache - extraction */
#line 3210 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 15821 "icache.c"

#define insn cache_entry->crack.M.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Rotate_Left_Word_then_AND_with_Mask_Rc0;

    /* semantic routine */
#line 3210 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Rotate Left Word then AND with Mask\n"));
#line 15831 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Rotate_Left_Word_then_AND_with_Mask, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3210 "../../../sim/ppc/powerpc.igen"
    {
      long n = MASKED(*rB, 59, 63);
      uint32_t r = ROTL32(*rS, n);
      uint32_t m = MASK(MB+32, ME+32);
      signed_word result = r & m;
      *rA = result;
      CR0_COMPARE(result, 0, Rc);
    }
#line 15849 "icache.c"
    return nia;
    /* extraction: 0.23,6.RS,11.RA,16.RB,21.MB,26.ME,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 15853 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Rotate_Left_Word_then_AND_with_Mask_Rc1(cpu *processor,
                                               instruction_word instruction,
                                               unsigned_word cia,
                                               idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Rotate_Left_Word_then_AND_with_Mask
#undef MY_PREFIX
#define MY_PREFIX Rotate_Left_Word_then_AND_with_Mask_Rc1
#line 3210 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Rotate Left Word then AND with Mask\n"));
#line 15872 "icache.c"

  /* validate: 0.23,6.RS,11.RA,16.RB,21.MB,26.ME,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x5c000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.23,6.RS,11.RA,16.RB,21.MB,26.ME,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 43 "../../../sim/ppc/powerpc.igen"
    unsigned const RS ATTRIBUTE_UNUSED = cache_entry->crack.M.RS = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 44 "../../../sim/ppc/powerpc.igen"
    signed_word * const rS ATTRIBUTE_UNUSED = cache_entry->crack.M.rS = (cpu_registers(processor)->gpr + RS); /* in icache - extraction */
#line 45 "../../../sim/ppc/powerpc.igen"
    uint32_t const RS_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.M.RS_BITMASK = (1 << RS); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.M.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.M.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.M.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.M.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.M.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.M.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 3210 "../../../sim/ppc/powerpc.igen"
    unsigned const MB ATTRIBUTE_UNUSED = cache_entry->crack.M.MB = EXTRACTED32(instruction, 21, 25); /* default in icache - extraction */
#line 3210 "../../../sim/ppc/powerpc.igen"
    unsigned const ME ATTRIBUTE_UNUSED = cache_entry->crack.M.ME = EXTRACTED32(instruction, 26, 30); /* default in icache - extraction */
#line 3210 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 15906 "icache.c"

#define insn cache_entry->crack.M.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Rotate_Left_Word_then_AND_with_Mask_Rc1;

    /* semantic routine */
#line 3210 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Rotate Left Word then AND with Mask\n"));
#line 15916 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Rotate_Left_Word_then_AND_with_Mask, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3210 "../../../sim/ppc/powerpc.igen"
    {
      long n = MASKED(*rB, 59, 63);
      uint32_t r = ROTL32(*rS, n);
      uint32_t m = MASK(MB+32, ME+32);
      signed_word result = r & m;
      *rA = result;
      CR0_COMPARE(result, 0, Rc);
    }
#line 15934 "icache.c"
    return nia;
    /* extraction: 0.23,6.RS,11.RA,16.RB,21.MB,26.ME,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 15938 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_OR_Immediate(cpu *processor,
                    instruction_word instruction,
                    unsigned_word cia,
                    idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_OR_Immediate
#undef MY_PREFIX
#define MY_PREFIX OR_Immediate
#line 2974 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode OR Immediate\n"));
#line 15957 "icache.c"

  /* validate: 0.24,6.RS,11.RA,16.UI */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x60000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.24,6.RS,11.RA,16.UI #define get-values-from-icache|put-values-in-icache */
#line 43 "../../../sim/ppc/powerpc.igen"
    unsigned const RS ATTRIBUTE_UNUSED = cache_entry->crack.D.RS = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 44 "../../../sim/ppc/powerpc.igen"
    signed_word * const rS ATTRIBUTE_UNUSED = cache_entry->crack.D.rS = (cpu_registers(processor)->gpr + RS); /* in icache - extraction */
#line 45 "../../../sim/ppc/powerpc.igen"
    uint32_t const RS_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.RS_BITMASK = (1 << RS); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.D.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.D.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 2974 "../../../sim/ppc/powerpc.igen"
    unsigned const UI ATTRIBUTE_UNUSED = cache_entry->crack.D.UI = EXTRACTED32(instruction, 16, 31); /* default in icache - extraction */
#line 15981 "icache.c"

#define insn cache_entry->crack.D.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_OR_Immediate;

    /* semantic routine */
#line 2974 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics OR Immediate\n"));
#line 15991 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_OR_Immediate, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2974 "../../../sim/ppc/powerpc.igen"
    {
      *rA = *rS | UI;
      ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
      PPC_INSN_INT(RA_BITMASK, RS_BITMASK, 0/*Rc*/);
    }
#line 16006 "icache.c"
    return nia;
    /* extraction: 0.24,6.RS,11.RA,16.UI #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 16010 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_OR_Immediate_Shifted(cpu *processor,
                            instruction_word instruction,
                            unsigned_word cia,
                            idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_OR_Immediate_Shifted
#undef MY_PREFIX
#define MY_PREFIX OR_Immediate_Shifted
#line 2983 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode OR Immediate Shifted\n"));
#line 16029 "icache.c"

  /* validate: 0.25,6.RS,11.RA,16.UI */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x64000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.25,6.RS,11.RA,16.UI #define get-values-from-icache|put-values-in-icache */
#line 43 "../../../sim/ppc/powerpc.igen"
    unsigned const RS ATTRIBUTE_UNUSED = cache_entry->crack.D.RS = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 44 "../../../sim/ppc/powerpc.igen"
    signed_word * const rS ATTRIBUTE_UNUSED = cache_entry->crack.D.rS = (cpu_registers(processor)->gpr + RS); /* in icache - extraction */
#line 45 "../../../sim/ppc/powerpc.igen"
    uint32_t const RS_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.RS_BITMASK = (1 << RS); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.D.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.D.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 2983 "../../../sim/ppc/powerpc.igen"
    unsigned const UI ATTRIBUTE_UNUSED = cache_entry->crack.D.UI = EXTRACTED32(instruction, 16, 31); /* default in icache - extraction */
#line 16053 "icache.c"

#define insn cache_entry->crack.D.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_OR_Immediate_Shifted;

    /* semantic routine */
#line 2983 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics OR Immediate Shifted\n"));
#line 16063 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_OR_Immediate_Shifted, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2983 "../../../sim/ppc/powerpc.igen"
    {
      *rA = *rS | (UI << 16);
      ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
      PPC_INSN_INT(RA_BITMASK, RS_BITMASK, 0/*Rc*/);
    }
#line 16078 "icache.c"
    return nia;
    /* extraction: 0.25,6.RS,11.RA,16.UI #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 16082 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_XOR_Immediate(cpu *processor,
                     instruction_word instruction,
                     unsigned_word cia,
                     idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_XOR_Immediate
#undef MY_PREFIX
#define MY_PREFIX XOR_Immediate
#line 2992 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode XOR Immediate\n"));
#line 16101 "icache.c"

  /* validate: 0.26,6.RS,11.RA,16.UI */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x68000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.26,6.RS,11.RA,16.UI #define get-values-from-icache|put-values-in-icache */
#line 43 "../../../sim/ppc/powerpc.igen"
    unsigned const RS ATTRIBUTE_UNUSED = cache_entry->crack.D.RS = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 44 "../../../sim/ppc/powerpc.igen"
    signed_word * const rS ATTRIBUTE_UNUSED = cache_entry->crack.D.rS = (cpu_registers(processor)->gpr + RS); /* in icache - extraction */
#line 45 "../../../sim/ppc/powerpc.igen"
    uint32_t const RS_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.RS_BITMASK = (1 << RS); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.D.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.D.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 2992 "../../../sim/ppc/powerpc.igen"
    unsigned const UI ATTRIBUTE_UNUSED = cache_entry->crack.D.UI = EXTRACTED32(instruction, 16, 31); /* default in icache - extraction */
#line 16125 "icache.c"

#define insn cache_entry->crack.D.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_XOR_Immediate;

    /* semantic routine */
#line 2992 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics XOR Immediate\n"));
#line 16135 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_XOR_Immediate, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2992 "../../../sim/ppc/powerpc.igen"
    {
      *rA = *rS ^ UI;
      ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
      PPC_INSN_INT(RA_BITMASK, RS_BITMASK, 0/*Rc*/);
    }
#line 16150 "icache.c"
    return nia;
    /* extraction: 0.26,6.RS,11.RA,16.UI #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 16154 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_XOR_Immediate_Shifted(cpu *processor,
                             instruction_word instruction,
                             unsigned_word cia,
                             idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_XOR_Immediate_Shifted
#undef MY_PREFIX
#define MY_PREFIX XOR_Immediate_Shifted
#line 3001 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode XOR Immediate Shifted\n"));
#line 16173 "icache.c"

  /* validate: 0.27,6.RS,11.RA,16.UI */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x6c000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.27,6.RS,11.RA,16.UI #define get-values-from-icache|put-values-in-icache */
#line 43 "../../../sim/ppc/powerpc.igen"
    unsigned const RS ATTRIBUTE_UNUSED = cache_entry->crack.D.RS = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 44 "../../../sim/ppc/powerpc.igen"
    signed_word * const rS ATTRIBUTE_UNUSED = cache_entry->crack.D.rS = (cpu_registers(processor)->gpr + RS); /* in icache - extraction */
#line 45 "../../../sim/ppc/powerpc.igen"
    uint32_t const RS_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.RS_BITMASK = (1 << RS); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.D.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.D.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 3001 "../../../sim/ppc/powerpc.igen"
    unsigned const UI ATTRIBUTE_UNUSED = cache_entry->crack.D.UI = EXTRACTED32(instruction, 16, 31); /* default in icache - extraction */
#line 16197 "icache.c"

#define insn cache_entry->crack.D.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_XOR_Immediate_Shifted;

    /* semantic routine */
#line 3001 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics XOR Immediate Shifted\n"));
#line 16207 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_XOR_Immediate_Shifted, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3001 "../../../sim/ppc/powerpc.igen"
    {
      *rA = *rS ^ (UI << 16);
      ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
      PPC_INSN_INT(RA_BITMASK, RS_BITMASK, 0/*Rc*/);
    }
#line 16222 "icache.c"
    return nia;
    /* extraction: 0.27,6.RS,11.RA,16.UI #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 16226 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_AND_Immediate(cpu *processor,
                     instruction_word instruction,
                     unsigned_word cia,
                     idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_AND_Immediate
#undef MY_PREFIX
#define MY_PREFIX AND_Immediate
#line 2954 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode AND Immediate\n"));
#line 16245 "icache.c"

  /* validate: 0.28,6.RS,11.RA,16.UI */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x70000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.28,6.RS,11.RA,16.UI #define get-values-from-icache|put-values-in-icache */
#line 43 "../../../sim/ppc/powerpc.igen"
    unsigned const RS ATTRIBUTE_UNUSED = cache_entry->crack.D.RS = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 44 "../../../sim/ppc/powerpc.igen"
    signed_word * const rS ATTRIBUTE_UNUSED = cache_entry->crack.D.rS = (cpu_registers(processor)->gpr + RS); /* in icache - extraction */
#line 45 "../../../sim/ppc/powerpc.igen"
    uint32_t const RS_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.RS_BITMASK = (1 << RS); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.D.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.D.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 2954 "../../../sim/ppc/powerpc.igen"
    unsigned const UI ATTRIBUTE_UNUSED = cache_entry->crack.D.UI = EXTRACTED32(instruction, 16, 31); /* default in icache - extraction */
#line 16269 "icache.c"

#define insn cache_entry->crack.D.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_AND_Immediate;

    /* semantic routine */
#line 2954 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics AND Immediate\n"));
#line 16279 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_AND_Immediate, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2954 "../../../sim/ppc/powerpc.igen"
    {
      *rA = *rS & UI;
      CR0_COMPARE(*rA, 0, 1/*Rc*/);
      ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
      PPC_INSN_INT(RA_BITMASK, RS_BITMASK, 1/*Rc*/);
    }
#line 16295 "icache.c"
    return nia;
    /* extraction: 0.28,6.RS,11.RA,16.UI #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 16299 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_AND_Immediate_Shifted(cpu *processor,
                             instruction_word instruction,
                             unsigned_word cia,
                             idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_AND_Immediate_Shifted
#undef MY_PREFIX
#define MY_PREFIX AND_Immediate_Shifted
#line 2964 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode AND Immediate Shifted\n"));
#line 16318 "icache.c"

  /* validate: 0.29,6.RS,11.RA,16.UI */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x74000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.29,6.RS,11.RA,16.UI #define get-values-from-icache|put-values-in-icache */
#line 43 "../../../sim/ppc/powerpc.igen"
    unsigned const RS ATTRIBUTE_UNUSED = cache_entry->crack.D.RS = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 44 "../../../sim/ppc/powerpc.igen"
    signed_word * const rS ATTRIBUTE_UNUSED = cache_entry->crack.D.rS = (cpu_registers(processor)->gpr + RS); /* in icache - extraction */
#line 45 "../../../sim/ppc/powerpc.igen"
    uint32_t const RS_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.RS_BITMASK = (1 << RS); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.D.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.D.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 2964 "../../../sim/ppc/powerpc.igen"
    unsigned const UI ATTRIBUTE_UNUSED = cache_entry->crack.D.UI = EXTRACTED32(instruction, 16, 31); /* default in icache - extraction */
#line 16342 "icache.c"

#define insn cache_entry->crack.D.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_AND_Immediate_Shifted;

    /* semantic routine */
#line 2964 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics AND Immediate Shifted\n"));
#line 16352 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_AND_Immediate_Shifted, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2964 "../../../sim/ppc/powerpc.igen"
    {
      *rA = *rS & (UI << 16);
      CR0_COMPARE(*rA, 0, 1/*Rc*/);
      ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
      PPC_INSN_INT(RA_BITMASK, RS_BITMASK, 1/*Rc*/);
    }
#line 16368 "icache.c"
    return nia;
    /* extraction: 0.29,6.RS,11.RA,16.UI #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 16372 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Compare(cpu *processor,
               instruction_word instruction,
               unsigned_word cia,
               idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Compare
#undef MY_PREFIX
#define MY_PREFIX Compare
#line 2810 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Compare\n"));
#line 16391 "icache.c"

  /* validate: 0.31,6.BF,9./,10.L,11.RA,16.RB,21.0,31./ */
  if (WITH_RESERVED_BITS && (instruction & 0xfc4007ff) != 0x7c000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.BF,9./,10.L,11.RA,16.RB,21.0,31./ #define get-values-from-icache|put-values-in-icache */
#line 67 "../../../sim/ppc/powerpc.igen"
    unsigned const BF ATTRIBUTE_UNUSED = cache_entry->crack.X.BF = EXTRACTED32(instruction, 6, 8); /* in icache - extraction */
#line 68 "../../../sim/ppc/powerpc.igen"
    uint32_t const BF_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.BF_BITMASK = (1 << BF); /* in icache - extraction */
#line 2810 "../../../sim/ppc/powerpc.igen"
    unsigned const L ATTRIBUTE_UNUSED = cache_entry->crack.X.L = EXTRACTED32(instruction, 10, 10); /* default in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.X.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.X.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.X.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.X.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 16419 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Compare;

    /* semantic routine */
#line 2810 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Compare\n"));
#line 16429 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Compare, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2810 "../../../sim/ppc/powerpc.igen"
    {
      if (!is_64bit_mode && L)
        program_interrupt(processor, cia,
                          illegal_instruction_program_interrupt);
      else {
        signed_word a;
        signed_word b;
        if (L == 0) {
          a = EXTENDED(*rA);
          b = EXTENDED(*rB);
        }
        else {
          a = *rA;
          b = *rB;
        }
        CR_COMPARE(BF, a, b);
      }
      PPC_INSN_INT_CR(0, RA_BITMASK | RB_BITMASK, BF_BITMASK);
    }
#line 16458 "icache.c"
    return nia;
    /* extraction: 0.31,6.BF,9./,10.L,11.RA,16.RB,21.0,31./ #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 16462 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Trap_Word(cpu *processor,
                 instruction_word instruction,
                 unsigned_word cia,
                 idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Trap_Word
#undef MY_PREFIX
#define MY_PREFIX Trap_Word
#line 2930 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Trap Word\n"));
#line 16481 "icache.c"

  /* validate: 0.31,6.TO,11.RA,16.RB,21.4,31./ */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007ff) != 0x7c000008)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.TO,11.RA,16.RB,21.4,31./ #define get-values-from-icache|put-values-in-icache */
#line 2930 "../../../sim/ppc/powerpc.igen"
    unsigned const TO ATTRIBUTE_UNUSED = cache_entry->crack.X.TO = EXTRACTED32(instruction, 6, 10); /* default in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.X.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.X.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.X.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.X.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 16505 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Trap_Word;

    /* semantic routine */
#line 2930 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Trap Word\n"));
#line 16515 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Trap_Word, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2930 "../../../sim/ppc/powerpc.igen"
    {
      signed_word a = EXTENDED(*rA);
      signed_word b = EXTENDED(*rB);
      if (TO == 12 && rA == rB) {
        ITRACE(trace_breakpoint, ("breakpoint\n"));
        cpu_halt(processor, cia, was_trap, 0);
      }
      else if ((a < b && TO_0_)
          || (a > b && TO_1_)
          || (a == b && TO_2_)
          || ((unsigned_word)a < (unsigned_word)b && TO_3_)
          || ((unsigned_word)a > (unsigned_word)b && TO_4_)
          )
        program_interrupt(processor, cia,
                          trap_program_interrupt);
    }
#line 16541 "icache.c"
    return nia;
    /* extraction: 0.31,6.TO,11.RA,16.RB,21.4,31./ #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 16545 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Subtract_From_Carrying_OE0_Rc0(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Subtract_From_Carrying
#undef MY_PREFIX
#define MY_PREFIX Subtract_From_Carrying_OE0_Rc0
#line 2596 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Subtract From Carrying\n"));
#line 16564 "icache.c"

  /* validate: 0.31,6.RT,11.RA,16.RB,21.OE,22.8,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0003fe) != 0x7c000010)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.8,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.XO.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.XO.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.XO.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 2596 "../../../sim/ppc/powerpc.igen"
    unsigned const OE ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 2596 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 16596 "icache.c"

#define insn cache_entry->crack.XO.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Subtract_From_Carrying_OE0_Rc0;

    /* semantic routine */
#line 2596 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Subtract From Carrying\n"));
#line 16606 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Subtract_From_Carrying, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2596 "../../../sim/ppc/powerpc.igen"
    {
      /* RT <- ~RA + RB + 1 === RT <- RB - RA */
      ALU_BEGIN(*rA);
      ALU_NOT;
      ALU_ADD(*rB);
      ALU_ADD(1);
      ALU_END(*rT, 1/*CA*/, OE, Rc);
      PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
    }
#line 16625 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.8,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 16629 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Subtract_From_Carrying_OE0_Rc1(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Subtract_From_Carrying
#undef MY_PREFIX
#define MY_PREFIX Subtract_From_Carrying_OE0_Rc1
#line 2596 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Subtract From Carrying\n"));
#line 16648 "icache.c"

  /* validate: 0.31,6.RT,11.RA,16.RB,21.OE,22.8,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0003fe) != 0x7c000010)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.8,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.XO.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.XO.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.XO.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 2596 "../../../sim/ppc/powerpc.igen"
    unsigned const OE ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 2596 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 16680 "icache.c"

#define insn cache_entry->crack.XO.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Subtract_From_Carrying_OE0_Rc1;

    /* semantic routine */
#line 2596 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Subtract From Carrying\n"));
#line 16690 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Subtract_From_Carrying, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2596 "../../../sim/ppc/powerpc.igen"
    {
      /* RT <- ~RA + RB + 1 === RT <- RB - RA */
      ALU_BEGIN(*rA);
      ALU_NOT;
      ALU_ADD(*rB);
      ALU_ADD(1);
      ALU_END(*rT, 1/*CA*/, OE, Rc);
      PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
    }
#line 16709 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.8,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 16713 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Add_Carrying_OE0_Rc0(cpu *processor,
                            instruction_word instruction,
                            unsigned_word cia,
                            idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Add_Carrying
#undef MY_PREFIX
#define MY_PREFIX Add_Carrying_OE0_Rc0
#line 2586 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Add Carrying\n"));
#line 16732 "icache.c"

  /* validate: 0.31,6.RT,11.RA,16.RB,21.OE,22.10,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0003fe) != 0x7c000014)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.10,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.XO.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.XO.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.XO.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 2586 "../../../sim/ppc/powerpc.igen"
    unsigned const OE ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 2586 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 16764 "icache.c"

#define insn cache_entry->crack.XO.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Add_Carrying_OE0_Rc0;

    /* semantic routine */
#line 2586 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Add Carrying\n"));
#line 16774 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Add_Carrying, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2586 "../../../sim/ppc/powerpc.igen"
    {
      ALU_BEGIN(*rA);
      ALU_ADD(*rB);
      ALU_END(*rT, 1/*CA*/, OE, Rc);
      PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
    }
#line 16790 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.10,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 16794 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Add_Carrying_OE0_Rc1(cpu *processor,
                            instruction_word instruction,
                            unsigned_word cia,
                            idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Add_Carrying
#undef MY_PREFIX
#define MY_PREFIX Add_Carrying_OE0_Rc1
#line 2586 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Add Carrying\n"));
#line 16813 "icache.c"

  /* validate: 0.31,6.RT,11.RA,16.RB,21.OE,22.10,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0003fe) != 0x7c000014)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.10,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.XO.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.XO.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.XO.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 2586 "../../../sim/ppc/powerpc.igen"
    unsigned const OE ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 2586 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 16845 "icache.c"

#define insn cache_entry->crack.XO.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Add_Carrying_OE0_Rc1;

    /* semantic routine */
#line 2586 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Add Carrying\n"));
#line 16855 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Add_Carrying, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2586 "../../../sim/ppc/powerpc.igen"
    {
      ALU_BEGIN(*rA);
      ALU_ADD(*rB);
      ALU_END(*rT, 1/*CA*/, OE, Rc);
      PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
    }
#line 16871 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.10,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 16875 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Multiply_High_Word_Unsigned_Rc0(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Multiply_High_Word_Unsigned
#undef MY_PREFIX
#define MY_PREFIX Multiply_High_Word_Unsigned_Rc0
#line 2730 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Multiply High Word Unsigned\n"));
#line 16894 "icache.c"

  /* validate: 0.31,6.RT,11.RA,16.RB,21./,22.11,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007fe) != 0x7c000016)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21./,22.11,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.XO.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.XO.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.XO.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 2730 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 16924 "icache.c"

#define insn cache_entry->crack.XO.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Multiply_High_Word_Unsigned_Rc0;

    /* semantic routine */
#line 2730 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Multiply High Word Unsigned\n"));
#line 16934 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Multiply_High_Word_Unsigned, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2730 "../../../sim/ppc/powerpc.igen"
    {
      uint64_t a = (uint32_t)(*rA);
      uint64_t b = (uint32_t)(*rB);
      uint64_t prod = a * b;
      signed_word t = EXTRACTED64(prod, 0, 31);
      *rT = t;
      CR0_COMPARE(t, 0, Rc);
      PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
    }
#line 16953 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21./,22.11,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 16957 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Multiply_High_Word_Unsigned_Rc1(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Multiply_High_Word_Unsigned
#undef MY_PREFIX
#define MY_PREFIX Multiply_High_Word_Unsigned_Rc1
#line 2730 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Multiply High Word Unsigned\n"));
#line 16976 "icache.c"

  /* validate: 0.31,6.RT,11.RA,16.RB,21./,22.11,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007fe) != 0x7c000016)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21./,22.11,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.XO.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.XO.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.XO.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 2730 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 17006 "icache.c"

#define insn cache_entry->crack.XO.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Multiply_High_Word_Unsigned_Rc1;

    /* semantic routine */
#line 2730 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Multiply High Word Unsigned\n"));
#line 17016 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Multiply_High_Word_Unsigned, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2730 "../../../sim/ppc/powerpc.igen"
    {
      uint64_t a = (uint32_t)(*rA);
      uint64_t b = (uint32_t)(*rB);
      uint64_t prod = a * b;
      signed_word t = EXTRACTED64(prod, 0, 31);
      *rT = t;
      CR0_COMPARE(t, 0, Rc);
      PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
    }
#line 17035 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21./,22.11,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 17039 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Move_From_Condition_Register(cpu *processor,
                                    instruction_word instruction,
                                    unsigned_word cia,
                                    idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Move_From_Condition_Register
#undef MY_PREFIX
#define MY_PREFIX Move_From_Condition_Register
#line 3452 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Move From Condition Register\n"));
#line 17058 "icache.c"

  /* validate: 0.31,6.RT,11./,16./,21.19,31./ */
  if (WITH_RESERVED_BITS && (instruction & 0xfc1fffff) != 0x7c000026)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11./,16./,21.19,31./ #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.X.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.X.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 17073 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Move_From_Condition_Register;

    /* semantic routine */
#line 3452 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Move From Condition Register\n"));
#line 17083 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Move_From_Condition_Register, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3452 "../../../sim/ppc/powerpc.igen"
    {
      *rT = (uint32_t)CR;
      PPC_INSN_MFCR(RT_BITMASK);
    }
#line 17097 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11./,16./,21.19,31./ #undef get-values-from-icache|put-values-in-icache */
#line 17100 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Load_Word_And_Reserve_Indexed(cpu *processor,
                                     instruction_word instruction,
                                     unsigned_word cia,
                                     idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_Word_And_Reserve_Indexed
#undef MY_PREFIX
#define MY_PREFIX Load_Word_And_Reserve_Indexed
#line 2422 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Load Word And Reserve Indexed\n"));
#line 17119 "icache.c"

  /* validate: 0.31,6.RT,11.RA,16.RB,21.20,31./ */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007ff) != 0x7c000028)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.20,31./ #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.X.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.X.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.X.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.X.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.X.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.X.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 17147 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Load_Word_And_Reserve_Indexed;

    /* semantic routine */
#line 2422 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Load Word And Reserve Indexed\n"));
#line 17157 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Load_Word_And_Reserve_Indexed, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2422 "../../../sim/ppc/powerpc.igen"
    {
      unsigned_word b;
      unsigned_word EA;
      if (RA_is_0) b = 0;
      else         b = *rA;
      EA = b + *rB;
      RESERVE = 1;
      RESERVE_ADDR = real_addr(EA, 1/*is-read?*/);
      RESERVE_DATA = MEM(unsigned, EA, 4);
      *rT = RESERVE_DATA;
      PPC_INSN_INT(RT_BITMASK, (RA_BITMASK & ~1) | RB_BITMASK, 0);
    }
#line 17179 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.20,31./ #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 17183 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Load_Word_and_Zero_Indexed(cpu *processor,
                                  instruction_word instruction,
                                  unsigned_word cia,
                                  idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_Word_and_Zero_Indexed
#undef MY_PREFIX
#define MY_PREFIX Load_Word_and_Zero_Indexed
#line 1898 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Load Word and Zero Indexed\n"));
#line 17202 "icache.c"

  /* validate: 0.31,6.RT,11.RA,16.RB,21.23,31./ */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007ff) != 0x7c00002e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.23,31./ #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.X.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.X.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.X.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.X.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.X.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.X.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 17230 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Load_Word_and_Zero_Indexed;

    /* semantic routine */
#line 1898 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Load Word and Zero Indexed\n"));
#line 17240 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Load_Word_and_Zero_Indexed, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1898 "../../../sim/ppc/powerpc.igen"
    {
      unsigned_word b;
      unsigned_word EA;
      if (RA_is_0) b = 0;
      else         b = *rA;
      EA = b + *rB;
      *rT = MEM(unsigned, EA, 4);
      PPC_INSN_INT(RT_BITMASK, (RA_BITMASK & ~1) | RB_BITMASK, 0);
    }
#line 17259 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.23,31./ #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 17263 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Shift_Left_Word_Rc0(cpu *processor,
                           instruction_word instruction,
                           unsigned_word cia,
                           idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Shift_Left_Word
#undef MY_PREFIX
#define MY_PREFIX Shift_Left_Word_Rc0
#line 3250 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Shift Left Word\n"));
#line 17282 "icache.c"

  /* validate: 0.31,6.RS,11.RA,16.RB,21.24,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007fe) != 0x7c000030)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RS,11.RA,16.RB,21.24,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 43 "../../../sim/ppc/powerpc.igen"
    unsigned const RS ATTRIBUTE_UNUSED = cache_entry->crack.X.RS = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 44 "../../../sim/ppc/powerpc.igen"
    signed_word * const rS ATTRIBUTE_UNUSED = cache_entry->crack.X.rS = (cpu_registers(processor)->gpr + RS); /* in icache - extraction */
#line 45 "../../../sim/ppc/powerpc.igen"
    uint32_t const RS_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RS_BITMASK = (1 << RS); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.X.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.X.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.X.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.X.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 3250 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 17312 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Shift_Left_Word_Rc0;

    /* semantic routine */
#line 3250 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Shift Left Word\n"));
#line 17322 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Shift_Left_Word, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3250 "../../../sim/ppc/powerpc.igen"
    {
      int n = MASKED(*rB, 58, 63);
      uint32_t source = *rS;
      signed_word shifted;
      if (n < 32)
        shifted = (source << n);
      else
        shifted = 0;
      *rA = shifted;
      CR0_COMPARE(shifted, 0, Rc);
      ITRACE(trace_alu,
             ("n=%d, source=0x%lx, shifted=0x%lx\n",
              n, (unsigned long)source, (unsigned long)shifted));
      PPC_INSN_INT(RA_BITMASK, RS_BITMASK, Rc);
    }
#line 17347 "icache.c"
    return nia;
    /* extraction: 0.31,6.RS,11.RA,16.RB,21.24,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 17351 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Shift_Left_Word_Rc1(cpu *processor,
                           instruction_word instruction,
                           unsigned_word cia,
                           idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Shift_Left_Word
#undef MY_PREFIX
#define MY_PREFIX Shift_Left_Word_Rc1
#line 3250 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Shift Left Word\n"));
#line 17370 "icache.c"

  /* validate: 0.31,6.RS,11.RA,16.RB,21.24,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007fe) != 0x7c000030)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RS,11.RA,16.RB,21.24,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 43 "../../../sim/ppc/powerpc.igen"
    unsigned const RS ATTRIBUTE_UNUSED = cache_entry->crack.X.RS = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 44 "../../../sim/ppc/powerpc.igen"
    signed_word * const rS ATTRIBUTE_UNUSED = cache_entry->crack.X.rS = (cpu_registers(processor)->gpr + RS); /* in icache - extraction */
#line 45 "../../../sim/ppc/powerpc.igen"
    uint32_t const RS_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RS_BITMASK = (1 << RS); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.X.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.X.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.X.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.X.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 3250 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 17400 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Shift_Left_Word_Rc1;

    /* semantic routine */
#line 3250 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Shift Left Word\n"));
#line 17410 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Shift_Left_Word, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3250 "../../../sim/ppc/powerpc.igen"
    {
      int n = MASKED(*rB, 58, 63);
      uint32_t source = *rS;
      signed_word shifted;
      if (n < 32)
        shifted = (source << n);
      else
        shifted = 0;
      *rA = shifted;
      CR0_COMPARE(shifted, 0, Rc);
      ITRACE(trace_alu,
             ("n=%d, source=0x%lx, shifted=0x%lx\n",
              n, (unsigned long)source, (unsigned long)shifted));
      PPC_INSN_INT(RA_BITMASK, RS_BITMASK, Rc);
    }
#line 17435 "icache.c"
    return nia;
    /* extraction: 0.31,6.RS,11.RA,16.RB,21.24,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 17439 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Count_Leading_Zeros_Word_Rc0(cpu *processor,
                                    instruction_word instruction,
                                    unsigned_word cia,
                                    idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Count_Leading_Zeros_Word
#undef MY_PREFIX
#define MY_PREFIX Count_Leading_Zeros_Word_Rc0
#line 3129 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Count Leading Zeros Word\n"));
#line 17458 "icache.c"

  /* validate: 0.31,6.RS,11.RA,16./,21.26,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00fffe) != 0x7c000034)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RS,11.RA,16./,21.26,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 43 "../../../sim/ppc/powerpc.igen"
    unsigned const RS ATTRIBUTE_UNUSED = cache_entry->crack.X.RS = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 44 "../../../sim/ppc/powerpc.igen"
    signed_word * const rS ATTRIBUTE_UNUSED = cache_entry->crack.X.rS = (cpu_registers(processor)->gpr + RS); /* in icache - extraction */
#line 45 "../../../sim/ppc/powerpc.igen"
    uint32_t const RS_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RS_BITMASK = (1 << RS); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.X.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.X.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 3129 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 17482 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Count_Leading_Zeros_Word_Rc0;

    /* semantic routine */
#line 3129 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Count Leading Zeros Word\n"));
#line 17492 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Count_Leading_Zeros_Word, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3129 "../../../sim/ppc/powerpc.igen"
    {
      int count = 0;
      uint32_t mask = BIT32(0);
      uint32_t source = *rS;
      while (!(source & mask) && mask != 0) {
        mask >>= 1;
        count++;
      }
      *rA = count;
      ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
      CR0_COMPARE(count, 0, Rc); /* FIXME - is this correct */
    }
#line 17514 "icache.c"
    return nia;
    /* extraction: 0.31,6.RS,11.RA,16./,21.26,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 17518 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Count_Leading_Zeros_Word_Rc1(cpu *processor,
                                    instruction_word instruction,
                                    unsigned_word cia,
                                    idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Count_Leading_Zeros_Word
#undef MY_PREFIX
#define MY_PREFIX Count_Leading_Zeros_Word_Rc1
#line 3129 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Count Leading Zeros Word\n"));
#line 17537 "icache.c"

  /* validate: 0.31,6.RS,11.RA,16./,21.26,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00fffe) != 0x7c000034)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RS,11.RA,16./,21.26,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 43 "../../../sim/ppc/powerpc.igen"
    unsigned const RS ATTRIBUTE_UNUSED = cache_entry->crack.X.RS = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 44 "../../../sim/ppc/powerpc.igen"
    signed_word * const rS ATTRIBUTE_UNUSED = cache_entry->crack.X.rS = (cpu_registers(processor)->gpr + RS); /* in icache - extraction */
#line 45 "../../../sim/ppc/powerpc.igen"
    uint32_t const RS_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RS_BITMASK = (1 << RS); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.X.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.X.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 3129 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 17561 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Count_Leading_Zeros_Word_Rc1;

    /* semantic routine */
#line 3129 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Count Leading Zeros Word\n"));
#line 17571 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Count_Leading_Zeros_Word, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3129 "../../../sim/ppc/powerpc.igen"
    {
      int count = 0;
      uint32_t mask = BIT32(0);
      uint32_t source = *rS;
      while (!(source & mask) && mask != 0) {
        mask >>= 1;
        count++;
      }
      *rA = count;
      ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
      CR0_COMPARE(count, 0, Rc); /* FIXME - is this correct */
    }
#line 17593 "icache.c"
    return nia;
    /* extraction: 0.31,6.RS,11.RA,16./,21.26,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 17597 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_AND_Rc0(cpu *processor,
               instruction_word instruction,
               unsigned_word cia,
               idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_AND
#undef MY_PREFIX
#define MY_PREFIX AND_Rc0
#line 3010 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode AND\n"));
#line 17616 "icache.c"

  /* validate: 0.31,6.RS,11.RA,16.RB,21.28,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007fe) != 0x7c000038)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RS,11.RA,16.RB,21.28,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 43 "../../../sim/ppc/powerpc.igen"
    unsigned const RS ATTRIBUTE_UNUSED = cache_entry->crack.X.RS = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 44 "../../../sim/ppc/powerpc.igen"
    signed_word * const rS ATTRIBUTE_UNUSED = cache_entry->crack.X.rS = (cpu_registers(processor)->gpr + RS); /* in icache - extraction */
#line 45 "../../../sim/ppc/powerpc.igen"
    uint32_t const RS_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RS_BITMASK = (1 << RS); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.X.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.X.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.X.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.X.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 3010 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 17646 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_AND_Rc0;

    /* semantic routine */
#line 3010 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics AND\n"));
#line 17656 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_AND, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3010 "../../../sim/ppc/powerpc.igen"
    {
      *rA = *rS & *rB;
      CR0_COMPARE(*rA, 0, Rc);
      ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
      PPC_INSN_INT(RA_BITMASK, RS_BITMASK | RB_BITMASK, Rc);
    }
#line 17672 "icache.c"
    return nia;
    /* extraction: 0.31,6.RS,11.RA,16.RB,21.28,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 17676 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_AND_Rc1(cpu *processor,
               instruction_word instruction,
               unsigned_word cia,
               idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_AND
#undef MY_PREFIX
#define MY_PREFIX AND_Rc1
#line 3010 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode AND\n"));
#line 17695 "icache.c"

  /* validate: 0.31,6.RS,11.RA,16.RB,21.28,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007fe) != 0x7c000038)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RS,11.RA,16.RB,21.28,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 43 "../../../sim/ppc/powerpc.igen"
    unsigned const RS ATTRIBUTE_UNUSED = cache_entry->crack.X.RS = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 44 "../../../sim/ppc/powerpc.igen"
    signed_word * const rS ATTRIBUTE_UNUSED = cache_entry->crack.X.rS = (cpu_registers(processor)->gpr + RS); /* in icache - extraction */
#line 45 "../../../sim/ppc/powerpc.igen"
    uint32_t const RS_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RS_BITMASK = (1 << RS); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.X.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.X.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.X.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.X.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 3010 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 17725 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_AND_Rc1;

    /* semantic routine */
#line 3010 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics AND\n"));
#line 17735 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_AND, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3010 "../../../sim/ppc/powerpc.igen"
    {
      *rA = *rS & *rB;
      CR0_COMPARE(*rA, 0, Rc);
      ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
      PPC_INSN_INT(RA_BITMASK, RS_BITMASK | RB_BITMASK, Rc);
    }
#line 17751 "icache.c"
    return nia;
    /* extraction: 0.31,6.RS,11.RA,16.RB,21.28,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 17755 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Compare_Logical(cpu *processor,
                       instruction_word instruction,
                       unsigned_word cia,
                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Compare_Logical
#undef MY_PREFIX
#define MY_PREFIX Compare_Logical
#line 2852 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Compare Logical\n"));
#line 17774 "icache.c"

  /* validate: 0.31,6.BF,9./,10.L,11.RA,16.RB,21.32,31./ */
  if (WITH_RESERVED_BITS && (instruction & 0xfc4007ff) != 0x7c000040)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.BF,9./,10.L,11.RA,16.RB,21.32,31./ #define get-values-from-icache|put-values-in-icache */
#line 67 "../../../sim/ppc/powerpc.igen"
    unsigned const BF ATTRIBUTE_UNUSED = cache_entry->crack.X.BF = EXTRACTED32(instruction, 6, 8); /* in icache - extraction */
#line 68 "../../../sim/ppc/powerpc.igen"
    uint32_t const BF_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.BF_BITMASK = (1 << BF); /* in icache - extraction */
#line 2852 "../../../sim/ppc/powerpc.igen"
    unsigned const L ATTRIBUTE_UNUSED = cache_entry->crack.X.L = EXTRACTED32(instruction, 10, 10); /* default in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.X.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.X.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.X.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.X.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 17802 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Compare_Logical;

    /* semantic routine */
#line 2852 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Compare Logical\n"));
#line 17812 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Compare_Logical, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2852 "../../../sim/ppc/powerpc.igen"
    {
      if (!is_64bit_mode && L)
        program_interrupt(processor, cia,
                          illegal_instruction_program_interrupt);
      else {
        unsigned_word a;
        unsigned_word b;
        if (L == 0) {
          a = MASKED(*rA, 32, 63);
          b = MASKED(*rB, 32, 63);
        }
        else {
          a = *rA;
          b = *rB;
        }
        CR_COMPARE(BF, a, b);
      }
      PPC_INSN_INT_CR(0, RA_BITMASK | RB_BITMASK, BF_BITMASK);
    }
#line 17841 "icache.c"
    return nia;
    /* extraction: 0.31,6.BF,9./,10.L,11.RA,16.RB,21.32,31./ #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 17845 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Subtract_From_OE0_Rc0(cpu *processor,
                             instruction_word instruction,
                             unsigned_word cia,
                             idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Subtract_From
#undef MY_PREFIX
#define MY_PREFIX Subtract_From_OE0_Rc0
#line 2542 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Subtract From\n"));
#line 17864 "icache.c"

  /* validate: 0.31,6.RT,11.RA,16.RB,21.OE,22.40,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0003fe) != 0x7c000050)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.40,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.XO.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.XO.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.XO.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 2542 "../../../sim/ppc/powerpc.igen"
    unsigned const OE ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 2542 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 17896 "icache.c"

#define insn cache_entry->crack.XO.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Subtract_From_OE0_Rc0;

    /* semantic routine */
#line 2542 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Subtract From\n"));
#line 17906 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Subtract_From, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2542 "../../../sim/ppc/powerpc.igen"
    {
      ALU_BEGIN(*rA);
      ALU_NOT;
      ALU_ADD(*rB);
      ALU_ADD(1);
      ALU_END(*rT, 0/*CA*/, OE, Rc);
      PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
    }
#line 17924 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.40,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 17928 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Subtract_From_OE0_Rc1(cpu *processor,
                             instruction_word instruction,
                             unsigned_word cia,
                             idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Subtract_From
#undef MY_PREFIX
#define MY_PREFIX Subtract_From_OE0_Rc1
#line 2542 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Subtract From\n"));
#line 17947 "icache.c"

  /* validate: 0.31,6.RT,11.RA,16.RB,21.OE,22.40,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0003fe) != 0x7c000050)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.40,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.XO.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.XO.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.XO.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 2542 "../../../sim/ppc/powerpc.igen"
    unsigned const OE ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 2542 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 17979 "icache.c"

#define insn cache_entry->crack.XO.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Subtract_From_OE0_Rc1;

    /* semantic routine */
#line 2542 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Subtract From\n"));
#line 17989 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Subtract_From, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2542 "../../../sim/ppc/powerpc.igen"
    {
      ALU_BEGIN(*rA);
      ALU_NOT;
      ALU_ADD(*rB);
      ALU_ADD(1);
      ALU_END(*rT, 0/*CA*/, OE, Rc);
      PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
    }
#line 18007 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.40,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 18011 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Data_Cache_Block_Store(cpu *processor,
                              instruction_word instruction,
                              unsigned_word cia,
                              idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Data_Cache_Block_Store
#undef MY_PREFIX
#define MY_PREFIX Data_Cache_Block_Store
#line 4811 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Data Cache Block Store\n"));
#line 18030 "icache.c"

  /* validate: 0.31,6./,11.RA,16.RB,21.54,31./ */
  if (WITH_RESERVED_BITS && (instruction & 0xffe007ff) != 0x7c00006c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6./,11.RA,16.RB,21.54,31./ #define get-values-from-icache|put-values-in-icache */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.X.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.X.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.X.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.X.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 18052 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Data_Cache_Block_Store;

    /* semantic routine */
#line 4811 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Data Cache Block Store\n"));
#line 18062 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Data_Cache_Block_Store, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4811 "../../../sim/ppc/powerpc.igen"
    {
      TRACE(trace_tbd,("Data Cache Block Store\n"));
      PPC_INSN_INT(0, (RA_BITMASK & ~1) | RB_BITMASK, 0/*Rc*/);
    }
#line 18076 "icache.c"
    return nia;
    /* extraction: 0.31,6./,11.RA,16.RB,21.54,31./ #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 18080 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Load_Word_and_Zero_with_Update_Indexed(cpu *processor,
                                              instruction_word instruction,
                                              unsigned_word cia,
                                              idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_Word_and_Zero_with_Update_Indexed
#undef MY_PREFIX
#define MY_PREFIX Load_Word_and_Zero_with_Update_Indexed
#line 1925 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Load Word and Zero with Update Indexed\n"));
#line 18099 "icache.c"

  /* validate: 0.31,6.RT,11.RA,16.RB,21.55,31./ */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007ff) != 0x7c00006e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.55,31./ #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.X.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.X.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.X.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.X.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.X.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.X.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 18127 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Load_Word_and_Zero_with_Update_Indexed;

    /* semantic routine */
#line 1925 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Load Word and Zero with Update Indexed\n"));
#line 18137 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Load_Word_and_Zero_with_Update_Indexed, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1925 "../../../sim/ppc/powerpc.igen"
    {
      unsigned_word EA;
      if (RA_is_0 || RA == RT)
        program_interrupt(processor, cia,
                          illegal_instruction_program_interrupt);
      EA = *rA + *rB;
      *rT = MEM(unsigned, EA, 4);
      *rA = EA;
      PPC_INSN_INT(RT_BITMASK | RA_BITMASK, RA_BITMASK | RB_BITMASK, 0);
    }
#line 18157 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.55,31./ #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 18161 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_AND_with_Complement_Rc0(cpu *processor,
                               instruction_word instruction,
                               unsigned_word cia,
                               idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_AND_with_Complement
#undef MY_PREFIX
#define MY_PREFIX AND_with_Complement_Rc0
#line 3070 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode AND with Complement\n"));
#line 18180 "icache.c"

  /* validate: 0.31,6.RS,11.RA,16.RB,21.60,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007fe) != 0x7c000078)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RS,11.RA,16.RB,21.60,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 43 "../../../sim/ppc/powerpc.igen"
    unsigned const RS ATTRIBUTE_UNUSED = cache_entry->crack.X.RS = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 44 "../../../sim/ppc/powerpc.igen"
    signed_word * const rS ATTRIBUTE_UNUSED = cache_entry->crack.X.rS = (cpu_registers(processor)->gpr + RS); /* in icache - extraction */
#line 45 "../../../sim/ppc/powerpc.igen"
    uint32_t const RS_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RS_BITMASK = (1 << RS); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.X.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.X.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.X.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.X.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 3070 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 18210 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_AND_with_Complement_Rc0;

    /* semantic routine */
#line 3070 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics AND with Complement\n"));
#line 18220 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_AND_with_Complement, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3070 "../../../sim/ppc/powerpc.igen"
    {
      *rA = *rS & ~*rB;
      CR0_COMPARE(*rA, 0, Rc);
      ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
      PPC_INSN_INT(RA_BITMASK, RS_BITMASK | RB_BITMASK, Rc);
    }
#line 18236 "icache.c"
    return nia;
    /* extraction: 0.31,6.RS,11.RA,16.RB,21.60,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 18240 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_AND_with_Complement_Rc1(cpu *processor,
                               instruction_word instruction,
                               unsigned_word cia,
                               idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_AND_with_Complement
#undef MY_PREFIX
#define MY_PREFIX AND_with_Complement_Rc1
#line 3070 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode AND with Complement\n"));
#line 18259 "icache.c"

  /* validate: 0.31,6.RS,11.RA,16.RB,21.60,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007fe) != 0x7c000078)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RS,11.RA,16.RB,21.60,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 43 "../../../sim/ppc/powerpc.igen"
    unsigned const RS ATTRIBUTE_UNUSED = cache_entry->crack.X.RS = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 44 "../../../sim/ppc/powerpc.igen"
    signed_word * const rS ATTRIBUTE_UNUSED = cache_entry->crack.X.rS = (cpu_registers(processor)->gpr + RS); /* in icache - extraction */
#line 45 "../../../sim/ppc/powerpc.igen"
    uint32_t const RS_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RS_BITMASK = (1 << RS); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.X.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.X.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.X.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.X.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 3070 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 18289 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_AND_with_Complement_Rc1;

    /* semantic routine */
#line 3070 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics AND with Complement\n"));
#line 18299 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_AND_with_Complement, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3070 "../../../sim/ppc/powerpc.igen"
    {
      *rA = *rS & ~*rB;
      CR0_COMPARE(*rA, 0, Rc);
      ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
      PPC_INSN_INT(RA_BITMASK, RS_BITMASK | RB_BITMASK, Rc);
    }
#line 18315 "icache.c"
    return nia;
    /* extraction: 0.31,6.RS,11.RA,16.RB,21.60,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 18319 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Multiply_High_Word_Rc0(cpu *processor,
                              instruction_word instruction,
                              unsigned_word cia,
                              idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Multiply_High_Word
#undef MY_PREFIX
#define MY_PREFIX Multiply_High_Word_Rc0
#line 2715 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Multiply High Word\n"));
#line 18338 "icache.c"

  /* validate: 0.31,6.RT,11.RA,16.RB,21./,22.75,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007fe) != 0x7c000096)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21./,22.75,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.XO.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.XO.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.XO.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 2715 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 18368 "icache.c"

#define insn cache_entry->crack.XO.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Multiply_High_Word_Rc0;

    /* semantic routine */
#line 2715 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Multiply High Word\n"));
#line 18378 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Multiply_High_Word, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2715 "../../../sim/ppc/powerpc.igen"
    {
      int64_t a = (int32_t)(*rA);
      int64_t b = (int32_t)(*rB);
      int64_t prod = a * b;
      signed_word t = EXTRACTED64(prod, 0, 31);
      *rT = t;
      CR0_COMPARE(t, 0, Rc);
      PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
    }
#line 18397 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21./,22.75,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 18401 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Multiply_High_Word_Rc1(cpu *processor,
                              instruction_word instruction,
                              unsigned_word cia,
                              idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Multiply_High_Word
#undef MY_PREFIX
#define MY_PREFIX Multiply_High_Word_Rc1
#line 2715 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Multiply High Word\n"));
#line 18420 "icache.c"

  /* validate: 0.31,6.RT,11.RA,16.RB,21./,22.75,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007fe) != 0x7c000096)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21./,22.75,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.XO.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.XO.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.XO.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 2715 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 18450 "icache.c"

#define insn cache_entry->crack.XO.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Multiply_High_Word_Rc1;

    /* semantic routine */
#line 2715 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Multiply High Word\n"));
#line 18460 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Multiply_High_Word, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2715 "../../../sim/ppc/powerpc.igen"
    {
      int64_t a = (int32_t)(*rA);
      int64_t b = (int32_t)(*rB);
      int64_t prod = a * b;
      signed_word t = EXTRACTED64(prod, 0, 31);
      *rT = t;
      CR0_COMPARE(t, 0, Rc);
      PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
    }
#line 18479 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21./,22.75,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 18483 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Move_From_Machine_State_Register(cpu *processor,
                                        instruction_word instruction,
                                        unsigned_word cia,
                                        idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Move_From_Machine_State_Register
#undef MY_PREFIX
#define MY_PREFIX Move_From_Machine_State_Register
#line 4898 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Move From Machine State Register\n"));
#line 18502 "icache.c"

  /* validate: 0.31,6.RT,11./,16./,21.83,31./ */
  if (WITH_RESERVED_BITS && (instruction & 0xfc1fffff) != 0x7c0000a6)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11./,16./,21.83,31./ #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.X.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.X.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 18517 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Move_From_Machine_State_Register;

    /* semantic routine */
#line 4898 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Move From Machine State Register\n"));
#line 18527 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Move_From_Machine_State_Register, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4898 "../../../sim/ppc/powerpc.igen"
    {
      if (IS_PROBLEM_STATE(processor))
        program_interrupt(processor, cia,
                          privileged_instruction_program_interrupt);
      else {
        *rT = MSR;
        check_masked_interrupts(processor);
      }
    }
#line 18546 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11./,16./,21.83,31./ #undef get-values-from-icache|put-values-in-icache */
#line 18549 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Data_Cache_Block_Flush(cpu *processor,
                              instruction_word instruction,
                              unsigned_word cia,
                              idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Data_Cache_Block_Flush
#undef MY_PREFIX
#define MY_PREFIX Data_Cache_Block_Flush
#line 4819 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Data Cache Block Flush\n"));
#line 18568 "icache.c"

  /* validate: 0.31,6./,11.RA,16.RB,21.86,31./ */
  if (WITH_RESERVED_BITS && (instruction & 0xffe007ff) != 0x7c0000ac)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6./,11.RA,16.RB,21.86,31./ #define get-values-from-icache|put-values-in-icache */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.X.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.X.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.X.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.X.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 18590 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Data_Cache_Block_Flush;

    /* semantic routine */
#line 4819 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Data Cache Block Flush\n"));
#line 18600 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Data_Cache_Block_Flush, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4819 "../../../sim/ppc/powerpc.igen"
    {
      TRACE(trace_tbd,("Data Cache Block Flush\n"));
      PPC_INSN_INT(0, (RA_BITMASK & ~1) | RB_BITMASK, 0/*Rc*/);
    }
#line 18614 "icache.c"
    return nia;
    /* extraction: 0.31,6./,11.RA,16.RB,21.86,31./ #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 18618 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Load_Byte_and_Zero_Indexed(cpu *processor,
                                  instruction_word instruction,
                                  unsigned_word cia,
                                  idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_Byte_and_Zero_Indexed
#undef MY_PREFIX
#define MY_PREFIX Load_Byte_and_Zero_Indexed
#line 1736 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Load Byte and Zero Indexed\n"));
#line 18637 "icache.c"

  /* validate: 0.31,6.RT,11.RA,16.RB,21.87,31./ */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007ff) != 0x7c0000ae)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.87,31./ #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.X.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.X.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.X.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.X.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.X.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.X.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 18665 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Load_Byte_and_Zero_Indexed;

    /* semantic routine */
#line 1736 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Load Byte and Zero Indexed\n"));
#line 18675 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Load_Byte_and_Zero_Indexed, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1736 "../../../sim/ppc/powerpc.igen"
    {
      unsigned_word b;
      unsigned_word EA;
      if (RA_is_0) b = 0;
      else         b = *rA;
      EA = b + *rB;
      *rT = MEM(unsigned, EA, 1);
      PPC_INSN_INT(RT_BITMASK, (RA_BITMASK & ~1) | RB_BITMASK, 0);
    }
#line 18694 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.87,31./ #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 18698 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Negate_OE0_Rc0(cpu *processor,
                      instruction_word instruction,
                      unsigned_word cia,
                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Negate
#undef MY_PREFIX
#define MY_PREFIX Negate_OE0_Rc0
#line 2676 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Negate\n"));
#line 18717 "icache.c"

  /* validate: 0.31,6.RT,11.RA,16./,21.OE,22.104,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00fbfe) != 0x7c0000d0)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.104,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.XO.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.XO.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 2676 "../../../sim/ppc/powerpc.igen"
    unsigned const OE ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 2676 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 18743 "icache.c"

#define insn cache_entry->crack.XO.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Negate_OE0_Rc0;

    /* semantic routine */
#line 2676 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Negate\n"));
#line 18753 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Negate, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2676 "../../../sim/ppc/powerpc.igen"
    {
      ALU_BEGIN(*rA);
      ALU_NOT;
      ALU_ADD(1);
      ALU_END(*rT,0/*CA*/,OE,Rc);
      PPC_INSN_INT(RT_BITMASK, RA_BITMASK, Rc);
    }
#line 18770 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.104,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 18774 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Negate_OE0_Rc1(cpu *processor,
                      instruction_word instruction,
                      unsigned_word cia,
                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Negate
#undef MY_PREFIX
#define MY_PREFIX Negate_OE0_Rc1
#line 2676 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Negate\n"));
#line 18793 "icache.c"

  /* validate: 0.31,6.RT,11.RA,16./,21.OE,22.104,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00fbfe) != 0x7c0000d0)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.104,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.XO.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.XO.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 2676 "../../../sim/ppc/powerpc.igen"
    unsigned const OE ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 2676 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 18819 "icache.c"

#define insn cache_entry->crack.XO.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Negate_OE0_Rc1;

    /* semantic routine */
#line 2676 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Negate\n"));
#line 18829 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Negate, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2676 "../../../sim/ppc/powerpc.igen"
    {
      ALU_BEGIN(*rA);
      ALU_NOT;
      ALU_ADD(1);
      ALU_END(*rT,0/*CA*/,OE,Rc);
      PPC_INSN_INT(RT_BITMASK, RA_BITMASK, Rc);
    }
#line 18846 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.104,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 18850 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Load_Byte_and_Zero_with_Update_Indexed(cpu *processor,
                                              instruction_word instruction,
                                              unsigned_word cia,
                                              idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_Byte_and_Zero_with_Update_Indexed
#undef MY_PREFIX
#define MY_PREFIX Load_Byte_and_Zero_with_Update_Indexed
#line 1763 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Load Byte and Zero with Update Indexed\n"));
#line 18869 "icache.c"

  /* validate: 0.31,6.RT,11.RA,16.RB,21.119,31./ */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007ff) != 0x7c0000ee)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.119,31./ #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.X.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.X.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.X.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.X.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.X.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.X.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 18897 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Load_Byte_and_Zero_with_Update_Indexed;

    /* semantic routine */
#line 1763 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Load Byte and Zero with Update Indexed\n"));
#line 18907 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Load_Byte_and_Zero_with_Update_Indexed, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1763 "../../../sim/ppc/powerpc.igen"
    {
      unsigned_word EA;
      if (RA_is_0 || RA == RT)
        program_interrupt(processor, cia,
                          illegal_instruction_program_interrupt);
      EA = *rA + *rB;
      *rT = MEM(unsigned, EA, 1);
      *rA = EA;
      PPC_INSN_INT(RT_BITMASK | RA_BITMASK, RA_BITMASK | RB_BITMASK, 0);
    }
#line 18927 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.119,31./ #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 18931 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_NOR_Rc0(cpu *processor,
               instruction_word instruction,
               unsigned_word cia,
               idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_NOR
#undef MY_PREFIX
#define MY_PREFIX NOR_Rc0
#line 3050 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode NOR\n"));
#line 18950 "icache.c"

  /* validate: 0.31,6.RS,11.RA,16.RB,21.124,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007fe) != 0x7c0000f8)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RS,11.RA,16.RB,21.124,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 43 "../../../sim/ppc/powerpc.igen"
    unsigned const RS ATTRIBUTE_UNUSED = cache_entry->crack.X.RS = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 44 "../../../sim/ppc/powerpc.igen"
    signed_word * const rS ATTRIBUTE_UNUSED = cache_entry->crack.X.rS = (cpu_registers(processor)->gpr + RS); /* in icache - extraction */
#line 45 "../../../sim/ppc/powerpc.igen"
    uint32_t const RS_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RS_BITMASK = (1 << RS); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.X.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.X.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.X.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.X.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 3050 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 18980 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_NOR_Rc0;

    /* semantic routine */
#line 3050 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics NOR\n"));
#line 18990 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_NOR, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3050 "../../../sim/ppc/powerpc.igen"
    {
      *rA = ~(*rS | *rB);
      CR0_COMPARE(*rA, 0, Rc);
      ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
      PPC_INSN_INT(RA_BITMASK, RS_BITMASK | RB_BITMASK, Rc);
    }
#line 19006 "icache.c"
    return nia;
    /* extraction: 0.31,6.RS,11.RA,16.RB,21.124,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 19010 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_NOR_Rc1(cpu *processor,
               instruction_word instruction,
               unsigned_word cia,
               idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_NOR
#undef MY_PREFIX
#define MY_PREFIX NOR_Rc1
#line 3050 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode NOR\n"));
#line 19029 "icache.c"

  /* validate: 0.31,6.RS,11.RA,16.RB,21.124,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007fe) != 0x7c0000f8)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RS,11.RA,16.RB,21.124,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 43 "../../../sim/ppc/powerpc.igen"
    unsigned const RS ATTRIBUTE_UNUSED = cache_entry->crack.X.RS = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 44 "../../../sim/ppc/powerpc.igen"
    signed_word * const rS ATTRIBUTE_UNUSED = cache_entry->crack.X.rS = (cpu_registers(processor)->gpr + RS); /* in icache - extraction */
#line 45 "../../../sim/ppc/powerpc.igen"
    uint32_t const RS_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RS_BITMASK = (1 << RS); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.X.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.X.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.X.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.X.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 3050 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 19059 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_NOR_Rc1;

    /* semantic routine */
#line 3050 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics NOR\n"));
#line 19069 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_NOR, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3050 "../../../sim/ppc/powerpc.igen"
    {
      *rA = ~(*rS | *rB);
      CR0_COMPARE(*rA, 0, Rc);
      ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
      PPC_INSN_INT(RA_BITMASK, RS_BITMASK | RB_BITMASK, Rc);
    }
#line 19085 "icache.c"
    return nia;
    /* extraction: 0.31,6.RS,11.RA,16.RB,21.124,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 19089 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Subtract_From_Extended_OE0_Rc0(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Subtract_From_Extended
#undef MY_PREFIX
#define MY_PREFIX Subtract_From_Extended_OE0_Rc0
#line 2620 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Subtract From Extended\n"));
#line 19108 "icache.c"

  /* validate: 0.31,6.RT,11.RA,16.RB,21.OE,22.136,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0003fe) != 0x7c000110)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.136,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.XO.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.XO.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.XO.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 2620 "../../../sim/ppc/powerpc.igen"
    unsigned const OE ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 2620 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 19140 "icache.c"

#define insn cache_entry->crack.XO.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Subtract_From_Extended_OE0_Rc0;

    /* semantic routine */
#line 2620 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Subtract From Extended\n"));
#line 19150 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Subtract_From_Extended, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2620 "../../../sim/ppc/powerpc.igen"
    {
      ALU_BEGIN(*rA);
      ALU_NOT;
      ALU_ADD(*rB);
      ALU_ADD_CA;
      ALU_END(*rT, 1/*CA*/, OE, Rc);
      PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
    }
#line 19168 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.136,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 19172 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Subtract_From_Extended_OE0_Rc1(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Subtract_From_Extended
#undef MY_PREFIX
#define MY_PREFIX Subtract_From_Extended_OE0_Rc1
#line 2620 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Subtract From Extended\n"));
#line 19191 "icache.c"

  /* validate: 0.31,6.RT,11.RA,16.RB,21.OE,22.136,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0003fe) != 0x7c000110)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.136,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.XO.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.XO.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.XO.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 2620 "../../../sim/ppc/powerpc.igen"
    unsigned const OE ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 2620 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 19223 "icache.c"

#define insn cache_entry->crack.XO.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Subtract_From_Extended_OE0_Rc1;

    /* semantic routine */
#line 2620 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Subtract From Extended\n"));
#line 19233 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Subtract_From_Extended, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2620 "../../../sim/ppc/powerpc.igen"
    {
      ALU_BEGIN(*rA);
      ALU_NOT;
      ALU_ADD(*rB);
      ALU_ADD_CA;
      ALU_END(*rT, 1/*CA*/, OE, Rc);
      PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
    }
#line 19251 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.136,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 19255 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Add_Extended_OE0_Rc0(cpu *processor,
                            instruction_word instruction,
                            unsigned_word cia,
                            idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Add_Extended
#undef MY_PREFIX
#define MY_PREFIX Add_Extended_OE0_Rc0
#line 2609 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Add Extended\n"));
#line 19274 "icache.c"

  /* validate: 0.31,6.RT,11.RA,16.RB,21.OE,22.138,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0003fe) != 0x7c000114)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.138,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.XO.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.XO.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.XO.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 2609 "../../../sim/ppc/powerpc.igen"
    unsigned const OE ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 2609 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 19306 "icache.c"

#define insn cache_entry->crack.XO.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Add_Extended_OE0_Rc0;

    /* semantic routine */
#line 2609 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Add Extended\n"));
#line 19316 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Add_Extended, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2609 "../../../sim/ppc/powerpc.igen"
    {
      ALU_BEGIN(*rA);
      ALU_ADD(*rB);
      ALU_ADD_CA;
      ALU_END(*rT, 1/*CA*/, OE, Rc);
      PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
    }
#line 19333 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.138,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 19337 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Add_Extended_OE0_Rc1(cpu *processor,
                            instruction_word instruction,
                            unsigned_word cia,
                            idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Add_Extended
#undef MY_PREFIX
#define MY_PREFIX Add_Extended_OE0_Rc1
#line 2609 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Add Extended\n"));
#line 19356 "icache.c"

  /* validate: 0.31,6.RT,11.RA,16.RB,21.OE,22.138,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0003fe) != 0x7c000114)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.138,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.XO.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.XO.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.XO.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 2609 "../../../sim/ppc/powerpc.igen"
    unsigned const OE ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 2609 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 19388 "icache.c"

#define insn cache_entry->crack.XO.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Add_Extended_OE0_Rc1;

    /* semantic routine */
#line 2609 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Add Extended\n"));
#line 19398 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Add_Extended, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2609 "../../../sim/ppc/powerpc.igen"
    {
      ALU_BEGIN(*rA);
      ALU_ADD(*rB);
      ALU_ADD_CA;
      ALU_END(*rT, 1/*CA*/, OE, Rc);
      PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
    }
#line 19415 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.138,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 19419 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Move_to_Condition_Register_Fields(cpu *processor,
                                         instruction_word instruction,
                                         unsigned_word cia,
                                         idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Move_to_Condition_Register_Fields
#undef MY_PREFIX
#define MY_PREFIX Move_to_Condition_Register_Fields
#line 3429 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Move to Condition Register Fields\n"));
#line 19438 "icache.c"

  /* validate: 0.31,6.RS,11./,12.FXM,20./,21.144,31./ */
  if (WITH_RESERVED_BITS && (instruction & 0xfc100fff) != 0x7c000120)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RS,11./,12.FXM,20./,21.144,31./ #define get-values-from-icache|put-values-in-icache */
#line 43 "../../../sim/ppc/powerpc.igen"
    unsigned const RS ATTRIBUTE_UNUSED = cache_entry->crack.XFX.RS = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 44 "../../../sim/ppc/powerpc.igen"
    signed_word * const rS ATTRIBUTE_UNUSED = cache_entry->crack.XFX.rS = (cpu_registers(processor)->gpr + RS); /* in icache - extraction */
#line 45 "../../../sim/ppc/powerpc.igen"
    uint32_t const RS_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XFX.RS_BITMASK = (1 << RS); /* in icache - extraction */
#line 3429 "../../../sim/ppc/powerpc.igen"
    unsigned const FXM ATTRIBUTE_UNUSED = cache_entry->crack.XFX.FXM = EXTRACTED32(instruction, 12, 19); /* default in icache - extraction */
#line 19455 "icache.c"

#define insn cache_entry->crack.XFX.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Move_to_Condition_Register_Fields;

    /* semantic routine */
#line 3429 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Move to Condition Register Fields\n"));
#line 19465 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Move_to_Condition_Register_Fields, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3429 "../../../sim/ppc/powerpc.igen"
    {
      if (FXM == 0xff) {
        CR = *rS;
      }
      else {
        unsigned_word mask = 0;
        unsigned_word f;
        for (f = 0; f < 8; f++) {
          if (FXM & (0x80 >> f))
            mask |= (0xf << 4*(7-f));
        }
        CR = (MASKED(*rS, 32, 63) & mask) | (CR & ~mask);
      }
      PPC_INSN_MTCR(RS_BITMASK, FXM);
    }
#line 19490 "icache.c"
    return nia;
    /* extraction: 0.31,6.RS,11./,12.FXM,20./,21.144,31./ #undef get-values-from-icache|put-values-in-icache */
#line 19493 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Move_To_Machine_State_Register(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Move_To_Machine_State_Register
#undef MY_PREFIX
#define MY_PREFIX Move_To_Machine_State_Register
#line 4885 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Move To Machine State Register\n"));
#line 19512 "icache.c"

  /* validate: 0.31,6.RS,11./,16./,21.146,31./ */
  if (WITH_RESERVED_BITS && (instruction & 0xfc1fffff) != 0x7c000124)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RS,11./,16./,21.146,31./ #define get-values-from-icache|put-values-in-icache */
#line 43 "../../../sim/ppc/powerpc.igen"
    unsigned const RS ATTRIBUTE_UNUSED = cache_entry->crack.X.RS = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 44 "../../../sim/ppc/powerpc.igen"
    signed_word * const rS ATTRIBUTE_UNUSED = cache_entry->crack.X.rS = (cpu_registers(processor)->gpr + RS); /* in icache - extraction */
#line 45 "../../../sim/ppc/powerpc.igen"
    uint32_t const RS_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RS_BITMASK = (1 << RS); /* in icache - extraction */
#line 19527 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Move_To_Machine_State_Register;

    /* semantic routine */
#line 4885 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Move To Machine State Register\n"));
#line 19537 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Move_To_Machine_State_Register, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4885 "../../../sim/ppc/powerpc.igen"
    {
      if (IS_PROBLEM_STATE(processor))
        program_interrupt(processor, cia,
                          privileged_instruction_program_interrupt);
      else {
        MSR = *rS;
        check_masked_interrupts(processor);
      }
    }
#line 19556 "icache.c"
    return nia;
    /* extraction: 0.31,6.RS,11./,16./,21.146,31./ #undef get-values-from-icache|put-values-in-icache */
#line 19559 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Store_Word_Conditional_Indexed(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_Word_Conditional_Indexed
#undef MY_PREFIX
#define MY_PREFIX Store_Word_Conditional_Indexed
#line 2450 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Store Word Conditional Indexed\n"));
#line 19578 "icache.c"

  /* validate: 0.31,6.RS,11.RA,16.RB,21.150,31.1 */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007ff) != 0x7c00012d)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RS,11.RA,16.RB,21.150,31.1 #define get-values-from-icache|put-values-in-icache */
#line 43 "../../../sim/ppc/powerpc.igen"
    unsigned const RS ATTRIBUTE_UNUSED = cache_entry->crack.X.RS = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 44 "../../../sim/ppc/powerpc.igen"
    signed_word * const rS ATTRIBUTE_UNUSED = cache_entry->crack.X.rS = (cpu_registers(processor)->gpr + RS); /* in icache - extraction */
#line 45 "../../../sim/ppc/powerpc.igen"
    uint32_t const RS_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RS_BITMASK = (1 << RS); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.X.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.X.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.X.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.X.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 19606 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Store_Word_Conditional_Indexed;

    /* semantic routine */
#line 2450 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Store Word Conditional Indexed\n"));
#line 19616 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Store_Word_Conditional_Indexed, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2450 "../../../sim/ppc/powerpc.igen"
    {
      unsigned_word b;
      unsigned_word EA;
      if (RA_is_0) b = 0;
      else         b = *rA;
      EA = b + *rB;
      if (RESERVE) {
        if (RESERVE_ADDR == real_addr(EA, 0/*is-read?*/)
            && /*HACK*/ RESERVE_DATA == MEM(unsigned, EA, 4)) {
          STORE(EA, 4, *rS);
          CR_SET_XER_SO(0, cr_i_zero);
        }
        else {
          /* ment to randomly to store, we never do! */	
          CR_SET_XER_SO(0, 0);
        }
        RESERVE = 0;
      }
      else {
        CR_SET_XER_SO(0, 0);
      }
      PPC_INSN_INT(0, (RA_BITMASK & ~1) | RB_BITMASK | RS_BITMASK, 1/*Rc*/);
    }
#line 19649 "icache.c"
    return nia;
    /* extraction: 0.31,6.RS,11.RA,16.RB,21.150,31.1 #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 19653 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Store_Word_Indexed(cpu *processor,
                          instruction_word instruction,
                          unsigned_word cia,
                          idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_Word_Indexed
#undef MY_PREFIX
#define MY_PREFIX Store_Word_Indexed
#line 2125 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Store Word Indexed\n"));
#line 19672 "icache.c"

  /* validate: 0.31,6.RS,11.RA,16.RB,21.151,31./ */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007ff) != 0x7c00012e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RS,11.RA,16.RB,21.151,31./ #define get-values-from-icache|put-values-in-icache */
#line 43 "../../../sim/ppc/powerpc.igen"
    unsigned const RS ATTRIBUTE_UNUSED = cache_entry->crack.X.RS = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 44 "../../../sim/ppc/powerpc.igen"
    signed_word * const rS ATTRIBUTE_UNUSED = cache_entry->crack.X.rS = (cpu_registers(processor)->gpr + RS); /* in icache - extraction */
#line 45 "../../../sim/ppc/powerpc.igen"
    uint32_t const RS_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RS_BITMASK = (1 << RS); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.X.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.X.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.X.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.X.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 19700 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Store_Word_Indexed;

    /* semantic routine */
#line 2125 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Store Word Indexed\n"));
#line 19710 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Store_Word_Indexed, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2125 "../../../sim/ppc/powerpc.igen"
    {
      unsigned_word b;
      unsigned_word EA;
      if (RA_is_0) b = 0;
      else         b = *rA;
      EA = b + *rB;
      STORE(EA, 4, *rS);
      PPC_INSN_INT(0, (RA_BITMASK & ~1) | RB_BITMASK | RS_BITMASK, 0);
    }
#line 19729 "icache.c"
    return nia;
    /* extraction: 0.31,6.RS,11.RA,16.RB,21.151,31./ #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 19733 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Store_Word_with_Update_Indexed(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_Word_with_Update_Indexed
#undef MY_PREFIX
#define MY_PREFIX Store_Word_with_Update_Indexed
#line 2152 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Store Word with Update Indexed\n"));
#line 19752 "icache.c"

  /* validate: 0.31,6.RS,11.RA,16.RB,21.183,31./ */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007ff) != 0x7c00016e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RS,11.RA,16.RB,21.183,31./ #define get-values-from-icache|put-values-in-icache */
#line 43 "../../../sim/ppc/powerpc.igen"
    unsigned const RS ATTRIBUTE_UNUSED = cache_entry->crack.X.RS = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 44 "../../../sim/ppc/powerpc.igen"
    signed_word * const rS ATTRIBUTE_UNUSED = cache_entry->crack.X.rS = (cpu_registers(processor)->gpr + RS); /* in icache - extraction */
#line 45 "../../../sim/ppc/powerpc.igen"
    uint32_t const RS_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RS_BITMASK = (1 << RS); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.X.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.X.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.X.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.X.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 19780 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Store_Word_with_Update_Indexed;

    /* semantic routine */
#line 2152 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Store Word with Update Indexed\n"));
#line 19790 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Store_Word_with_Update_Indexed, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2152 "../../../sim/ppc/powerpc.igen"
    {
      unsigned_word EA;
      if (RA_is_0)
        program_interrupt(processor, cia,
                          illegal_instruction_program_interrupt);
      EA = *rA + *rB;
      STORE(EA, 4, *rS);
      *rA = EA;
      PPC_INSN_INT(RA_BITMASK, RA_BITMASK | RB_BITMASK | RS_BITMASK, 0);
    }
#line 19810 "icache.c"
    return nia;
    /* extraction: 0.31,6.RS,11.RA,16.RB,21.183,31./ #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 19814 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Subtract_from_Zero_Extended_OE0_Rc0(cpu *processor,
                                           instruction_word instruction,
                                           unsigned_word cia,
                                           idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Subtract_from_Zero_Extended
#undef MY_PREFIX
#define MY_PREFIX Subtract_from_Zero_Extended_OE0_Rc0
#line 2665 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Subtract from Zero Extended\n"));
#line 19833 "icache.c"

  /* validate: 0.31,6.RT,11.RA,16./,21.OE,22.200,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00fbfe) != 0x7c000190)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.200,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.XO.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.XO.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 2665 "../../../sim/ppc/powerpc.igen"
    unsigned const OE ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 2665 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 19859 "icache.c"

#define insn cache_entry->crack.XO.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Subtract_from_Zero_Extended_OE0_Rc0;

    /* semantic routine */
#line 2665 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Subtract from Zero Extended\n"));
#line 19869 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Subtract_from_Zero_Extended, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2665 "../../../sim/ppc/powerpc.igen"
    {
      ALU_BEGIN(*rA);
      ALU_NOT;
      ALU_ADD_CA;
      ALU_END(*rT, 1/*CA*/, OE, Rc);
      PPC_INSN_INT(RT_BITMASK, RA_BITMASK, Rc);
    }
#line 19886 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.200,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 19890 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Subtract_from_Zero_Extended_OE0_Rc1(cpu *processor,
                                           instruction_word instruction,
                                           unsigned_word cia,
                                           idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Subtract_from_Zero_Extended
#undef MY_PREFIX
#define MY_PREFIX Subtract_from_Zero_Extended_OE0_Rc1
#line 2665 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Subtract from Zero Extended\n"));
#line 19909 "icache.c"

  /* validate: 0.31,6.RT,11.RA,16./,21.OE,22.200,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00fbfe) != 0x7c000190)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.200,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.XO.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.XO.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 2665 "../../../sim/ppc/powerpc.igen"
    unsigned const OE ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 2665 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 19935 "icache.c"

#define insn cache_entry->crack.XO.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Subtract_from_Zero_Extended_OE0_Rc1;

    /* semantic routine */
#line 2665 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Subtract from Zero Extended\n"));
#line 19945 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Subtract_from_Zero_Extended, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2665 "../../../sim/ppc/powerpc.igen"
    {
      ALU_BEGIN(*rA);
      ALU_NOT;
      ALU_ADD_CA;
      ALU_END(*rT, 1/*CA*/, OE, Rc);
      PPC_INSN_INT(RT_BITMASK, RA_BITMASK, Rc);
    }
#line 19962 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.200,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 19966 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Add_to_Zero_Extended_OE0_Rc0(cpu *processor,
                                    instruction_word instruction,
                                    unsigned_word cia,
                                    idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Add_to_Zero_Extended
#undef MY_PREFIX
#define MY_PREFIX Add_to_Zero_Extended_OE0_Rc0
#line 2655 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Add to Zero Extended\n"));
#line 19985 "icache.c"

  /* validate: 0.31,6.RT,11.RA,16./,21.OE,22.202,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00fbfe) != 0x7c000194)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.202,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.XO.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.XO.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 2655 "../../../sim/ppc/powerpc.igen"
    unsigned const OE ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 2655 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 20011 "icache.c"

#define insn cache_entry->crack.XO.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Add_to_Zero_Extended_OE0_Rc0;

    /* semantic routine */
#line 2655 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Add to Zero Extended\n"));
#line 20021 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Add_to_Zero_Extended, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2655 "../../../sim/ppc/powerpc.igen"
    {
      ALU_BEGIN(*rA);
      ALU_ADD_CA;
      ALU_END(*rT, 1/*CA*/, OE, Rc);
      PPC_INSN_INT(RT_BITMASK, RA_BITMASK, Rc);
    }
#line 20037 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.202,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 20041 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Add_to_Zero_Extended_OE0_Rc1(cpu *processor,
                                    instruction_word instruction,
                                    unsigned_word cia,
                                    idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Add_to_Zero_Extended
#undef MY_PREFIX
#define MY_PREFIX Add_to_Zero_Extended_OE0_Rc1
#line 2655 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Add to Zero Extended\n"));
#line 20060 "icache.c"

  /* validate: 0.31,6.RT,11.RA,16./,21.OE,22.202,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00fbfe) != 0x7c000194)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.202,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.XO.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.XO.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 2655 "../../../sim/ppc/powerpc.igen"
    unsigned const OE ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 2655 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 20086 "icache.c"

#define insn cache_entry->crack.XO.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Add_to_Zero_Extended_OE0_Rc1;

    /* semantic routine */
#line 2655 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Add to Zero Extended\n"));
#line 20096 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Add_to_Zero_Extended, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2655 "../../../sim/ppc/powerpc.igen"
    {
      ALU_BEGIN(*rA);
      ALU_ADD_CA;
      ALU_END(*rT, 1/*CA*/, OE, Rc);
      PPC_INSN_INT(RT_BITMASK, RA_BITMASK, Rc);
    }
#line 20112 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.202,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 20116 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Move_To_Segment_Register(cpu *processor,
                                instruction_word instruction,
                                unsigned_word cia,
                                idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Move_To_Segment_Register
#undef MY_PREFIX
#define MY_PREFIX Move_To_Segment_Register
#line 4931 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Move To Segment Register\n"));
#line 20135 "icache.c"

  /* validate: 0.31,6.RS,11./,12.SR,16./,21.210,31./ */
  if (WITH_RESERVED_BITS && (instruction & 0xfc10ffff) != 0x7c0001a4)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RS,11./,12.SR,16./,21.210,31./ #define get-values-from-icache|put-values-in-icache */
#line 43 "../../../sim/ppc/powerpc.igen"
    unsigned const RS ATTRIBUTE_UNUSED = cache_entry->crack.X.RS = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 44 "../../../sim/ppc/powerpc.igen"
    signed_word * const rS ATTRIBUTE_UNUSED = cache_entry->crack.X.rS = (cpu_registers(processor)->gpr + RS); /* in icache - extraction */
#line 45 "../../../sim/ppc/powerpc.igen"
    uint32_t const RS_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RS_BITMASK = (1 << RS); /* in icache - extraction */
#line 4931 "../../../sim/ppc/powerpc.igen"
    unsigned const SR ATTRIBUTE_UNUSED = cache_entry->crack.X.SR = EXTRACTED32(instruction, 12, 15); /* default in icache - extraction */
#line 20152 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Move_To_Segment_Register;

    /* semantic routine */
#line 4931 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Move To Segment Register\n"));
#line 20162 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Move_To_Segment_Register, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4931 "../../../sim/ppc/powerpc.igen"
    {
      if (IS_PROBLEM_STATE(processor))
        program_interrupt(processor, cia,
                          privileged_instruction_program_interrupt);
      else
        SEGREG(SR) = *rS;
    }
#line 20179 "icache.c"
    return nia;
    /* extraction: 0.31,6.RS,11./,12.SR,16./,21.210,31./ #undef get-values-from-icache|put-values-in-icache */
#line 20182 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Store_Byte_Indexed(cpu *processor,
                          instruction_word instruction,
                          unsigned_word cia,
                          idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_Byte_Indexed
#undef MY_PREFIX
#define MY_PREFIX Store_Byte_Indexed
#line 2017 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Store Byte Indexed\n"));
#line 20201 "icache.c"

  /* validate: 0.31,6.RS,11.RA,16.RB,21.215,31./ */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007ff) != 0x7c0001ae)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RS,11.RA,16.RB,21.215,31./ #define get-values-from-icache|put-values-in-icache */
#line 43 "../../../sim/ppc/powerpc.igen"
    unsigned const RS ATTRIBUTE_UNUSED = cache_entry->crack.X.RS = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 44 "../../../sim/ppc/powerpc.igen"
    signed_word * const rS ATTRIBUTE_UNUSED = cache_entry->crack.X.rS = (cpu_registers(processor)->gpr + RS); /* in icache - extraction */
#line 45 "../../../sim/ppc/powerpc.igen"
    uint32_t const RS_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RS_BITMASK = (1 << RS); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.X.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.X.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.X.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.X.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 20229 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Store_Byte_Indexed;

    /* semantic routine */
#line 2017 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Store Byte Indexed\n"));
#line 20239 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Store_Byte_Indexed, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2017 "../../../sim/ppc/powerpc.igen"
    {
      unsigned_word b;
      unsigned_word EA;
      if (RA_is_0) b = 0;
      else         b = *rA;
      EA = b + *rB;
      STORE(EA, 1, *rS);
      PPC_INSN_INT(0, (RA_BITMASK & ~1) | RB_BITMASK | RS_BITMASK, 0);
    }
#line 20258 "icache.c"
    return nia;
    /* extraction: 0.31,6.RS,11.RA,16.RB,21.215,31./ #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 20262 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Subtract_From_Minus_One_Extended_OE0_Rc0(cpu *processor,
                                                instruction_word instruction,
                                                unsigned_word cia,
                                                idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Subtract_From_Minus_One_Extended
#undef MY_PREFIX
#define MY_PREFIX Subtract_From_Minus_One_Extended_OE0_Rc0
#line 2643 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Subtract From Minus One Extended\n"));
#line 20281 "icache.c"

  /* validate: 0.31,6.RT,11.RA,16./,21.OE,22.232,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00fbfe) != 0x7c0001d0)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.232,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.XO.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.XO.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 2643 "../../../sim/ppc/powerpc.igen"
    unsigned const OE ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 2643 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 20307 "icache.c"

#define insn cache_entry->crack.XO.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Subtract_From_Minus_One_Extended_OE0_Rc0;

    /* semantic routine */
#line 2643 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Subtract From Minus One Extended\n"));
#line 20317 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Subtract_From_Minus_One_Extended, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2643 "../../../sim/ppc/powerpc.igen"
    {
      ALU_BEGIN(*rA);
      ALU_NOT;
      ALU_ADD_CA;
      ALU_ADD(-1);
      ALU_END(*rT, 1/*CA*/, OE, Rc);
      PPC_INSN_INT(RT_BITMASK, RA_BITMASK, Rc);
    }
#line 20335 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.232,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 20339 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Subtract_From_Minus_One_Extended_OE0_Rc1(cpu *processor,
                                                instruction_word instruction,
                                                unsigned_word cia,
                                                idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Subtract_From_Minus_One_Extended
#undef MY_PREFIX
#define MY_PREFIX Subtract_From_Minus_One_Extended_OE0_Rc1
#line 2643 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Subtract From Minus One Extended\n"));
#line 20358 "icache.c"

  /* validate: 0.31,6.RT,11.RA,16./,21.OE,22.232,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00fbfe) != 0x7c0001d0)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.232,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.XO.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.XO.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 2643 "../../../sim/ppc/powerpc.igen"
    unsigned const OE ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 2643 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 20384 "icache.c"

#define insn cache_entry->crack.XO.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Subtract_From_Minus_One_Extended_OE0_Rc1;

    /* semantic routine */
#line 2643 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Subtract From Minus One Extended\n"));
#line 20394 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Subtract_From_Minus_One_Extended, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2643 "../../../sim/ppc/powerpc.igen"
    {
      ALU_BEGIN(*rA);
      ALU_NOT;
      ALU_ADD_CA;
      ALU_ADD(-1);
      ALU_END(*rT, 1/*CA*/, OE, Rc);
      PPC_INSN_INT(RT_BITMASK, RA_BITMASK, Rc);
    }
#line 20412 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.232,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 20416 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Add_to_Minus_One_Extended_OE0_Rc0(cpu *processor,
                                         instruction_word instruction,
                                         unsigned_word cia,
                                         idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Add_to_Minus_One_Extended
#undef MY_PREFIX
#define MY_PREFIX Add_to_Minus_One_Extended_OE0_Rc0
#line 2632 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Add to Minus One Extended\n"));
#line 20435 "icache.c"

  /* validate: 0.31,6.RT,11.RA,16./,21.OE,22.234,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00fbfe) != 0x7c0001d4)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.234,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.XO.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.XO.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 2632 "../../../sim/ppc/powerpc.igen"
    unsigned const OE ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 2632 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 20461 "icache.c"

#define insn cache_entry->crack.XO.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Add_to_Minus_One_Extended_OE0_Rc0;

    /* semantic routine */
#line 2632 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Add to Minus One Extended\n"));
#line 20471 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Add_to_Minus_One_Extended, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2632 "../../../sim/ppc/powerpc.igen"
    {
      ALU_BEGIN(*rA);
      ALU_ADD_CA;
      ALU_ADD(-1);
      ALU_END(*rT, 1/*CA*/, OE, Rc);
      PPC_INSN_INT(RT_BITMASK, RA_BITMASK, Rc);
    }
#line 20488 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.234,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 20492 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Add_to_Minus_One_Extended_OE0_Rc1(cpu *processor,
                                         instruction_word instruction,
                                         unsigned_word cia,
                                         idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Add_to_Minus_One_Extended
#undef MY_PREFIX
#define MY_PREFIX Add_to_Minus_One_Extended_OE0_Rc1
#line 2632 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Add to Minus One Extended\n"));
#line 20511 "icache.c"

  /* validate: 0.31,6.RT,11.RA,16./,21.OE,22.234,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00fbfe) != 0x7c0001d4)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.234,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.XO.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.XO.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 2632 "../../../sim/ppc/powerpc.igen"
    unsigned const OE ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 2632 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 20537 "icache.c"

#define insn cache_entry->crack.XO.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Add_to_Minus_One_Extended_OE0_Rc1;

    /* semantic routine */
#line 2632 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Add to Minus One Extended\n"));
#line 20547 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Add_to_Minus_One_Extended, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2632 "../../../sim/ppc/powerpc.igen"
    {
      ALU_BEGIN(*rA);
      ALU_ADD_CA;
      ALU_ADD(-1);
      ALU_END(*rT, 1/*CA*/, OE, Rc);
      PPC_INSN_INT(RT_BITMASK, RA_BITMASK, Rc);
    }
#line 20564 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.234,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 20568 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Multiply_Low_Word_OE0_Rc0(cpu *processor,
                                 instruction_word instruction,
                                 unsigned_word cia,
                                 idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Multiply_Low_Word
#undef MY_PREFIX
#define MY_PREFIX Multiply_Low_Word_OE0_Rc0
#line 2698 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Multiply Low Word\n"));
#line 20587 "icache.c"

  /* validate: 0.31,6.RT,11.RA,16.RB,21.OE,22.235,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0003fe) != 0x7c0001d6)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.235,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.XO.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.XO.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.XO.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 2698 "../../../sim/ppc/powerpc.igen"
    unsigned const OE ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 2698 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 20619 "icache.c"

#define insn cache_entry->crack.XO.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Multiply_Low_Word_OE0_Rc0;

    /* semantic routine */
#line 2698 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Multiply Low Word\n"));
#line 20629 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Multiply_Low_Word, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2698 "../../../sim/ppc/powerpc.igen"
    {
      int64_t a = (int32_t)(*rA);
      int64_t b = (int32_t)(*rB);
      int64_t prod = a * b;
      signed_word t = prod;
      *rT = *rA * *rB;
      if (t != prod && OE)
        XER |= (xer_overflow | xer_summary_overflow);
      CR0_COMPARE(t, 0, Rc);
      PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
    }
#line 20650 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.235,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 20654 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Multiply_Low_Word_OE0_Rc1(cpu *processor,
                                 instruction_word instruction,
                                 unsigned_word cia,
                                 idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Multiply_Low_Word
#undef MY_PREFIX
#define MY_PREFIX Multiply_Low_Word_OE0_Rc1
#line 2698 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Multiply Low Word\n"));
#line 20673 "icache.c"

  /* validate: 0.31,6.RT,11.RA,16.RB,21.OE,22.235,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0003fe) != 0x7c0001d6)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.235,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.XO.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.XO.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.XO.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 2698 "../../../sim/ppc/powerpc.igen"
    unsigned const OE ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 2698 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 20705 "icache.c"

#define insn cache_entry->crack.XO.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Multiply_Low_Word_OE0_Rc1;

    /* semantic routine */
#line 2698 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Multiply Low Word\n"));
#line 20715 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Multiply_Low_Word, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2698 "../../../sim/ppc/powerpc.igen"
    {
      int64_t a = (int32_t)(*rA);
      int64_t b = (int32_t)(*rB);
      int64_t prod = a * b;
      signed_word t = prod;
      *rT = *rA * *rB;
      if (t != prod && OE)
        XER |= (xer_overflow | xer_summary_overflow);
      CR0_COMPARE(t, 0, Rc);
      PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
    }
#line 20736 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.235,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 20740 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Move_To_Segment_Register_Indirect(cpu *processor,
                                         instruction_word instruction,
                                         unsigned_word cia,
                                         idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Move_To_Segment_Register_Indirect
#undef MY_PREFIX
#define MY_PREFIX Move_To_Segment_Register_Indirect
#line 4942 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Move To Segment Register Indirect\n"));
#line 20759 "icache.c"

  /* validate: 0.31,6.RS,11./,16.RB,21.242,31./ */
  if (WITH_RESERVED_BITS && (instruction & 0xfc1f07ff) != 0x7c0001e4)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RS,11./,16.RB,21.242,31./ #define get-values-from-icache|put-values-in-icache */
#line 43 "../../../sim/ppc/powerpc.igen"
    unsigned const RS ATTRIBUTE_UNUSED = cache_entry->crack.X.RS = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 44 "../../../sim/ppc/powerpc.igen"
    signed_word * const rS ATTRIBUTE_UNUSED = cache_entry->crack.X.rS = (cpu_registers(processor)->gpr + RS); /* in icache - extraction */
#line 45 "../../../sim/ppc/powerpc.igen"
    uint32_t const RS_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RS_BITMASK = (1 << RS); /* in icache - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.X.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.X.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 20780 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Move_To_Segment_Register_Indirect;

    /* semantic routine */
#line 4942 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Move To Segment Register Indirect\n"));
#line 20790 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Move_To_Segment_Register_Indirect, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4942 "../../../sim/ppc/powerpc.igen"
    {
      if (IS_PROBLEM_STATE(processor))
        program_interrupt(processor, cia,
                          privileged_instruction_program_interrupt);
      else
        SEGREG(EXTRACTED32(*rB, 0, 3)) = *rS;
    }
#line 20807 "icache.c"
    return nia;
    /* extraction: 0.31,6.RS,11./,16.RB,21.242,31./ #undef get-values-from-icache|put-values-in-icache */
#line 20810 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Data_Cache_Block_Touch_for_Store(cpu *processor,
                                        instruction_word instruction,
                                        unsigned_word cia,
                                        idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Data_Cache_Block_Touch_for_Store
#undef MY_PREFIX
#define MY_PREFIX Data_Cache_Block_Touch_for_Store
#line 4795 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Data Cache Block Touch for Store\n"));
#line 20829 "icache.c"

  /* validate: 0.31,6./,11.RA,16.RB,21.246,31./ */
  if (WITH_RESERVED_BITS && (instruction & 0xffe007ff) != 0x7c0001ec)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6./,11.RA,16.RB,21.246,31./ #define get-values-from-icache|put-values-in-icache */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.X.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.X.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.X.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.X.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 20851 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Data_Cache_Block_Touch_for_Store;

    /* semantic routine */
#line 4795 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Data Cache Block Touch for Store\n"));
#line 20861 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Data_Cache_Block_Touch_for_Store, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4795 "../../../sim/ppc/powerpc.igen"
    {
      TRACE(trace_tbd,("Data Cache Block Touch for Store\n"));
      PPC_INSN_INT(0, (RA_BITMASK & ~1) | RB_BITMASK, 0/*Rc*/);
    }
#line 20875 "icache.c"
    return nia;
    /* extraction: 0.31,6./,11.RA,16.RB,21.246,31./ #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 20879 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Store_Byte_with_Update_Indexed(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_Byte_with_Update_Indexed
#undef MY_PREFIX
#define MY_PREFIX Store_Byte_with_Update_Indexed
#line 2044 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Store Byte with Update Indexed\n"));
#line 20898 "icache.c"

  /* validate: 0.31,6.RS,11.RA,16.RB,21.247,31./ */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007ff) != 0x7c0001ee)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RS,11.RA,16.RB,21.247,31./ #define get-values-from-icache|put-values-in-icache */
#line 43 "../../../sim/ppc/powerpc.igen"
    unsigned const RS ATTRIBUTE_UNUSED = cache_entry->crack.X.RS = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 44 "../../../sim/ppc/powerpc.igen"
    signed_word * const rS ATTRIBUTE_UNUSED = cache_entry->crack.X.rS = (cpu_registers(processor)->gpr + RS); /* in icache - extraction */
#line 45 "../../../sim/ppc/powerpc.igen"
    uint32_t const RS_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RS_BITMASK = (1 << RS); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.X.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.X.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.X.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.X.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 20926 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Store_Byte_with_Update_Indexed;

    /* semantic routine */
#line 2044 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Store Byte with Update Indexed\n"));
#line 20936 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Store_Byte_with_Update_Indexed, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2044 "../../../sim/ppc/powerpc.igen"
    {
      unsigned_word EA;
      if (RA_is_0)
        program_interrupt(processor, cia,
                          illegal_instruction_program_interrupt);
      EA = *rA + *rB;
      STORE(EA, 1, *rS);
      *rA = EA;
      PPC_INSN_INT(RA_BITMASK, RA_BITMASK | RB_BITMASK | RS_BITMASK, 0);
    }
#line 20956 "icache.c"
    return nia;
    /* extraction: 0.31,6.RS,11.RA,16.RB,21.247,31./ #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 20960 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Add_OE0_Rc0(cpu *processor,
                   instruction_word instruction,
                   unsigned_word cia,
                   idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Add
#undef MY_PREFIX
#define MY_PREFIX Add_OE0_Rc0
#line 2532 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Add\n"));
#line 20979 "icache.c"

  /* validate: 0.31,6.RT,11.RA,16.RB,21.OE,22.266,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0003fe) != 0x7c000214)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.266,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.XO.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.XO.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.XO.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 2532 "../../../sim/ppc/powerpc.igen"
    unsigned const OE ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 2532 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 21011 "icache.c"

#define insn cache_entry->crack.XO.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Add_OE0_Rc0;

    /* semantic routine */
#line 2532 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Add\n"));
#line 21021 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Add, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2532 "../../../sim/ppc/powerpc.igen"
    {
      ALU_BEGIN(*rA);
      ALU_ADD(*rB);
      ALU_END(*rT, 0/*CA*/, OE, Rc);
      PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
    }
#line 21037 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.266,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 21041 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Add_OE0_Rc1(cpu *processor,
                   instruction_word instruction,
                   unsigned_word cia,
                   idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Add
#undef MY_PREFIX
#define MY_PREFIX Add_OE0_Rc1
#line 2532 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Add\n"));
#line 21060 "icache.c"

  /* validate: 0.31,6.RT,11.RA,16.RB,21.OE,22.266,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0003fe) != 0x7c000214)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.266,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.XO.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.XO.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.XO.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 2532 "../../../sim/ppc/powerpc.igen"
    unsigned const OE ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 2532 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 21092 "icache.c"

#define insn cache_entry->crack.XO.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Add_OE0_Rc1;

    /* semantic routine */
#line 2532 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Add\n"));
#line 21102 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Add, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2532 "../../../sim/ppc/powerpc.igen"
    {
      ALU_BEGIN(*rA);
      ALU_ADD(*rB);
      ALU_END(*rT, 0/*CA*/, OE, Rc);
      PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
    }
#line 21118 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.266,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 21122 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Data_Cache_Block_Touch(cpu *processor,
                              instruction_word instruction,
                              unsigned_word cia,
                              idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Data_Cache_Block_Touch
#undef MY_PREFIX
#define MY_PREFIX Data_Cache_Block_Touch
#line 4787 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Data Cache Block Touch\n"));
#line 21141 "icache.c"

  /* validate: 0.31,6./,11.RA,16.RB,21.278,31./ */
  if (WITH_RESERVED_BITS && (instruction & 0xffe007ff) != 0x7c00022c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6./,11.RA,16.RB,21.278,31./ #define get-values-from-icache|put-values-in-icache */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.X.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.X.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.X.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.X.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 21163 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Data_Cache_Block_Touch;

    /* semantic routine */
#line 4787 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Data Cache Block Touch\n"));
#line 21173 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Data_Cache_Block_Touch, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4787 "../../../sim/ppc/powerpc.igen"
    {
      TRACE(trace_tbd,("Data Cache Block Touch\n"));
      PPC_INSN_INT(0, (RA_BITMASK & ~1) | RB_BITMASK, 0/*Rc*/);
    }
#line 21187 "icache.c"
    return nia;
    /* extraction: 0.31,6./,11.RA,16.RB,21.278,31./ #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 21191 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Load_Halfword_and_Zero_Indexed(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_Halfword_and_Zero_Indexed
#undef MY_PREFIX
#define MY_PREFIX Load_Halfword_and_Zero_Indexed
#line 1790 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Load Halfword and Zero Indexed\n"));
#line 21210 "icache.c"

  /* validate: 0.31,6.RT,11.RA,16.RB,21.279,31./ */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007ff) != 0x7c00022e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.279,31./ #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.X.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.X.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.X.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.X.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.X.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.X.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 21238 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Load_Halfword_and_Zero_Indexed;

    /* semantic routine */
#line 1790 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Load Halfword and Zero Indexed\n"));
#line 21248 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Load_Halfword_and_Zero_Indexed, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1790 "../../../sim/ppc/powerpc.igen"
    {
      unsigned_word b;
      unsigned_word EA;
      if (RA_is_0) b = 0;
      else         b = *rA;
      EA = b + *rB;
      *rT = MEM(unsigned, EA, 2);
      PPC_INSN_INT(RT_BITMASK, (RA_BITMASK & ~1) | RB_BITMASK, 0);
    }
#line 21267 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.279,31./ #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 21271 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Equivalent_Rc0(cpu *processor,
                      instruction_word instruction,
                      unsigned_word cia,
                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Equivalent
#undef MY_PREFIX
#define MY_PREFIX Equivalent_Rc0
#line 3060 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Equivalent\n"));
#line 21290 "icache.c"

  /* validate: 0.31,6.RS,11.RA,16.RB,21.284,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007fe) != 0x7c000238)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RS,11.RA,16.RB,21.284,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 43 "../../../sim/ppc/powerpc.igen"
    unsigned const RS ATTRIBUTE_UNUSED = cache_entry->crack.X.RS = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 44 "../../../sim/ppc/powerpc.igen"
    signed_word * const rS ATTRIBUTE_UNUSED = cache_entry->crack.X.rS = (cpu_registers(processor)->gpr + RS); /* in icache - extraction */
#line 45 "../../../sim/ppc/powerpc.igen"
    uint32_t const RS_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RS_BITMASK = (1 << RS); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.X.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.X.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.X.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.X.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 3060 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 21320 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Equivalent_Rc0;

    /* semantic routine */
#line 3060 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Equivalent\n"));
#line 21330 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Equivalent, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3060 "../../../sim/ppc/powerpc.igen"
    {
      *rA = ~(*rS ^ *rB); /* A === B */
      CR0_COMPARE(*rA, 0, Rc);
      ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
      PPC_INSN_INT(RA_BITMASK, RS_BITMASK | RB_BITMASK, Rc);
    }
#line 21346 "icache.c"
    return nia;
    /* extraction: 0.31,6.RS,11.RA,16.RB,21.284,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 21350 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Equivalent_Rc1(cpu *processor,
                      instruction_word instruction,
                      unsigned_word cia,
                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Equivalent
#undef MY_PREFIX
#define MY_PREFIX Equivalent_Rc1
#line 3060 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Equivalent\n"));
#line 21369 "icache.c"

  /* validate: 0.31,6.RS,11.RA,16.RB,21.284,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007fe) != 0x7c000238)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RS,11.RA,16.RB,21.284,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 43 "../../../sim/ppc/powerpc.igen"
    unsigned const RS ATTRIBUTE_UNUSED = cache_entry->crack.X.RS = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 44 "../../../sim/ppc/powerpc.igen"
    signed_word * const rS ATTRIBUTE_UNUSED = cache_entry->crack.X.rS = (cpu_registers(processor)->gpr + RS); /* in icache - extraction */
#line 45 "../../../sim/ppc/powerpc.igen"
    uint32_t const RS_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RS_BITMASK = (1 << RS); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.X.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.X.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.X.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.X.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 3060 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 21399 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Equivalent_Rc1;

    /* semantic routine */
#line 3060 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Equivalent\n"));
#line 21409 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Equivalent, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3060 "../../../sim/ppc/powerpc.igen"
    {
      *rA = ~(*rS ^ *rB); /* A === B */
      CR0_COMPARE(*rA, 0, Rc);
      ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
      PPC_INSN_INT(RA_BITMASK, RS_BITMASK | RB_BITMASK, Rc);
    }
#line 21425 "icache.c"
    return nia;
    /* extraction: 0.31,6.RS,11.RA,16.RB,21.284,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 21429 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_TLB_Invalidate_Entry(cpu *processor,
                            instruction_word instruction,
                            unsigned_word cia,
                            idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_TLB_Invalidate_Entry
#undef MY_PREFIX
#define MY_PREFIX TLB_Invalidate_Entry
#line 4980 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode TLB Invalidate Entry\n"));
#line 21448 "icache.c"

  /* validate: 0.31,6./,11./,16.RB,21.306,31./ */
  if (WITH_RESERVED_BITS && (instruction & 0xffff07ff) != 0x7c000264)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6./,11./,16.RB,21.306,31./ #define get-values-from-icache|put-values-in-icache */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.X.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.X.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 21463 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_TLB_Invalidate_Entry;

    /* semantic routine */
#line 4980 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics TLB Invalidate Entry\n"));
#line 21473 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_TLB_Invalidate_Entry, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4980 "../../../sim/ppc/powerpc.igen"
    {
      if (IS_PROBLEM_STATE(processor))
        program_interrupt(processor, cia,
                          privileged_instruction_program_interrupt);
      else {
        int nr = 0;
        cpu *proc;
        while (1) {
          proc = psim_cpu(cpu_system(processor), nr);
          if (proc == NULL) break;
          cpu_page_tlb_invalidate_entry(proc, *rB);
          nr++;
        }
      }
    }
#line 21498 "icache.c"
    return nia;
    /* extraction: 0.31,6./,11./,16.RB,21.306,31./ #undef get-values-from-icache|put-values-in-icache */
#line 21501 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Load_Halfword_and_Zero_with_Update_Indexed(cpu *processor,
                                                  instruction_word instruction,
                                                  unsigned_word cia,
                                                  idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_Halfword_and_Zero_with_Update_Indexed
#undef MY_PREFIX
#define MY_PREFIX Load_Halfword_and_Zero_with_Update_Indexed
#line 1817 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Load Halfword and Zero with Update Indexed\n"));
#line 21520 "icache.c"

  /* validate: 0.31,6.RT,11.RA,16.RB,21.311,31./ */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007ff) != 0x7c00026e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.311,31./ #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.X.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.X.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.X.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.X.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.X.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.X.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 21548 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Load_Halfword_and_Zero_with_Update_Indexed;

    /* semantic routine */
#line 1817 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Load Halfword and Zero with Update Indexed\n"));
#line 21558 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Load_Halfword_and_Zero_with_Update_Indexed, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1817 "../../../sim/ppc/powerpc.igen"
    {
      unsigned_word EA;
      if (RA_is_0 || RA == RT)
        program_interrupt(processor, cia,
                          illegal_instruction_program_interrupt);
      EA = *rA + *rB;
      *rT = MEM(unsigned, EA, 2);
      *rA = EA;
      PPC_INSN_INT(RT_BITMASK | RA_BITMASK, RA_BITMASK | RB_BITMASK, 0);
    }
#line 21578 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.311,31./ #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 21582 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_XOR_Rc0(cpu *processor,
               instruction_word instruction,
               unsigned_word cia,
               idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_XOR
#undef MY_PREFIX
#define MY_PREFIX XOR_Rc0
#line 3030 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode XOR\n"));
#line 21601 "icache.c"

  /* validate: 0.31,6.RS,11.RA,16.RB,21.316,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007fe) != 0x7c000278)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RS,11.RA,16.RB,21.316,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 43 "../../../sim/ppc/powerpc.igen"
    unsigned const RS ATTRIBUTE_UNUSED = cache_entry->crack.X.RS = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 44 "../../../sim/ppc/powerpc.igen"
    signed_word * const rS ATTRIBUTE_UNUSED = cache_entry->crack.X.rS = (cpu_registers(processor)->gpr + RS); /* in icache - extraction */
#line 45 "../../../sim/ppc/powerpc.igen"
    uint32_t const RS_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RS_BITMASK = (1 << RS); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.X.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.X.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.X.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.X.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 3030 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 21631 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_XOR_Rc0;

    /* semantic routine */
#line 3030 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics XOR\n"));
#line 21641 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_XOR, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3030 "../../../sim/ppc/powerpc.igen"
    {
      *rA = *rS ^ *rB;
      CR0_COMPARE(*rA, 0, Rc);
      ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
      PPC_INSN_INT(RA_BITMASK, RS_BITMASK | RB_BITMASK, Rc);
    }
#line 21657 "icache.c"
    return nia;
    /* extraction: 0.31,6.RS,11.RA,16.RB,21.316,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 21661 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_XOR_Rc1(cpu *processor,
               instruction_word instruction,
               unsigned_word cia,
               idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_XOR
#undef MY_PREFIX
#define MY_PREFIX XOR_Rc1
#line 3030 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode XOR\n"));
#line 21680 "icache.c"

  /* validate: 0.31,6.RS,11.RA,16.RB,21.316,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007fe) != 0x7c000278)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RS,11.RA,16.RB,21.316,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 43 "../../../sim/ppc/powerpc.igen"
    unsigned const RS ATTRIBUTE_UNUSED = cache_entry->crack.X.RS = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 44 "../../../sim/ppc/powerpc.igen"
    signed_word * const rS ATTRIBUTE_UNUSED = cache_entry->crack.X.rS = (cpu_registers(processor)->gpr + RS); /* in icache - extraction */
#line 45 "../../../sim/ppc/powerpc.igen"
    uint32_t const RS_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RS_BITMASK = (1 << RS); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.X.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.X.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.X.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.X.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 3030 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 21710 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_XOR_Rc1;

    /* semantic routine */
#line 3030 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics XOR\n"));
#line 21720 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_XOR, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3030 "../../../sim/ppc/powerpc.igen"
    {
      *rA = *rS ^ *rB;
      CR0_COMPARE(*rA, 0, Rc);
      ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
      PPC_INSN_INT(RA_BITMASK, RS_BITMASK | RB_BITMASK, Rc);
    }
#line 21736 "icache.c"
    return nia;
    /* extraction: 0.31,6.RS,11.RA,16.RB,21.316,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 21740 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Move_from_Special_Purpose_Register_SPR256(cpu *processor,
                                                 instruction_word instruction,
                                                 unsigned_word cia,
                                                 idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Move_from_Special_Purpose_Register
#undef MY_PREFIX
#define MY_PREFIX Move_from_Special_Purpose_Register_SPR256
#line 3388 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Move from Special Purpose Register\n"));
#line 21759 "icache.c"

  /* validate: 0.31,6.RT,11.SPR,21.339,31./ */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007ff) != 0x7c0002a6)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11.SPR,21.339,31./ #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.XFX.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.XFX.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XFX.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 3388 "../../../sim/ppc/powerpc.igen"
    unsigned const SPR ATTRIBUTE_UNUSED = 256; /* default in icache - constant field */
#line 21776 "icache.c"

#define insn cache_entry->crack.XFX.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Move_from_Special_Purpose_Register_SPR256;

    /* semantic routine */
#line 3388 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Move from Special Purpose Register\n"));
#line 21786 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Move_from_Special_Purpose_Register, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3388 "../../../sim/ppc/powerpc.igen"
    {
      int n = (SPR_5_9_ << 5) | SPR_0_4_;
      if (SPR_0_ && IS_PROBLEM_STATE(processor))
        program_interrupt(processor, cia,
                          privileged_instruction_program_interrupt);
      else if (!spr_is_valid(n))
        program_interrupt(processor, cia,
                          illegal_instruction_program_interrupt);
      else {
        /* HACK - time base registers need to be calculated */
        if (WITH_TIME_BASE) {
          switch (n) {
          case spr_dec:
            *rT = cpu_get_decrementer(processor);
            break;
      	case spr_tbrl:
        	  if (is_64bit_implementation) *rT = TB;
        	  else                         *rT = EXTRACTED64(TB, 32, 63);
      	break;
      	case spr_tbru:
        	  if (is_64bit_implementation) *rT = EXTRACTED64(TB, 0, 31);
      	  else                         *rT = EXTRACTED64(TB, 0, 31);
      	break;
          case spr_tbu:
          case spr_tbl:
            /* NOTE - these SPR's are not readable. Use mftb[ul] */
          default:
            *rT = SPREG(n);
            break;
          }
        }
        else {
          *rT = SPREG(n);
        }
      }
      PPC_INSN_FROM_SPR(RT_BITMASK, n);
    }
#line 21833 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11.SPR,21.339,31./ #undef get-values-from-icache|put-values-in-icache */
#line 21836 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Move_from_Special_Purpose_Register_SPR(cpu *processor,
                                              instruction_word instruction,
                                              unsigned_word cia,
                                              idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Move_from_Special_Purpose_Register
#undef MY_PREFIX
#define MY_PREFIX Move_from_Special_Purpose_Register_SPR
#line 3388 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Move from Special Purpose Register\n"));
#line 21855 "icache.c"

  /* validate: 0.31,6.RT,11.SPR,21.339,31./ */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007ff) != 0x7c0002a6)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11.SPR,21.339,31./ #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.XFX.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.XFX.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XFX.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 3388 "../../../sim/ppc/powerpc.igen"
    unsigned const SPR ATTRIBUTE_UNUSED = cache_entry->crack.XFX.SPR = EXTRACTED32(instruction, 11, 20); /* default in icache - extraction */
#line 21872 "icache.c"

#define insn cache_entry->crack.XFX.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Move_from_Special_Purpose_Register_SPR;

    /* semantic routine */
#line 3388 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Move from Special Purpose Register\n"));
#line 21882 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Move_from_Special_Purpose_Register, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3388 "../../../sim/ppc/powerpc.igen"
    {
      int n = (SPR_5_9_ << 5) | SPR_0_4_;
      if (SPR_0_ && IS_PROBLEM_STATE(processor))
        program_interrupt(processor, cia,
                          privileged_instruction_program_interrupt);
      else if (!spr_is_valid(n))
        program_interrupt(processor, cia,
                          illegal_instruction_program_interrupt);
      else {
        /* HACK - time base registers need to be calculated */
        if (WITH_TIME_BASE) {
          switch (n) {
          case spr_dec:
            *rT = cpu_get_decrementer(processor);
            break;
      	case spr_tbrl:
        	  if (is_64bit_implementation) *rT = TB;
        	  else                         *rT = EXTRACTED64(TB, 32, 63);
      	break;
      	case spr_tbru:
        	  if (is_64bit_implementation) *rT = EXTRACTED64(TB, 0, 31);
      	  else                         *rT = EXTRACTED64(TB, 0, 31);
      	break;
          case spr_tbu:
          case spr_tbl:
            /* NOTE - these SPR's are not readable. Use mftb[ul] */
          default:
            *rT = SPREG(n);
            break;
          }
        }
        else {
          *rT = SPREG(n);
        }
      }
      PPC_INSN_FROM_SPR(RT_BITMASK, n);
    }
#line 21929 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11.SPR,21.339,31./ #undef get-values-from-icache|put-values-in-icache */
#line 21932 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Load_Halfword_Algebraic_Indexed(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_Halfword_Algebraic_Indexed
#undef MY_PREFIX
#define MY_PREFIX Load_Halfword_Algebraic_Indexed
#line 1844 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Load Halfword Algebraic Indexed\n"));
#line 21951 "icache.c"

  /* validate: 0.31,6.RT,11.RA,16.RB,21.343,31./ */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007ff) != 0x7c0002ae)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.343,31./ #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.X.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.X.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.X.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.X.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.X.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.X.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 21979 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Load_Halfword_Algebraic_Indexed;

    /* semantic routine */
#line 1844 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Load Halfword Algebraic Indexed\n"));
#line 21989 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Load_Halfword_Algebraic_Indexed, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1844 "../../../sim/ppc/powerpc.igen"
    {
      unsigned_word b;
      unsigned_word EA;
      if (RA_is_0) b = 0;
      else         b = *rA;
      EA = b + *rB;
      *rT = MEM(signed, EA, 2);
      PPC_INSN_INT(RT_BITMASK, (RA_BITMASK & ~1) | RB_BITMASK, 0);
    }
#line 22008 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.343,31./ #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 22012 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_TLB_Invalidate_All(cpu *processor,
                          instruction_word instruction,
                          unsigned_word cia,
                          idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_TLB_Invalidate_All
#undef MY_PREFIX
#define MY_PREFIX TLB_Invalidate_All
#line 4995 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode TLB Invalidate All\n"));
#line 22031 "icache.c"

  /* validate: 0.31,6./,11./,16./,21.370,31./ */
  if (WITH_RESERVED_BITS && (instruction & 0xffffffff) != 0x7c0002e4)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6./,11./,16./,21.370,31./ #define get-values-from-icache|put-values-in-icache */
#line 22040 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_TLB_Invalidate_All;

    /* semantic routine */
#line 4995 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics TLB Invalidate All\n"));
#line 22050 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_TLB_Invalidate_All, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4995 "../../../sim/ppc/powerpc.igen"
    {
      if (IS_PROBLEM_STATE(processor))
        program_interrupt(processor, cia,
                          privileged_instruction_program_interrupt);
      else {
        int nr = 0;
        cpu *proc;
        while (1) {
          proc = psim_cpu(cpu_system(processor), nr);
          if (proc == NULL) break;
          cpu_page_tlb_invalidate_all(proc);
          nr++;
        }
      }
    }
#line 22075 "icache.c"
    return nia;
    /* extraction: 0.31,6./,11./,16./,21.370,31./ #undef get-values-from-icache|put-values-in-icache */
#line 22078 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Move_From_Time_Base(cpu *processor,
                           instruction_word instruction,
                           unsigned_word cia,
                           idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Move_From_Time_Base
#undef MY_PREFIX
#define MY_PREFIX Move_From_Time_Base
#line 4838 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Move From Time Base\n"));
#line 22097 "icache.c"

  /* validate: 0.31,6.RT,11.tbr,21.371,31./ */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007ff) != 0x7c0002e6)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11.tbr,21.371,31./ #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.XFX.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.XFX.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XFX.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 4838 "../../../sim/ppc/powerpc.igen"
    unsigned const tbr ATTRIBUTE_UNUSED = cache_entry->crack.XFX.tbr = EXTRACTED32(instruction, 11, 20); /* default in icache - extraction */
#line 22114 "icache.c"

#define insn cache_entry->crack.XFX.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Move_From_Time_Base;

    /* semantic routine */
#line 4838 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Move From Time Base\n"));
#line 22124 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Move_From_Time_Base, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4838 "../../../sim/ppc/powerpc.igen"
    {
      int n = (tbr_5_9_ << 5) | tbr_0_4_;
      if (n == 268) {
        if (is_64bit_implementation) *rT = TB;
        else                         *rT = EXTRACTED64(TB, 32, 63);
      }
      else if (n == 269) {
        if (is_64bit_implementation) *rT = EXTRACTED64(TB, 0, 31);
        else                         *rT = EXTRACTED64(TB, 0, 31);
      }
      else
        program_interrupt(processor, cia,
                          illegal_instruction_program_interrupt);
    }
#line 22148 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11.tbr,21.371,31./ #undef get-values-from-icache|put-values-in-icache */
#line 22151 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Load_Halfword_Algebraic_with_Update_Indexed(cpu *processor,
                                                   instruction_word instruction,
                                                   unsigned_word cia,
                                                   idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_Halfword_Algebraic_with_Update_Indexed
#undef MY_PREFIX
#define MY_PREFIX Load_Halfword_Algebraic_with_Update_Indexed
#line 1871 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Load Halfword Algebraic with Update Indexed\n"));
#line 22170 "icache.c"

  /* validate: 0.31,6.RT,11.RA,16.RB,21.375,31./ */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007ff) != 0x7c0002ee)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.375,31./ #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.X.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.X.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.X.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.X.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.X.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.X.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 22198 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Load_Halfword_Algebraic_with_Update_Indexed;

    /* semantic routine */
#line 1871 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Load Halfword Algebraic with Update Indexed\n"));
#line 22208 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Load_Halfword_Algebraic_with_Update_Indexed, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1871 "../../../sim/ppc/powerpc.igen"
    {
      unsigned_word EA;
      if (RA_is_0 || RA == RT)
        program_interrupt(processor, cia,
                          illegal_instruction_program_interrupt);
      EA = *rA + *rB;
      *rT = MEM(signed, EA, 2);
      *rA = EA;
      PPC_INSN_INT(RT_BITMASK | RA_BITMASK, RA_BITMASK | RB_BITMASK, 0);
    }
#line 22228 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.375,31./ #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 22232 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Store_Half_Word_Indexed(cpu *processor,
                               instruction_word instruction,
                               unsigned_word cia,
                               idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_Half_Word_Indexed
#undef MY_PREFIX
#define MY_PREFIX Store_Half_Word_Indexed
#line 2071 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Store Half Word Indexed\n"));
#line 22251 "icache.c"

  /* validate: 0.31,6.RS,11.RA,16.RB,21.407,31./ */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007ff) != 0x7c00032e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RS,11.RA,16.RB,21.407,31./ #define get-values-from-icache|put-values-in-icache */
#line 43 "../../../sim/ppc/powerpc.igen"
    unsigned const RS ATTRIBUTE_UNUSED = cache_entry->crack.X.RS = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 44 "../../../sim/ppc/powerpc.igen"
    signed_word * const rS ATTRIBUTE_UNUSED = cache_entry->crack.X.rS = (cpu_registers(processor)->gpr + RS); /* in icache - extraction */
#line 45 "../../../sim/ppc/powerpc.igen"
    uint32_t const RS_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RS_BITMASK = (1 << RS); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.X.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.X.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.X.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.X.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 22279 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Store_Half_Word_Indexed;

    /* semantic routine */
#line 2071 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Store Half Word Indexed\n"));
#line 22289 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Store_Half_Word_Indexed, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2071 "../../../sim/ppc/powerpc.igen"
    {
      unsigned_word b;
      unsigned_word EA;
      if (RA_is_0) b = 0;
      else         b = *rA;
      EA = b + *rB;
      STORE(EA, 2, *rS);
      PPC_INSN_INT(0, (RA_BITMASK & ~1) | RB_BITMASK | RS_BITMASK, 0);
    }
#line 22308 "icache.c"
    return nia;
    /* extraction: 0.31,6.RS,11.RA,16.RB,21.407,31./ #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 22312 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_OR_with_Complement_Rc0(cpu *processor,
                              instruction_word instruction,
                              unsigned_word cia,
                              idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_OR_with_Complement
#undef MY_PREFIX
#define MY_PREFIX OR_with_Complement_Rc0
#line 3080 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode OR with Complement\n"));
#line 22331 "icache.c"

  /* validate: 0.31,6.RS,11.RA,16.RB,21.412,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007fe) != 0x7c000338)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RS,11.RA,16.RB,21.412,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 43 "../../../sim/ppc/powerpc.igen"
    unsigned const RS ATTRIBUTE_UNUSED = cache_entry->crack.X.RS = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 44 "../../../sim/ppc/powerpc.igen"
    signed_word * const rS ATTRIBUTE_UNUSED = cache_entry->crack.X.rS = (cpu_registers(processor)->gpr + RS); /* in icache - extraction */
#line 45 "../../../sim/ppc/powerpc.igen"
    uint32_t const RS_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RS_BITMASK = (1 << RS); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.X.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.X.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.X.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.X.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 3080 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 22361 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_OR_with_Complement_Rc0;

    /* semantic routine */
#line 3080 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics OR with Complement\n"));
#line 22371 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_OR_with_Complement, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3080 "../../../sim/ppc/powerpc.igen"
    {
      *rA = *rS | ~*rB;
      CR0_COMPARE(*rA, 0, Rc);
      ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
      PPC_INSN_INT(RA_BITMASK, RS_BITMASK | RB_BITMASK, Rc);
    }
#line 22387 "icache.c"
    return nia;
    /* extraction: 0.31,6.RS,11.RA,16.RB,21.412,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 22391 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_OR_with_Complement_Rc1(cpu *processor,
                              instruction_word instruction,
                              unsigned_word cia,
                              idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_OR_with_Complement
#undef MY_PREFIX
#define MY_PREFIX OR_with_Complement_Rc1
#line 3080 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode OR with Complement\n"));
#line 22410 "icache.c"

  /* validate: 0.31,6.RS,11.RA,16.RB,21.412,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007fe) != 0x7c000338)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RS,11.RA,16.RB,21.412,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 43 "../../../sim/ppc/powerpc.igen"
    unsigned const RS ATTRIBUTE_UNUSED = cache_entry->crack.X.RS = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 44 "../../../sim/ppc/powerpc.igen"
    signed_word * const rS ATTRIBUTE_UNUSED = cache_entry->crack.X.rS = (cpu_registers(processor)->gpr + RS); /* in icache - extraction */
#line 45 "../../../sim/ppc/powerpc.igen"
    uint32_t const RS_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RS_BITMASK = (1 << RS); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.X.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.X.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.X.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.X.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 3080 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 22440 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_OR_with_Complement_Rc1;

    /* semantic routine */
#line 3080 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics OR with Complement\n"));
#line 22450 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_OR_with_Complement, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3080 "../../../sim/ppc/powerpc.igen"
    {
      *rA = *rS | ~*rB;
      CR0_COMPARE(*rA, 0, Rc);
      ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
      PPC_INSN_INT(RA_BITMASK, RS_BITMASK | RB_BITMASK, Rc);
    }
#line 22466 "icache.c"
    return nia;
    /* extraction: 0.31,6.RS,11.RA,16.RB,21.412,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 22470 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Store_Half_Word_with_Update_Indexed(cpu *processor,
                                           instruction_word instruction,
                                           unsigned_word cia,
                                           idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_Half_Word_with_Update_Indexed
#undef MY_PREFIX
#define MY_PREFIX Store_Half_Word_with_Update_Indexed
#line 2098 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Store Half Word with Update Indexed\n"));
#line 22489 "icache.c"

  /* validate: 0.31,6.RS,11.RA,16.RB,21.439,31./ */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007ff) != 0x7c00036e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RS,11.RA,16.RB,21.439,31./ #define get-values-from-icache|put-values-in-icache */
#line 43 "../../../sim/ppc/powerpc.igen"
    unsigned const RS ATTRIBUTE_UNUSED = cache_entry->crack.X.RS = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 44 "../../../sim/ppc/powerpc.igen"
    signed_word * const rS ATTRIBUTE_UNUSED = cache_entry->crack.X.rS = (cpu_registers(processor)->gpr + RS); /* in icache - extraction */
#line 45 "../../../sim/ppc/powerpc.igen"
    uint32_t const RS_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RS_BITMASK = (1 << RS); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.X.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.X.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.X.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.X.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 22517 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Store_Half_Word_with_Update_Indexed;

    /* semantic routine */
#line 2098 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Store Half Word with Update Indexed\n"));
#line 22527 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Store_Half_Word_with_Update_Indexed, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2098 "../../../sim/ppc/powerpc.igen"
    {
      unsigned_word EA;
      if (RA_is_0)
        program_interrupt(processor, cia,
                          illegal_instruction_program_interrupt);
      EA = *rA + *rB;
      STORE(EA, 2, *rS);
      *rA = EA;
      PPC_INSN_INT(RA_BITMASK, RA_BITMASK | RB_BITMASK | RS_BITMASK, 0);
    }
#line 22547 "icache.c"
    return nia;
    /* extraction: 0.31,6.RS,11.RA,16.RB,21.439,31./ #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 22551 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_OR_Rc0(cpu *processor,
              instruction_word instruction,
              unsigned_word cia,
              idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_OR
#undef MY_PREFIX
#define MY_PREFIX OR_Rc0
#line 3020 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode OR\n"));
#line 22570 "icache.c"

  /* validate: 0.31,6.RS,11.RA,16.RB,21.444,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007fe) != 0x7c000378)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RS,11.RA,16.RB,21.444,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 43 "../../../sim/ppc/powerpc.igen"
    unsigned const RS ATTRIBUTE_UNUSED = cache_entry->crack.X.RS = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 44 "../../../sim/ppc/powerpc.igen"
    signed_word * const rS ATTRIBUTE_UNUSED = cache_entry->crack.X.rS = (cpu_registers(processor)->gpr + RS); /* in icache - extraction */
#line 45 "../../../sim/ppc/powerpc.igen"
    uint32_t const RS_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RS_BITMASK = (1 << RS); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.X.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.X.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.X.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.X.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 3020 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 22600 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_OR_Rc0;

    /* semantic routine */
#line 3020 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics OR\n"));
#line 22610 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_OR, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3020 "../../../sim/ppc/powerpc.igen"
    {
      *rA = *rS | *rB;
      CR0_COMPARE(*rA, 0, Rc);
      ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
      PPC_INSN_INT(RA_BITMASK, RS_BITMASK | RB_BITMASK, Rc);
    }
#line 22626 "icache.c"
    return nia;
    /* extraction: 0.31,6.RS,11.RA,16.RB,21.444,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 22630 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_OR_Rc1(cpu *processor,
              instruction_word instruction,
              unsigned_word cia,
              idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_OR
#undef MY_PREFIX
#define MY_PREFIX OR_Rc1
#line 3020 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode OR\n"));
#line 22649 "icache.c"

  /* validate: 0.31,6.RS,11.RA,16.RB,21.444,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007fe) != 0x7c000378)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RS,11.RA,16.RB,21.444,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 43 "../../../sim/ppc/powerpc.igen"
    unsigned const RS ATTRIBUTE_UNUSED = cache_entry->crack.X.RS = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 44 "../../../sim/ppc/powerpc.igen"
    signed_word * const rS ATTRIBUTE_UNUSED = cache_entry->crack.X.rS = (cpu_registers(processor)->gpr + RS); /* in icache - extraction */
#line 45 "../../../sim/ppc/powerpc.igen"
    uint32_t const RS_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RS_BITMASK = (1 << RS); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.X.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.X.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.X.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.X.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 3020 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 22679 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_OR_Rc1;

    /* semantic routine */
#line 3020 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics OR\n"));
#line 22689 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_OR, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3020 "../../../sim/ppc/powerpc.igen"
    {
      *rA = *rS | *rB;
      CR0_COMPARE(*rA, 0, Rc);
      ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
      PPC_INSN_INT(RA_BITMASK, RS_BITMASK | RB_BITMASK, Rc);
    }
#line 22705 "icache.c"
    return nia;
    /* extraction: 0.31,6.RS,11.RA,16.RB,21.444,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 22709 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Divide_Word_Unsigned_OE0_Rc0(cpu *processor,
                                    instruction_word instruction,
                                    unsigned_word cia,
                                    idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Divide_Word_Unsigned
#undef MY_PREFIX
#define MY_PREFIX Divide_Word_Unsigned_OE0_Rc0
#line 2767 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Divide Word Unsigned\n"));
#line 22728 "icache.c"

  /* validate: 0.31,6.RT,11.RA,16.RB,21.OE,22.459,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0003fe) != 0x7c000396)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.459,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.XO.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.XO.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.XO.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 2767 "../../../sim/ppc/powerpc.igen"
    unsigned const OE ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 2767 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 22760 "icache.c"

#define insn cache_entry->crack.XO.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Divide_Word_Unsigned_OE0_Rc0;

    /* semantic routine */
#line 2767 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Divide Word Unsigned\n"));
#line 22770 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Divide_Word_Unsigned, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2767 "../../../sim/ppc/powerpc.igen"
    {
      uint64_t dividend = (uint32_t)(*rA);
      uint64_t divisor = (uint32_t)(*rB);
      if (divisor == 0) {
        if (OE)
          XER |= (xer_overflow | xer_summary_overflow);
        CR0_COMPARE(0, 0, Rc);
      }
      else {
        uint64_t quotent = dividend / divisor;
        *rT = quotent;
        CR0_COMPARE((signed_word)quotent, 0, Rc);
      }
      PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
    }
#line 22795 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.459,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 22799 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Divide_Word_Unsigned_OE0_Rc1(cpu *processor,
                                    instruction_word instruction,
                                    unsigned_word cia,
                                    idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Divide_Word_Unsigned
#undef MY_PREFIX
#define MY_PREFIX Divide_Word_Unsigned_OE0_Rc1
#line 2767 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Divide Word Unsigned\n"));
#line 22818 "icache.c"

  /* validate: 0.31,6.RT,11.RA,16.RB,21.OE,22.459,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0003fe) != 0x7c000396)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.459,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.XO.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.XO.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.XO.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 2767 "../../../sim/ppc/powerpc.igen"
    unsigned const OE ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 2767 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 22850 "icache.c"

#define insn cache_entry->crack.XO.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Divide_Word_Unsigned_OE0_Rc1;

    /* semantic routine */
#line 2767 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Divide Word Unsigned\n"));
#line 22860 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Divide_Word_Unsigned, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2767 "../../../sim/ppc/powerpc.igen"
    {
      uint64_t dividend = (uint32_t)(*rA);
      uint64_t divisor = (uint32_t)(*rB);
      if (divisor == 0) {
        if (OE)
          XER |= (xer_overflow | xer_summary_overflow);
        CR0_COMPARE(0, 0, Rc);
      }
      else {
        uint64_t quotent = dividend / divisor;
        *rT = quotent;
        CR0_COMPARE((signed_word)quotent, 0, Rc);
      }
      PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
    }
#line 22885 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.459,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 22889 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Move_to_Special_Purpose_Register_SPR256(cpu *processor,
                                               instruction_word instruction,
                                               unsigned_word cia,
                                               idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Move_to_Special_Purpose_Register
#undef MY_PREFIX
#define MY_PREFIX Move_to_Special_Purpose_Register_SPR256
#line 3344 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Move to Special Purpose Register\n"));
#line 22908 "icache.c"

  /* validate: 0.31,6.RS,11.SPR,21.467,31./ */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007ff) != 0x7c0003a6)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RS,11.SPR,21.467,31./ #define get-values-from-icache|put-values-in-icache */
#line 43 "../../../sim/ppc/powerpc.igen"
    unsigned const RS ATTRIBUTE_UNUSED = cache_entry->crack.XFX.RS = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 44 "../../../sim/ppc/powerpc.igen"
    signed_word * const rS ATTRIBUTE_UNUSED = cache_entry->crack.XFX.rS = (cpu_registers(processor)->gpr + RS); /* in icache - extraction */
#line 45 "../../../sim/ppc/powerpc.igen"
    uint32_t const RS_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XFX.RS_BITMASK = (1 << RS); /* in icache - extraction */
#line 3344 "../../../sim/ppc/powerpc.igen"
    unsigned const SPR ATTRIBUTE_UNUSED = 256; /* default in icache - constant field */
#line 22925 "icache.c"

#define insn cache_entry->crack.XFX.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Move_to_Special_Purpose_Register_SPR256;

    /* semantic routine */
#line 3344 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Move to Special Purpose Register\n"));
#line 22935 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Move_to_Special_Purpose_Register, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3344 "../../../sim/ppc/powerpc.igen"
    {
      int n = (SPR_5_9_ << 5) | SPR_0_4_;
      if (SPR_0_ && IS_PROBLEM_STATE(processor))
        program_interrupt(processor, cia,
                          privileged_instruction_program_interrupt);
      else if (!spr_is_valid(n)
               || spr_is_readonly(n))
        program_interrupt(processor, cia,
                          illegal_instruction_program_interrupt);
      else {
        spreg new_val = (spr_length(n) == 64
      		   ? *rS
      		   : MASKED(*rS, 32, 63));
        /* HACK - time base registers need to be updated immediately */
        if (WITH_TIME_BASE) {
          switch (n) {
          case spr_tbu:
            cpu_set_time_base(processor,
                              (MASKED64(cpu_get_time_base(processor), 32, 63)
                               | INSERTED64(new_val, 0, 31)));
            break;
          case spr_tbl:
            cpu_set_time_base(processor,
                              (MASKED64(cpu_get_time_base(processor), 0, 31)
                               | INSERTED64(new_val, 32, 63)));
            break;
          case spr_dec:
            cpu_set_decrementer(processor, new_val);
            break;
          default:
            SPREG(n) = new_val;
            break;
          }
        }
        else {
          SPREG(n) = new_val;
        }
      }
      PPC_INSN_TO_SPR(RS_BITMASK, n);
    }
#line 22985 "icache.c"
    return nia;
    /* extraction: 0.31,6.RS,11.SPR,21.467,31./ #undef get-values-from-icache|put-values-in-icache */
#line 22988 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Move_to_Special_Purpose_Register_SPR(cpu *processor,
                                            instruction_word instruction,
                                            unsigned_word cia,
                                            idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Move_to_Special_Purpose_Register
#undef MY_PREFIX
#define MY_PREFIX Move_to_Special_Purpose_Register_SPR
#line 3344 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Move to Special Purpose Register\n"));
#line 23007 "icache.c"

  /* validate: 0.31,6.RS,11.SPR,21.467,31./ */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007ff) != 0x7c0003a6)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RS,11.SPR,21.467,31./ #define get-values-from-icache|put-values-in-icache */
#line 43 "../../../sim/ppc/powerpc.igen"
    unsigned const RS ATTRIBUTE_UNUSED = cache_entry->crack.XFX.RS = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 44 "../../../sim/ppc/powerpc.igen"
    signed_word * const rS ATTRIBUTE_UNUSED = cache_entry->crack.XFX.rS = (cpu_registers(processor)->gpr + RS); /* in icache - extraction */
#line 45 "../../../sim/ppc/powerpc.igen"
    uint32_t const RS_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XFX.RS_BITMASK = (1 << RS); /* in icache - extraction */
#line 3344 "../../../sim/ppc/powerpc.igen"
    unsigned const SPR ATTRIBUTE_UNUSED = cache_entry->crack.XFX.SPR = EXTRACTED32(instruction, 11, 20); /* default in icache - extraction */
#line 23024 "icache.c"

#define insn cache_entry->crack.XFX.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Move_to_Special_Purpose_Register_SPR;

    /* semantic routine */
#line 3344 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Move to Special Purpose Register\n"));
#line 23034 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Move_to_Special_Purpose_Register, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3344 "../../../sim/ppc/powerpc.igen"
    {
      int n = (SPR_5_9_ << 5) | SPR_0_4_;
      if (SPR_0_ && IS_PROBLEM_STATE(processor))
        program_interrupt(processor, cia,
                          privileged_instruction_program_interrupt);
      else if (!spr_is_valid(n)
               || spr_is_readonly(n))
        program_interrupt(processor, cia,
                          illegal_instruction_program_interrupt);
      else {
        spreg new_val = (spr_length(n) == 64
      		   ? *rS
      		   : MASKED(*rS, 32, 63));
        /* HACK - time base registers need to be updated immediately */
        if (WITH_TIME_BASE) {
          switch (n) {
          case spr_tbu:
            cpu_set_time_base(processor,
                              (MASKED64(cpu_get_time_base(processor), 32, 63)
                               | INSERTED64(new_val, 0, 31)));
            break;
          case spr_tbl:
            cpu_set_time_base(processor,
                              (MASKED64(cpu_get_time_base(processor), 0, 31)
                               | INSERTED64(new_val, 32, 63)));
            break;
          case spr_dec:
            cpu_set_decrementer(processor, new_val);
            break;
          default:
            SPREG(n) = new_val;
            break;
          }
        }
        else {
          SPREG(n) = new_val;
        }
      }
      PPC_INSN_TO_SPR(RS_BITMASK, n);
    }
#line 23084 "icache.c"
    return nia;
    /* extraction: 0.31,6.RS,11.SPR,21.467,31./ #undef get-values-from-icache|put-values-in-icache */
#line 23087 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Data_Cache_Block_Invalidate(cpu *processor,
                                   instruction_word instruction,
                                   unsigned_word cia,
                                   idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Data_Cache_Block_Invalidate
#undef MY_PREFIX
#define MY_PREFIX Data_Cache_Block_Invalidate
#line 4916 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Data Cache Block Invalidate\n"));
#line 23106 "icache.c"

  /* validate: 0.31,6./,11.RA,16.RB,21.470,31./ */
  if (WITH_RESERVED_BITS && (instruction & 0xffe007ff) != 0x7c0003ac)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6./,11.RA,16.RB,21.470,31./ #define get-values-from-icache|put-values-in-icache */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.X.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.X.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.X.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.X.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 23128 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Data_Cache_Block_Invalidate;

    /* semantic routine */
#line 4916 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Data Cache Block Invalidate\n"));
#line 23138 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Data_Cache_Block_Invalidate, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4916 "../../../sim/ppc/powerpc.igen"
    {
      if (IS_PROBLEM_STATE(processor))
        program_interrupt(processor, cia,
                          privileged_instruction_program_interrupt);
      else
        TRACE(trace_tbd,("Data Cache Block Invalidate\n"));
    }
#line 23155 "icache.c"
    return nia;
    /* extraction: 0.31,6./,11.RA,16.RB,21.470,31./ #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 23159 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_NAND_Rc0(cpu *processor,
                instruction_word instruction,
                unsigned_word cia,
                idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_NAND
#undef MY_PREFIX
#define MY_PREFIX NAND_Rc0
#line 3040 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode NAND\n"));
#line 23178 "icache.c"

  /* validate: 0.31,6.RS,11.RA,16.RB,21.476,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007fe) != 0x7c0003b8)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RS,11.RA,16.RB,21.476,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 43 "../../../sim/ppc/powerpc.igen"
    unsigned const RS ATTRIBUTE_UNUSED = cache_entry->crack.X.RS = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 44 "../../../sim/ppc/powerpc.igen"
    signed_word * const rS ATTRIBUTE_UNUSED = cache_entry->crack.X.rS = (cpu_registers(processor)->gpr + RS); /* in icache - extraction */
#line 45 "../../../sim/ppc/powerpc.igen"
    uint32_t const RS_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RS_BITMASK = (1 << RS); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.X.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.X.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.X.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.X.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 3040 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 23208 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_NAND_Rc0;

    /* semantic routine */
#line 3040 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics NAND\n"));
#line 23218 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_NAND, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3040 "../../../sim/ppc/powerpc.igen"
    {
      *rA = ~(*rS & *rB);
      CR0_COMPARE(*rA, 0, Rc);
      ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
      PPC_INSN_INT(RA_BITMASK, RS_BITMASK | RB_BITMASK, Rc);
    }
#line 23234 "icache.c"
    return nia;
    /* extraction: 0.31,6.RS,11.RA,16.RB,21.476,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 23238 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_NAND_Rc1(cpu *processor,
                instruction_word instruction,
                unsigned_word cia,
                idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_NAND
#undef MY_PREFIX
#define MY_PREFIX NAND_Rc1
#line 3040 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode NAND\n"));
#line 23257 "icache.c"

  /* validate: 0.31,6.RS,11.RA,16.RB,21.476,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007fe) != 0x7c0003b8)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RS,11.RA,16.RB,21.476,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 43 "../../../sim/ppc/powerpc.igen"
    unsigned const RS ATTRIBUTE_UNUSED = cache_entry->crack.X.RS = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 44 "../../../sim/ppc/powerpc.igen"
    signed_word * const rS ATTRIBUTE_UNUSED = cache_entry->crack.X.rS = (cpu_registers(processor)->gpr + RS); /* in icache - extraction */
#line 45 "../../../sim/ppc/powerpc.igen"
    uint32_t const RS_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RS_BITMASK = (1 << RS); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.X.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.X.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.X.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.X.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 3040 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 23287 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_NAND_Rc1;

    /* semantic routine */
#line 3040 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics NAND\n"));
#line 23297 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_NAND, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3040 "../../../sim/ppc/powerpc.igen"
    {
      *rA = ~(*rS & *rB);
      CR0_COMPARE(*rA, 0, Rc);
      ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
      PPC_INSN_INT(RA_BITMASK, RS_BITMASK | RB_BITMASK, Rc);
    }
#line 23313 "icache.c"
    return nia;
    /* extraction: 0.31,6.RS,11.RA,16.RB,21.476,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 23317 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Divide_Word_OE0_Rc0(cpu *processor,
                           instruction_word instruction,
                           unsigned_word cia,
                           idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Divide_Word
#undef MY_PREFIX
#define MY_PREFIX Divide_Word_OE0_Rc0
#line 2745 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Divide Word\n"));
#line 23336 "icache.c"

  /* validate: 0.31,6.RT,11.RA,16.RB,21.OE,22.491,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0003fe) != 0x7c0003d6)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.491,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.XO.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.XO.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.XO.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 2745 "../../../sim/ppc/powerpc.igen"
    unsigned const OE ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 2745 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 23368 "icache.c"

#define insn cache_entry->crack.XO.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Divide_Word_OE0_Rc0;

    /* semantic routine */
#line 2745 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Divide Word\n"));
#line 23378 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Divide_Word, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2745 "../../../sim/ppc/powerpc.igen"
    {
      int64_t dividend = (int32_t)(*rA);
      int64_t divisor = (int32_t)(*rB);
      if (divisor == 0 /* nb 0x8000..0 is sign extended */
          || (dividend == 0x80000000 && divisor == -1)) {
        if (OE)
          XER |= (xer_overflow | xer_summary_overflow);
        CR0_COMPARE(0, 0, Rc);
      }
      else {
        int64_t quotent = dividend / divisor;
        *rT = quotent;
        CR0_COMPARE((signed_word)quotent, 0, Rc);
      }
      PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
    }
#line 23404 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.491,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 23408 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Divide_Word_OE0_Rc1(cpu *processor,
                           instruction_word instruction,
                           unsigned_word cia,
                           idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Divide_Word
#undef MY_PREFIX
#define MY_PREFIX Divide_Word_OE0_Rc1
#line 2745 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Divide Word\n"));
#line 23427 "icache.c"

  /* validate: 0.31,6.RT,11.RA,16.RB,21.OE,22.491,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0003fe) != 0x7c0003d6)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.491,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.XO.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.XO.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.XO.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 2745 "../../../sim/ppc/powerpc.igen"
    unsigned const OE ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 2745 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 23459 "icache.c"

#define insn cache_entry->crack.XO.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Divide_Word_OE0_Rc1;

    /* semantic routine */
#line 2745 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Divide Word\n"));
#line 23469 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Divide_Word, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2745 "../../../sim/ppc/powerpc.igen"
    {
      int64_t dividend = (int32_t)(*rA);
      int64_t divisor = (int32_t)(*rB);
      if (divisor == 0 /* nb 0x8000..0 is sign extended */
          || (dividend == 0x80000000 && divisor == -1)) {
        if (OE)
          XER |= (xer_overflow | xer_summary_overflow);
        CR0_COMPARE(0, 0, Rc);
      }
      else {
        int64_t quotent = dividend / divisor;
        *rT = quotent;
        CR0_COMPARE((signed_word)quotent, 0, Rc);
      }
      PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
    }
#line 23495 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.491,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 23499 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Move_to_Condition_Register_from_XER(cpu *processor,
                                           instruction_word instruction,
                                           unsigned_word cia,
                                           idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Move_to_Condition_Register_from_XER
#undef MY_PREFIX
#define MY_PREFIX Move_to_Condition_Register_from_XER
#line 3444 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Move to Condition Register from XER\n"));
#line 23518 "icache.c"

  /* validate: 0.31,6.BF,9./,11./,16./,21.512,31./ */
  if (WITH_RESERVED_BITS && (instruction & 0xfc7fffff) != 0x7c000400)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.BF,9./,11./,16./,21.512,31./ #define get-values-from-icache|put-values-in-icache */
#line 67 "../../../sim/ppc/powerpc.igen"
    unsigned const BF ATTRIBUTE_UNUSED = cache_entry->crack.X.BF = EXTRACTED32(instruction, 6, 8); /* in icache - extraction */
#line 68 "../../../sim/ppc/powerpc.igen"
    uint32_t const BF_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.BF_BITMASK = (1 << BF); /* in icache - extraction */
#line 23531 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Move_to_Condition_Register_from_XER;

    /* semantic routine */
#line 3444 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Move to Condition Register from XER\n"));
#line 23541 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Move_to_Condition_Register_from_XER, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3444 "../../../sim/ppc/powerpc.igen"
    error("%s:%d:0x%08lx:%s unimplemented\n",
          itable[MY_INDEX].file, itable[MY_INDEX].line_nr, (long)cia, itable[MY_INDEX].name);
#line 23553 "icache.c"
    return nia;
    /* extraction: 0.31,6.BF,9./,11./,16./,21.512,31./ #undef get-values-from-icache|put-values-in-icache */
#line 23556 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Subtract_From_Carrying_OE1_Rc0(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Subtract_From_Carrying
#undef MY_PREFIX
#define MY_PREFIX Subtract_From_Carrying_OE1_Rc0
#line 2596 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Subtract From Carrying\n"));
#line 23575 "icache.c"

  /* validate: 0.31,6.RT,11.RA,16.RB,21.OE,22.8,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0003fe) != 0x7c000010)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.8,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.XO.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.XO.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.XO.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 2596 "../../../sim/ppc/powerpc.igen"
    unsigned const OE ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 2596 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 23607 "icache.c"

#define insn cache_entry->crack.XO.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Subtract_From_Carrying_OE1_Rc0;

    /* semantic routine */
#line 2596 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Subtract From Carrying\n"));
#line 23617 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Subtract_From_Carrying, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2596 "../../../sim/ppc/powerpc.igen"
    {
      /* RT <- ~RA + RB + 1 === RT <- RB - RA */
      ALU_BEGIN(*rA);
      ALU_NOT;
      ALU_ADD(*rB);
      ALU_ADD(1);
      ALU_END(*rT, 1/*CA*/, OE, Rc);
      PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
    }
#line 23636 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.8,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 23640 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Subtract_From_Carrying_OE1_Rc1(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Subtract_From_Carrying
#undef MY_PREFIX
#define MY_PREFIX Subtract_From_Carrying_OE1_Rc1
#line 2596 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Subtract From Carrying\n"));
#line 23659 "icache.c"

  /* validate: 0.31,6.RT,11.RA,16.RB,21.OE,22.8,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0003fe) != 0x7c000010)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.8,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.XO.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.XO.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.XO.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 2596 "../../../sim/ppc/powerpc.igen"
    unsigned const OE ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 2596 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 23691 "icache.c"

#define insn cache_entry->crack.XO.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Subtract_From_Carrying_OE1_Rc1;

    /* semantic routine */
#line 2596 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Subtract From Carrying\n"));
#line 23701 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Subtract_From_Carrying, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2596 "../../../sim/ppc/powerpc.igen"
    {
      /* RT <- ~RA + RB + 1 === RT <- RB - RA */
      ALU_BEGIN(*rA);
      ALU_NOT;
      ALU_ADD(*rB);
      ALU_ADD(1);
      ALU_END(*rT, 1/*CA*/, OE, Rc);
      PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
    }
#line 23720 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.8,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 23724 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Add_Carrying_OE1_Rc0(cpu *processor,
                            instruction_word instruction,
                            unsigned_word cia,
                            idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Add_Carrying
#undef MY_PREFIX
#define MY_PREFIX Add_Carrying_OE1_Rc0
#line 2586 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Add Carrying\n"));
#line 23743 "icache.c"

  /* validate: 0.31,6.RT,11.RA,16.RB,21.OE,22.10,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0003fe) != 0x7c000014)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.10,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.XO.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.XO.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.XO.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 2586 "../../../sim/ppc/powerpc.igen"
    unsigned const OE ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 2586 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 23775 "icache.c"

#define insn cache_entry->crack.XO.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Add_Carrying_OE1_Rc0;

    /* semantic routine */
#line 2586 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Add Carrying\n"));
#line 23785 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Add_Carrying, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2586 "../../../sim/ppc/powerpc.igen"
    {
      ALU_BEGIN(*rA);
      ALU_ADD(*rB);
      ALU_END(*rT, 1/*CA*/, OE, Rc);
      PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
    }
#line 23801 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.10,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 23805 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Add_Carrying_OE1_Rc1(cpu *processor,
                            instruction_word instruction,
                            unsigned_word cia,
                            idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Add_Carrying
#undef MY_PREFIX
#define MY_PREFIX Add_Carrying_OE1_Rc1
#line 2586 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Add Carrying\n"));
#line 23824 "icache.c"

  /* validate: 0.31,6.RT,11.RA,16.RB,21.OE,22.10,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0003fe) != 0x7c000014)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.10,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.XO.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.XO.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.XO.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 2586 "../../../sim/ppc/powerpc.igen"
    unsigned const OE ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 2586 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 23856 "icache.c"

#define insn cache_entry->crack.XO.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Add_Carrying_OE1_Rc1;

    /* semantic routine */
#line 2586 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Add Carrying\n"));
#line 23866 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Add_Carrying, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2586 "../../../sim/ppc/powerpc.igen"
    {
      ALU_BEGIN(*rA);
      ALU_ADD(*rB);
      ALU_END(*rT, 1/*CA*/, OE, Rc);
      PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
    }
#line 23882 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.10,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 23886 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Load_String_Word_Indexed(cpu *processor,
                                instruction_word instruction,
                                unsigned_word cia,
                                idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_String_Word_Indexed
#undef MY_PREFIX
#define MY_PREFIX Load_String_Word_Indexed
#line 2328 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Load String Word Indexed\n"));
#line 23905 "icache.c"

  /* validate: 0.31,6.RT,11.RA,16.RB,21.533,31./ */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007ff) != 0x7c00042a)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.533,31./ #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.X.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.X.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.X.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.X.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.X.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.X.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 23933 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Load_String_Word_Indexed;

    /* semantic routine */
#line 2328 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Load String Word Indexed\n"));
#line 23943 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Load_String_Word_Indexed, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2328 "../../../sim/ppc/powerpc.igen"
    {
      unsigned_word EA;
      unsigned_word b;
      int n;
      int r;
      int i;
      int nr;
      if (RA_is_0) b = 0;
      else         b = *rA;
      EA = b + *rB;
      n = EXTRACTED32(XER, 25, 31);
      r = RT - 1;
      i = 32;
      nr = (n + 3) / 4;
      if (((RT + nr >= 32)
           ? ((RA >= RT || RA < (RT + nr) % 32)
              || (RB >= RT || RB < (RT + nr) % 32))
           : ((RA >= RT && RA < RT + nr)
              || (RB >= RT && RB < RT + nr)))
          || (RT == RA || RT == RB))
        program_interrupt(processor, cia,
                        illegal_instruction_program_interrupt);
      if (CURRENT_ALIGNMENT == STRICT_ALIGNMENT)
        alignment_interrupt(processor, cia, EA);
      while (n > 0) {
        if (i == 32) {
          r = (r + 1) % 32;
          GPR(r) = 0;
        }
        GPR(r) |= INSERTED(MEM(unsigned, EA, 1), i, i+7);
        i = i + 8;
        if (i == 64) i = 32;
        EA = EA + 1;
        n = n - 1;
      }
    }
#line 23989 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.533,31./ #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 23993 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Load_Word_ByteReverse_Indexed(cpu *processor,
                                     instruction_word instruction,
                                     unsigned_word cia,
                                     idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_Word_ByteReverse_Indexed
#undef MY_PREFIX
#define MY_PREFIX Load_Word_ByteReverse_Indexed
#line 2215 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Load Word Byte-Reverse Indexed\n"));
#line 24012 "icache.c"

  /* validate: 0.31,6.RT,11.RA,16.RB,21.534,31./ */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007ff) != 0x7c00042c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.534,31./ #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.X.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.X.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.X.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.X.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.X.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.X.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 24040 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Load_Word_ByteReverse_Indexed;

    /* semantic routine */
#line 2215 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Load Word Byte-Reverse Indexed\n"));
#line 24050 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Load_Word_ByteReverse_Indexed, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2215 "../../../sim/ppc/powerpc.igen"
    {
      unsigned_word b;
      unsigned_word EA;
      if (RA_is_0) b = 0;
      else         b = *rA;
      EA = b + *rB;
      *rT = SWAP_4(MEM(unsigned, EA, 4));
      PPC_INSN_INT(RT_BITMASK, (RA_BITMASK & ~1) | RB_BITMASK, 0);
    }
#line 24069 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.534,31./ #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 24073 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Load_FloatingPoint_Single_Indexed(cpu *processor,
                                         instruction_word instruction,
                                         unsigned_word cia,
                                         idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_FloatingPoint_Single_Indexed
#undef MY_PREFIX
#define MY_PREFIX Load_FloatingPoint_Single_Indexed
#line 3477 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Load Floating-Point Single Indexed\n"));
#line 24092 "icache.c"

  /* validate: 0.31,6.FRT,11.RA,16.RB,21.535,31./ */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007ff) != 0x7c00042e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.FRT,11.RA,16.RB,21.535,31./ #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.X.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.X.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.X.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.X.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.X.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 24127 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Load_FloatingPoint_Single_Indexed;

    /* semantic routine */
#line 3477 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Load Floating-Point Single Indexed\n"));
#line 24137 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Load_FloatingPoint_Single_Indexed, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3477 "../../../sim/ppc/powerpc.igen"
    {
      unsigned_word b;
      unsigned_word EA;
      if (RA_is_0) b = 0;
      else         b = *rA;
      EA = b + *rB;
      *frT = DOUBLE(MEM(unsigned, EA, 4));
      PPC_INSN_INT_FLOAT(0, FRT_BITMASK, (RA_BITMASK & ~1) | RB_BITMASK, 0);
    }
#line 24156 "icache.c"
    return nia;
    /* extraction: 0.31,6.FRT,11.RA,16.RB,21.535,31./ #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef RA_is_0
#line 24161 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Shift_Right_Word_Rc0(cpu *processor,
                            instruction_word instruction,
                            unsigned_word cia,
                            idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Shift_Right_Word
#undef MY_PREFIX
#define MY_PREFIX Shift_Right_Word_Rc0
#line 3271 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Shift Right Word\n"));
#line 24180 "icache.c"

  /* validate: 0.31,6.RS,11.RA,16.RB,21.536,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007fe) != 0x7c000430)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RS,11.RA,16.RB,21.536,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 43 "../../../sim/ppc/powerpc.igen"
    unsigned const RS ATTRIBUTE_UNUSED = cache_entry->crack.X.RS = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 44 "../../../sim/ppc/powerpc.igen"
    signed_word * const rS ATTRIBUTE_UNUSED = cache_entry->crack.X.rS = (cpu_registers(processor)->gpr + RS); /* in icache - extraction */
#line 45 "../../../sim/ppc/powerpc.igen"
    uint32_t const RS_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RS_BITMASK = (1 << RS); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.X.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.X.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.X.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.X.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 3271 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 24210 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Shift_Right_Word_Rc0;

    /* semantic routine */
#line 3271 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Shift Right Word\n"));
#line 24220 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Shift_Right_Word, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3271 "../../../sim/ppc/powerpc.igen"
    {
      int n = MASKED(*rB, 58, 63);
      uint32_t source = *rS;
      signed_word shifted;
      if (n < 32)
        shifted = (source >> n);
      else
        shifted = 0;
      *rA = shifted;
      CR0_COMPARE(shifted, 0, Rc);
      ITRACE(trace_alu, \
             ("n=%d, source=0x%lx, shifted=0x%lx\n",
              n, (unsigned long)source, (unsigned long)shifted));
      PPC_INSN_INT(RA_BITMASK, RS_BITMASK, Rc);
    }
#line 24245 "icache.c"
    return nia;
    /* extraction: 0.31,6.RS,11.RA,16.RB,21.536,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 24249 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Shift_Right_Word_Rc1(cpu *processor,
                            instruction_word instruction,
                            unsigned_word cia,
                            idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Shift_Right_Word
#undef MY_PREFIX
#define MY_PREFIX Shift_Right_Word_Rc1
#line 3271 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Shift Right Word\n"));
#line 24268 "icache.c"

  /* validate: 0.31,6.RS,11.RA,16.RB,21.536,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007fe) != 0x7c000430)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RS,11.RA,16.RB,21.536,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 43 "../../../sim/ppc/powerpc.igen"
    unsigned const RS ATTRIBUTE_UNUSED = cache_entry->crack.X.RS = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 44 "../../../sim/ppc/powerpc.igen"
    signed_word * const rS ATTRIBUTE_UNUSED = cache_entry->crack.X.rS = (cpu_registers(processor)->gpr + RS); /* in icache - extraction */
#line 45 "../../../sim/ppc/powerpc.igen"
    uint32_t const RS_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RS_BITMASK = (1 << RS); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.X.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.X.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.X.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.X.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 3271 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 24298 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Shift_Right_Word_Rc1;

    /* semantic routine */
#line 3271 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Shift Right Word\n"));
#line 24308 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Shift_Right_Word, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3271 "../../../sim/ppc/powerpc.igen"
    {
      int n = MASKED(*rB, 58, 63);
      uint32_t source = *rS;
      signed_word shifted;
      if (n < 32)
        shifted = (source >> n);
      else
        shifted = 0;
      *rA = shifted;
      CR0_COMPARE(shifted, 0, Rc);
      ITRACE(trace_alu, \
             ("n=%d, source=0x%lx, shifted=0x%lx\n",
              n, (unsigned long)source, (unsigned long)shifted));
      PPC_INSN_INT(RA_BITMASK, RS_BITMASK, Rc);
    }
#line 24333 "icache.c"
    return nia;
    /* extraction: 0.31,6.RS,11.RA,16.RB,21.536,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 24337 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Subtract_From_OE1_Rc0(cpu *processor,
                             instruction_word instruction,
                             unsigned_word cia,
                             idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Subtract_From
#undef MY_PREFIX
#define MY_PREFIX Subtract_From_OE1_Rc0
#line 2542 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Subtract From\n"));
#line 24356 "icache.c"

  /* validate: 0.31,6.RT,11.RA,16.RB,21.OE,22.40,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0003fe) != 0x7c000050)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.40,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.XO.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.XO.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.XO.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 2542 "../../../sim/ppc/powerpc.igen"
    unsigned const OE ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 2542 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 24388 "icache.c"

#define insn cache_entry->crack.XO.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Subtract_From_OE1_Rc0;

    /* semantic routine */
#line 2542 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Subtract From\n"));
#line 24398 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Subtract_From, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2542 "../../../sim/ppc/powerpc.igen"
    {
      ALU_BEGIN(*rA);
      ALU_NOT;
      ALU_ADD(*rB);
      ALU_ADD(1);
      ALU_END(*rT, 0/*CA*/, OE, Rc);
      PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
    }
#line 24416 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.40,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 24420 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Subtract_From_OE1_Rc1(cpu *processor,
                             instruction_word instruction,
                             unsigned_word cia,
                             idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Subtract_From
#undef MY_PREFIX
#define MY_PREFIX Subtract_From_OE1_Rc1
#line 2542 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Subtract From\n"));
#line 24439 "icache.c"

  /* validate: 0.31,6.RT,11.RA,16.RB,21.OE,22.40,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0003fe) != 0x7c000050)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.40,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.XO.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.XO.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.XO.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 2542 "../../../sim/ppc/powerpc.igen"
    unsigned const OE ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 2542 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 24471 "icache.c"

#define insn cache_entry->crack.XO.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Subtract_From_OE1_Rc1;

    /* semantic routine */
#line 2542 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Subtract From\n"));
#line 24481 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Subtract_From, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2542 "../../../sim/ppc/powerpc.igen"
    {
      ALU_BEGIN(*rA);
      ALU_NOT;
      ALU_ADD(*rB);
      ALU_ADD(1);
      ALU_END(*rT, 0/*CA*/, OE, Rc);
      PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
    }
#line 24499 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.40,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 24503 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_TLB_Synchronize(cpu *processor,
                       instruction_word instruction,
                       unsigned_word cia,
                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_TLB_Synchronize
#undef MY_PREFIX
#define MY_PREFIX TLB_Synchronize
#line 5010 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode TLB Synchronize\n"));
#line 24522 "icache.c"

  /* validate: 0.31,6./,11./,16./,21.566,31./ */
  if (WITH_RESERVED_BITS && (instruction & 0xffffffff) != 0x7c00046c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6./,11./,16./,21.566,31./ #define get-values-from-icache|put-values-in-icache */
#line 24531 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_TLB_Synchronize;

    /* semantic routine */
#line 5010 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics TLB Synchronize\n"));
#line 24541 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_TLB_Synchronize, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 5010 "../../../sim/ppc/powerpc.igen"
    {
      /* nothing happens here - always in sync */
    }
#line 24554 "icache.c"
    return nia;
    /* extraction: 0.31,6./,11./,16./,21.566,31./ #undef get-values-from-icache|put-values-in-icache */
#line 24557 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Load_FloatingPoint_Single_with_Update_Indexed(cpu *processor,
                                                     instruction_word instruction,
                                                     unsigned_word cia,
                                                     idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_FloatingPoint_Single_with_Update_Indexed
#undef MY_PREFIX
#define MY_PREFIX Load_FloatingPoint_Single_with_Update_Indexed
#line 3504 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Load Floating-Point Single with Update Indexed\n"));
#line 24576 "icache.c"

  /* validate: 0.31,6.FRT,11.RA,16.RB,21.567,31./ */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007ff) != 0x7c00046e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.FRT,11.RA,16.RB,21.567,31./ #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.X.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.X.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.X.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.X.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.X.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 24611 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Load_FloatingPoint_Single_with_Update_Indexed;

    /* semantic routine */
#line 3504 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Load Floating-Point Single with Update Indexed\n"));
#line 24621 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Load_FloatingPoint_Single_with_Update_Indexed, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3504 "../../../sim/ppc/powerpc.igen"
    {
      unsigned_word EA;
      if (RA_is_0)
        program_interrupt(processor, cia,
                          illegal_instruction_program_interrupt);
      EA = *rA + *rB;
      *frT = DOUBLE(MEM(unsigned, EA, 4));
      *rA = EA;
      PPC_INSN_INT_FLOAT(RA_BITMASK, FRT_BITMASK, (RA_BITMASK & ~1) | RB_BITMASK, 0);
    }
#line 24641 "icache.c"
    return nia;
    /* extraction: 0.31,6.FRT,11.RA,16.RB,21.567,31./ #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef RA_is_0
#line 24646 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Move_From_Segment_Register(cpu *processor,
                                  instruction_word instruction,
                                  unsigned_word cia,
                                  idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Move_From_Segment_Register
#undef MY_PREFIX
#define MY_PREFIX Move_From_Segment_Register
#line 4953 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Move From Segment Register\n"));
#line 24665 "icache.c"

  /* validate: 0.31,6.RT,11./,12.SR,16./,21.595,31./ */
  if (WITH_RESERVED_BITS && (instruction & 0xfc10ffff) != 0x7c0004a6)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11./,12.SR,16./,21.595,31./ #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.X.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.X.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 4953 "../../../sim/ppc/powerpc.igen"
    unsigned const SR ATTRIBUTE_UNUSED = cache_entry->crack.X.SR = EXTRACTED32(instruction, 12, 15); /* default in icache - extraction */
#line 24682 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Move_From_Segment_Register;

    /* semantic routine */
#line 4953 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Move From Segment Register\n"));
#line 24692 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Move_From_Segment_Register, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4953 "../../../sim/ppc/powerpc.igen"
    {
      if (IS_PROBLEM_STATE(processor))
        program_interrupt(processor, cia,
                          privileged_instruction_program_interrupt);
      else
        *rT = SEGREG(SR);
    }
#line 24709 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11./,12.SR,16./,21.595,31./ #undef get-values-from-icache|put-values-in-icache */
#line 24712 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Load_String_Word_Immediate(cpu *processor,
                                  instruction_word instruction,
                                  unsigned_word cia,
                                  idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_String_Word_Immediate
#undef MY_PREFIX
#define MY_PREFIX Load_String_Word_Immediate
#line 2296 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Load String Word Immediate\n"));
#line 24731 "icache.c"

  /* validate: 0.31,6.RT,11.RA,16.NB,21.597,31./ */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007ff) != 0x7c0004aa)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11.RA,16.NB,21.597,31./ #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.X.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.X.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.X.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.X.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 2296 "../../../sim/ppc/powerpc.igen"
    unsigned const NB ATTRIBUTE_UNUSED = cache_entry->crack.X.NB = EXTRACTED32(instruction, 16, 20); /* default in icache - extraction */
#line 24755 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Load_String_Word_Immediate;

    /* semantic routine */
#line 2296 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Load String Word Immediate\n"));
#line 24765 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Load_String_Word_Immediate, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2296 "../../../sim/ppc/powerpc.igen"
    {
      unsigned_word EA;
      int n;
      int r;
      int i;
      int nr;
      if (RA_is_0) EA = 0;
      else         EA = *rA;
      if (NB == 0) n = 32;
      else         n = NB;
      r = RT - 1;
      i = 32;
      nr = (n + 3) / 4;
      if ((RT + nr >= 32)
          ? (RA >= RT || RA < (RT + nr) % 32)
          : (RA >= RT && RA < RT + nr))
        program_interrupt(processor, cia,
                          illegal_instruction_program_interrupt);
      if (CURRENT_ALIGNMENT == STRICT_ALIGNMENT)
        alignment_interrupt(processor, cia, EA);
      while (n > 0) {
        if (i == 32) {
          r = (r + 1) % 32;
          GPR(r) = 0;
        }
        GPR(r) |= INSERTED(MEM(unsigned, EA, 1), i, i+7);
        i = i + 8;
        if (i == 64) i = 32;
        EA = EA + 1;
        n = n - 1;
      }
    }
#line 24807 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11.RA,16.NB,21.597,31./ #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 24811 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Synchronize(cpu *processor,
                   instruction_word instruction,
                   unsigned_word cia,
                   idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Synchronize
#undef MY_PREFIX
#define MY_PREFIX Synchronize
#line 2500 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Synchronize\n"));
#line 24830 "icache.c"

  /* validate: 0.31,6./,9.L,11./,16./,21.598,31./ */
  if (WITH_RESERVED_BITS && (instruction & 0xff9fffff) != 0x7c0004ac)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6./,9.L,11./,16./,21.598,31./ #define get-values-from-icache|put-values-in-icache */
#line 2500 "../../../sim/ppc/powerpc.igen"
    unsigned const L ATTRIBUTE_UNUSED = cache_entry->crack.X.L = EXTRACTED32(instruction, 9, 10); /* default in icache - extraction */
#line 24841 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Synchronize;

    /* semantic routine */
#line 2500 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Synchronize\n"));
#line 24851 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Synchronize, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2500 "../../../sim/ppc/powerpc.igen"
    {
      /* do nothing */
    }
#line 24864 "icache.c"
    return nia;
    /* extraction: 0.31,6./,9.L,11./,16./,21.598,31./ #undef get-values-from-icache|put-values-in-icache */
#line 24867 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Load_FloatingPoint_Double_Indexed(cpu *processor,
                                         instruction_word instruction,
                                         unsigned_word cia,
                                         idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_FloatingPoint_Double_Indexed
#undef MY_PREFIX
#define MY_PREFIX Load_FloatingPoint_Double_Indexed
#line 3531 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Load Floating-Point Double Indexed\n"));
#line 24886 "icache.c"

  /* validate: 0.31,6.FRT,11.RA,16.RB,21.599,31./ */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007ff) != 0x7c0004ae)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.FRT,11.RA,16.RB,21.599,31./ #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.X.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.X.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.X.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.X.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.X.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 24921 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Load_FloatingPoint_Double_Indexed;

    /* semantic routine */
#line 3531 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Load Floating-Point Double Indexed\n"));
#line 24931 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Load_FloatingPoint_Double_Indexed, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3531 "../../../sim/ppc/powerpc.igen"
    {
      unsigned_word b;
      unsigned_word EA;
      if (RA_is_0) b = 0;
      else         b = *rA;
      EA = b + *rB;
      *frT = MEM(unsigned, EA, 8);
      PPC_INSN_INT_FLOAT(0, FRT_BITMASK, (RA_BITMASK & ~1) | RB_BITMASK, 0);
    }
#line 24950 "icache.c"
    return nia;
    /* extraction: 0.31,6.FRT,11.RA,16.RB,21.599,31./ #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef RA_is_0
#line 24955 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Negate_OE1_Rc0(cpu *processor,
                      instruction_word instruction,
                      unsigned_word cia,
                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Negate
#undef MY_PREFIX
#define MY_PREFIX Negate_OE1_Rc0
#line 2676 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Negate\n"));
#line 24974 "icache.c"

  /* validate: 0.31,6.RT,11.RA,16./,21.OE,22.104,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00fbfe) != 0x7c0000d0)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.104,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.XO.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.XO.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 2676 "../../../sim/ppc/powerpc.igen"
    unsigned const OE ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 2676 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 25000 "icache.c"

#define insn cache_entry->crack.XO.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Negate_OE1_Rc0;

    /* semantic routine */
#line 2676 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Negate\n"));
#line 25010 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Negate, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2676 "../../../sim/ppc/powerpc.igen"
    {
      ALU_BEGIN(*rA);
      ALU_NOT;
      ALU_ADD(1);
      ALU_END(*rT,0/*CA*/,OE,Rc);
      PPC_INSN_INT(RT_BITMASK, RA_BITMASK, Rc);
    }
#line 25027 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.104,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 25031 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Negate_OE1_Rc1(cpu *processor,
                      instruction_word instruction,
                      unsigned_word cia,
                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Negate
#undef MY_PREFIX
#define MY_PREFIX Negate_OE1_Rc1
#line 2676 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Negate\n"));
#line 25050 "icache.c"

  /* validate: 0.31,6.RT,11.RA,16./,21.OE,22.104,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00fbfe) != 0x7c0000d0)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.104,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.XO.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.XO.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 2676 "../../../sim/ppc/powerpc.igen"
    unsigned const OE ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 2676 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 25076 "icache.c"

#define insn cache_entry->crack.XO.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Negate_OE1_Rc1;

    /* semantic routine */
#line 2676 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Negate\n"));
#line 25086 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Negate, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2676 "../../../sim/ppc/powerpc.igen"
    {
      ALU_BEGIN(*rA);
      ALU_NOT;
      ALU_ADD(1);
      ALU_END(*rT,0/*CA*/,OE,Rc);
      PPC_INSN_INT(RT_BITMASK, RA_BITMASK, Rc);
    }
#line 25103 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.104,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 25107 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Load_FloatingPoint_Double_with_Update_Indexed(cpu *processor,
                                                     instruction_word instruction,
                                                     unsigned_word cia,
                                                     idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_FloatingPoint_Double_with_Update_Indexed
#undef MY_PREFIX
#define MY_PREFIX Load_FloatingPoint_Double_with_Update_Indexed
#line 3558 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Load Floating-Point Double with Update Indexed\n"));
#line 25126 "icache.c"

  /* validate: 0.31,6.FRT,11.RA,16.RB,21.631,31./ */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007ff) != 0x7c0004ee)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.FRT,11.RA,16.RB,21.631,31./ #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.X.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.X.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.X.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.X.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.X.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 25161 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Load_FloatingPoint_Double_with_Update_Indexed;

    /* semantic routine */
#line 3558 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Load Floating-Point Double with Update Indexed\n"));
#line 25171 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Load_FloatingPoint_Double_with_Update_Indexed, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3558 "../../../sim/ppc/powerpc.igen"
    {
      unsigned_word EA;
      if (RA_is_0)
        program_interrupt(processor, cia,
                          illegal_instruction_program_interrupt);
      EA = *rA + *rB;
      *frT = MEM(unsigned, EA, 8);
      *rA = EA;
      PPC_INSN_INT_FLOAT(RA_BITMASK, FRT_BITMASK, (RA_BITMASK & ~1) | RB_BITMASK, 0);
    }
#line 25191 "icache.c"
    return nia;
    /* extraction: 0.31,6.FRT,11.RA,16.RB,21.631,31./ #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef RA_is_0
#line 25196 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Subtract_From_Extended_OE1_Rc0(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Subtract_From_Extended
#undef MY_PREFIX
#define MY_PREFIX Subtract_From_Extended_OE1_Rc0
#line 2620 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Subtract From Extended\n"));
#line 25215 "icache.c"

  /* validate: 0.31,6.RT,11.RA,16.RB,21.OE,22.136,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0003fe) != 0x7c000110)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.136,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.XO.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.XO.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.XO.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 2620 "../../../sim/ppc/powerpc.igen"
    unsigned const OE ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 2620 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 25247 "icache.c"

#define insn cache_entry->crack.XO.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Subtract_From_Extended_OE1_Rc0;

    /* semantic routine */
#line 2620 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Subtract From Extended\n"));
#line 25257 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Subtract_From_Extended, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2620 "../../../sim/ppc/powerpc.igen"
    {
      ALU_BEGIN(*rA);
      ALU_NOT;
      ALU_ADD(*rB);
      ALU_ADD_CA;
      ALU_END(*rT, 1/*CA*/, OE, Rc);
      PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
    }
#line 25275 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.136,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 25279 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Subtract_From_Extended_OE1_Rc1(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Subtract_From_Extended
#undef MY_PREFIX
#define MY_PREFIX Subtract_From_Extended_OE1_Rc1
#line 2620 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Subtract From Extended\n"));
#line 25298 "icache.c"

  /* validate: 0.31,6.RT,11.RA,16.RB,21.OE,22.136,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0003fe) != 0x7c000110)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.136,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.XO.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.XO.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.XO.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 2620 "../../../sim/ppc/powerpc.igen"
    unsigned const OE ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 2620 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 25330 "icache.c"

#define insn cache_entry->crack.XO.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Subtract_From_Extended_OE1_Rc1;

    /* semantic routine */
#line 2620 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Subtract From Extended\n"));
#line 25340 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Subtract_From_Extended, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2620 "../../../sim/ppc/powerpc.igen"
    {
      ALU_BEGIN(*rA);
      ALU_NOT;
      ALU_ADD(*rB);
      ALU_ADD_CA;
      ALU_END(*rT, 1/*CA*/, OE, Rc);
      PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
    }
#line 25358 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.136,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 25362 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Add_Extended_OE1_Rc0(cpu *processor,
                            instruction_word instruction,
                            unsigned_word cia,
                            idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Add_Extended
#undef MY_PREFIX
#define MY_PREFIX Add_Extended_OE1_Rc0
#line 2609 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Add Extended\n"));
#line 25381 "icache.c"

  /* validate: 0.31,6.RT,11.RA,16.RB,21.OE,22.138,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0003fe) != 0x7c000114)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.138,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.XO.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.XO.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.XO.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 2609 "../../../sim/ppc/powerpc.igen"
    unsigned const OE ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 2609 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 25413 "icache.c"

#define insn cache_entry->crack.XO.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Add_Extended_OE1_Rc0;

    /* semantic routine */
#line 2609 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Add Extended\n"));
#line 25423 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Add_Extended, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2609 "../../../sim/ppc/powerpc.igen"
    {
      ALU_BEGIN(*rA);
      ALU_ADD(*rB);
      ALU_ADD_CA;
      ALU_END(*rT, 1/*CA*/, OE, Rc);
      PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
    }
#line 25440 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.138,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 25444 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Add_Extended_OE1_Rc1(cpu *processor,
                            instruction_word instruction,
                            unsigned_word cia,
                            idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Add_Extended
#undef MY_PREFIX
#define MY_PREFIX Add_Extended_OE1_Rc1
#line 2609 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Add Extended\n"));
#line 25463 "icache.c"

  /* validate: 0.31,6.RT,11.RA,16.RB,21.OE,22.138,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0003fe) != 0x7c000114)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.138,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.XO.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.XO.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.XO.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 2609 "../../../sim/ppc/powerpc.igen"
    unsigned const OE ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 2609 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 25495 "icache.c"

#define insn cache_entry->crack.XO.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Add_Extended_OE1_Rc1;

    /* semantic routine */
#line 2609 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Add Extended\n"));
#line 25505 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Add_Extended, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2609 "../../../sim/ppc/powerpc.igen"
    {
      ALU_BEGIN(*rA);
      ALU_ADD(*rB);
      ALU_ADD_CA;
      ALU_END(*rT, 1/*CA*/, OE, Rc);
      PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
    }
#line 25522 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.138,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 25526 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Move_From_Segment_Register_Indirect(cpu *processor,
                                           instruction_word instruction,
                                           unsigned_word cia,
                                           idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Move_From_Segment_Register_Indirect
#undef MY_PREFIX
#define MY_PREFIX Move_From_Segment_Register_Indirect
#line 4964 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Move From Segment Register Indirect\n"));
#line 25545 "icache.c"

  /* validate: 0.31,6.RT,11./,16.RB,21.659,31./ */
  if (WITH_RESERVED_BITS && (instruction & 0xfc1f07ff) != 0x7c000526)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11./,16.RB,21.659,31./ #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.X.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.X.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.X.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.X.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 25566 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Move_From_Segment_Register_Indirect;

    /* semantic routine */
#line 4964 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Move From Segment Register Indirect\n"));
#line 25576 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Move_From_Segment_Register_Indirect, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4964 "../../../sim/ppc/powerpc.igen"
    {
      if (IS_PROBLEM_STATE(processor))
        program_interrupt(processor, cia,
                          privileged_instruction_program_interrupt);
      else
        *rT = SEGREG(EXTRACTED32(*rB, 0, 3));
    }
#line 25593 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11./,16.RB,21.659,31./ #undef get-values-from-icache|put-values-in-icache */
#line 25596 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Store_String_Word_Indexed(cpu *processor,
                                 instruction_word instruction,
                                 unsigned_word cia,
                                 idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_String_Word_Indexed
#undef MY_PREFIX
#define MY_PREFIX Store_String_Word_Indexed
#line 2386 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Store String Word Indexed\n"));
#line 25615 "icache.c"

  /* validate: 0.31,6.RS,11.RA,16.RB,21.661,31./ */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007ff) != 0x7c00052a)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RS,11.RA,16.RB,21.661,31./ #define get-values-from-icache|put-values-in-icache */
#line 43 "../../../sim/ppc/powerpc.igen"
    unsigned const RS ATTRIBUTE_UNUSED = cache_entry->crack.X.RS = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 44 "../../../sim/ppc/powerpc.igen"
    signed_word * const rS ATTRIBUTE_UNUSED = cache_entry->crack.X.rS = (cpu_registers(processor)->gpr + RS); /* in icache - extraction */
#line 45 "../../../sim/ppc/powerpc.igen"
    uint32_t const RS_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RS_BITMASK = (1 << RS); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.X.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.X.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.X.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.X.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 25643 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Store_String_Word_Indexed;

    /* semantic routine */
#line 2386 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Store String Word Indexed\n"));
#line 25653 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Store_String_Word_Indexed, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2386 "../../../sim/ppc/powerpc.igen"
    {
      unsigned_word EA;
      unsigned_word b;
      int n;
      int r;
      int i;
      if (RA_is_0) b = 0;
      else         b = *rA;
      EA = b + *rB;
      if (CURRENT_ALIGNMENT == STRICT_ALIGNMENT)
        alignment_interrupt(processor, cia, EA);
      n = EXTRACTED32(XER, 25, 31);
      r = RS - 1;
      i = 32;
      while (n > 0) {
        if (i == 32) r = (r + 1) % 32;
        STORE(EA, 1, EXTRACTED(GPR(r), i, i+7));
        i = i + 8;
        if (i == 64) i = 32;
        EA = EA + 1;
        n = n - 1;
      }
    }
#line 25686 "icache.c"
    return nia;
    /* extraction: 0.31,6.RS,11.RA,16.RB,21.661,31./ #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 25690 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Store_Word_ByteReversed_Indexed(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_Word_ByteReversed_Indexed
#undef MY_PREFIX
#define MY_PREFIX Store_Word_ByteReversed_Indexed
#line 2241 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Store Word Byte-Reversed Indexed\n"));
#line 25709 "icache.c"

  /* validate: 0.31,6.RS,11.RA,16.RB,21.662,31./ */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007ff) != 0x7c00052c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RS,11.RA,16.RB,21.662,31./ #define get-values-from-icache|put-values-in-icache */
#line 43 "../../../sim/ppc/powerpc.igen"
    unsigned const RS ATTRIBUTE_UNUSED = cache_entry->crack.X.RS = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 44 "../../../sim/ppc/powerpc.igen"
    signed_word * const rS ATTRIBUTE_UNUSED = cache_entry->crack.X.rS = (cpu_registers(processor)->gpr + RS); /* in icache - extraction */
#line 45 "../../../sim/ppc/powerpc.igen"
    uint32_t const RS_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RS_BITMASK = (1 << RS); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.X.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.X.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.X.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.X.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 25737 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Store_Word_ByteReversed_Indexed;

    /* semantic routine */
#line 2241 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Store Word Byte-Reversed Indexed\n"));
#line 25747 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Store_Word_ByteReversed_Indexed, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2241 "../../../sim/ppc/powerpc.igen"
    {
      unsigned_word b;
      unsigned_word EA;
      if (RA_is_0) b = 0;
      else         b = *rA;
      EA = b + *rB;
      STORE(EA, 4, SWAP_4(*rS));
      PPC_INSN_INT(0, (RA_BITMASK & ~1) | RB_BITMASK | RS_BITMASK, 0);
    }
#line 25766 "icache.c"
    return nia;
    /* extraction: 0.31,6.RS,11.RA,16.RB,21.662,31./ #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 25770 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Store_FloatingPoint_Single_Indexed(cpu *processor,
                                          instruction_word instruction,
                                          unsigned_word cia,
                                          idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_FloatingPoint_Single_Indexed
#undef MY_PREFIX
#define MY_PREFIX Store_FloatingPoint_Single_Indexed
#line 3590 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Store Floating-Point Single Indexed\n"));
#line 25789 "icache.c"

  /* validate: 0.31,6.FRS,11.RA,16.RB,21.663,31./ */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007ff) != 0x7c00052e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.FRS,11.RA,16.RB,21.663,31./ #define get-values-from-icache|put-values-in-icache */
#define FRS EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 59 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frS ATTRIBUTE_UNUSED = cache_entry->crack.X.frS = (cpu_registers(processor)->fpr + FRS); /* in icache - extraction */
#line 60 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRS_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.FRS_BITMASK = (1 << FRS); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.X.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.X.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.X.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.X.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 25824 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Store_FloatingPoint_Single_Indexed;

    /* semantic routine */
#line 3590 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Store Floating-Point Single Indexed\n"));
#line 25834 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Store_FloatingPoint_Single_Indexed, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3590 "../../../sim/ppc/powerpc.igen"
    {
      unsigned_word b;
      unsigned_word EA;
      if (RA_is_0) b = 0;
      else         b = *rA;
      EA = b + *rB;
      STORE(EA, 4, SINGLE(*frS));
      PPC_INSN_INT_FLOAT(0, 0, (RA_BITMASK & ~1) | RB_BITMASK, FRS_BITMASK);
    }
#line 25853 "icache.c"
    return nia;
    /* extraction: 0.31,6.FRS,11.RA,16.RB,21.663,31./ #undef get-values-from-icache|put-values-in-icache */
#undef FRS
#undef RA_is_0
#line 25858 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Store_FloatingPoint_Single_with_Update_Indexed(cpu *processor,
                                                      instruction_word instruction,
                                                      unsigned_word cia,
                                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_FloatingPoint_Single_with_Update_Indexed
#undef MY_PREFIX
#define MY_PREFIX Store_FloatingPoint_Single_with_Update_Indexed
#line 3617 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Store Floating-Point Single with Update Indexed\n"));
#line 25877 "icache.c"

  /* validate: 0.31,6.FRS,11.RA,16.RB,21.695,31./ */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007ff) != 0x7c00056e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.FRS,11.RA,16.RB,21.695,31./ #define get-values-from-icache|put-values-in-icache */
#define FRS EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 59 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frS ATTRIBUTE_UNUSED = cache_entry->crack.X.frS = (cpu_registers(processor)->fpr + FRS); /* in icache - extraction */
#line 60 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRS_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.FRS_BITMASK = (1 << FRS); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.X.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.X.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.X.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.X.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 25912 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Store_FloatingPoint_Single_with_Update_Indexed;

    /* semantic routine */
#line 3617 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Store Floating-Point Single with Update Indexed\n"));
#line 25922 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Store_FloatingPoint_Single_with_Update_Indexed, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3617 "../../../sim/ppc/powerpc.igen"
    {
      unsigned_word EA;
      if (RA_is_0)
        program_interrupt(processor, cia,
                          illegal_instruction_program_interrupt);
      EA = *rA + *rB;
      STORE(EA, 4, SINGLE(*frS));
      *rA = EA;
      PPC_INSN_INT_FLOAT(RA_BITMASK, 0, (RA_BITMASK & ~1) | RB_BITMASK, FRS_BITMASK);
    }
#line 25942 "icache.c"
    return nia;
    /* extraction: 0.31,6.FRS,11.RA,16.RB,21.695,31./ #undef get-values-from-icache|put-values-in-icache */
#undef FRS
#undef RA_is_0
#line 25947 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Subtract_from_Zero_Extended_OE1_Rc0(cpu *processor,
                                           instruction_word instruction,
                                           unsigned_word cia,
                                           idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Subtract_from_Zero_Extended
#undef MY_PREFIX
#define MY_PREFIX Subtract_from_Zero_Extended_OE1_Rc0
#line 2665 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Subtract from Zero Extended\n"));
#line 25966 "icache.c"

  /* validate: 0.31,6.RT,11.RA,16./,21.OE,22.200,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00fbfe) != 0x7c000190)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.200,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.XO.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.XO.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 2665 "../../../sim/ppc/powerpc.igen"
    unsigned const OE ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 2665 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 25992 "icache.c"

#define insn cache_entry->crack.XO.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Subtract_from_Zero_Extended_OE1_Rc0;

    /* semantic routine */
#line 2665 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Subtract from Zero Extended\n"));
#line 26002 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Subtract_from_Zero_Extended, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2665 "../../../sim/ppc/powerpc.igen"
    {
      ALU_BEGIN(*rA);
      ALU_NOT;
      ALU_ADD_CA;
      ALU_END(*rT, 1/*CA*/, OE, Rc);
      PPC_INSN_INT(RT_BITMASK, RA_BITMASK, Rc);
    }
#line 26019 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.200,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 26023 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Subtract_from_Zero_Extended_OE1_Rc1(cpu *processor,
                                           instruction_word instruction,
                                           unsigned_word cia,
                                           idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Subtract_from_Zero_Extended
#undef MY_PREFIX
#define MY_PREFIX Subtract_from_Zero_Extended_OE1_Rc1
#line 2665 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Subtract from Zero Extended\n"));
#line 26042 "icache.c"

  /* validate: 0.31,6.RT,11.RA,16./,21.OE,22.200,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00fbfe) != 0x7c000190)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.200,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.XO.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.XO.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 2665 "../../../sim/ppc/powerpc.igen"
    unsigned const OE ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 2665 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 26068 "icache.c"

#define insn cache_entry->crack.XO.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Subtract_from_Zero_Extended_OE1_Rc1;

    /* semantic routine */
#line 2665 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Subtract from Zero Extended\n"));
#line 26078 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Subtract_from_Zero_Extended, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2665 "../../../sim/ppc/powerpc.igen"
    {
      ALU_BEGIN(*rA);
      ALU_NOT;
      ALU_ADD_CA;
      ALU_END(*rT, 1/*CA*/, OE, Rc);
      PPC_INSN_INT(RT_BITMASK, RA_BITMASK, Rc);
    }
#line 26095 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.200,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 26099 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Add_to_Zero_Extended_OE1_Rc0(cpu *processor,
                                    instruction_word instruction,
                                    unsigned_word cia,
                                    idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Add_to_Zero_Extended
#undef MY_PREFIX
#define MY_PREFIX Add_to_Zero_Extended_OE1_Rc0
#line 2655 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Add to Zero Extended\n"));
#line 26118 "icache.c"

  /* validate: 0.31,6.RT,11.RA,16./,21.OE,22.202,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00fbfe) != 0x7c000194)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.202,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.XO.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.XO.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 2655 "../../../sim/ppc/powerpc.igen"
    unsigned const OE ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 2655 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 26144 "icache.c"

#define insn cache_entry->crack.XO.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Add_to_Zero_Extended_OE1_Rc0;

    /* semantic routine */
#line 2655 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Add to Zero Extended\n"));
#line 26154 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Add_to_Zero_Extended, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2655 "../../../sim/ppc/powerpc.igen"
    {
      ALU_BEGIN(*rA);
      ALU_ADD_CA;
      ALU_END(*rT, 1/*CA*/, OE, Rc);
      PPC_INSN_INT(RT_BITMASK, RA_BITMASK, Rc);
    }
#line 26170 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.202,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 26174 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Add_to_Zero_Extended_OE1_Rc1(cpu *processor,
                                    instruction_word instruction,
                                    unsigned_word cia,
                                    idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Add_to_Zero_Extended
#undef MY_PREFIX
#define MY_PREFIX Add_to_Zero_Extended_OE1_Rc1
#line 2655 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Add to Zero Extended\n"));
#line 26193 "icache.c"

  /* validate: 0.31,6.RT,11.RA,16./,21.OE,22.202,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00fbfe) != 0x7c000194)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.202,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.XO.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.XO.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 2655 "../../../sim/ppc/powerpc.igen"
    unsigned const OE ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 2655 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 26219 "icache.c"

#define insn cache_entry->crack.XO.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Add_to_Zero_Extended_OE1_Rc1;

    /* semantic routine */
#line 2655 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Add to Zero Extended\n"));
#line 26229 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Add_to_Zero_Extended, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2655 "../../../sim/ppc/powerpc.igen"
    {
      ALU_BEGIN(*rA);
      ALU_ADD_CA;
      ALU_END(*rT, 1/*CA*/, OE, Rc);
      PPC_INSN_INT(RT_BITMASK, RA_BITMASK, Rc);
    }
#line 26245 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.202,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 26249 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Store_String_Word_Immedate(cpu *processor,
                                  instruction_word instruction,
                                  unsigned_word cia,
                                  idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_String_Word_Immedate
#undef MY_PREFIX
#define MY_PREFIX Store_String_Word_Immedate
#line 2364 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Store String Word Immedate\n"));
#line 26268 "icache.c"

  /* validate: 0.31,6.RS,11.RA,16.NB,21.725,31./ */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007ff) != 0x7c0005aa)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RS,11.RA,16.NB,21.725,31./ #define get-values-from-icache|put-values-in-icache */
#line 43 "../../../sim/ppc/powerpc.igen"
    unsigned const RS ATTRIBUTE_UNUSED = cache_entry->crack.X.RS = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 44 "../../../sim/ppc/powerpc.igen"
    signed_word * const rS ATTRIBUTE_UNUSED = cache_entry->crack.X.rS = (cpu_registers(processor)->gpr + RS); /* in icache - extraction */
#line 45 "../../../sim/ppc/powerpc.igen"
    uint32_t const RS_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RS_BITMASK = (1 << RS); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.X.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.X.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 2364 "../../../sim/ppc/powerpc.igen"
    unsigned const NB ATTRIBUTE_UNUSED = cache_entry->crack.X.NB = EXTRACTED32(instruction, 16, 20); /* default in icache - extraction */
#line 26292 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Store_String_Word_Immedate;

    /* semantic routine */
#line 2364 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Store String Word Immedate\n"));
#line 26302 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Store_String_Word_Immedate, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2364 "../../../sim/ppc/powerpc.igen"
    {
      unsigned_word EA;
      int n;
      int r;
      int i;
      if (RA_is_0) EA = 0;
      else         EA = *rA;
      if (NB == 0) n = 32;
      else         n = NB;
      r = RS - 1;
      i = 32;
      if (CURRENT_ALIGNMENT == STRICT_ALIGNMENT)
        alignment_interrupt(processor, cia, EA);
      while (n > 0) {
        if (i == 32) r = (r + 1) % 32;
        STORE(EA, 1, EXTRACTED(GPR(r), i, i+7));
        i = i + 8;
        if (i == 64) i = 32;
        EA = EA + 1;
        n = n - 1;
      }
    }
#line 26334 "icache.c"
    return nia;
    /* extraction: 0.31,6.RS,11.RA,16.NB,21.725,31./ #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 26338 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Store_FloatingPoint_Double_Indexed(cpu *processor,
                                          instruction_word instruction,
                                          unsigned_word cia,
                                          idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_FloatingPoint_Double_Indexed
#undef MY_PREFIX
#define MY_PREFIX Store_FloatingPoint_Double_Indexed
#line 3644 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Store Floating-Point Double Indexed\n"));
#line 26357 "icache.c"

  /* validate: 0.31,6.FRS,11.RA,16.RB,21.727,31./ */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007ff) != 0x7c0005ae)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.FRS,11.RA,16.RB,21.727,31./ #define get-values-from-icache|put-values-in-icache */
#define FRS EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 59 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frS ATTRIBUTE_UNUSED = cache_entry->crack.X.frS = (cpu_registers(processor)->fpr + FRS); /* in icache - extraction */
#line 60 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRS_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.FRS_BITMASK = (1 << FRS); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.X.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.X.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.X.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.X.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 26392 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Store_FloatingPoint_Double_Indexed;

    /* semantic routine */
#line 3644 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Store Floating-Point Double Indexed\n"));
#line 26402 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Store_FloatingPoint_Double_Indexed, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3644 "../../../sim/ppc/powerpc.igen"
    {
      unsigned_word b;
      unsigned_word EA;
      if (RA_is_0) b = 0;
      else         b = *rA;
      EA = b + *rB;
      STORE(EA, 8, *frS);
      PPC_INSN_INT_FLOAT(0, 0, (RA_BITMASK & ~1) | RB_BITMASK, FRS_BITMASK);
    }
#line 26421 "icache.c"
    return nia;
    /* extraction: 0.31,6.FRS,11.RA,16.RB,21.727,31./ #undef get-values-from-icache|put-values-in-icache */
#undef FRS
#undef RA_is_0
#line 26426 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Subtract_From_Minus_One_Extended_OE1_Rc0(cpu *processor,
                                                instruction_word instruction,
                                                unsigned_word cia,
                                                idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Subtract_From_Minus_One_Extended
#undef MY_PREFIX
#define MY_PREFIX Subtract_From_Minus_One_Extended_OE1_Rc0
#line 2643 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Subtract From Minus One Extended\n"));
#line 26445 "icache.c"

  /* validate: 0.31,6.RT,11.RA,16./,21.OE,22.232,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00fbfe) != 0x7c0001d0)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.232,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.XO.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.XO.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 2643 "../../../sim/ppc/powerpc.igen"
    unsigned const OE ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 2643 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 26471 "icache.c"

#define insn cache_entry->crack.XO.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Subtract_From_Minus_One_Extended_OE1_Rc0;

    /* semantic routine */
#line 2643 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Subtract From Minus One Extended\n"));
#line 26481 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Subtract_From_Minus_One_Extended, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2643 "../../../sim/ppc/powerpc.igen"
    {
      ALU_BEGIN(*rA);
      ALU_NOT;
      ALU_ADD_CA;
      ALU_ADD(-1);
      ALU_END(*rT, 1/*CA*/, OE, Rc);
      PPC_INSN_INT(RT_BITMASK, RA_BITMASK, Rc);
    }
#line 26499 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.232,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 26503 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Subtract_From_Minus_One_Extended_OE1_Rc1(cpu *processor,
                                                instruction_word instruction,
                                                unsigned_word cia,
                                                idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Subtract_From_Minus_One_Extended
#undef MY_PREFIX
#define MY_PREFIX Subtract_From_Minus_One_Extended_OE1_Rc1
#line 2643 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Subtract From Minus One Extended\n"));
#line 26522 "icache.c"

  /* validate: 0.31,6.RT,11.RA,16./,21.OE,22.232,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00fbfe) != 0x7c0001d0)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.232,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.XO.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.XO.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 2643 "../../../sim/ppc/powerpc.igen"
    unsigned const OE ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 2643 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 26548 "icache.c"

#define insn cache_entry->crack.XO.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Subtract_From_Minus_One_Extended_OE1_Rc1;

    /* semantic routine */
#line 2643 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Subtract From Minus One Extended\n"));
#line 26558 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Subtract_From_Minus_One_Extended, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2643 "../../../sim/ppc/powerpc.igen"
    {
      ALU_BEGIN(*rA);
      ALU_NOT;
      ALU_ADD_CA;
      ALU_ADD(-1);
      ALU_END(*rT, 1/*CA*/, OE, Rc);
      PPC_INSN_INT(RT_BITMASK, RA_BITMASK, Rc);
    }
#line 26576 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.232,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 26580 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Add_to_Minus_One_Extended_OE1_Rc0(cpu *processor,
                                         instruction_word instruction,
                                         unsigned_word cia,
                                         idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Add_to_Minus_One_Extended
#undef MY_PREFIX
#define MY_PREFIX Add_to_Minus_One_Extended_OE1_Rc0
#line 2632 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Add to Minus One Extended\n"));
#line 26599 "icache.c"

  /* validate: 0.31,6.RT,11.RA,16./,21.OE,22.234,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00fbfe) != 0x7c0001d4)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.234,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.XO.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.XO.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 2632 "../../../sim/ppc/powerpc.igen"
    unsigned const OE ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 2632 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 26625 "icache.c"

#define insn cache_entry->crack.XO.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Add_to_Minus_One_Extended_OE1_Rc0;

    /* semantic routine */
#line 2632 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Add to Minus One Extended\n"));
#line 26635 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Add_to_Minus_One_Extended, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2632 "../../../sim/ppc/powerpc.igen"
    {
      ALU_BEGIN(*rA);
      ALU_ADD_CA;
      ALU_ADD(-1);
      ALU_END(*rT, 1/*CA*/, OE, Rc);
      PPC_INSN_INT(RT_BITMASK, RA_BITMASK, Rc);
    }
#line 26652 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.234,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 26656 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Add_to_Minus_One_Extended_OE1_Rc1(cpu *processor,
                                         instruction_word instruction,
                                         unsigned_word cia,
                                         idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Add_to_Minus_One_Extended
#undef MY_PREFIX
#define MY_PREFIX Add_to_Minus_One_Extended_OE1_Rc1
#line 2632 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Add to Minus One Extended\n"));
#line 26675 "icache.c"

  /* validate: 0.31,6.RT,11.RA,16./,21.OE,22.234,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00fbfe) != 0x7c0001d4)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.234,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.XO.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.XO.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 2632 "../../../sim/ppc/powerpc.igen"
    unsigned const OE ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 2632 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 26701 "icache.c"

#define insn cache_entry->crack.XO.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Add_to_Minus_One_Extended_OE1_Rc1;

    /* semantic routine */
#line 2632 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Add to Minus One Extended\n"));
#line 26711 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Add_to_Minus_One_Extended, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2632 "../../../sim/ppc/powerpc.igen"
    {
      ALU_BEGIN(*rA);
      ALU_ADD_CA;
      ALU_ADD(-1);
      ALU_END(*rT, 1/*CA*/, OE, Rc);
      PPC_INSN_INT(RT_BITMASK, RA_BITMASK, Rc);
    }
#line 26728 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.234,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 26732 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Multiply_Low_Word_OE1_Rc0(cpu *processor,
                                 instruction_word instruction,
                                 unsigned_word cia,
                                 idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Multiply_Low_Word
#undef MY_PREFIX
#define MY_PREFIX Multiply_Low_Word_OE1_Rc0
#line 2698 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Multiply Low Word\n"));
#line 26751 "icache.c"

  /* validate: 0.31,6.RT,11.RA,16.RB,21.OE,22.235,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0003fe) != 0x7c0001d6)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.235,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.XO.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.XO.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.XO.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 2698 "../../../sim/ppc/powerpc.igen"
    unsigned const OE ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 2698 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 26783 "icache.c"

#define insn cache_entry->crack.XO.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Multiply_Low_Word_OE1_Rc0;

    /* semantic routine */
#line 2698 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Multiply Low Word\n"));
#line 26793 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Multiply_Low_Word, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2698 "../../../sim/ppc/powerpc.igen"
    {
      int64_t a = (int32_t)(*rA);
      int64_t b = (int32_t)(*rB);
      int64_t prod = a * b;
      signed_word t = prod;
      *rT = *rA * *rB;
      if (t != prod && OE)
        XER |= (xer_overflow | xer_summary_overflow);
      CR0_COMPARE(t, 0, Rc);
      PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
    }
#line 26814 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.235,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 26818 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Multiply_Low_Word_OE1_Rc1(cpu *processor,
                                 instruction_word instruction,
                                 unsigned_word cia,
                                 idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Multiply_Low_Word
#undef MY_PREFIX
#define MY_PREFIX Multiply_Low_Word_OE1_Rc1
#line 2698 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Multiply Low Word\n"));
#line 26837 "icache.c"

  /* validate: 0.31,6.RT,11.RA,16.RB,21.OE,22.235,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0003fe) != 0x7c0001d6)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.235,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.XO.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.XO.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.XO.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 2698 "../../../sim/ppc/powerpc.igen"
    unsigned const OE ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 2698 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 26869 "icache.c"

#define insn cache_entry->crack.XO.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Multiply_Low_Word_OE1_Rc1;

    /* semantic routine */
#line 2698 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Multiply Low Word\n"));
#line 26879 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Multiply_Low_Word, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2698 "../../../sim/ppc/powerpc.igen"
    {
      int64_t a = (int32_t)(*rA);
      int64_t b = (int32_t)(*rB);
      int64_t prod = a * b;
      signed_word t = prod;
      *rT = *rA * *rB;
      if (t != prod && OE)
        XER |= (xer_overflow | xer_summary_overflow);
      CR0_COMPARE(t, 0, Rc);
      PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
    }
#line 26900 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.235,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 26904 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Store_FloatingPoint_Double_with_Update_Indexed(cpu *processor,
                                                      instruction_word instruction,
                                                      unsigned_word cia,
                                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_FloatingPoint_Double_with_Update_Indexed
#undef MY_PREFIX
#define MY_PREFIX Store_FloatingPoint_Double_with_Update_Indexed
#line 3683 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Store Floating-Point Double with Update Indexed\n"));
#line 26923 "icache.c"

  /* validate: 0.31,6.FRS,11.RA,16.RB,21.759,31./ */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007ff) != 0x7c0005ee)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.FRS,11.RA,16.RB,21.759,31./ #define get-values-from-icache|put-values-in-icache */
#define FRS EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 59 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frS ATTRIBUTE_UNUSED = cache_entry->crack.X.frS = (cpu_registers(processor)->fpr + FRS); /* in icache - extraction */
#line 60 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRS_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.FRS_BITMASK = (1 << FRS); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.X.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.X.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.X.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.X.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 26958 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Store_FloatingPoint_Double_with_Update_Indexed;

    /* semantic routine */
#line 3683 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Store Floating-Point Double with Update Indexed\n"));
#line 26968 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Store_FloatingPoint_Double_with_Update_Indexed, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3683 "../../../sim/ppc/powerpc.igen"
    {
      unsigned_word EA;
      if (RA_is_0)
        program_interrupt(processor, cia,
                          illegal_instruction_program_interrupt);
      EA = *rA + *rB;
      STORE(EA, 8, *frS);
      *rA = EA;
      PPC_INSN_INT_FLOAT(RA_BITMASK, 0, (RA_BITMASK & ~1) | RB_BITMASK, FRS_BITMASK);
    }
#line 26988 "icache.c"
    return nia;
    /* extraction: 0.31,6.FRS,11.RA,16.RB,21.759,31./ #undef get-values-from-icache|put-values-in-icache */
#undef FRS
#undef RA_is_0
#line 26993 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Add_OE1_Rc0(cpu *processor,
                   instruction_word instruction,
                   unsigned_word cia,
                   idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Add
#undef MY_PREFIX
#define MY_PREFIX Add_OE1_Rc0
#line 2532 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Add\n"));
#line 27012 "icache.c"

  /* validate: 0.31,6.RT,11.RA,16.RB,21.OE,22.266,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0003fe) != 0x7c000214)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.266,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.XO.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.XO.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.XO.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 2532 "../../../sim/ppc/powerpc.igen"
    unsigned const OE ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 2532 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 27044 "icache.c"

#define insn cache_entry->crack.XO.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Add_OE1_Rc0;

    /* semantic routine */
#line 2532 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Add\n"));
#line 27054 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Add, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2532 "../../../sim/ppc/powerpc.igen"
    {
      ALU_BEGIN(*rA);
      ALU_ADD(*rB);
      ALU_END(*rT, 0/*CA*/, OE, Rc);
      PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
    }
#line 27070 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.266,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 27074 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Add_OE1_Rc1(cpu *processor,
                   instruction_word instruction,
                   unsigned_word cia,
                   idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Add
#undef MY_PREFIX
#define MY_PREFIX Add_OE1_Rc1
#line 2532 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Add\n"));
#line 27093 "icache.c"

  /* validate: 0.31,6.RT,11.RA,16.RB,21.OE,22.266,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0003fe) != 0x7c000214)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.266,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.XO.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.XO.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.XO.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 2532 "../../../sim/ppc/powerpc.igen"
    unsigned const OE ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 2532 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 27125 "icache.c"

#define insn cache_entry->crack.XO.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Add_OE1_Rc1;

    /* semantic routine */
#line 2532 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Add\n"));
#line 27135 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Add, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2532 "../../../sim/ppc/powerpc.igen"
    {
      ALU_BEGIN(*rA);
      ALU_ADD(*rB);
      ALU_END(*rT, 0/*CA*/, OE, Rc);
      PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
    }
#line 27151 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.266,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 27155 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Load_Halfword_ByteReverse_Indexed(cpu *processor,
                                         instruction_word instruction,
                                         unsigned_word cia,
                                         idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_Halfword_ByteReverse_Indexed
#undef MY_PREFIX
#define MY_PREFIX Load_Halfword_ByteReverse_Indexed
#line 2202 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Load Halfword Byte-Reverse Indexed\n"));
#line 27174 "icache.c"

  /* validate: 0.31,6.RT,11.RA,16.RB,21.790,31./ */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007ff) != 0x7c00062c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.790,31./ #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.X.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.X.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.X.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.X.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.X.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.X.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 27202 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Load_Halfword_ByteReverse_Indexed;

    /* semantic routine */
#line 2202 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Load Halfword Byte-Reverse Indexed\n"));
#line 27212 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Load_Halfword_ByteReverse_Indexed, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2202 "../../../sim/ppc/powerpc.igen"
    {
      unsigned_word b;
      unsigned_word EA;
      if (RA_is_0) b = 0;
      else         b = *rA;
      EA = b + *rB;
      *rT = SWAP_2(MEM(unsigned, EA, 2));
      PPC_INSN_INT(RT_BITMASK, (RA_BITMASK & ~1) | RB_BITMASK, 0);
    }
#line 27231 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.790,31./ #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 27235 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Shift_Right_Algebraic_Word_Rc0(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Shift_Right_Algebraic_Word
#undef MY_PREFIX
#define MY_PREFIX Shift_Right_Algebraic_Word_Rc0
#line 3314 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Shift Right Algebraic Word\n"));
#line 27254 "icache.c"

  /* validate: 0.31,6.RS,11.RA,16.RB,21.792,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007fe) != 0x7c000630)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RS,11.RA,16.RB,21.792,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 43 "../../../sim/ppc/powerpc.igen"
    unsigned const RS ATTRIBUTE_UNUSED = cache_entry->crack.X.RS = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 44 "../../../sim/ppc/powerpc.igen"
    signed_word * const rS ATTRIBUTE_UNUSED = cache_entry->crack.X.rS = (cpu_registers(processor)->gpr + RS); /* in icache - extraction */
#line 45 "../../../sim/ppc/powerpc.igen"
    uint32_t const RS_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RS_BITMASK = (1 << RS); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.X.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.X.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.X.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.X.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 3314 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 27284 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Shift_Right_Algebraic_Word_Rc0;

    /* semantic routine */
#line 3314 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Shift Right Algebraic Word\n"));
#line 27294 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Shift_Right_Algebraic_Word, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3314 "../../../sim/ppc/powerpc.igen"
    {
      uint64_t mask;
      int n = MASKED(*rB, 59, 63);
      int32_t source = (int32_t)*rS; /* signed to keep sign bit */
      int S = (MASKED(*rS,32,32) != 0);
      int64_t r = ((uint64_t) source);
      r = ((uint64_t) source) << 32 | (uint32_t) source;
      r = ROTL64(r,64-n);
      if (MASKED(*rB,58,58) == 0)
      	mask = (uint64_t) MASK64(n+32,63);
      else
      	mask = (uint64_t) 0;
      *rA = (signed_word) ((r & mask) | (((int64_t) -1*S) & ~mask)); /* if 64bit will sign extend */
      if (S && (MASKED(r & ~mask,32,63)!=0))
        XER |= xer_carry;
      else
        XER &= ~xer_carry;
      CR0_COMPARE(*rA, 0, Rc);
      ITRACE(trace_alu, (" Result = %ld (0x%lx), XER = %ld\n",
      		   (long)*rA, (long)*rA, (long)XER));
      PPC_INSN_INT(RA_BITMASK, RS_BITMASK, Rc);
    }
#line 27326 "icache.c"
    return nia;
    /* extraction: 0.31,6.RS,11.RA,16.RB,21.792,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 27330 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Shift_Right_Algebraic_Word_Rc1(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Shift_Right_Algebraic_Word
#undef MY_PREFIX
#define MY_PREFIX Shift_Right_Algebraic_Word_Rc1
#line 3314 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Shift Right Algebraic Word\n"));
#line 27349 "icache.c"

  /* validate: 0.31,6.RS,11.RA,16.RB,21.792,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007fe) != 0x7c000630)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RS,11.RA,16.RB,21.792,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 43 "../../../sim/ppc/powerpc.igen"
    unsigned const RS ATTRIBUTE_UNUSED = cache_entry->crack.X.RS = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 44 "../../../sim/ppc/powerpc.igen"
    signed_word * const rS ATTRIBUTE_UNUSED = cache_entry->crack.X.rS = (cpu_registers(processor)->gpr + RS); /* in icache - extraction */
#line 45 "../../../sim/ppc/powerpc.igen"
    uint32_t const RS_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RS_BITMASK = (1 << RS); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.X.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.X.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.X.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.X.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 3314 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 27379 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Shift_Right_Algebraic_Word_Rc1;

    /* semantic routine */
#line 3314 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Shift Right Algebraic Word\n"));
#line 27389 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Shift_Right_Algebraic_Word, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3314 "../../../sim/ppc/powerpc.igen"
    {
      uint64_t mask;
      int n = MASKED(*rB, 59, 63);
      int32_t source = (int32_t)*rS; /* signed to keep sign bit */
      int S = (MASKED(*rS,32,32) != 0);
      int64_t r = ((uint64_t) source);
      r = ((uint64_t) source) << 32 | (uint32_t) source;
      r = ROTL64(r,64-n);
      if (MASKED(*rB,58,58) == 0)
      	mask = (uint64_t) MASK64(n+32,63);
      else
      	mask = (uint64_t) 0;
      *rA = (signed_word) ((r & mask) | (((int64_t) -1*S) & ~mask)); /* if 64bit will sign extend */
      if (S && (MASKED(r & ~mask,32,63)!=0))
        XER |= xer_carry;
      else
        XER &= ~xer_carry;
      CR0_COMPARE(*rA, 0, Rc);
      ITRACE(trace_alu, (" Result = %ld (0x%lx), XER = %ld\n",
      		   (long)*rA, (long)*rA, (long)XER));
      PPC_INSN_INT(RA_BITMASK, RS_BITMASK, Rc);
    }
#line 27421 "icache.c"
    return nia;
    /* extraction: 0.31,6.RS,11.RA,16.RB,21.792,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 27425 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Shift_Right_Algebraic_Word_Immediate_Rc0(cpu *processor,
                                                instruction_word instruction,
                                                unsigned_word cia,
                                                idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Shift_Right_Algebraic_Word_Immediate
#undef MY_PREFIX
#define MY_PREFIX Shift_Right_Algebraic_Word_Immediate_Rc0
#line 3292 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Shift Right Algebraic Word Immediate\n"));
#line 27444 "icache.c"

  /* validate: 0.31,6.RS,11.RA,16.SH,21.824,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007fe) != 0x7c000670)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RS,11.RA,16.SH,21.824,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 43 "../../../sim/ppc/powerpc.igen"
    unsigned const RS ATTRIBUTE_UNUSED = cache_entry->crack.X.RS = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 44 "../../../sim/ppc/powerpc.igen"
    signed_word * const rS ATTRIBUTE_UNUSED = cache_entry->crack.X.rS = (cpu_registers(processor)->gpr + RS); /* in icache - extraction */
#line 45 "../../../sim/ppc/powerpc.igen"
    uint32_t const RS_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RS_BITMASK = (1 << RS); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.X.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.X.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 3292 "../../../sim/ppc/powerpc.igen"
    unsigned const SH ATTRIBUTE_UNUSED = cache_entry->crack.X.SH = EXTRACTED32(instruction, 16, 20); /* default in icache - extraction */
#line 3292 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 27470 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Shift_Right_Algebraic_Word_Immediate_Rc0;

    /* semantic routine */
#line 3292 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Shift Right Algebraic Word Immediate\n"));
#line 27480 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Shift_Right_Algebraic_Word_Immediate, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3292 "../../../sim/ppc/powerpc.igen"
    {
      int n = SH;
      signed_word r = ROTL32(*rS, /*64*/32-n);
      signed_word m = MASK(n+32, 63);
      int S = MASKED(*rS, 32, 32);
      signed_word shifted = (r & m) | (S ? ~m : 0);
      *rA = shifted;
      if (S && ((r & ~m) & MASK(32, 63)) != 0)
        XER |= xer_carry;
      else
        XER &= ~xer_carry;
      CR0_COMPARE(shifted, 0, Rc);
      ITRACE(trace_alu, (" Result = %ld (0x%lx), XER = %ld\n",
      		   (long)*rA, (long)*rA, (long)XER));
      PPC_INSN_INT(RA_BITMASK, RS_BITMASK, Rc);
    }
#line 27506 "icache.c"
    return nia;
    /* extraction: 0.31,6.RS,11.RA,16.SH,21.824,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 27510 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Shift_Right_Algebraic_Word_Immediate_Rc1(cpu *processor,
                                                instruction_word instruction,
                                                unsigned_word cia,
                                                idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Shift_Right_Algebraic_Word_Immediate
#undef MY_PREFIX
#define MY_PREFIX Shift_Right_Algebraic_Word_Immediate_Rc1
#line 3292 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Shift Right Algebraic Word Immediate\n"));
#line 27529 "icache.c"

  /* validate: 0.31,6.RS,11.RA,16.SH,21.824,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007fe) != 0x7c000670)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RS,11.RA,16.SH,21.824,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 43 "../../../sim/ppc/powerpc.igen"
    unsigned const RS ATTRIBUTE_UNUSED = cache_entry->crack.X.RS = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 44 "../../../sim/ppc/powerpc.igen"
    signed_word * const rS ATTRIBUTE_UNUSED = cache_entry->crack.X.rS = (cpu_registers(processor)->gpr + RS); /* in icache - extraction */
#line 45 "../../../sim/ppc/powerpc.igen"
    uint32_t const RS_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RS_BITMASK = (1 << RS); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.X.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.X.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 3292 "../../../sim/ppc/powerpc.igen"
    unsigned const SH ATTRIBUTE_UNUSED = cache_entry->crack.X.SH = EXTRACTED32(instruction, 16, 20); /* default in icache - extraction */
#line 3292 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 27555 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Shift_Right_Algebraic_Word_Immediate_Rc1;

    /* semantic routine */
#line 3292 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Shift Right Algebraic Word Immediate\n"));
#line 27565 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Shift_Right_Algebraic_Word_Immediate, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3292 "../../../sim/ppc/powerpc.igen"
    {
      int n = SH;
      signed_word r = ROTL32(*rS, /*64*/32-n);
      signed_word m = MASK(n+32, 63);
      int S = MASKED(*rS, 32, 32);
      signed_word shifted = (r & m) | (S ? ~m : 0);
      *rA = shifted;
      if (S && ((r & ~m) & MASK(32, 63)) != 0)
        XER |= xer_carry;
      else
        XER &= ~xer_carry;
      CR0_COMPARE(shifted, 0, Rc);
      ITRACE(trace_alu, (" Result = %ld (0x%lx), XER = %ld\n",
      		   (long)*rA, (long)*rA, (long)XER));
      PPC_INSN_INT(RA_BITMASK, RS_BITMASK, Rc);
    }
#line 27591 "icache.c"
    return nia;
    /* extraction: 0.31,6.RS,11.RA,16.SH,21.824,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 27595 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Enforce_Inorder_Execution_of_IO(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Enforce_Inorder_Execution_of_IO
#undef MY_PREFIX
#define MY_PREFIX Enforce_Inorder_Execution_of_IO
#line 4827 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Enforce In-order Execution of I/O\n"));
#line 27614 "icache.c"

  /* validate: 0.31,6./,11./,16./,21.854,31./ */
  if (WITH_RESERVED_BITS && (instruction & 0xffffffff) != 0x7c0006ac)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6./,11./,16./,21.854,31./ #define get-values-from-icache|put-values-in-icache */
#line 27623 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Enforce_Inorder_Execution_of_IO;

    /* semantic routine */
#line 4827 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Enforce In-order Execution of I/O\n"));
#line 27633 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Enforce_Inorder_Execution_of_IO, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4827 "../../../sim/ppc/powerpc.igen"
    {
      /* Since this model has no instruction overlap
         this instruction need do nothing */
    }
#line 27647 "icache.c"
    return nia;
    /* extraction: 0.31,6./,11./,16./,21.854,31./ #undef get-values-from-icache|put-values-in-icache */
#line 27650 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Store_Half_Word_ByteReversed_Indexed(cpu *processor,
                                            instruction_word instruction,
                                            unsigned_word cia,
                                            idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_Half_Word_ByteReversed_Indexed
#undef MY_PREFIX
#define MY_PREFIX Store_Half_Word_ByteReversed_Indexed
#line 2228 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Store Half Word Byte-Reversed Indexed\n"));
#line 27669 "icache.c"

  /* validate: 0.31,6.RS,11.RA,16.RB,21.918,31./ */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007ff) != 0x7c00072c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RS,11.RA,16.RB,21.918,31./ #define get-values-from-icache|put-values-in-icache */
#line 43 "../../../sim/ppc/powerpc.igen"
    unsigned const RS ATTRIBUTE_UNUSED = cache_entry->crack.X.RS = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 44 "../../../sim/ppc/powerpc.igen"
    signed_word * const rS ATTRIBUTE_UNUSED = cache_entry->crack.X.rS = (cpu_registers(processor)->gpr + RS); /* in icache - extraction */
#line 45 "../../../sim/ppc/powerpc.igen"
    uint32_t const RS_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RS_BITMASK = (1 << RS); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.X.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.X.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.X.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.X.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 27697 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Store_Half_Word_ByteReversed_Indexed;

    /* semantic routine */
#line 2228 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Store Half Word Byte-Reversed Indexed\n"));
#line 27707 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Store_Half_Word_ByteReversed_Indexed, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2228 "../../../sim/ppc/powerpc.igen"
    {
      unsigned_word b;
      unsigned_word EA;
      if (RA_is_0) b = 0;
      else         b = *rA;
      EA = b + *rB;
      STORE(EA, 2, SWAP_2(*rS));
      PPC_INSN_INT(0, (RA_BITMASK & ~1) | RB_BITMASK | RS_BITMASK, 0);
    }
#line 27726 "icache.c"
    return nia;
    /* extraction: 0.31,6.RS,11.RA,16.RB,21.918,31./ #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 27730 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Extend_Sign_Half_Word_Rc0(cpu *processor,
                                 instruction_word instruction,
                                 unsigned_word cia,
                                 idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Extend_Sign_Half_Word
#undef MY_PREFIX
#define MY_PREFIX Extend_Sign_Half_Word_Rc0
#line 3100 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Extend Sign Half Word\n"));
#line 27749 "icache.c"

  /* validate: 0.31,6.RS,11.RA,16./,21.922,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00fffe) != 0x7c000734)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RS,11.RA,16./,21.922,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 43 "../../../sim/ppc/powerpc.igen"
    unsigned const RS ATTRIBUTE_UNUSED = cache_entry->crack.X.RS = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 44 "../../../sim/ppc/powerpc.igen"
    signed_word * const rS ATTRIBUTE_UNUSED = cache_entry->crack.X.rS = (cpu_registers(processor)->gpr + RS); /* in icache - extraction */
#line 45 "../../../sim/ppc/powerpc.igen"
    uint32_t const RS_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RS_BITMASK = (1 << RS); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.X.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.X.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 3100 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 27773 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Extend_Sign_Half_Word_Rc0;

    /* semantic routine */
#line 3100 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Extend Sign Half Word\n"));
#line 27783 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Extend_Sign_Half_Word, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3100 "../../../sim/ppc/powerpc.igen"
    {
      *rA = (signed_word)(int16_t)*rS;
      CR0_COMPARE(*rA, 0, Rc);
      ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
      PPC_INSN_INT(RA_BITMASK, RS_BITMASK, Rc);
    }
#line 27799 "icache.c"
    return nia;
    /* extraction: 0.31,6.RS,11.RA,16./,21.922,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 27803 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Extend_Sign_Half_Word_Rc1(cpu *processor,
                                 instruction_word instruction,
                                 unsigned_word cia,
                                 idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Extend_Sign_Half_Word
#undef MY_PREFIX
#define MY_PREFIX Extend_Sign_Half_Word_Rc1
#line 3100 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Extend Sign Half Word\n"));
#line 27822 "icache.c"

  /* validate: 0.31,6.RS,11.RA,16./,21.922,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00fffe) != 0x7c000734)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RS,11.RA,16./,21.922,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 43 "../../../sim/ppc/powerpc.igen"
    unsigned const RS ATTRIBUTE_UNUSED = cache_entry->crack.X.RS = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 44 "../../../sim/ppc/powerpc.igen"
    signed_word * const rS ATTRIBUTE_UNUSED = cache_entry->crack.X.rS = (cpu_registers(processor)->gpr + RS); /* in icache - extraction */
#line 45 "../../../sim/ppc/powerpc.igen"
    uint32_t const RS_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RS_BITMASK = (1 << RS); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.X.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.X.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 3100 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 27846 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Extend_Sign_Half_Word_Rc1;

    /* semantic routine */
#line 3100 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Extend Sign Half Word\n"));
#line 27856 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Extend_Sign_Half_Word, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3100 "../../../sim/ppc/powerpc.igen"
    {
      *rA = (signed_word)(int16_t)*rS;
      CR0_COMPARE(*rA, 0, Rc);
      ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
      PPC_INSN_INT(RA_BITMASK, RS_BITMASK, Rc);
    }
#line 27872 "icache.c"
    return nia;
    /* extraction: 0.31,6.RS,11.RA,16./,21.922,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 27876 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Extend_Sign_Byte_Rc0(cpu *processor,
                            instruction_word instruction,
                            unsigned_word cia,
                            idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Extend_Sign_Byte
#undef MY_PREFIX
#define MY_PREFIX Extend_Sign_Byte_Rc0
#line 3090 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Extend Sign Byte\n"));
#line 27895 "icache.c"

  /* validate: 0.31,6.RS,11.RA,16./,21.954,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00fffe) != 0x7c000774)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RS,11.RA,16./,21.954,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 43 "../../../sim/ppc/powerpc.igen"
    unsigned const RS ATTRIBUTE_UNUSED = cache_entry->crack.X.RS = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 44 "../../../sim/ppc/powerpc.igen"
    signed_word * const rS ATTRIBUTE_UNUSED = cache_entry->crack.X.rS = (cpu_registers(processor)->gpr + RS); /* in icache - extraction */
#line 45 "../../../sim/ppc/powerpc.igen"
    uint32_t const RS_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RS_BITMASK = (1 << RS); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.X.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.X.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 3090 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 27919 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Extend_Sign_Byte_Rc0;

    /* semantic routine */
#line 3090 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Extend Sign Byte\n"));
#line 27929 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Extend_Sign_Byte, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3090 "../../../sim/ppc/powerpc.igen"
    {
      *rA = (signed_word)(int8_t)*rS;
      CR0_COMPARE(*rA, 0, Rc);
      ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
      PPC_INSN_INT(RA_BITMASK, RS_BITMASK, Rc);
    }
#line 27945 "icache.c"
    return nia;
    /* extraction: 0.31,6.RS,11.RA,16./,21.954,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 27949 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Extend_Sign_Byte_Rc1(cpu *processor,
                            instruction_word instruction,
                            unsigned_word cia,
                            idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Extend_Sign_Byte
#undef MY_PREFIX
#define MY_PREFIX Extend_Sign_Byte_Rc1
#line 3090 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Extend Sign Byte\n"));
#line 27968 "icache.c"

  /* validate: 0.31,6.RS,11.RA,16./,21.954,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00fffe) != 0x7c000774)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RS,11.RA,16./,21.954,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 43 "../../../sim/ppc/powerpc.igen"
    unsigned const RS ATTRIBUTE_UNUSED = cache_entry->crack.X.RS = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 44 "../../../sim/ppc/powerpc.igen"
    signed_word * const rS ATTRIBUTE_UNUSED = cache_entry->crack.X.rS = (cpu_registers(processor)->gpr + RS); /* in icache - extraction */
#line 45 "../../../sim/ppc/powerpc.igen"
    uint32_t const RS_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RS_BITMASK = (1 << RS); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.X.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.X.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 3090 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 27992 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Extend_Sign_Byte_Rc1;

    /* semantic routine */
#line 3090 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Extend Sign Byte\n"));
#line 28002 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Extend_Sign_Byte, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3090 "../../../sim/ppc/powerpc.igen"
    {
      *rA = (signed_word)(int8_t)*rS;
      CR0_COMPARE(*rA, 0, Rc);
      ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
      PPC_INSN_INT(RA_BITMASK, RS_BITMASK, Rc);
    }
#line 28018 "icache.c"
    return nia;
    /* extraction: 0.31,6.RS,11.RA,16./,21.954,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 28022 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Divide_Word_Unsigned_OE1_Rc0(cpu *processor,
                                    instruction_word instruction,
                                    unsigned_word cia,
                                    idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Divide_Word_Unsigned
#undef MY_PREFIX
#define MY_PREFIX Divide_Word_Unsigned_OE1_Rc0
#line 2767 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Divide Word Unsigned\n"));
#line 28041 "icache.c"

  /* validate: 0.31,6.RT,11.RA,16.RB,21.OE,22.459,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0003fe) != 0x7c000396)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.459,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.XO.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.XO.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.XO.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 2767 "../../../sim/ppc/powerpc.igen"
    unsigned const OE ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 2767 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 28073 "icache.c"

#define insn cache_entry->crack.XO.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Divide_Word_Unsigned_OE1_Rc0;

    /* semantic routine */
#line 2767 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Divide Word Unsigned\n"));
#line 28083 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Divide_Word_Unsigned, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2767 "../../../sim/ppc/powerpc.igen"
    {
      uint64_t dividend = (uint32_t)(*rA);
      uint64_t divisor = (uint32_t)(*rB);
      if (divisor == 0) {
        if (OE)
          XER |= (xer_overflow | xer_summary_overflow);
        CR0_COMPARE(0, 0, Rc);
      }
      else {
        uint64_t quotent = dividend / divisor;
        *rT = quotent;
        CR0_COMPARE((signed_word)quotent, 0, Rc);
      }
      PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
    }
#line 28108 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.459,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 28112 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Divide_Word_Unsigned_OE1_Rc1(cpu *processor,
                                    instruction_word instruction,
                                    unsigned_word cia,
                                    idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Divide_Word_Unsigned
#undef MY_PREFIX
#define MY_PREFIX Divide_Word_Unsigned_OE1_Rc1
#line 2767 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Divide Word Unsigned\n"));
#line 28131 "icache.c"

  /* validate: 0.31,6.RT,11.RA,16.RB,21.OE,22.459,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0003fe) != 0x7c000396)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.459,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.XO.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.XO.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.XO.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 2767 "../../../sim/ppc/powerpc.igen"
    unsigned const OE ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 2767 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 28163 "icache.c"

#define insn cache_entry->crack.XO.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Divide_Word_Unsigned_OE1_Rc1;

    /* semantic routine */
#line 2767 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Divide Word Unsigned\n"));
#line 28173 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Divide_Word_Unsigned, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2767 "../../../sim/ppc/powerpc.igen"
    {
      uint64_t dividend = (uint32_t)(*rA);
      uint64_t divisor = (uint32_t)(*rB);
      if (divisor == 0) {
        if (OE)
          XER |= (xer_overflow | xer_summary_overflow);
        CR0_COMPARE(0, 0, Rc);
      }
      else {
        uint64_t quotent = dividend / divisor;
        *rT = quotent;
        CR0_COMPARE((signed_word)quotent, 0, Rc);
      }
      PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
    }
#line 28198 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.459,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 28202 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Instruction_Cache_Block_Invalidate(cpu *processor,
                                          instruction_word instruction,
                                          unsigned_word cia,
                                          idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Instruction_Cache_Block_Invalidate
#undef MY_PREFIX
#define MY_PREFIX Instruction_Cache_Block_Invalidate
#line 4763 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Instruction Cache Block Invalidate\n"));
#line 28221 "icache.c"

  /* validate: 0.31,6./,11.RA,16.RB,21.982,31./ */
  if (WITH_RESERVED_BITS && (instruction & 0xffe007ff) != 0x7c0007ac)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6./,11.RA,16.RB,21.982,31./ #define get-values-from-icache|put-values-in-icache */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.X.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.X.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.X.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.X.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 28243 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Instruction_Cache_Block_Invalidate;

    /* semantic routine */
#line 4763 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Instruction Cache Block Invalidate\n"));
#line 28253 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Instruction_Cache_Block_Invalidate, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4763 "../../../sim/ppc/powerpc.igen"
    {
      /* blindly flush all instruction cache entries */
#if WITH_IDECODE_CACHE_SIZE
      cpu_flush_icache(processor);
#endif
      PPC_INSN_INT(0, (RA_BITMASK & ~1) | RB_BITMASK, 0);
    }
#line 28270 "icache.c"
    return nia;
    /* extraction: 0.31,6./,11.RA,16.RB,21.982,31./ #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 28274 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Store_FloatingPoint_Integer_Word_Indexed(cpu *processor,
                                                instruction_word instruction,
                                                unsigned_word cia,
                                                idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_FloatingPoint_Integer_Word_Indexed
#undef MY_PREFIX
#define MY_PREFIX Store_FloatingPoint_Integer_Word_Indexed
#line 3656 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Store Floating-Point Integer Word Indexed\n"));
#line 28293 "icache.c"

  /* validate: 0.31,6.FRS,11.RA,16.RB,21.983,31./ */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007ff) != 0x7c0007ae)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.FRS,11.RA,16.RB,21.983,31./ #define get-values-from-icache|put-values-in-icache */
#define FRS EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 59 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frS ATTRIBUTE_UNUSED = cache_entry->crack.X.frS = (cpu_registers(processor)->fpr + FRS); /* in icache - extraction */
#line 60 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRS_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.FRS_BITMASK = (1 << FRS); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.X.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.X.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.X.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.X.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 28328 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Store_FloatingPoint_Integer_Word_Indexed;

    /* semantic routine */
#line 3656 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Store Floating-Point Integer Word Indexed\n"));
#line 28338 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Store_FloatingPoint_Integer_Word_Indexed, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3656 "../../../sim/ppc/powerpc.igen"
    {
      unsigned_word b;
      unsigned_word EA;
      if (RA_is_0) b = 0;
      else         b = *rA;
      EA = b + *rB;
      STORE(EA, 4, *frS);
      PPC_INSN_INT_FLOAT(0, 0, (RA_BITMASK & ~1) | RB_BITMASK, FRS_BITMASK);
    }
#line 28357 "icache.c"
    return nia;
    /* extraction: 0.31,6.FRS,11.RA,16.RB,21.983,31./ #undef get-values-from-icache|put-values-in-icache */
#undef FRS
#undef RA_is_0
#line 28362 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Divide_Word_OE1_Rc0(cpu *processor,
                           instruction_word instruction,
                           unsigned_word cia,
                           idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Divide_Word
#undef MY_PREFIX
#define MY_PREFIX Divide_Word_OE1_Rc0
#line 2745 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Divide Word\n"));
#line 28381 "icache.c"

  /* validate: 0.31,6.RT,11.RA,16.RB,21.OE,22.491,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0003fe) != 0x7c0003d6)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.491,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.XO.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.XO.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.XO.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 2745 "../../../sim/ppc/powerpc.igen"
    unsigned const OE ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 2745 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 28413 "icache.c"

#define insn cache_entry->crack.XO.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Divide_Word_OE1_Rc0;

    /* semantic routine */
#line 2745 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Divide Word\n"));
#line 28423 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Divide_Word, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2745 "../../../sim/ppc/powerpc.igen"
    {
      int64_t dividend = (int32_t)(*rA);
      int64_t divisor = (int32_t)(*rB);
      if (divisor == 0 /* nb 0x8000..0 is sign extended */
          || (dividend == 0x80000000 && divisor == -1)) {
        if (OE)
          XER |= (xer_overflow | xer_summary_overflow);
        CR0_COMPARE(0, 0, Rc);
      }
      else {
        int64_t quotent = dividend / divisor;
        *rT = quotent;
        CR0_COMPARE((signed_word)quotent, 0, Rc);
      }
      PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
    }
#line 28449 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.491,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 28453 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Divide_Word_OE1_Rc1(cpu *processor,
                           instruction_word instruction,
                           unsigned_word cia,
                           idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Divide_Word
#undef MY_PREFIX
#define MY_PREFIX Divide_Word_OE1_Rc1
#line 2745 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Divide Word\n"));
#line 28472 "icache.c"

  /* validate: 0.31,6.RT,11.RA,16.RB,21.OE,22.491,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0003fe) != 0x7c0003d6)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.491,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.XO.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.XO.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.XO.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XO.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 2745 "../../../sim/ppc/powerpc.igen"
    unsigned const OE ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 2745 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 28504 "icache.c"

#define insn cache_entry->crack.XO.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Divide_Word_OE1_Rc1;

    /* semantic routine */
#line 2745 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Divide Word\n"));
#line 28514 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Divide_Word, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2745 "../../../sim/ppc/powerpc.igen"
    {
      int64_t dividend = (int32_t)(*rA);
      int64_t divisor = (int32_t)(*rB);
      if (divisor == 0 /* nb 0x8000..0 is sign extended */
          || (dividend == 0x80000000 && divisor == -1)) {
        if (OE)
          XER |= (xer_overflow | xer_summary_overflow);
        CR0_COMPARE(0, 0, Rc);
      }
      else {
        int64_t quotent = dividend / divisor;
        *rT = quotent;
        CR0_COMPARE((signed_word)quotent, 0, Rc);
      }
      PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
    }
#line 28540 "icache.c"
    return nia;
    /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.491,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 28544 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Data_Cache_Block_set_to_Zero(cpu *processor,
                                    instruction_word instruction,
                                    unsigned_word cia,
                                    idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Data_Cache_Block_set_to_Zero
#undef MY_PREFIX
#define MY_PREFIX Data_Cache_Block_set_to_Zero
#line 4803 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Data Cache Block set to Zero\n"));
#line 28563 "icache.c"

  /* validate: 0.31,6./,11.RA,16.RB,21.1014,31./ */
  if (WITH_RESERVED_BITS && (instruction & 0xffe007ff) != 0x7c0007ec)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.31,6./,11.RA,16.RB,21.1014,31./ #define get-values-from-icache|put-values-in-icache */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.X.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.X.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 46 "../../../sim/ppc/powerpc.igen"
    unsigned const RB ATTRIBUTE_UNUSED = cache_entry->crack.X.RB = EXTRACTED32(instruction, 16, 20); /* in icache - extraction */
#line 47 "../../../sim/ppc/powerpc.igen"
    signed_word * const rB ATTRIBUTE_UNUSED = cache_entry->crack.X.rB = (cpu_registers(processor)->gpr + RB); /* in icache - extraction */
#line 48 "../../../sim/ppc/powerpc.igen"
    uint32_t const RB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.RB_BITMASK = (1 << RB); /* in icache - extraction */
#line 28585 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Data_Cache_Block_set_to_Zero;

    /* semantic routine */
#line 4803 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Data Cache Block set to Zero\n"));
#line 28595 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Data_Cache_Block_set_to_Zero, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4803 "../../../sim/ppc/powerpc.igen"
    {
      TRACE(trace_tbd,("Data Cache Block set to Zero\n"));
      PPC_INSN_INT(0, (RA_BITMASK & ~1) | RB_BITMASK, 0/*Rc*/);
    }
#line 28609 "icache.c"
    return nia;
    /* extraction: 0.31,6./,11.RA,16.RB,21.1014,31./ #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 28613 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Load_Word_and_Zero(cpu *processor,
                          instruction_word instruction,
                          unsigned_word cia,
                          idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_Word_and_Zero
#undef MY_PREFIX
#define MY_PREFIX Load_Word_and_Zero
#line 1885 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Load Word and Zero\n"));
#line 28632 "icache.c"

  /* validate: 0.32,6.RT,11.RA,16.D */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x80000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.32,6.RT,11.RA,16.D #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.D.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.D.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.D.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.D.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 79 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_D ATTRIBUTE_UNUSED = cache_entry->crack.D.EXTS_D = ((signed_word)(int16_t)(instruction)); /* in icache - extraction */
#line 28656 "icache.c"

#define insn cache_entry->crack.D.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Load_Word_and_Zero;

    /* semantic routine */
#line 1885 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Load Word and Zero\n"));
#line 28666 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Load_Word_and_Zero, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1885 "../../../sim/ppc/powerpc.igen"
    {
      unsigned_word b;
      unsigned_word EA;
      if (RA_is_0) b = 0;
      else         b = *rA;
      EA = b + EXTS(D);
      *rT = MEM(unsigned, EA, 4);
      PPC_INSN_INT(RT_BITMASK, (RA_BITMASK & ~1), 0);
    }
#line 28685 "icache.c"
    return nia;
    /* extraction: 0.32,6.RT,11.RA,16.D #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 28689 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Load_Word_and_Zero_with_Update(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_Word_and_Zero_with_Update
#undef MY_PREFIX
#define MY_PREFIX Load_Word_and_Zero_with_Update
#line 1911 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Load Word and Zero with Update\n"));
#line 28708 "icache.c"

  /* validate: 0.33,6.RT,11.RA,16.D */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x84000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.33,6.RT,11.RA,16.D #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.D.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.D.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.D.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.D.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 79 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_D ATTRIBUTE_UNUSED = cache_entry->crack.D.EXTS_D = ((signed_word)(int16_t)(instruction)); /* in icache - extraction */
#line 28732 "icache.c"

#define insn cache_entry->crack.D.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Load_Word_and_Zero_with_Update;

    /* semantic routine */
#line 1911 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Load Word and Zero with Update\n"));
#line 28742 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Load_Word_and_Zero_with_Update, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1911 "../../../sim/ppc/powerpc.igen"
    {
      unsigned_word EA;
      if (RA_is_0 || RA == RT)
        program_interrupt(processor, cia,
                          illegal_instruction_program_interrupt);
      EA = *rA + EXTS(D);
      *rT = MEM(unsigned, EA, 4);
      *rA = EA;
      PPC_INSN_INT(RT_BITMASK | RA_BITMASK, RA_BITMASK, 0);
    }
#line 28762 "icache.c"
    return nia;
    /* extraction: 0.33,6.RT,11.RA,16.D #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 28766 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Load_Byte_and_Zero(cpu *processor,
                          instruction_word instruction,
                          unsigned_word cia,
                          idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_Byte_and_Zero
#undef MY_PREFIX
#define MY_PREFIX Load_Byte_and_Zero
#line 1722 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Load Byte and Zero\n"));
#line 28785 "icache.c"

  /* validate: 0.34,6.RT,11.RA,16.D */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x88000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.34,6.RT,11.RA,16.D #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.D.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.D.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.D.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.D.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 79 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_D ATTRIBUTE_UNUSED = cache_entry->crack.D.EXTS_D = ((signed_word)(int16_t)(instruction)); /* in icache - extraction */
#line 28809 "icache.c"

#define insn cache_entry->crack.D.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Load_Byte_and_Zero;

    /* semantic routine */
#line 1722 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Load Byte and Zero\n"));
#line 28819 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Load_Byte_and_Zero, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1722 "../../../sim/ppc/powerpc.igen"
    {
      unsigned_word b;
      unsigned_word EA;
      if (RA_is_0) b = 0;
      else         b = *rA;
      EA = b + EXTS(D);
      *rT = MEM(unsigned, EA, 1);
      PPC_INSN_INT(RT_BITMASK, (RA_BITMASK & ~1), 0);
    }
#line 28838 "icache.c"
    return nia;
    /* extraction: 0.34,6.RT,11.RA,16.D #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 28842 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Load_Byte_and_Zero_with_Update(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_Byte_and_Zero_with_Update
#undef MY_PREFIX
#define MY_PREFIX Load_Byte_and_Zero_with_Update
#line 1749 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Load Byte and Zero with Update\n"));
#line 28861 "icache.c"

  /* validate: 0.35,6.RT,11.RA,16.D */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x8c000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.35,6.RT,11.RA,16.D #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.D.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.D.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.D.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.D.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 79 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_D ATTRIBUTE_UNUSED = cache_entry->crack.D.EXTS_D = ((signed_word)(int16_t)(instruction)); /* in icache - extraction */
#line 28885 "icache.c"

#define insn cache_entry->crack.D.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Load_Byte_and_Zero_with_Update;

    /* semantic routine */
#line 1749 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Load Byte and Zero with Update\n"));
#line 28895 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Load_Byte_and_Zero_with_Update, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1749 "../../../sim/ppc/powerpc.igen"
    {
      unsigned_word EA;
      if (RA_is_0 || RA == RT)
        program_interrupt(processor, cia,
                          illegal_instruction_program_interrupt);
      EA = *rA + EXTS(D);
      *rT = MEM(unsigned, EA, 1);
      *rA = EA;
      PPC_INSN_INT(RT_BITMASK | RA_BITMASK, RA_BITMASK, 0);
    }
#line 28915 "icache.c"
    return nia;
    /* extraction: 0.35,6.RT,11.RA,16.D #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 28919 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Store_Word(cpu *processor,
                  instruction_word instruction,
                  unsigned_word cia,
                  idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_Word
#undef MY_PREFIX
#define MY_PREFIX Store_Word
#line 2112 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Store Word\n"));
#line 28938 "icache.c"

  /* validate: 0.36,6.RS,11.RA,16.D */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x90000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.36,6.RS,11.RA,16.D #define get-values-from-icache|put-values-in-icache */
#line 43 "../../../sim/ppc/powerpc.igen"
    unsigned const RS ATTRIBUTE_UNUSED = cache_entry->crack.D.RS = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 44 "../../../sim/ppc/powerpc.igen"
    signed_word * const rS ATTRIBUTE_UNUSED = cache_entry->crack.D.rS = (cpu_registers(processor)->gpr + RS); /* in icache - extraction */
#line 45 "../../../sim/ppc/powerpc.igen"
    uint32_t const RS_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.RS_BITMASK = (1 << RS); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.D.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.D.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 79 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_D ATTRIBUTE_UNUSED = cache_entry->crack.D.EXTS_D = ((signed_word)(int16_t)(instruction)); /* in icache - extraction */
#line 28962 "icache.c"

#define insn cache_entry->crack.D.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Store_Word;

    /* semantic routine */
#line 2112 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Store Word\n"));
#line 28972 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Store_Word, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2112 "../../../sim/ppc/powerpc.igen"
    {
      unsigned_word b;
      unsigned_word EA;
      if (RA_is_0) b = 0;
      else         b = *rA;
      EA = b + EXTS(D);
      STORE(EA, 4, *rS);
      PPC_INSN_INT(0, (RA_BITMASK & ~1) | RS_BITMASK, 0);
    }
#line 28991 "icache.c"
    return nia;
    /* extraction: 0.36,6.RS,11.RA,16.D #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 28995 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Store_Word_with_Update(cpu *processor,
                              instruction_word instruction,
                              unsigned_word cia,
                              idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_Word_with_Update
#undef MY_PREFIX
#define MY_PREFIX Store_Word_with_Update
#line 2138 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Store Word with Update\n"));
#line 29014 "icache.c"

  /* validate: 0.37,6.RS,11.RA,16.D */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x94000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.37,6.RS,11.RA,16.D #define get-values-from-icache|put-values-in-icache */
#line 43 "../../../sim/ppc/powerpc.igen"
    unsigned const RS ATTRIBUTE_UNUSED = cache_entry->crack.D.RS = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 44 "../../../sim/ppc/powerpc.igen"
    signed_word * const rS ATTRIBUTE_UNUSED = cache_entry->crack.D.rS = (cpu_registers(processor)->gpr + RS); /* in icache - extraction */
#line 45 "../../../sim/ppc/powerpc.igen"
    uint32_t const RS_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.RS_BITMASK = (1 << RS); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.D.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.D.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 79 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_D ATTRIBUTE_UNUSED = cache_entry->crack.D.EXTS_D = ((signed_word)(int16_t)(instruction)); /* in icache - extraction */
#line 29038 "icache.c"

#define insn cache_entry->crack.D.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Store_Word_with_Update;

    /* semantic routine */
#line 2138 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Store Word with Update\n"));
#line 29048 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Store_Word_with_Update, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2138 "../../../sim/ppc/powerpc.igen"
    {
      unsigned_word EA;
      if (RA_is_0)
        program_interrupt(processor, cia,
                          illegal_instruction_program_interrupt);
      EA = *rA + EXTS(D);
      STORE(EA, 4, *rS);
      *rA = EA;
      PPC_INSN_INT(RA_BITMASK, RA_BITMASK | RS_BITMASK, 0);
    }
#line 29068 "icache.c"
    return nia;
    /* extraction: 0.37,6.RS,11.RA,16.D #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 29072 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Store_Byte(cpu *processor,
                  instruction_word instruction,
                  unsigned_word cia,
                  idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_Byte
#undef MY_PREFIX
#define MY_PREFIX Store_Byte
#line 2004 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Store Byte\n"));
#line 29091 "icache.c"

  /* validate: 0.38,6.RS,11.RA,16.D */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x98000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.38,6.RS,11.RA,16.D #define get-values-from-icache|put-values-in-icache */
#line 43 "../../../sim/ppc/powerpc.igen"
    unsigned const RS ATTRIBUTE_UNUSED = cache_entry->crack.D.RS = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 44 "../../../sim/ppc/powerpc.igen"
    signed_word * const rS ATTRIBUTE_UNUSED = cache_entry->crack.D.rS = (cpu_registers(processor)->gpr + RS); /* in icache - extraction */
#line 45 "../../../sim/ppc/powerpc.igen"
    uint32_t const RS_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.RS_BITMASK = (1 << RS); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.D.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.D.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 79 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_D ATTRIBUTE_UNUSED = cache_entry->crack.D.EXTS_D = ((signed_word)(int16_t)(instruction)); /* in icache - extraction */
#line 29115 "icache.c"

#define insn cache_entry->crack.D.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Store_Byte;

    /* semantic routine */
#line 2004 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Store Byte\n"));
#line 29125 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Store_Byte, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2004 "../../../sim/ppc/powerpc.igen"
    {
      unsigned_word b;
      unsigned_word EA;
      if (RA_is_0) b = 0;
      else         b = *rA;
      EA = b + EXTS(D);
      STORE(EA, 1, *rS);
      PPC_INSN_INT(0, (RA_BITMASK & ~1) | RS_BITMASK, 0);
    }
#line 29144 "icache.c"
    return nia;
    /* extraction: 0.38,6.RS,11.RA,16.D #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 29148 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Store_Byte_with_Update(cpu *processor,
                              instruction_word instruction,
                              unsigned_word cia,
                              idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_Byte_with_Update
#undef MY_PREFIX
#define MY_PREFIX Store_Byte_with_Update
#line 2030 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Store Byte with Update\n"));
#line 29167 "icache.c"

  /* validate: 0.39,6.RS,11.RA,16.D */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0x9c000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.39,6.RS,11.RA,16.D #define get-values-from-icache|put-values-in-icache */
#line 43 "../../../sim/ppc/powerpc.igen"
    unsigned const RS ATTRIBUTE_UNUSED = cache_entry->crack.D.RS = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 44 "../../../sim/ppc/powerpc.igen"
    signed_word * const rS ATTRIBUTE_UNUSED = cache_entry->crack.D.rS = (cpu_registers(processor)->gpr + RS); /* in icache - extraction */
#line 45 "../../../sim/ppc/powerpc.igen"
    uint32_t const RS_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.RS_BITMASK = (1 << RS); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.D.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.D.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 79 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_D ATTRIBUTE_UNUSED = cache_entry->crack.D.EXTS_D = ((signed_word)(int16_t)(instruction)); /* in icache - extraction */
#line 29191 "icache.c"

#define insn cache_entry->crack.D.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Store_Byte_with_Update;

    /* semantic routine */
#line 2030 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Store Byte with Update\n"));
#line 29201 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Store_Byte_with_Update, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2030 "../../../sim/ppc/powerpc.igen"
    {
      unsigned_word EA;
      if (RA_is_0)
        program_interrupt(processor, cia,
                          illegal_instruction_program_interrupt);
      EA = *rA + EXTS(D);
      STORE(EA, 1, *rS);
      *rA = EA;
      PPC_INSN_INT(RA_BITMASK, RA_BITMASK | RS_BITMASK, 0);
    }
#line 29221 "icache.c"
    return nia;
    /* extraction: 0.39,6.RS,11.RA,16.D #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 29225 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Load_Halfword_and_Zero(cpu *processor,
                              instruction_word instruction,
                              unsigned_word cia,
                              idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_Halfword_and_Zero
#undef MY_PREFIX
#define MY_PREFIX Load_Halfword_and_Zero
#line 1777 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Load Halfword and Zero\n"));
#line 29244 "icache.c"

  /* validate: 0.40,6.RT,11.RA,16.D */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0xa0000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.40,6.RT,11.RA,16.D #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.D.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.D.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.D.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.D.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 79 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_D ATTRIBUTE_UNUSED = cache_entry->crack.D.EXTS_D = ((signed_word)(int16_t)(instruction)); /* in icache - extraction */
#line 29268 "icache.c"

#define insn cache_entry->crack.D.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Load_Halfword_and_Zero;

    /* semantic routine */
#line 1777 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Load Halfword and Zero\n"));
#line 29278 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Load_Halfword_and_Zero, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1777 "../../../sim/ppc/powerpc.igen"
    {
      unsigned_word b;
      unsigned_word EA;
      if (RA_is_0) b = 0;
      else         b = *rA;
      EA = b + EXTS(D);
      *rT = MEM(unsigned, EA, 2);
      PPC_INSN_INT(RT_BITMASK, (RA_BITMASK & ~1), 0);
    }
#line 29297 "icache.c"
    return nia;
    /* extraction: 0.40,6.RT,11.RA,16.D #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 29301 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Load_Halfword_and_Zero_with_Update(cpu *processor,
                                          instruction_word instruction,
                                          unsigned_word cia,
                                          idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_Halfword_and_Zero_with_Update
#undef MY_PREFIX
#define MY_PREFIX Load_Halfword_and_Zero_with_Update
#line 1803 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Load Halfword and Zero with Update\n"));
#line 29320 "icache.c"

  /* validate: 0.41,6.RT,11.RA,16.D */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0xa4000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.41,6.RT,11.RA,16.D #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.D.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.D.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.D.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.D.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 79 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_D ATTRIBUTE_UNUSED = cache_entry->crack.D.EXTS_D = ((signed_word)(int16_t)(instruction)); /* in icache - extraction */
#line 29344 "icache.c"

#define insn cache_entry->crack.D.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Load_Halfword_and_Zero_with_Update;

    /* semantic routine */
#line 1803 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Load Halfword and Zero with Update\n"));
#line 29354 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Load_Halfword_and_Zero_with_Update, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1803 "../../../sim/ppc/powerpc.igen"
    {
      unsigned_word EA;
      if (RA_is_0 || RA == RT)
        program_interrupt(processor, cia,
                          illegal_instruction_program_interrupt);
      EA = *rA + EXTS(D);
      *rT = MEM(unsigned, EA, 2);
      *rA = EA;
      PPC_INSN_INT(RT_BITMASK | RA_BITMASK, RA_BITMASK, 0);
    }
#line 29374 "icache.c"
    return nia;
    /* extraction: 0.41,6.RT,11.RA,16.D #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 29378 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Load_Halfword_Algebraic(cpu *processor,
                               instruction_word instruction,
                               unsigned_word cia,
                               idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_Halfword_Algebraic
#undef MY_PREFIX
#define MY_PREFIX Load_Halfword_Algebraic
#line 1831 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Load Halfword Algebraic\n"));
#line 29397 "icache.c"

  /* validate: 0.42,6.RT,11.RA,16.D */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0xa8000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.42,6.RT,11.RA,16.D #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.D.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.D.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.D.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.D.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 79 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_D ATTRIBUTE_UNUSED = cache_entry->crack.D.EXTS_D = ((signed_word)(int16_t)(instruction)); /* in icache - extraction */
#line 29421 "icache.c"

#define insn cache_entry->crack.D.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Load_Halfword_Algebraic;

    /* semantic routine */
#line 1831 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Load Halfword Algebraic\n"));
#line 29431 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Load_Halfword_Algebraic, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1831 "../../../sim/ppc/powerpc.igen"
    {
      unsigned_word b;
      unsigned_word EA;
      if (RA_is_0) b = 0;
      else         b = *rA;
      EA = b + EXTS(D);
      *rT = MEM(signed, EA, 2);
      PPC_INSN_INT(RT_BITMASK, (RA_BITMASK & ~1), 0);
    }
#line 29450 "icache.c"
    return nia;
    /* extraction: 0.42,6.RT,11.RA,16.D #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 29454 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Load_Halfword_Algebraic_with_Update(cpu *processor,
                                           instruction_word instruction,
                                           unsigned_word cia,
                                           idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_Halfword_Algebraic_with_Update
#undef MY_PREFIX
#define MY_PREFIX Load_Halfword_Algebraic_with_Update
#line 1857 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Load Halfword Algebraic with Update\n"));
#line 29473 "icache.c"

  /* validate: 0.43,6.RT,11.RA,16.D */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0xac000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.43,6.RT,11.RA,16.D #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.D.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.D.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.D.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.D.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 79 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_D ATTRIBUTE_UNUSED = cache_entry->crack.D.EXTS_D = ((signed_word)(int16_t)(instruction)); /* in icache - extraction */
#line 29497 "icache.c"

#define insn cache_entry->crack.D.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Load_Halfword_Algebraic_with_Update;

    /* semantic routine */
#line 1857 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Load Halfword Algebraic with Update\n"));
#line 29507 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Load_Halfword_Algebraic_with_Update, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 1857 "../../../sim/ppc/powerpc.igen"
    {
      unsigned_word EA;
      if (RA_is_0 || RA == RT)
        program_interrupt(processor, cia,
                          illegal_instruction_program_interrupt);
      EA = *rA + EXTS(D);
      *rT = MEM(signed, EA, 2);
      *rA = EA;
      PPC_INSN_INT(RT_BITMASK | RA_BITMASK, RA_BITMASK, 0);
    }
#line 29527 "icache.c"
    return nia;
    /* extraction: 0.43,6.RT,11.RA,16.D #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 29531 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Store_Half_Word(cpu *processor,
                       instruction_word instruction,
                       unsigned_word cia,
                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_Half_Word
#undef MY_PREFIX
#define MY_PREFIX Store_Half_Word
#line 2058 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Store Half Word\n"));
#line 29550 "icache.c"

  /* validate: 0.44,6.RS,11.RA,16.D */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0xb0000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.44,6.RS,11.RA,16.D #define get-values-from-icache|put-values-in-icache */
#line 43 "../../../sim/ppc/powerpc.igen"
    unsigned const RS ATTRIBUTE_UNUSED = cache_entry->crack.D.RS = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 44 "../../../sim/ppc/powerpc.igen"
    signed_word * const rS ATTRIBUTE_UNUSED = cache_entry->crack.D.rS = (cpu_registers(processor)->gpr + RS); /* in icache - extraction */
#line 45 "../../../sim/ppc/powerpc.igen"
    uint32_t const RS_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.RS_BITMASK = (1 << RS); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.D.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.D.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 79 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_D ATTRIBUTE_UNUSED = cache_entry->crack.D.EXTS_D = ((signed_word)(int16_t)(instruction)); /* in icache - extraction */
#line 29574 "icache.c"

#define insn cache_entry->crack.D.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Store_Half_Word;

    /* semantic routine */
#line 2058 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Store Half Word\n"));
#line 29584 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Store_Half_Word, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2058 "../../../sim/ppc/powerpc.igen"
    {
      unsigned_word b;
      unsigned_word EA;
      if (RA_is_0) b = 0;
      else         b = *rA;
      EA = b + EXTS(D);
      STORE(EA, 2, *rS);
      PPC_INSN_INT(0, (RA_BITMASK & ~1) | RS_BITMASK, 0);
    }
#line 29603 "icache.c"
    return nia;
    /* extraction: 0.44,6.RS,11.RA,16.D #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 29607 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Store_Half_Word_with_Update(cpu *processor,
                                   instruction_word instruction,
                                   unsigned_word cia,
                                   idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_Half_Word_with_Update
#undef MY_PREFIX
#define MY_PREFIX Store_Half_Word_with_Update
#line 2084 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Store Half Word with Update\n"));
#line 29626 "icache.c"

  /* validate: 0.45,6.RS,11.RA,16.D */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0xb4000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.45,6.RS,11.RA,16.D #define get-values-from-icache|put-values-in-icache */
#line 43 "../../../sim/ppc/powerpc.igen"
    unsigned const RS ATTRIBUTE_UNUSED = cache_entry->crack.D.RS = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 44 "../../../sim/ppc/powerpc.igen"
    signed_word * const rS ATTRIBUTE_UNUSED = cache_entry->crack.D.rS = (cpu_registers(processor)->gpr + RS); /* in icache - extraction */
#line 45 "../../../sim/ppc/powerpc.igen"
    uint32_t const RS_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.RS_BITMASK = (1 << RS); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.D.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.D.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 79 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_D ATTRIBUTE_UNUSED = cache_entry->crack.D.EXTS_D = ((signed_word)(int16_t)(instruction)); /* in icache - extraction */
#line 29650 "icache.c"

#define insn cache_entry->crack.D.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Store_Half_Word_with_Update;

    /* semantic routine */
#line 2084 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Store Half Word with Update\n"));
#line 29660 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Store_Half_Word_with_Update, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2084 "../../../sim/ppc/powerpc.igen"
    {
      unsigned_word EA;
      if (RA_is_0)
        program_interrupt(processor, cia,
                          illegal_instruction_program_interrupt);
      EA = *rA + EXTS(D);
      STORE(EA, 2, *rS);
      *rA = EA;
      PPC_INSN_INT(RA_BITMASK, RA_BITMASK | RS_BITMASK, 0);
    }
#line 29680 "icache.c"
    return nia;
    /* extraction: 0.45,6.RS,11.RA,16.D #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 29684 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Load_Multiple_Word(cpu *processor,
                          instruction_word instruction,
                          unsigned_word cia,
                          idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_Multiple_Word
#undef MY_PREFIX
#define MY_PREFIX Load_Multiple_Word
#line 2255 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Load Multiple Word\n"));
#line 29703 "icache.c"

  /* validate: 0.46,6.RT,11.RA,16.D */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0xb8000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.46,6.RT,11.RA,16.D #define get-values-from-icache|put-values-in-icache */
#line 40 "../../../sim/ppc/powerpc.igen"
    unsigned const RT ATTRIBUTE_UNUSED = cache_entry->crack.D.RT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 41 "../../../sim/ppc/powerpc.igen"
    signed_word * const rT ATTRIBUTE_UNUSED = cache_entry->crack.D.rT = (cpu_registers(processor)->gpr + RT); /* in icache - extraction */
#line 42 "../../../sim/ppc/powerpc.igen"
    uint32_t const RT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.RT_BITMASK = (1 << RT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.D.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.D.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 79 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_D ATTRIBUTE_UNUSED = cache_entry->crack.D.EXTS_D = ((signed_word)(int16_t)(instruction)); /* in icache - extraction */
#line 29727 "icache.c"

#define insn cache_entry->crack.D.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Load_Multiple_Word;

    /* semantic routine */
#line 2255 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Load Multiple Word\n"));
#line 29737 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Load_Multiple_Word, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2255 "../../../sim/ppc/powerpc.igen"
    {
      unsigned_word EA;
      unsigned_word b;
      int r;
      if (RA_is_0) b = 0;
      else         b = *rA;
      EA = b + EXTS(D);
      r = RT;
      if (RA >= r)
        program_interrupt(processor, cia,
                        illegal_instruction_program_interrupt);
      if (CURRENT_ALIGNMENT == STRICT_ALIGNMENT || (EA % 4 != 0))
        alignment_interrupt(processor, cia, EA);
      while (r <= 31) {
        GPR(r) = MEM(unsigned, EA, 4);
        r = r + 1;
        EA = EA + 4;
      }
    }
#line 29766 "icache.c"
    return nia;
    /* extraction: 0.46,6.RT,11.RA,16.D #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 29770 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Store_Multiple_Word(cpu *processor,
                           instruction_word instruction,
                           unsigned_word cia,
                           idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_Multiple_Word
#undef MY_PREFIX
#define MY_PREFIX Store_Multiple_Word
#line 2274 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Store Multiple Word\n"));
#line 29789 "icache.c"

  /* validate: 0.47,6.RS,11.RA,16.D */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0xbc000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.47,6.RS,11.RA,16.D #define get-values-from-icache|put-values-in-icache */
#line 43 "../../../sim/ppc/powerpc.igen"
    unsigned const RS ATTRIBUTE_UNUSED = cache_entry->crack.D.RS = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 44 "../../../sim/ppc/powerpc.igen"
    signed_word * const rS ATTRIBUTE_UNUSED = cache_entry->crack.D.rS = (cpu_registers(processor)->gpr + RS); /* in icache - extraction */
#line 45 "../../../sim/ppc/powerpc.igen"
    uint32_t const RS_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.RS_BITMASK = (1 << RS); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.D.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.D.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 79 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_D ATTRIBUTE_UNUSED = cache_entry->crack.D.EXTS_D = ((signed_word)(int16_t)(instruction)); /* in icache - extraction */
#line 29813 "icache.c"

#define insn cache_entry->crack.D.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Store_Multiple_Word;

    /* semantic routine */
#line 2274 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Store Multiple Word\n"));
#line 29823 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Store_Multiple_Word, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 2274 "../../../sim/ppc/powerpc.igen"
    {
      unsigned_word EA;
      unsigned_word b;
      int r;
      if (RA_is_0) b = 0;
      else         b = *rA;
      EA = b + EXTS(D);
      if (CURRENT_ALIGNMENT == STRICT_ALIGNMENT
          || (EA % 4 != 0))
        alignment_interrupt(processor, cia, EA);
      r = RS;
      while (r <= 31) {
        STORE(EA, 4, GPR(r));
        r = r + 1;
        EA = EA + 4;
      }
    }
#line 29850 "icache.c"
    return nia;
    /* extraction: 0.47,6.RS,11.RA,16.D #undef get-values-from-icache|put-values-in-icache */
#undef RA_is_0
#line 29854 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Load_FloatingPoint_Single(cpu *processor,
                                 instruction_word instruction,
                                 unsigned_word cia,
                                 idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_FloatingPoint_Single
#undef MY_PREFIX
#define MY_PREFIX Load_FloatingPoint_Single
#line 3464 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Load Floating-Point Single\n"));
#line 29873 "icache.c"

  /* validate: 0.48,6.FRT,11.RA,16.D */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0xc0000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.48,6.FRT,11.RA,16.D #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.D.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.D.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.D.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 79 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_D ATTRIBUTE_UNUSED = cache_entry->crack.D.EXTS_D = ((signed_word)(int16_t)(instruction)); /* in icache - extraction */
#line 29904 "icache.c"

#define insn cache_entry->crack.D.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Load_FloatingPoint_Single;

    /* semantic routine */
#line 3464 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Load Floating-Point Single\n"));
#line 29914 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Load_FloatingPoint_Single, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3464 "../../../sim/ppc/powerpc.igen"
    {
      unsigned_word b;
      unsigned_word EA;
      if (RA_is_0) b = 0;
      else         b = *rA;
      EA = b + EXTS(D);
      *frT = DOUBLE(MEM(unsigned, EA, 4));
      PPC_INSN_INT_FLOAT(0, FRT_BITMASK, (RA_BITMASK & ~1), 0);
    }
#line 29933 "icache.c"
    return nia;
    /* extraction: 0.48,6.FRT,11.RA,16.D #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef RA_is_0
#line 29938 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Load_FloatingPoint_Single_with_Update(cpu *processor,
                                             instruction_word instruction,
                                             unsigned_word cia,
                                             idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_FloatingPoint_Single_with_Update
#undef MY_PREFIX
#define MY_PREFIX Load_FloatingPoint_Single_with_Update
#line 3490 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Load Floating-Point Single with Update\n"));
#line 29957 "icache.c"

  /* validate: 0.49,6.FRT,11.RA,16.D */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0xc4000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.49,6.FRT,11.RA,16.D #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.D.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.D.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.D.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 79 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_D ATTRIBUTE_UNUSED = cache_entry->crack.D.EXTS_D = ((signed_word)(int16_t)(instruction)); /* in icache - extraction */
#line 29988 "icache.c"

#define insn cache_entry->crack.D.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Load_FloatingPoint_Single_with_Update;

    /* semantic routine */
#line 3490 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Load Floating-Point Single with Update\n"));
#line 29998 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Load_FloatingPoint_Single_with_Update, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3490 "../../../sim/ppc/powerpc.igen"
    {
      unsigned_word EA;
      if (RA_is_0)
        program_interrupt(processor, cia,
                          illegal_instruction_program_interrupt);
      EA = *rA + EXTS(D);
      *frT = DOUBLE(MEM(unsigned, EA, 4));
      *rA = EA;
      PPC_INSN_INT_FLOAT(RA_BITMASK, FRT_BITMASK, (RA_BITMASK & ~1), 0);
    }
#line 30018 "icache.c"
    return nia;
    /* extraction: 0.49,6.FRT,11.RA,16.D #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef RA_is_0
#line 30023 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Load_FloatingPoint_Double(cpu *processor,
                                 instruction_word instruction,
                                 unsigned_word cia,
                                 idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_FloatingPoint_Double
#undef MY_PREFIX
#define MY_PREFIX Load_FloatingPoint_Double
#line 3518 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Load Floating-Point Double\n"));
#line 30042 "icache.c"

  /* validate: 0.50,6.FRT,11.RA,16.D */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0xc8000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.50,6.FRT,11.RA,16.D #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.D.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.D.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.D.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 79 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_D ATTRIBUTE_UNUSED = cache_entry->crack.D.EXTS_D = ((signed_word)(int16_t)(instruction)); /* in icache - extraction */
#line 30073 "icache.c"

#define insn cache_entry->crack.D.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Load_FloatingPoint_Double;

    /* semantic routine */
#line 3518 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Load Floating-Point Double\n"));
#line 30083 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Load_FloatingPoint_Double, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3518 "../../../sim/ppc/powerpc.igen"
    {
      unsigned_word b;
      unsigned_word EA;
      if (RA_is_0) b = 0;
      else         b = *rA;
      EA = b + EXTS(D);
      *frT = MEM(unsigned, EA, 8);
      PPC_INSN_INT_FLOAT(0, FRT_BITMASK, (RA_BITMASK & ~1), 0);
    }
#line 30102 "icache.c"
    return nia;
    /* extraction: 0.50,6.FRT,11.RA,16.D #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef RA_is_0
#line 30107 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Load_FloatingPoint_Double_with_Update(cpu *processor,
                                             instruction_word instruction,
                                             unsigned_word cia,
                                             idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_FloatingPoint_Double_with_Update
#undef MY_PREFIX
#define MY_PREFIX Load_FloatingPoint_Double_with_Update
#line 3544 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Load Floating-Point Double with Update\n"));
#line 30126 "icache.c"

  /* validate: 0.51,6.FRT,11.RA,16.D */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0xcc000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.51,6.FRT,11.RA,16.D #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.D.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.D.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.D.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 79 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_D ATTRIBUTE_UNUSED = cache_entry->crack.D.EXTS_D = ((signed_word)(int16_t)(instruction)); /* in icache - extraction */
#line 30157 "icache.c"

#define insn cache_entry->crack.D.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Load_FloatingPoint_Double_with_Update;

    /* semantic routine */
#line 3544 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Load Floating-Point Double with Update\n"));
#line 30167 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Load_FloatingPoint_Double_with_Update, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3544 "../../../sim/ppc/powerpc.igen"
    {
      unsigned_word EA;
      if (RA_is_0)
        program_interrupt(processor, cia,
                          illegal_instruction_program_interrupt);
      EA = *rA + EXTS(D);
      *frT = MEM(unsigned, EA, 8);
      *rA = EA;
      PPC_INSN_INT_FLOAT(RA_BITMASK, FRT_BITMASK, (RA_BITMASK & ~1), 0);
    }
#line 30187 "icache.c"
    return nia;
    /* extraction: 0.51,6.FRT,11.RA,16.D #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef RA_is_0
#line 30192 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Store_FloatingPoint_Single(cpu *processor,
                                  instruction_word instruction,
                                  unsigned_word cia,
                                  idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_FloatingPoint_Single
#undef MY_PREFIX
#define MY_PREFIX Store_FloatingPoint_Single
#line 3577 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Store Floating-Point Single\n"));
#line 30211 "icache.c"

  /* validate: 0.52,6.FRS,11.RA,16.D */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0xd0000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.52,6.FRS,11.RA,16.D #define get-values-from-icache|put-values-in-icache */
#define FRS EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 59 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frS ATTRIBUTE_UNUSED = cache_entry->crack.D.frS = (cpu_registers(processor)->fpr + FRS); /* in icache - extraction */
#line 60 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRS_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.FRS_BITMASK = (1 << FRS); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.D.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.D.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 79 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_D ATTRIBUTE_UNUSED = cache_entry->crack.D.EXTS_D = ((signed_word)(int16_t)(instruction)); /* in icache - extraction */
#line 30242 "icache.c"

#define insn cache_entry->crack.D.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Store_FloatingPoint_Single;

    /* semantic routine */
#line 3577 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Store Floating-Point Single\n"));
#line 30252 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Store_FloatingPoint_Single, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3577 "../../../sim/ppc/powerpc.igen"
    {
      unsigned_word b;
      unsigned_word EA;
      if (RA_is_0) b = 0;
      else         b = *rA;
      EA = b + EXTS(D);
      STORE(EA, 4, SINGLE(*frS));
      PPC_INSN_INT_FLOAT(0, 0, (RA_BITMASK & ~1), FRS_BITMASK);
    }
#line 30271 "icache.c"
    return nia;
    /* extraction: 0.52,6.FRS,11.RA,16.D #undef get-values-from-icache|put-values-in-icache */
#undef FRS
#undef RA_is_0
#line 30276 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Store_FloatingPoint_Single_with_Update(cpu *processor,
                                              instruction_word instruction,
                                              unsigned_word cia,
                                              idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_FloatingPoint_Single_with_Update
#undef MY_PREFIX
#define MY_PREFIX Store_FloatingPoint_Single_with_Update
#line 3603 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Store Floating-Point Single with Update\n"));
#line 30295 "icache.c"

  /* validate: 0.53,6.FRS,11.RA,16.D */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0xd4000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.53,6.FRS,11.RA,16.D #define get-values-from-icache|put-values-in-icache */
#define FRS EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 59 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frS ATTRIBUTE_UNUSED = cache_entry->crack.D.frS = (cpu_registers(processor)->fpr + FRS); /* in icache - extraction */
#line 60 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRS_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.FRS_BITMASK = (1 << FRS); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.D.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.D.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 79 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_D ATTRIBUTE_UNUSED = cache_entry->crack.D.EXTS_D = ((signed_word)(int16_t)(instruction)); /* in icache - extraction */
#line 30326 "icache.c"

#define insn cache_entry->crack.D.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Store_FloatingPoint_Single_with_Update;

    /* semantic routine */
#line 3603 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Store Floating-Point Single with Update\n"));
#line 30336 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Store_FloatingPoint_Single_with_Update, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3603 "../../../sim/ppc/powerpc.igen"
    {
      unsigned_word EA;
      if (RA_is_0)
        program_interrupt(processor, cia,
                          illegal_instruction_program_interrupt);
      EA = *rA + EXTS(D);
      STORE(EA, 4, SINGLE(*frS));
      *rA = EA;
      PPC_INSN_INT_FLOAT(RA_BITMASK, 0, (RA_BITMASK & ~1), FRS_BITMASK);
    }
#line 30356 "icache.c"
    return nia;
    /* extraction: 0.53,6.FRS,11.RA,16.D #undef get-values-from-icache|put-values-in-icache */
#undef FRS
#undef RA_is_0
#line 30361 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Store_FloatingPoint_Double(cpu *processor,
                                  instruction_word instruction,
                                  unsigned_word cia,
                                  idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_FloatingPoint_Double
#undef MY_PREFIX
#define MY_PREFIX Store_FloatingPoint_Double
#line 3631 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Store Floating-Point Double\n"));
#line 30380 "icache.c"

  /* validate: 0.54,6.FRS,11.RA,16.D */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0xd8000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.54,6.FRS,11.RA,16.D #define get-values-from-icache|put-values-in-icache */
#define FRS EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 59 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frS ATTRIBUTE_UNUSED = cache_entry->crack.D.frS = (cpu_registers(processor)->fpr + FRS); /* in icache - extraction */
#line 60 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRS_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.FRS_BITMASK = (1 << FRS); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.D.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.D.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 79 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_D ATTRIBUTE_UNUSED = cache_entry->crack.D.EXTS_D = ((signed_word)(int16_t)(instruction)); /* in icache - extraction */
#line 30411 "icache.c"

#define insn cache_entry->crack.D.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Store_FloatingPoint_Double;

    /* semantic routine */
#line 3631 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Store Floating-Point Double\n"));
#line 30421 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Store_FloatingPoint_Double, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3631 "../../../sim/ppc/powerpc.igen"
    {
      unsigned_word b;
      unsigned_word EA;
      if (RA_is_0) b = 0;
      else         b = *rA;
      EA = b + EXTS(D);
      STORE(EA, 8, *frS);
      PPC_INSN_INT_FLOAT(0, 0, (RA_BITMASK & ~1), FRS_BITMASK);
    }
#line 30440 "icache.c"
    return nia;
    /* extraction: 0.54,6.FRS,11.RA,16.D #undef get-values-from-icache|put-values-in-icache */
#undef FRS
#undef RA_is_0
#line 30445 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Store_FloatingPoint_Double_with_Update(cpu *processor,
                                              instruction_word instruction,
                                              unsigned_word cia,
                                              idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_FloatingPoint_Double_with_Update
#undef MY_PREFIX
#define MY_PREFIX Store_FloatingPoint_Double_with_Update
#line 3669 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Store Floating-Point Double with Update\n"));
#line 30464 "icache.c"

  /* validate: 0.55,6.FRS,11.RA,16.D */
  if (WITH_RESERVED_BITS && (instruction & 0xfc000000) != 0xdc000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.55,6.FRS,11.RA,16.D #define get-values-from-icache|put-values-in-icache */
#define FRS EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 59 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frS ATTRIBUTE_UNUSED = cache_entry->crack.D.frS = (cpu_registers(processor)->fpr + FRS); /* in icache - extraction */
#line 60 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRS_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.FRS_BITMASK = (1 << FRS); /* in icache - extraction */
#line 36 "../../../sim/ppc/powerpc.igen"
    unsigned const RA ATTRIBUTE_UNUSED = cache_entry->crack.D.RA = EXTRACTED32(instruction, 11, 15); /* in icache - extraction */
#line 37 "../../../sim/ppc/powerpc.igen"
    signed_word * const rA ATTRIBUTE_UNUSED = cache_entry->crack.D.rA = (cpu_registers(processor)->gpr + RA); /* in icache - extraction */
#line 38 "../../../sim/ppc/powerpc.igen"
    uint32_t const RA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.D.RA_BITMASK = (1 << RA); /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#line 79 "../../../sim/ppc/powerpc.igen"
    unsigned_word const EXTS_D ATTRIBUTE_UNUSED = cache_entry->crack.D.EXTS_D = ((signed_word)(int16_t)(instruction)); /* in icache - extraction */
#line 30495 "icache.c"

#define insn cache_entry->crack.D.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Store_FloatingPoint_Double_with_Update;

    /* semantic routine */
#line 3669 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Store Floating-Point Double with Update\n"));
#line 30505 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Store_FloatingPoint_Double_with_Update, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3669 "../../../sim/ppc/powerpc.igen"
    {
      unsigned_word EA;
      if (RA_is_0)
        program_interrupt(processor, cia,
                          illegal_instruction_program_interrupt);
      EA = *rA + EXTS(D);
      STORE(EA, 8, *frS);
      *rA = EA;
      PPC_INSN_INT_FLOAT(RA_BITMASK, 0, (RA_BITMASK & ~1), FRS_BITMASK);
    }
#line 30525 "icache.c"
    return nia;
    /* extraction: 0.55,6.FRS,11.RA,16.D #undef get-values-from-icache|put-values-in-icache */
#undef FRS
#undef RA_is_0
#line 30530 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Divide_Single_Rc0(cpu *processor,
                                  instruction_word instruction,
                                  unsigned_word cia,
                                  idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Divide_Single
#undef MY_PREFIX
#define MY_PREFIX Floating_Divide_Single_Rc0
#line 3932 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Divide Single\n"));
#line 30549 "icache.c"

  /* validate: 0.59,6.FRT,11.FRA,16.FRB,21./,26.18,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007fe) != 0xec000024)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21./,26.18,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#line 3932 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 30583 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Divide_Single_Rc0;

    /* semantic routine */
#line 3932 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Divide Single\n"));
#line 30593 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Divide_Single, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3932 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      if (is_invalid_operation(processor, cia,
                               *frA, *frB,
                               fpscr_vxsnan | fpscr_vxzdz,
                               1, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, *frA, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      1); /*single-precision*/
      }
      else if (is_invalid_zero_divide (processor, cia,
                                       *frA, *frB,
                                       1 /*single?*/)) {
        invalid_zero_divide_operation (processor, cia,
                                       frT, *frA, *frB,
                                       1 /*single?*/);
      }
      else {
        /*HACK!*/
        float s = *(double*)frA / *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK, Rc);
    }
#line 30632 "icache.c"
    return nia;
    /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21./,26.18,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#line 30638 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Divide_Single_Rc1(cpu *processor,
                                  instruction_word instruction,
                                  unsigned_word cia,
                                  idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Divide_Single
#undef MY_PREFIX
#define MY_PREFIX Floating_Divide_Single_Rc1
#line 3932 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Divide Single\n"));
#line 30657 "icache.c"

  /* validate: 0.59,6.FRT,11.FRA,16.FRB,21./,26.18,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007fe) != 0xec000024)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21./,26.18,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#line 3932 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 30691 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Divide_Single_Rc1;

    /* semantic routine */
#line 3932 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Divide Single\n"));
#line 30701 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Divide_Single, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3932 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      if (is_invalid_operation(processor, cia,
                               *frA, *frB,
                               fpscr_vxsnan | fpscr_vxzdz,
                               1, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, *frA, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      1); /*single-precision*/
      }
      else if (is_invalid_zero_divide (processor, cia,
                                       *frA, *frB,
                                       1 /*single?*/)) {
        invalid_zero_divide_operation (processor, cia,
                                       frT, *frA, *frB,
                                       1 /*single?*/);
      }
      else {
        /*HACK!*/
        float s = *(double*)frA / *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK, Rc);
    }
#line 30740 "icache.c"
    return nia;
    /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21./,26.18,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#line 30746 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Subtract_Single_Rc0(cpu *processor,
                                    instruction_word instruction,
                                    unsigned_word cia,
                                    idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Subtract_Single
#undef MY_PREFIX
#define MY_PREFIX Floating_Subtract_Single_Rc0
#line 3821 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Subtract Single\n"));
#line 30765 "icache.c"

  /* validate: 0.59,6.FRT,11.FRA,16.FRB,21./,26.20,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007fe) != 0xec000028)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21./,26.20,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#line 3821 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 30799 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Subtract_Single_Rc0;

    /* semantic routine */
#line 3821 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Subtract Single\n"));
#line 30809 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Subtract_Single, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3821 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      if (is_invalid_operation(processor, cia,
                               *frA, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               1, /*single?*/
                               1) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, *frA, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      1); /*single-precision*/
      }
      else {
        /*HACK!*/
        float s = *(double*)frA - *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK, Rc);
    }
#line 30841 "icache.c"
    return nia;
    /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21./,26.20,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#line 30847 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Subtract_Single_Rc1(cpu *processor,
                                    instruction_word instruction,
                                    unsigned_word cia,
                                    idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Subtract_Single
#undef MY_PREFIX
#define MY_PREFIX Floating_Subtract_Single_Rc1
#line 3821 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Subtract Single\n"));
#line 30866 "icache.c"

  /* validate: 0.59,6.FRT,11.FRA,16.FRB,21./,26.20,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007fe) != 0xec000028)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21./,26.20,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#line 3821 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 30900 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Subtract_Single_Rc1;

    /* semantic routine */
#line 3821 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Subtract Single\n"));
#line 30910 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Subtract_Single, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3821 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      if (is_invalid_operation(processor, cia,
                               *frA, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               1, /*single?*/
                               1) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, *frA, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      1); /*single-precision*/
      }
      else {
        /*HACK!*/
        float s = *(double*)frA - *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK, Rc);
    }
#line 30942 "icache.c"
    return nia;
    /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21./,26.20,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#line 30948 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Add_Single_Rc0(cpu *processor,
                               instruction_word instruction,
                               unsigned_word cia,
                               idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Add_Single
#undef MY_PREFIX
#define MY_PREFIX Floating_Add_Single_Rc0
#line 3769 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Add Single\n"));
#line 30967 "icache.c"

  /* validate: 0.59,6.FRT,11.FRA,16.FRB,21./,26.21,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007fe) != 0xec00002a)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21./,26.21,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#line 3769 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 31001 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Add_Single_Rc0;

    /* semantic routine */
#line 3769 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Add Single\n"));
#line 31011 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Add_Single, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3769 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      if (is_invalid_operation(processor, cia,
                               *frA, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               1, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, *frA, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      1); /*single-precision*/
      }
      else {
        /*HACK!*/
        float s = *(double*)frA + *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK, Rc);
    }
#line 31043 "icache.c"
    return nia;
    /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21./,26.21,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#line 31049 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Add_Single_Rc1(cpu *processor,
                               instruction_word instruction,
                               unsigned_word cia,
                               idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Add_Single
#undef MY_PREFIX
#define MY_PREFIX Floating_Add_Single_Rc1
#line 3769 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Add Single\n"));
#line 31068 "icache.c"

  /* validate: 0.59,6.FRT,11.FRA,16.FRB,21./,26.21,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007fe) != 0xec00002a)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21./,26.21,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#line 3769 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 31102 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Add_Single_Rc1;

    /* semantic routine */
#line 3769 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Add Single\n"));
#line 31112 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Add_Single, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3769 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      if (is_invalid_operation(processor, cia,
                               *frA, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               1, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, *frA, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      1); /*single-precision*/
      }
      else {
        /*HACK!*/
        float s = *(double*)frA + *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK, Rc);
    }
#line 31144 "icache.c"
    return nia;
    /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21./,26.21,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#line 31150 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Square_Root_Single_Rc0(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Square_Root_Single
#undef MY_PREFIX
#define MY_PREFIX Floating_Square_Root_Single_Rc0
#line 4726 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Square Root Single\n"));
#line 31169 "icache.c"

  /* validate: 0.59,6.FRT,11./,16.FRB,21./,26.22,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc1f07fe) != 0xec00002c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.59,6.FRT,11./,16.FRB,21./,26.22,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#line 4726 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 31198 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Square_Root_Single_Rc0;

    /* semantic routine */
#line 4726 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Square Root Single\n"));
#line 31208 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Square_Root_Single, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4726 "../../../sim/ppc/powerpc.igen"
    {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    }
#line 31221 "icache.c"
    return nia;
    /* extraction: 0.59,6.FRT,11./,16.FRB,21./,26.22,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRB
#line 31226 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Square_Root_Single_Rc1(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Square_Root_Single
#undef MY_PREFIX
#define MY_PREFIX Floating_Square_Root_Single_Rc1
#line 4726 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Square Root Single\n"));
#line 31245 "icache.c"

  /* validate: 0.59,6.FRT,11./,16.FRB,21./,26.22,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc1f07fe) != 0xec00002c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.59,6.FRT,11./,16.FRB,21./,26.22,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#line 4726 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 31274 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Square_Root_Single_Rc1;

    /* semantic routine */
#line 4726 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Square Root Single\n"));
#line 31284 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Square_Root_Single, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4726 "../../../sim/ppc/powerpc.igen"
    {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    }
#line 31297 "icache.c"
    return nia;
    /* extraction: 0.59,6.FRT,11./,16.FRB,21./,26.22,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRB
#line 31302 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Reciprocal_Estimate_Single_Rc0(cpu *processor,
                                               instruction_word instruction,
                                               unsigned_word cia,
                                               idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Reciprocal_Estimate_Single
#undef MY_PREFIX
#define MY_PREFIX Floating_Reciprocal_Estimate_Single_Rc0
#line 4729 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Reciprocal Estimate Single\n"));
#line 31321 "icache.c"

  /* validate: 0.59,6.FRT,11./,16.FRB,21./,26.24,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc1f07fe) != 0xec000030)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.59,6.FRT,11./,16.FRB,21./,26.24,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#line 4729 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 31350 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Reciprocal_Estimate_Single_Rc0;

    /* semantic routine */
#line 4729 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Reciprocal Estimate Single\n"));
#line 31360 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Reciprocal_Estimate_Single, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4729 "../../../sim/ppc/powerpc.igen"
    {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    }
#line 31373 "icache.c"
    return nia;
    /* extraction: 0.59,6.FRT,11./,16.FRB,21./,26.24,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRB
#line 31378 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Reciprocal_Estimate_Single_Rc1(cpu *processor,
                                               instruction_word instruction,
                                               unsigned_word cia,
                                               idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Reciprocal_Estimate_Single
#undef MY_PREFIX
#define MY_PREFIX Floating_Reciprocal_Estimate_Single_Rc1
#line 4729 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Reciprocal Estimate Single\n"));
#line 31397 "icache.c"

  /* validate: 0.59,6.FRT,11./,16.FRB,21./,26.24,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc1f07fe) != 0xec000030)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.59,6.FRT,11./,16.FRB,21./,26.24,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#line 4729 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 31426 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Reciprocal_Estimate_Single_Rc1;

    /* semantic routine */
#line 4729 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Reciprocal Estimate Single\n"));
#line 31436 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Reciprocal_Estimate_Single, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4729 "../../../sim/ppc/powerpc.igen"
    {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    }
#line 31449 "icache.c"
    return nia;
    /* extraction: 0.59,6.FRT,11./,16.FRB,21./,26.24,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRB
#line 31454 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Multiply_Single_Rc0(cpu *processor,
                                    instruction_word instruction,
                                    unsigned_word cia,
                                    idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply_Single
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_Single_Rc0
#line 3873 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply Single\n"));
#line 31473 "icache.c"

  /* validate: 0.59,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00f83e) != 0xec000032)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.59,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRC EXTRACTED32(instruction, 21, 25) /* icache scratch - extraction */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3873 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 31507 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Multiply_Single_Rc0;

    /* semantic routine */
#line 3873 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply Single\n"));
#line 31517 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Multiply_Single, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3873 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               1, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      1); /*single-precision*/
      }
      else {
        /*HACK!*/
        float s = *(double*)frA * *(double*)frC;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
    }
#line 31549 "icache.c"
    return nia;
    /* extraction: 0.59,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRC
#line 31555 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Multiply_Single_Rc1(cpu *processor,
                                    instruction_word instruction,
                                    unsigned_word cia,
                                    idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply_Single
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_Single_Rc1
#line 3873 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply Single\n"));
#line 31574 "icache.c"

  /* validate: 0.59,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00f83e) != 0xec000032)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.59,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRC EXTRACTED32(instruction, 21, 25) /* icache scratch - extraction */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3873 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 31608 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Multiply_Single_Rc1;

    /* semantic routine */
#line 3873 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply Single\n"));
#line 31618 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Multiply_Single, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3873 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               1, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      1); /*single-precision*/
      }
      else {
        /*HACK!*/
        float s = *(double*)frA * *(double*)frC;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
    }
#line 31650 "icache.c"
    return nia;
    /* extraction: 0.59,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRC
#line 31656 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplySubtract_Single_Rc0(cpu *processor,
                                            instruction_word instruction,
                                            unsigned_word cia,
                                            idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract_Single
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_Single_Rc0
#line 4106 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Subtract Single\n"));
#line 31675 "icache.c"

  /* validate: 0.59,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xec000038)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC EXTRACTED32(instruction, 21, 25) /* icache scratch - extraction */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4106 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 31714 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplySubtract_Single_Rc0;

    /* semantic routine */
#line 4106 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract Single\n"));
#line 31724 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplySubtract_Single, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4106 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      float product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               1, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               1, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        float s = product - *(double*)frB;
        *(double*)frT = (double)s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 31777 "icache.c"
    return nia;
    /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 31784 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplySubtract_Single_Rc1(cpu *processor,
                                            instruction_word instruction,
                                            unsigned_word cia,
                                            idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract_Single
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_Single_Rc1
#line 4106 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Subtract Single\n"));
#line 31803 "icache.c"

  /* validate: 0.59,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xec000038)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC EXTRACTED32(instruction, 21, 25) /* icache scratch - extraction */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4106 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 31842 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplySubtract_Single_Rc1;

    /* semantic routine */
#line 4106 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract Single\n"));
#line 31852 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplySubtract_Single, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4106 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      float product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               1, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               1, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        float s = product - *(double*)frB;
        *(double*)frT = (double)s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 31905 "icache.c"
    return nia;
    /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 31912 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplyAdd_Single_Rc0(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd_Single
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_Single_Rc0
#line 4012 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Add Single\n"));
#line 31931 "icache.c"

  /* validate: 0.59,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xec00003a)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC EXTRACTED32(instruction, 21, 25) /* icache scratch - extraction */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4012 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 31970 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplyAdd_Single_Rc0;

    /* semantic routine */
#line 4012 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Add Single\n"));
#line 31980 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplyAdd_Single, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4012 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      float product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               1, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               1, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        float s = product + *(double*)frB;
        *(double*)frT = (double)s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 32033 "icache.c"
    return nia;
    /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 32040 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplyAdd_Single_Rc1(cpu *processor,
                                       instruction_word instruction,
                                       unsigned_word cia,
                                       idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd_Single
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_Single_Rc1
#line 4012 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Add Single\n"));
#line 32059 "icache.c"

  /* validate: 0.59,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xec00003a)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC EXTRACTED32(instruction, 21, 25) /* icache scratch - extraction */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4012 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 32098 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplyAdd_Single_Rc1;

    /* semantic routine */
#line 4012 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Add Single\n"));
#line 32108 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplyAdd_Single, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4012 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      float product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               1, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               1, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        float s = product + *(double*)frB;
        *(double*)frT = (double)s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 32161 "icache.c"
    return nia;
    /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 32168 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplySubtract_Single_Rc0(cpu *processor,
                                                     instruction_word instruction,
                                                     unsigned_word cia,
                                                     idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract_Single
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_Single_Rc0
#line 4294 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Subtract Single\n"));
#line 32187 "icache.c"

  /* validate: 0.59,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xec00003c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC EXTRACTED32(instruction, 21, 25) /* icache scratch - extraction */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4294 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 32226 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplySubtract_Single_Rc0;

    /* semantic routine */
#line 4294 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract Single\n"));
#line 32236 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplySubtract_Single, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4294 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      float product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               1, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               1, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        float s = -(product - *(double*)frB);
        *(double*)frT = (double)s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 32289 "icache.c"
    return nia;
    /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 32296 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplySubtract_Single_Rc1(cpu *processor,
                                                     instruction_word instruction,
                                                     unsigned_word cia,
                                                     idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract_Single
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_Single_Rc1
#line 4294 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Subtract Single\n"));
#line 32315 "icache.c"

  /* validate: 0.59,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xec00003c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC EXTRACTED32(instruction, 21, 25) /* icache scratch - extraction */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4294 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 32354 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplySubtract_Single_Rc1;

    /* semantic routine */
#line 4294 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract Single\n"));
#line 32364 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplySubtract_Single, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4294 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      float product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               1, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               1, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        float s = -(product - *(double*)frB);
        *(double*)frT = (double)s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 32417 "icache.c"
    return nia;
    /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 32424 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplyAdd_Single_Rc0(cpu *processor,
                                                instruction_word instruction,
                                                unsigned_word cia,
                                                idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd_Single
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_Single_Rc0
#line 4200 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Add Single\n"));
#line 32443 "icache.c"

  /* validate: 0.59,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xec00003e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC EXTRACTED32(instruction, 21, 25) /* icache scratch - extraction */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4200 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 32482 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplyAdd_Single_Rc0;

    /* semantic routine */
#line 4200 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add Single\n"));
#line 32492 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplyAdd_Single, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4200 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      float product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               1, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               1, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        float s = -(product + *(double*)frB);
        *(double*)frT = (double)s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 32545 "icache.c"
    return nia;
    /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 32552 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplyAdd_Single_Rc1(cpu *processor,
                                                instruction_word instruction,
                                                unsigned_word cia,
                                                idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd_Single
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_Single_Rc1
#line 4200 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Add Single\n"));
#line 32571 "icache.c"

  /* validate: 0.59,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xec00003e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC EXTRACTED32(instruction, 21, 25) /* icache scratch - extraction */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4200 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 32610 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplyAdd_Single_Rc1;

    /* semantic routine */
#line 4200 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add Single\n"));
#line 32620 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplyAdd_Single, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4200 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      float product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               1, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               1, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        float s = -(product + *(double*)frB);
        *(double*)frT = (double)s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 32673 "icache.c"
    return nia;
    /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 32680 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Compare_Unordered(cpu *processor,
                                  instruction_word instruction,
                                  unsigned_word cia,
                                  idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Compare_Unordered
#undef MY_PREFIX
#define MY_PREFIX Floating_Compare_Unordered
#line 4621 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Compare Unordered\n"));
#line 32699 "icache.c"

  /* validate: 0.63,6.BF,9./,11.FRA,16.FRB,21.0,31./ */
  if (WITH_RESERVED_BITS && (instruction & 0xfc6007ff) != 0xfc000000)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.BF,9./,11.FRA,16.FRB,21.0,31./ #define get-values-from-icache|put-values-in-icache */
#line 67 "../../../sim/ppc/powerpc.igen"
    unsigned const BF ATTRIBUTE_UNUSED = cache_entry->crack.X.BF = EXTRACTED32(instruction, 6, 8); /* in icache - extraction */
#line 68 "../../../sim/ppc/powerpc.igen"
    uint32_t const BF_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.BF_BITMASK = (1 << BF); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.X.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.X.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#line 32730 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Compare_Unordered;

    /* semantic routine */
#line 4621 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Compare Unordered\n"));
#line 32740 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Compare_Unordered, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4621 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      unsigned c;
      if (is_NaN(*frA, 0) || is_NaN(*frB, 0))
        c = cr_i_summary_overflow; /* 0b0001 - (FRA) ? (FRB) */
      else if (is_less_than(frA, frB))
        c = cr_i_negative; /* 0b1000 - (FRA) < (FRB) */
      else if (is_greater_than(frA, frB))
        c = cr_i_positive; /* 0b0100 - (FRA) > (FRB) */
      else
        c = cr_i_zero; /* 0b0010 - (FRA) = (FRB) */
      FPSCR_SET_FPCC(c);
      CR_SET(BF, c); /* CR[4*BF..4*BF+3] = c */
      if (is_SNaN(*frA, 0) || is_SNaN(*frB, 0))
        FPSCR_OR_VX(fpscr_vxsnan);
      FPSCR_END(0);
      PPC_INSN_FLOAT_CR(0, FRA_BITMASK | FRB_BITMASK, BF_BITMASK);
    }
#line 32768 "icache.c"
    return nia;
    /* extraction: 0.63,6.BF,9./,11.FRA,16.FRB,21.0,31./ #undef get-values-from-icache|put-values-in-icache */
#undef FRA
#undef FRB
#line 32773 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Round_to_SinglePrecision_Rc0(cpu *processor,
                                             instruction_word instruction,
                                             unsigned_word cia,
                                             idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Round_to_SinglePrecision
#undef MY_PREFIX
#define MY_PREFIX Floating_Round_to_SinglePrecision_Rc0
#line 4346 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Round to Single-Precision\n"));
#line 32792 "icache.c"

  /* validate: 0.63,6.FRT,11./,16.FRB,21.12,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc1f07fe) != 0xfc000018)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11./,16.FRB,21.12,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.X.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.X.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#line 4346 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 32821 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Round_to_SinglePrecision_Rc0;

    /* semantic routine */
#line 4346 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Round to Single-Precision\n"));
#line 32831 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Round_to_SinglePrecision, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4346 "../../../sim/ppc/powerpc.igen"
    {
      int sign;
      int exp;
      uint64_t frac_grx;
      /***/
        /* split off cases for what to do */
        if (EXTRACTED64(*frB, 1, 11) < 897
            && EXTRACTED64(*frB, 1, 63) > 0) {
            if ((FPSCR & fpscr_ue) == 0) GOTO(Disabled_Exponent_Underflow);
            if ((FPSCR & fpscr_ue) != 0) GOTO(Enabled_Exponent_Underflow);
        }
        if (EXTRACTED64(*frB, 1, 11) > 1150
            && EXTRACTED64(*frB, 1, 11) < 2047) {
            if ((FPSCR & fpscr_oe) == 0) GOTO(Disabled_Exponent_Overflow);
            if ((FPSCR & fpscr_oe) != 0) GOTO(Enabled_Exponent_Overflow);
        }
        if (EXTRACTED64(*frB, 1, 11) > 896
            && EXTRACTED64(*frB, 1, 11) < 1151) GOTO(Normal_Operand);
        if (EXTRACTED64(*frB, 1, 63) == 0) GOTO(Zero_Operand);
        if (EXTRACTED64(*frB, 1, 11) == 2047) {
          if (EXTRACTED64(*frB, 12, 63) == 0) GOTO(Infinity_Operand);
          if (EXTRACTED64(*frB, 12, 12) == 1) GOTO(QNaN_Operand);
          if (EXTRACTED64(*frB, 12, 12) == 0
              && EXTRACTED64(*frB, 13, 63) > 0) GOTO(SNaN_Operand);
        }
      /**/
      LABEL(Disabled_Exponent_Underflow):
        sign = EXTRACTED64(*frB, 0, 0);
        if (EXTRACTED64(*frB, 1, 11) == 0) {
          exp = -1022;
          frac_grx = INSERTED64(EXTRACTED64(*frB, 12, 63), 1, 52);
        }
        if (EXTRACTED64(*frB, 1, 11) > 0) {
          exp = EXTRACTED64(*frB, 1, 11) - 1023;
          frac_grx = BIT64(0) | INSERTED64(EXTRACTED64(*frB, 12, 63), 1, 52);
        }
          /* G|R|X == zero from above */
          while (exp < -126) {
            exp = exp + 1;
            frac_grx = (INSERTED64(EXTRACTED64(frac_grx, 0, 54), 1, 55)
                        | MASKED64(frac_grx, 55, 55));
          }
        FPSCR_SET_UX(EXTRACTED64(frac_grx, 24, 55) > 0);
        Round_Single(processor, sign, &exp, &frac_grx);
        FPSCR_SET_XX(FPSCR & fpscr_fi);
        if (EXTRACTED64(frac_grx, 0, 52) == 0) {
          *frT = INSERTED64(sign, 0, 0);
          if (sign == 0) FPSCR_SET_FPRF(fpscr_rf_pos_zero);
          if (sign == 1) FPSCR_SET_FPRF(fpscr_rf_neg_zero);
        }
        if (EXTRACTED64(frac_grx, 0, 52) > 0) {
          if (EXTRACTED64(frac_grx, 0, 0) == 1) {
            if (sign == 0) FPSCR_SET_FPRF(fpscr_rf_pos_normal_number);
            if (sign == 1) FPSCR_SET_FPRF(fpscr_rf_neg_normal_number);
          }
          if (EXTRACTED64(frac_grx, 0, 0) == 0) {
            if (sign == 0) FPSCR_SET_FPRF(fpscr_rf_pos_denormalized_number);
            if (sign == 1) FPSCR_SET_FPRF(fpscr_rf_neg_denormalized_number);
          }
          /*Normalize_Operand:*/
            while (EXTRACTED64(frac_grx, 0, 0) == 0) {
              exp = exp - 1;
              frac_grx = INSERTED64(EXTRACTED64(frac_grx, 1,  52), 0, 51);
            }
          *frT = (INSERTED64(sign, 0, 0)
                  | INSERTED64(exp + 1023, 1, 11)
                  | INSERTED64(EXTRACTED64(frac_grx, 1, 52), 12, 63));
        }
        GOTO(Done);
      /**/
      LABEL(Enabled_Exponent_Underflow):
        FPSCR_SET_UX(1);
        sign = EXTRACTED64(*frB, 0, 0);
        if (EXTRACTED64(*frB, 1, 11) == 0) {
          exp = -1022;
          frac_grx = INSERTED64(EXTRACTED64(*frB, 12, 63), 1, 52);
        }
        if (EXTRACTED64(*frB, 1, 11) > 0) {
          exp = EXTRACTED64(*frB, 1, 11) - 1023;
          frac_grx = (BIT64(0) |
                      INSERTED64(EXTRACTED64(*frB, 12, 63), 1, 52));
        }
        /*Normalize_Operand:*/
          while (EXTRACTED64(frac_grx, 0, 0) == 0) {
            exp = exp - 1;
            frac_grx = INSERTED64(EXTRACTED64(frac_grx, 1, 52), 0, 51);
          }
        Round_Single(processor, sign, &exp, &frac_grx);
        FPSCR_SET_XX(FPSCR & fpscr_fi);
        exp = exp + 192;
        *frT = (INSERTED64(sign, 0, 0)
                | INSERTED64(exp + 1023, 1, 11)
                | INSERTED64(EXTRACTED64(frac_grx, 1, 52), 12, 63));
        if (sign == 0) FPSCR_SET_FPRF(fpscr_rf_pos_normal_number);
        if (sign == 1) FPSCR_SET_FPRF(fpscr_rf_neg_normal_number);
        GOTO(Done);
      /**/
      LABEL(Disabled_Exponent_Overflow):
        FPSCR_SET_OX(1);
        if ((FPSCR & fpscr_rn) == fpscr_rn_round_to_nearest) {
          if (EXTRACTED64(*frB, 0, 0) == 0) {
            *frT = INSERTED64(0x7FF00000, 0, 31) | 0x00000000;
            FPSCR_SET_FPRF(fpscr_rf_pos_infinity);
          }
          if (EXTRACTED64(*frB, 0, 0) == 1) {
            *frT = INSERTED64(0xFFF00000, 0, 31) | 0x00000000;
            FPSCR_SET_FPRF(fpscr_rf_neg_infinity);
          }
        }
        if ((FPSCR & fpscr_rn) == fpscr_rn_round_towards_zero) {
          if (EXTRACTED64(*frB, 0, 0) == 0) {
            *frT = INSERTED64(0x47EFFFFF, 0, 31) | 0xE0000000;
            FPSCR_SET_FPRF(fpscr_rf_pos_normal_number);
          }
          if (EXTRACTED64(*frB, 0, 0) == 1) {
            *frT = INSERTED64(0xC7EFFFFF, 0, 31) | 0xE0000000;
            FPSCR_SET_FPRF(fpscr_rf_neg_normal_number);
          }
        }
        if ((FPSCR & fpscr_rn) == fpscr_rn_round_towards_pos_infinity) {
          if (EXTRACTED64(*frB, 0, 0) == 0) {
            *frT = INSERTED64(0x7FF00000, 0, 31) | 0x00000000;
            FPSCR_SET_FPRF(fpscr_rf_pos_infinity);
          }
          if (EXTRACTED64(*frB, 0, 0) == 1) {
            *frT = INSERTED64(0xC7EFFFFF, 0, 31) | 0xE0000000;
            FPSCR_SET_FPRF(fpscr_rf_neg_normal_number);
          }
        }
        if ((FPSCR & fpscr_rn) == fpscr_rn_round_towards_neg_infinity) {
          if (EXTRACTED64(*frB, 0, 0) == 0) {
            *frT = INSERTED64(0x47EFFFFF, 0, 31) | 0xE0000000;
            FPSCR_SET_FPRF(fpscr_rf_pos_normal_number);
          }
          if (EXTRACTED64(*frB, 0, 0) == 1) {
            *frT = INSERTED64(0xFFF00000, 0, 31) | 0x00000000;
            FPSCR_SET_FPRF(fpscr_rf_neg_infinity);
          }
        }
        /* FPSCR[FR] <- undefined */
        FPSCR_SET_FI(1);
        FPSCR_SET_XX(1);
        GOTO(Done);
      /**/
      LABEL(Enabled_Exponent_Overflow):
        sign = EXTRACTED64(*frB, 0, 0);
        exp = EXTRACTED64(*frB, 1, 11) - 1023;
        frac_grx = BIT64(0) | INSERTED64(EXTRACTED64(*frB, 12, 63), 1, 52);
        Round_Single(processor, sign, &exp, &frac_grx);
        FPSCR_SET_XX(FPSCR & fpscr_fi);
      /**/
      LABEL(Enabled_Overflow):
        FPSCR_SET_OX(1);
        exp = exp - 192;
        *frT = (INSERTED64(sign, 0, 0)
                | INSERTED64(exp + 1023, 1, 11)
                | INSERTED64(EXTRACTED64(frac_grx, 1, 52), 12, 63));
        if (sign == 0) FPSCR_SET_FPRF(fpscr_rf_pos_normal_number);
        if (sign == 1) FPSCR_SET_FPRF(fpscr_rf_neg_normal_number);
        GOTO(Done);
      /**/
      LABEL(Zero_Operand):
        *frT = *frB;
        if (EXTRACTED64(*frB, 0, 0) == 0) FPSCR_SET_FPRF(fpscr_rf_pos_zero);
        if (EXTRACTED64(*frB, 0, 0) == 1) FPSCR_SET_FPRF(fpscr_rf_neg_zero);
        FPSCR_SET_FR(0);
        FPSCR_SET_FI(0);
        GOTO(Done);
      /**/
      LABEL(Infinity_Operand):
        *frT = *frB;
        if (EXTRACTED64(*frB, 0, 0) == 0) FPSCR_SET_FPRF(fpscr_rf_pos_infinity);
        if (EXTRACTED64(*frB, 0, 0) == 1) FPSCR_SET_FPRF(fpscr_rf_neg_infinity);
        FPSCR_SET_FR(0);
        FPSCR_SET_FI(0);
        GOTO(Done);
      /**/
      LABEL(QNaN_Operand):
        *frT = INSERTED64(EXTRACTED64(*frB, 0, 34), 0, 34);
        FPSCR_SET_FPRF(fpscr_rf_quiet_nan);
        FPSCR_SET_FR(0);
        FPSCR_SET_FI(0);
        GOTO(Done);
      /**/
      LABEL(SNaN_Operand):
        FPSCR_OR_VX(fpscr_vxsnan);
        if ((FPSCR & fpscr_ve) == 0) {
          *frT = (MASKED64(*frB, 0, 11)
                  | BIT64(12)
                  | MASKED64(*frB, 13, 34));
          FPSCR_SET_FPRF(fpscr_rf_quiet_nan);
        }
        FPSCR_SET_FR(0);
        FPSCR_SET_FI(0);
        GOTO(Done);
      /**/
      LABEL(Normal_Operand):
        sign = EXTRACTED64(*frB, 0, 0);
        exp = EXTRACTED64(*frB, 1, 11) - 1023;
        frac_grx = BIT64(0) | INSERTED64(EXTRACTED64(*frB, 12, 63), 1, 52);
        Round_Single(processor, sign, &exp, &frac_grx);
        FPSCR_SET_XX(FPSCR & fpscr_fi);
        if (exp > 127 && (FPSCR & fpscr_oe) == 0) GOTO(Disabled_Exponent_Overflow);
        if (exp > 127 && (FPSCR & fpscr_oe) != 0) GOTO(Enabled_Overflow);
        *frT = (INSERTED64(sign, 0, 0)
                | INSERTED64(exp + 1023, 1, 11)
                | INSERTED64(EXTRACTED64(frac_grx, 1, 52), 12, 63));
        if (sign == 0) FPSCR_SET_FPRF(fpscr_rf_pos_normal_number);
        if (sign == 1) FPSCR_SET_FPRF(fpscr_rf_neg_normal_number);
        GOTO(Done);
      /**/
      LABEL(Done):
        PPC_INSN_FLOAT(FRT_BITMASK, FRB_BITMASK, Rc);
    }
#line 33055 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11./,16.FRB,21.12,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRB
#line 33060 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Round_to_SinglePrecision_Rc1(cpu *processor,
                                             instruction_word instruction,
                                             unsigned_word cia,
                                             idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Round_to_SinglePrecision
#undef MY_PREFIX
#define MY_PREFIX Floating_Round_to_SinglePrecision_Rc1
#line 4346 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Round to Single-Precision\n"));
#line 33079 "icache.c"

  /* validate: 0.63,6.FRT,11./,16.FRB,21.12,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc1f07fe) != 0xfc000018)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11./,16.FRB,21.12,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.X.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.X.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#line 4346 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 33108 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Round_to_SinglePrecision_Rc1;

    /* semantic routine */
#line 4346 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Round to Single-Precision\n"));
#line 33118 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Round_to_SinglePrecision, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4346 "../../../sim/ppc/powerpc.igen"
    {
      int sign;
      int exp;
      uint64_t frac_grx;
      /***/
        /* split off cases for what to do */
        if (EXTRACTED64(*frB, 1, 11) < 897
            && EXTRACTED64(*frB, 1, 63) > 0) {
            if ((FPSCR & fpscr_ue) == 0) GOTO(Disabled_Exponent_Underflow);
            if ((FPSCR & fpscr_ue) != 0) GOTO(Enabled_Exponent_Underflow);
        }
        if (EXTRACTED64(*frB, 1, 11) > 1150
            && EXTRACTED64(*frB, 1, 11) < 2047) {
            if ((FPSCR & fpscr_oe) == 0) GOTO(Disabled_Exponent_Overflow);
            if ((FPSCR & fpscr_oe) != 0) GOTO(Enabled_Exponent_Overflow);
        }
        if (EXTRACTED64(*frB, 1, 11) > 896
            && EXTRACTED64(*frB, 1, 11) < 1151) GOTO(Normal_Operand);
        if (EXTRACTED64(*frB, 1, 63) == 0) GOTO(Zero_Operand);
        if (EXTRACTED64(*frB, 1, 11) == 2047) {
          if (EXTRACTED64(*frB, 12, 63) == 0) GOTO(Infinity_Operand);
          if (EXTRACTED64(*frB, 12, 12) == 1) GOTO(QNaN_Operand);
          if (EXTRACTED64(*frB, 12, 12) == 0
              && EXTRACTED64(*frB, 13, 63) > 0) GOTO(SNaN_Operand);
        }
      /**/
      LABEL(Disabled_Exponent_Underflow):
        sign = EXTRACTED64(*frB, 0, 0);
        if (EXTRACTED64(*frB, 1, 11) == 0) {
          exp = -1022;
          frac_grx = INSERTED64(EXTRACTED64(*frB, 12, 63), 1, 52);
        }
        if (EXTRACTED64(*frB, 1, 11) > 0) {
          exp = EXTRACTED64(*frB, 1, 11) - 1023;
          frac_grx = BIT64(0) | INSERTED64(EXTRACTED64(*frB, 12, 63), 1, 52);
        }
          /* G|R|X == zero from above */
          while (exp < -126) {
            exp = exp + 1;
            frac_grx = (INSERTED64(EXTRACTED64(frac_grx, 0, 54), 1, 55)
                        | MASKED64(frac_grx, 55, 55));
          }
        FPSCR_SET_UX(EXTRACTED64(frac_grx, 24, 55) > 0);
        Round_Single(processor, sign, &exp, &frac_grx);
        FPSCR_SET_XX(FPSCR & fpscr_fi);
        if (EXTRACTED64(frac_grx, 0, 52) == 0) {
          *frT = INSERTED64(sign, 0, 0);
          if (sign == 0) FPSCR_SET_FPRF(fpscr_rf_pos_zero);
          if (sign == 1) FPSCR_SET_FPRF(fpscr_rf_neg_zero);
        }
        if (EXTRACTED64(frac_grx, 0, 52) > 0) {
          if (EXTRACTED64(frac_grx, 0, 0) == 1) {
            if (sign == 0) FPSCR_SET_FPRF(fpscr_rf_pos_normal_number);
            if (sign == 1) FPSCR_SET_FPRF(fpscr_rf_neg_normal_number);
          }
          if (EXTRACTED64(frac_grx, 0, 0) == 0) {
            if (sign == 0) FPSCR_SET_FPRF(fpscr_rf_pos_denormalized_number);
            if (sign == 1) FPSCR_SET_FPRF(fpscr_rf_neg_denormalized_number);
          }
          /*Normalize_Operand:*/
            while (EXTRACTED64(frac_grx, 0, 0) == 0) {
              exp = exp - 1;
              frac_grx = INSERTED64(EXTRACTED64(frac_grx, 1,  52), 0, 51);
            }
          *frT = (INSERTED64(sign, 0, 0)
                  | INSERTED64(exp + 1023, 1, 11)
                  | INSERTED64(EXTRACTED64(frac_grx, 1, 52), 12, 63));
        }
        GOTO(Done);
      /**/
      LABEL(Enabled_Exponent_Underflow):
        FPSCR_SET_UX(1);
        sign = EXTRACTED64(*frB, 0, 0);
        if (EXTRACTED64(*frB, 1, 11) == 0) {
          exp = -1022;
          frac_grx = INSERTED64(EXTRACTED64(*frB, 12, 63), 1, 52);
        }
        if (EXTRACTED64(*frB, 1, 11) > 0) {
          exp = EXTRACTED64(*frB, 1, 11) - 1023;
          frac_grx = (BIT64(0) |
                      INSERTED64(EXTRACTED64(*frB, 12, 63), 1, 52));
        }
        /*Normalize_Operand:*/
          while (EXTRACTED64(frac_grx, 0, 0) == 0) {
            exp = exp - 1;
            frac_grx = INSERTED64(EXTRACTED64(frac_grx, 1, 52), 0, 51);
          }
        Round_Single(processor, sign, &exp, &frac_grx);
        FPSCR_SET_XX(FPSCR & fpscr_fi);
        exp = exp + 192;
        *frT = (INSERTED64(sign, 0, 0)
                | INSERTED64(exp + 1023, 1, 11)
                | INSERTED64(EXTRACTED64(frac_grx, 1, 52), 12, 63));
        if (sign == 0) FPSCR_SET_FPRF(fpscr_rf_pos_normal_number);
        if (sign == 1) FPSCR_SET_FPRF(fpscr_rf_neg_normal_number);
        GOTO(Done);
      /**/
      LABEL(Disabled_Exponent_Overflow):
        FPSCR_SET_OX(1);
        if ((FPSCR & fpscr_rn) == fpscr_rn_round_to_nearest) {
          if (EXTRACTED64(*frB, 0, 0) == 0) {
            *frT = INSERTED64(0x7FF00000, 0, 31) | 0x00000000;
            FPSCR_SET_FPRF(fpscr_rf_pos_infinity);
          }
          if (EXTRACTED64(*frB, 0, 0) == 1) {
            *frT = INSERTED64(0xFFF00000, 0, 31) | 0x00000000;
            FPSCR_SET_FPRF(fpscr_rf_neg_infinity);
          }
        }
        if ((FPSCR & fpscr_rn) == fpscr_rn_round_towards_zero) {
          if (EXTRACTED64(*frB, 0, 0) == 0) {
            *frT = INSERTED64(0x47EFFFFF, 0, 31) | 0xE0000000;
            FPSCR_SET_FPRF(fpscr_rf_pos_normal_number);
          }
          if (EXTRACTED64(*frB, 0, 0) == 1) {
            *frT = INSERTED64(0xC7EFFFFF, 0, 31) | 0xE0000000;
            FPSCR_SET_FPRF(fpscr_rf_neg_normal_number);
          }
        }
        if ((FPSCR & fpscr_rn) == fpscr_rn_round_towards_pos_infinity) {
          if (EXTRACTED64(*frB, 0, 0) == 0) {
            *frT = INSERTED64(0x7FF00000, 0, 31) | 0x00000000;
            FPSCR_SET_FPRF(fpscr_rf_pos_infinity);
          }
          if (EXTRACTED64(*frB, 0, 0) == 1) {
            *frT = INSERTED64(0xC7EFFFFF, 0, 31) | 0xE0000000;
            FPSCR_SET_FPRF(fpscr_rf_neg_normal_number);
          }
        }
        if ((FPSCR & fpscr_rn) == fpscr_rn_round_towards_neg_infinity) {
          if (EXTRACTED64(*frB, 0, 0) == 0) {
            *frT = INSERTED64(0x47EFFFFF, 0, 31) | 0xE0000000;
            FPSCR_SET_FPRF(fpscr_rf_pos_normal_number);
          }
          if (EXTRACTED64(*frB, 0, 0) == 1) {
            *frT = INSERTED64(0xFFF00000, 0, 31) | 0x00000000;
            FPSCR_SET_FPRF(fpscr_rf_neg_infinity);
          }
        }
        /* FPSCR[FR] <- undefined */
        FPSCR_SET_FI(1);
        FPSCR_SET_XX(1);
        GOTO(Done);
      /**/
      LABEL(Enabled_Exponent_Overflow):
        sign = EXTRACTED64(*frB, 0, 0);
        exp = EXTRACTED64(*frB, 1, 11) - 1023;
        frac_grx = BIT64(0) | INSERTED64(EXTRACTED64(*frB, 12, 63), 1, 52);
        Round_Single(processor, sign, &exp, &frac_grx);
        FPSCR_SET_XX(FPSCR & fpscr_fi);
      /**/
      LABEL(Enabled_Overflow):
        FPSCR_SET_OX(1);
        exp = exp - 192;
        *frT = (INSERTED64(sign, 0, 0)
                | INSERTED64(exp + 1023, 1, 11)
                | INSERTED64(EXTRACTED64(frac_grx, 1, 52), 12, 63));
        if (sign == 0) FPSCR_SET_FPRF(fpscr_rf_pos_normal_number);
        if (sign == 1) FPSCR_SET_FPRF(fpscr_rf_neg_normal_number);
        GOTO(Done);
      /**/
      LABEL(Zero_Operand):
        *frT = *frB;
        if (EXTRACTED64(*frB, 0, 0) == 0) FPSCR_SET_FPRF(fpscr_rf_pos_zero);
        if (EXTRACTED64(*frB, 0, 0) == 1) FPSCR_SET_FPRF(fpscr_rf_neg_zero);
        FPSCR_SET_FR(0);
        FPSCR_SET_FI(0);
        GOTO(Done);
      /**/
      LABEL(Infinity_Operand):
        *frT = *frB;
        if (EXTRACTED64(*frB, 0, 0) == 0) FPSCR_SET_FPRF(fpscr_rf_pos_infinity);
        if (EXTRACTED64(*frB, 0, 0) == 1) FPSCR_SET_FPRF(fpscr_rf_neg_infinity);
        FPSCR_SET_FR(0);
        FPSCR_SET_FI(0);
        GOTO(Done);
      /**/
      LABEL(QNaN_Operand):
        *frT = INSERTED64(EXTRACTED64(*frB, 0, 34), 0, 34);
        FPSCR_SET_FPRF(fpscr_rf_quiet_nan);
        FPSCR_SET_FR(0);
        FPSCR_SET_FI(0);
        GOTO(Done);
      /**/
      LABEL(SNaN_Operand):
        FPSCR_OR_VX(fpscr_vxsnan);
        if ((FPSCR & fpscr_ve) == 0) {
          *frT = (MASKED64(*frB, 0, 11)
                  | BIT64(12)
                  | MASKED64(*frB, 13, 34));
          FPSCR_SET_FPRF(fpscr_rf_quiet_nan);
        }
        FPSCR_SET_FR(0);
        FPSCR_SET_FI(0);
        GOTO(Done);
      /**/
      LABEL(Normal_Operand):
        sign = EXTRACTED64(*frB, 0, 0);
        exp = EXTRACTED64(*frB, 1, 11) - 1023;
        frac_grx = BIT64(0) | INSERTED64(EXTRACTED64(*frB, 12, 63), 1, 52);
        Round_Single(processor, sign, &exp, &frac_grx);
        FPSCR_SET_XX(FPSCR & fpscr_fi);
        if (exp > 127 && (FPSCR & fpscr_oe) == 0) GOTO(Disabled_Exponent_Overflow);
        if (exp > 127 && (FPSCR & fpscr_oe) != 0) GOTO(Enabled_Overflow);
        *frT = (INSERTED64(sign, 0, 0)
                | INSERTED64(exp + 1023, 1, 11)
                | INSERTED64(EXTRACTED64(frac_grx, 1, 52), 12, 63));
        if (sign == 0) FPSCR_SET_FPRF(fpscr_rf_pos_normal_number);
        if (sign == 1) FPSCR_SET_FPRF(fpscr_rf_neg_normal_number);
        GOTO(Done);
      /**/
      LABEL(Done):
        PPC_INSN_FLOAT(FRT_BITMASK, FRB_BITMASK, Rc);
    }
#line 33342 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11./,16.FRB,21.12,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRB
#line 33347 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Convert_To_Integer_Word_Rc0(cpu *processor,
                                            instruction_word instruction,
                                            unsigned_word cia,
                                            idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Convert_To_Integer_Word
#undef MY_PREFIX
#define MY_PREFIX Floating_Convert_To_Integer_Word_Rc0
#line 4567 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Convert To Integer Word\n"));
#line 33366 "icache.c"

  /* validate: 0.63,6.FRT,11./,16.FRB,21.14,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc1f07fe) != 0xfc00001c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11./,16.FRB,21.14,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.X.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.X.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#line 4567 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 33395 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Convert_To_Integer_Word_Rc0;

    /* semantic routine */
#line 4567 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Convert To Integer Word\n"));
#line 33405 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Convert_To_Integer_Word, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4567 "../../../sim/ppc/powerpc.igen"
    {
      floating_point_assist_interrupt(processor, cia);
    }
#line 33418 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11./,16.FRB,21.14,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRB
#line 33423 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Convert_To_Integer_Word_Rc1(cpu *processor,
                                            instruction_word instruction,
                                            unsigned_word cia,
                                            idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Convert_To_Integer_Word
#undef MY_PREFIX
#define MY_PREFIX Floating_Convert_To_Integer_Word_Rc1
#line 4567 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Convert To Integer Word\n"));
#line 33442 "icache.c"

  /* validate: 0.63,6.FRT,11./,16.FRB,21.14,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc1f07fe) != 0xfc00001c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11./,16.FRB,21.14,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.X.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.X.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#line 4567 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 33471 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Convert_To_Integer_Word_Rc1;

    /* semantic routine */
#line 4567 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Convert To Integer Word\n"));
#line 33481 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Convert_To_Integer_Word, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4567 "../../../sim/ppc/powerpc.igen"
    {
      floating_point_assist_interrupt(processor, cia);
    }
#line 33494 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11./,16.FRB,21.14,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRB
#line 33499 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Convert_To_Integer_Word_with_round_towards_Zero_Rc0(cpu *processor,
                                                                    instruction_word instruction,
                                                                    unsigned_word cia,
                                                                    idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Convert_To_Integer_Word_with_round_towards_Zero
#undef MY_PREFIX
#define MY_PREFIX Floating_Convert_To_Integer_Word_with_round_towards_Zero_Rc0
#line 4574 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Convert To Integer Word with round towards Zero\n"));
#line 33518 "icache.c"

  /* validate: 0.63,6.FRT,11./,16.FRB,21.15,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc1f07fe) != 0xfc00001e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11./,16.FRB,21.15,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.X.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.X.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#line 4574 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 33547 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Convert_To_Integer_Word_with_round_towards_Zero_Rc0;

    /* semantic routine */
#line 4574 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Convert To Integer Word with round towards Zero\n"));
#line 33557 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Convert_To_Integer_Word_with_round_towards_Zero, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4574 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      convert_to_integer(processor, cia,
                         frT, *frB,
                         fpscr_rn_round_towards_zero, 32);
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRB_BITMASK, Rc);
    }
#line 33575 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11./,16.FRB,21.15,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRB
#line 33580 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Convert_To_Integer_Word_with_round_towards_Zero_Rc1(cpu *processor,
                                                                    instruction_word instruction,
                                                                    unsigned_word cia,
                                                                    idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Convert_To_Integer_Word_with_round_towards_Zero
#undef MY_PREFIX
#define MY_PREFIX Floating_Convert_To_Integer_Word_with_round_towards_Zero_Rc1
#line 4574 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Convert To Integer Word with round towards Zero\n"));
#line 33599 "icache.c"

  /* validate: 0.63,6.FRT,11./,16.FRB,21.15,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc1f07fe) != 0xfc00001e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11./,16.FRB,21.15,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.X.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.X.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#line 4574 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 33628 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Convert_To_Integer_Word_with_round_towards_Zero_Rc1;

    /* semantic routine */
#line 4574 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Convert To Integer Word with round towards Zero\n"));
#line 33638 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Convert_To_Integer_Word_with_round_towards_Zero, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4574 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      convert_to_integer(processor, cia,
                         frT, *frB,
                         fpscr_rn_round_towards_zero, 32);
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRB_BITMASK, Rc);
    }
#line 33656 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11./,16.FRB,21.15,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRB
#line 33661 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Divide_Rc0(cpu *processor,
                           instruction_word instruction,
                           unsigned_word cia,
                           idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Divide
#undef MY_PREFIX
#define MY_PREFIX Floating_Divide_Rc0
#line 3899 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Divide\n"));
#line 33680 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21./,26.18,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007fe) != 0xfc000024)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21./,26.18,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#line 3899 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 33714 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Divide_Rc0;

    /* semantic routine */
#line 3899 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Divide\n"));
#line 33724 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Divide, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3899 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      if (is_invalid_operation(processor, cia,
                               *frA, *frB,
                               fpscr_vxsnan | fpscr_vxzdz,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, *frA, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else if (is_invalid_zero_divide (processor, cia,
                                       *frA, *frB,
                                       0 /*single?*/)) {
        invalid_zero_divide_operation (processor, cia,
                                       frT, *frA, *frB,
                                       0 /*single?*/);
      }
      else {
        /*HACK!*/
        double s = *(double*)frA / *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK, Rc);
    }
#line 33763 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21./,26.18,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#line 33769 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Divide_Rc1(cpu *processor,
                           instruction_word instruction,
                           unsigned_word cia,
                           idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Divide
#undef MY_PREFIX
#define MY_PREFIX Floating_Divide_Rc1
#line 3899 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Divide\n"));
#line 33788 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21./,26.18,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007fe) != 0xfc000024)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21./,26.18,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#line 3899 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 33822 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Divide_Rc1;

    /* semantic routine */
#line 3899 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Divide\n"));
#line 33832 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Divide, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3899 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      if (is_invalid_operation(processor, cia,
                               *frA, *frB,
                               fpscr_vxsnan | fpscr_vxzdz,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, *frA, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else if (is_invalid_zero_divide (processor, cia,
                                       *frA, *frB,
                                       0 /*single?*/)) {
        invalid_zero_divide_operation (processor, cia,
                                       frT, *frA, *frB,
                                       0 /*single?*/);
      }
      else {
        /*HACK!*/
        double s = *(double*)frA / *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK, Rc);
    }
#line 33871 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21./,26.18,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#line 33877 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Subtract_Rc0(cpu *processor,
                             instruction_word instruction,
                             unsigned_word cia,
                             idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Subtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Subtract_Rc0
#line 3795 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Subtract\n"));
#line 33896 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21./,26.20,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007fe) != 0xfc000028)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21./,26.20,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#line 3795 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 33930 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Subtract_Rc0;

    /* semantic routine */
#line 3795 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Subtract\n"));
#line 33940 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Subtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3795 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      if (is_invalid_operation(processor, cia,
                               *frA, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               1) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, *frA, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = *(double*)frA - *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK, Rc);
    }
#line 33972 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21./,26.20,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#line 33978 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Subtract_Rc1(cpu *processor,
                             instruction_word instruction,
                             unsigned_word cia,
                             idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Subtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Subtract_Rc1
#line 3795 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Subtract\n"));
#line 33997 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21./,26.20,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007fe) != 0xfc000028)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21./,26.20,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#line 3795 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 34031 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Subtract_Rc1;

    /* semantic routine */
#line 3795 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Subtract\n"));
#line 34041 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Subtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3795 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      if (is_invalid_operation(processor, cia,
                               *frA, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               1) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, *frA, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = *(double*)frA - *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK, Rc);
    }
#line 34073 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21./,26.20,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#line 34079 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Add_Rc0(cpu *processor,
                        instruction_word instruction,
                        unsigned_word cia,
                        idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Add
#undef MY_PREFIX
#define MY_PREFIX Floating_Add_Rc0
#line 3743 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Add\n"));
#line 34098 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21./,26.21,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007fe) != 0xfc00002a)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21./,26.21,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#line 3743 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 34132 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Add_Rc0;

    /* semantic routine */
#line 3743 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Add\n"));
#line 34142 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Add, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3743 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      if (is_invalid_operation(processor, cia,
                               *frA, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, *frA, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = *(double*)frA + *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK, Rc);
    }
#line 34174 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21./,26.21,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#line 34180 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Add_Rc1(cpu *processor,
                        instruction_word instruction,
                        unsigned_word cia,
                        idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Add
#undef MY_PREFIX
#define MY_PREFIX Floating_Add_Rc1
#line 3743 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Add\n"));
#line 34199 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21./,26.21,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc0007fe) != 0xfc00002a)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21./,26.21,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#line 3743 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 34233 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Add_Rc1;

    /* semantic routine */
#line 3743 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Add\n"));
#line 34243 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Add, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3743 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      if (is_invalid_operation(processor, cia,
                               *frA, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, *frA, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = *(double*)frA + *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK, Rc);
    }
#line 34275 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21./,26.21,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#line 34281 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Square_Root_Rc0(cpu *processor,
                                instruction_word instruction,
                                unsigned_word cia,
                                idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Square_Root
#undef MY_PREFIX
#define MY_PREFIX Floating_Square_Root_Rc0
#line 4723 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Square Root\n"));
#line 34300 "icache.c"

  /* validate: 0.63,6.FRT,11./,16.FRB,21./,26.22,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc1f07fe) != 0xfc00002c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11./,16.FRB,21./,26.22,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#line 4723 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 34329 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Square_Root_Rc0;

    /* semantic routine */
#line 4723 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Square Root\n"));
#line 34339 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Square_Root, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4723 "../../../sim/ppc/powerpc.igen"
    {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    }
#line 34352 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11./,16.FRB,21./,26.22,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRB
#line 34357 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Square_Root_Rc1(cpu *processor,
                                instruction_word instruction,
                                unsigned_word cia,
                                idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Square_Root
#undef MY_PREFIX
#define MY_PREFIX Floating_Square_Root_Rc1
#line 4723 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Square Root\n"));
#line 34376 "icache.c"

  /* validate: 0.63,6.FRT,11./,16.FRB,21./,26.22,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc1f07fe) != 0xfc00002c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11./,16.FRB,21./,26.22,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#line 4723 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 34405 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Square_Root_Rc1;

    /* semantic routine */
#line 4723 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Square Root\n"));
#line 34415 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Square_Root, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4723 "../../../sim/ppc/powerpc.igen"
    {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    }
#line 34428 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11./,16.FRB,21./,26.22,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRB
#line 34433 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Select_FRC0_Rc0(cpu *processor,
                                instruction_word instruction,
                                unsigned_word cia,
                                idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC0_Rc0
#line 4743 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Select\n"));
#line 34452 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00002e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 0 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4743 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 34491 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Select_FRC0_Rc0;

    /* semantic routine */
#line 4743 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 34501 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Select, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4743 "../../../sim/ppc/powerpc.igen"
    {
      if (CURRENT_MODEL == MODEL_ppc601) {
        program_interrupt(processor, cia, optional_instruction_program_interrupt);
      } else {
        uint64_t zero = 0;
        FPSCR_BEGIN;
        if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
        else						    *frT = *frC;
        FPSCR_END(Rc);
        PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
      }
    }
#line 34523 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 34530 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Select_FRC0_Rc1(cpu *processor,
                                instruction_word instruction,
                                unsigned_word cia,
                                idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC0_Rc1
#line 4743 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Select\n"));
#line 34549 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00002e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 0 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4743 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 34588 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Select_FRC0_Rc1;

    /* semantic routine */
#line 4743 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 34598 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Select, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4743 "../../../sim/ppc/powerpc.igen"
    {
      if (CURRENT_MODEL == MODEL_ppc601) {
        program_interrupt(processor, cia, optional_instruction_program_interrupt);
      } else {
        uint64_t zero = 0;
        FPSCR_BEGIN;
        if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
        else						    *frT = *frC;
        FPSCR_END(Rc);
        PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
      }
    }
#line 34620 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 34627 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Multiply_FRC0_Rc0(cpu *processor,
                                  instruction_word instruction,
                                  unsigned_word cia,
                                  idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC0_Rc0
#line 3847 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply\n"));
#line 34646 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00f83e) != 0xfc000032)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRC 0 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3847 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 34680 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Multiply_FRC0_Rc0;

    /* semantic routine */
#line 3847 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 34690 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Multiply, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3847 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = *(double*)frA * *(double*)frC;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
    }
#line 34722 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRC
#line 34728 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Multiply_FRC0_Rc1(cpu *processor,
                                  instruction_word instruction,
                                  unsigned_word cia,
                                  idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC0_Rc1
#line 3847 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply\n"));
#line 34747 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00f83e) != 0xfc000032)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRC 0 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3847 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 34781 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Multiply_FRC0_Rc1;

    /* semantic routine */
#line 3847 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 34791 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Multiply, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3847 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = *(double*)frA * *(double*)frC;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
    }
#line 34823 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRC
#line 34829 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Reciprocal_Square_Root_Estimate_Rc0(cpu *processor,
                                                    instruction_word instruction,
                                                    unsigned_word cia,
                                                    idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Reciprocal_Square_Root_Estimate
#undef MY_PREFIX
#define MY_PREFIX Floating_Reciprocal_Square_Root_Estimate_Rc0
#line 4732 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Reciprocal Square Root Estimate\n"));
#line 34848 "icache.c"

  /* validate: 0.63,6.FRT,11./,16.FRB,21./,26.26,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc1f07fe) != 0xfc000034)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11./,16.FRB,21./,26.26,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#line 4732 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 34877 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Reciprocal_Square_Root_Estimate_Rc0;

    /* semantic routine */
#line 4732 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Reciprocal Square Root Estimate\n"));
#line 34887 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Reciprocal_Square_Root_Estimate, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4732 "../../../sim/ppc/powerpc.igen"
    {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    }
#line 34900 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11./,16.FRB,21./,26.26,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRB
#line 34905 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Reciprocal_Square_Root_Estimate_Rc1(cpu *processor,
                                                    instruction_word instruction,
                                                    unsigned_word cia,
                                                    idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Reciprocal_Square_Root_Estimate
#undef MY_PREFIX
#define MY_PREFIX Floating_Reciprocal_Square_Root_Estimate_Rc1
#line 4732 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Reciprocal Square Root Estimate\n"));
#line 34924 "icache.c"

  /* validate: 0.63,6.FRT,11./,16.FRB,21./,26.26,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc1f07fe) != 0xfc000034)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11./,16.FRB,21./,26.26,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#line 4732 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 34953 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Reciprocal_Square_Root_Estimate_Rc1;

    /* semantic routine */
#line 4732 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Reciprocal Square Root Estimate\n"));
#line 34963 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Reciprocal_Square_Root_Estimate, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4732 "../../../sim/ppc/powerpc.igen"
    {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    }
#line 34976 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11./,16.FRB,21./,26.26,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRB
#line 34981 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplySubtract_FRC0_Rc0(cpu *processor,
                                          instruction_word instruction,
                                          unsigned_word cia,
                                          idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC0_Rc0
#line 4059 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Subtract\n"));
#line 35000 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc000038)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 0 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4059 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 35039 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplySubtract_FRC0_Rc0;

    /* semantic routine */
#line 4059 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 35049 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4059 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product - *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 35102 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 35109 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplySubtract_FRC0_Rc1(cpu *processor,
                                          instruction_word instruction,
                                          unsigned_word cia,
                                          idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC0_Rc1
#line 4059 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Subtract\n"));
#line 35128 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc000038)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 0 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4059 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 35167 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplySubtract_FRC0_Rc1;

    /* semantic routine */
#line 4059 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 35177 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4059 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product - *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 35230 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 35237 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplyAdd_FRC0_Rc0(cpu *processor,
                                     instruction_word instruction,
                                     unsigned_word cia,
                                     idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC0_Rc0
#line 3965 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Add\n"));
#line 35256 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003a)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 0 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3965 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 35295 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplyAdd_FRC0_Rc0;

    /* semantic routine */
#line 3965 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 35305 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3965 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product + *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 35358 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 35365 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplyAdd_FRC0_Rc1(cpu *processor,
                                     instruction_word instruction,
                                     unsigned_word cia,
                                     idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC0_Rc1
#line 3965 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Add\n"));
#line 35384 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003a)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 0 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3965 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 35423 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplyAdd_FRC0_Rc1;

    /* semantic routine */
#line 3965 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 35433 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3965 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product + *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 35486 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 35493 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplySubtract_FRC0_Rc0(cpu *processor,
                                                   instruction_word instruction,
                                                   unsigned_word cia,
                                                   idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC0_Rc0
#line 4247 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Subtract\n"));
#line 35512 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 0 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4247 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 35551 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplySubtract_FRC0_Rc0;

    /* semantic routine */
#line 4247 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 35561 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4247 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product - *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 35614 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 35621 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplySubtract_FRC0_Rc1(cpu *processor,
                                                   instruction_word instruction,
                                                   unsigned_word cia,
                                                   idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC0_Rc1
#line 4247 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Subtract\n"));
#line 35640 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 0 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4247 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 35679 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplySubtract_FRC0_Rc1;

    /* semantic routine */
#line 4247 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 35689 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4247 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product - *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 35742 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 35749 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplyAdd_FRC0_Rc0(cpu *processor,
                                              instruction_word instruction,
                                              unsigned_word cia,
                                              idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC0_Rc0
#line 4153 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Add\n"));
#line 35768 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 0 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4153 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 35807 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplyAdd_FRC0_Rc0;

    /* semantic routine */
#line 4153 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 35817 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4153 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product + *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 35870 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 35877 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplyAdd_FRC0_Rc1(cpu *processor,
                                              instruction_word instruction,
                                              unsigned_word cia,
                                              idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC0_Rc1
#line 4153 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Add\n"));
#line 35896 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 0 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4153 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 35935 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplyAdd_FRC0_Rc1;

    /* semantic routine */
#line 4153 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 35945 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4153 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product + *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 35998 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 36005 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Compare_Ordered(cpu *processor,
                                instruction_word instruction,
                                unsigned_word cia,
                                idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Compare_Ordered
#undef MY_PREFIX
#define MY_PREFIX Floating_Compare_Ordered
#line 4643 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Compare Ordered\n"));
#line 36024 "icache.c"

  /* validate: 0.63,6.BF,9./,11.FRA,16.FRB,21.32,31./ */
  if (WITH_RESERVED_BITS && (instruction & 0xfc6007ff) != 0xfc000040)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.BF,9./,11.FRA,16.FRB,21.32,31./ #define get-values-from-icache|put-values-in-icache */
#line 67 "../../../sim/ppc/powerpc.igen"
    unsigned const BF ATTRIBUTE_UNUSED = cache_entry->crack.X.BF = EXTRACTED32(instruction, 6, 8); /* in icache - extraction */
#line 68 "../../../sim/ppc/powerpc.igen"
    uint32_t const BF_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.BF_BITMASK = (1 << BF); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.X.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.X.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#line 36055 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Compare_Ordered;

    /* semantic routine */
#line 4643 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Compare Ordered\n"));
#line 36065 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Compare_Ordered, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4643 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      unsigned c;
      if (is_NaN(*frA, 0) || is_NaN(*frB, 0))
        c = cr_i_summary_overflow; /* 0b0001 - (FRA) ? (FRB) */
      else if (is_less_than(frA, frB))
        c = cr_i_negative; /* 0b1000 - (FRA) < (FRB) */
      else if (is_greater_than(frA, frB))
        c = cr_i_positive; /* 0b0100 - (FRA) > (FRB) */
      else
        c = cr_i_zero; /* 0b0010 - (FRA) = (FRB) */
      FPSCR_SET_FPCC(c);
      CR_SET(BF, c); /* CR[4*BF..4*BF+3] = c */
      if (is_SNaN(*frA, 0) || is_SNaN(*frB, 0)) {
        FPSCR_OR_VX(fpscr_vxsnan);
        if ((FPSCR & fpscr_ve) == 0)
          FPSCR_OR_VX(fpscr_vxvc);
      }
      else if (is_QNaN(*frA, 0) || is_QNaN(*frB, 0)) {
        FPSCR_OR_VX(fpscr_vxvc);
      }
      FPSCR_END(0);
      PPC_INSN_FLOAT_CR(0, FRA_BITMASK | FRB_BITMASK, BF_BITMASK);
    }
#line 36099 "icache.c"
    return nia;
    /* extraction: 0.63,6.BF,9./,11.FRA,16.FRB,21.32,31./ #undef get-values-from-icache|put-values-in-icache */
#undef FRA
#undef FRB
#line 36104 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Move_To_FPSCR_Bit_1_Rc0(cpu *processor,
                               instruction_word instruction,
                               unsigned_word cia,
                               idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Move_To_FPSCR_Bit_1
#undef MY_PREFIX
#define MY_PREFIX Move_To_FPSCR_Bit_1_Rc0
#line 4706 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Move To FPSCR Bit 1\n"));
#line 36123 "icache.c"

  /* validate: 0.63,6.BT,11./,16./,21.38,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc1ffffe) != 0xfc00004c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.BT,11./,16./,21.38,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 75 "../../../sim/ppc/powerpc.igen"
    unsigned const BT ATTRIBUTE_UNUSED = cache_entry->crack.X.BT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 76 "../../../sim/ppc/powerpc.igen"
    uint32_t const BT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.BT_BITMASK = (1 << BT); /* in icache - extraction */
#line 4706 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 36146 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Move_To_FPSCR_Bit_1_Rc0;

    /* semantic routine */
#line 4706 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Move To FPSCR Bit 1\n"));
#line 36156 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Move_To_FPSCR_Bit_1, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4706 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      uint32_t bit = BIT32(BT);
      if (bit & fpscr_fi)
        bit |= fpscr_xx;
      if ((bit & fpscr_vx_bits))
        bit |= fpscr_fx;
      /* note - omit vx bit */
      if ((bit & (fpscr_ox | fpscr_ux | fpscr_zx | fpscr_xx)))
        bit |= fpscr_fx;
      FPSCR |= bit;
      FPSCR_END(Rc);
    }
#line 36179 "icache.c"
    return nia;
    /* extraction: 0.63,6.BT,11./,16./,21.38,31.Rc #undef get-values-from-icache|put-values-in-icache */
#line 36182 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Move_To_FPSCR_Bit_1_Rc1(cpu *processor,
                               instruction_word instruction,
                               unsigned_word cia,
                               idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Move_To_FPSCR_Bit_1
#undef MY_PREFIX
#define MY_PREFIX Move_To_FPSCR_Bit_1_Rc1
#line 4706 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Move To FPSCR Bit 1\n"));
#line 36201 "icache.c"

  /* validate: 0.63,6.BT,11./,16./,21.38,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc1ffffe) != 0xfc00004c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.BT,11./,16./,21.38,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 75 "../../../sim/ppc/powerpc.igen"
    unsigned const BT ATTRIBUTE_UNUSED = cache_entry->crack.X.BT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 76 "../../../sim/ppc/powerpc.igen"
    uint32_t const BT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.BT_BITMASK = (1 << BT); /* in icache - extraction */
#line 4706 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 36224 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Move_To_FPSCR_Bit_1_Rc1;

    /* semantic routine */
#line 4706 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Move To FPSCR Bit 1\n"));
#line 36234 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Move_To_FPSCR_Bit_1, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4706 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      uint32_t bit = BIT32(BT);
      if (bit & fpscr_fi)
        bit |= fpscr_xx;
      if ((bit & fpscr_vx_bits))
        bit |= fpscr_fx;
      /* note - omit vx bit */
      if ((bit & (fpscr_ox | fpscr_ux | fpscr_zx | fpscr_xx)))
        bit |= fpscr_fx;
      FPSCR |= bit;
      FPSCR_END(Rc);
    }
#line 36257 "icache.c"
    return nia;
    /* extraction: 0.63,6.BT,11./,16./,21.38,31.Rc #undef get-values-from-icache|put-values-in-icache */
#line 36260 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negate_Rc0(cpu *processor,
                           instruction_word instruction,
                           unsigned_word cia,
                           idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negate
#undef MY_PREFIX
#define MY_PREFIX Floating_Negate_Rc0
#line 3711 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negate\n"));
#line 36279 "icache.c"

  /* validate: 0.63,6.FRT,11./,16.FRB,21.40,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc1f07fe) != 0xfc000050)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11./,16.FRB,21.40,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.X.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.X.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#line 3711 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 36308 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negate_Rc0;

    /* semantic routine */
#line 3711 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negate\n"));
#line 36318 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negate, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3711 "../../../sim/ppc/powerpc.igen"
    {
      *frT = *frB ^ BIT64(0);
      CR1_UPDATE(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRB_BITMASK, Rc);
    }
#line 36333 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11./,16.FRB,21.40,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRB
#line 36338 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negate_Rc1(cpu *processor,
                           instruction_word instruction,
                           unsigned_word cia,
                           idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negate
#undef MY_PREFIX
#define MY_PREFIX Floating_Negate_Rc1
#line 3711 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negate\n"));
#line 36357 "icache.c"

  /* validate: 0.63,6.FRT,11./,16.FRB,21.40,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc1f07fe) != 0xfc000050)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11./,16.FRB,21.40,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.X.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.X.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#line 3711 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 36386 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negate_Rc1;

    /* semantic routine */
#line 3711 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negate\n"));
#line 36396 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negate, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3711 "../../../sim/ppc/powerpc.igen"
    {
      *frT = *frB ^ BIT64(0);
      CR1_UPDATE(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRB_BITMASK, Rc);
    }
#line 36411 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11./,16.FRB,21.40,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRB
#line 36416 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Select_FRC1_Rc0(cpu *processor,
                                instruction_word instruction,
                                unsigned_word cia,
                                idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC1_Rc0
#line 4743 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Select\n"));
#line 36435 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00002e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 1 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4743 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 36474 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Select_FRC1_Rc0;

    /* semantic routine */
#line 4743 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 36484 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Select, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4743 "../../../sim/ppc/powerpc.igen"
    {
      if (CURRENT_MODEL == MODEL_ppc601) {
        program_interrupt(processor, cia, optional_instruction_program_interrupt);
      } else {
        uint64_t zero = 0;
        FPSCR_BEGIN;
        if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
        else						    *frT = *frC;
        FPSCR_END(Rc);
        PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
      }
    }
#line 36506 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 36513 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Select_FRC1_Rc1(cpu *processor,
                                instruction_word instruction,
                                unsigned_word cia,
                                idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC1_Rc1
#line 4743 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Select\n"));
#line 36532 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00002e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 1 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4743 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 36571 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Select_FRC1_Rc1;

    /* semantic routine */
#line 4743 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 36581 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Select, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4743 "../../../sim/ppc/powerpc.igen"
    {
      if (CURRENT_MODEL == MODEL_ppc601) {
        program_interrupt(processor, cia, optional_instruction_program_interrupt);
      } else {
        uint64_t zero = 0;
        FPSCR_BEGIN;
        if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
        else						    *frT = *frC;
        FPSCR_END(Rc);
        PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
      }
    }
#line 36603 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 36610 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Multiply_FRC1_Rc0(cpu *processor,
                                  instruction_word instruction,
                                  unsigned_word cia,
                                  idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC1_Rc0
#line 3847 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply\n"));
#line 36629 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00f83e) != 0xfc000032)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRC 1 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3847 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 36663 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Multiply_FRC1_Rc0;

    /* semantic routine */
#line 3847 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 36673 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Multiply, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3847 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = *(double*)frA * *(double*)frC;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
    }
#line 36705 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRC
#line 36711 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Multiply_FRC1_Rc1(cpu *processor,
                                  instruction_word instruction,
                                  unsigned_word cia,
                                  idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC1_Rc1
#line 3847 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply\n"));
#line 36730 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00f83e) != 0xfc000032)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRC 1 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3847 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 36764 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Multiply_FRC1_Rc1;

    /* semantic routine */
#line 3847 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 36774 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Multiply, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3847 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = *(double*)frA * *(double*)frC;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
    }
#line 36806 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRC
#line 36812 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplySubtract_FRC1_Rc0(cpu *processor,
                                          instruction_word instruction,
                                          unsigned_word cia,
                                          idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC1_Rc0
#line 4059 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Subtract\n"));
#line 36831 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc000038)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 1 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4059 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 36870 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplySubtract_FRC1_Rc0;

    /* semantic routine */
#line 4059 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 36880 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4059 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product - *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 36933 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 36940 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplySubtract_FRC1_Rc1(cpu *processor,
                                          instruction_word instruction,
                                          unsigned_word cia,
                                          idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC1_Rc1
#line 4059 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Subtract\n"));
#line 36959 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc000038)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 1 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4059 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 36998 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplySubtract_FRC1_Rc1;

    /* semantic routine */
#line 4059 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 37008 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4059 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product - *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 37061 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 37068 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplyAdd_FRC1_Rc0(cpu *processor,
                                     instruction_word instruction,
                                     unsigned_word cia,
                                     idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC1_Rc0
#line 3965 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Add\n"));
#line 37087 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003a)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 1 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3965 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 37126 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplyAdd_FRC1_Rc0;

    /* semantic routine */
#line 3965 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 37136 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3965 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product + *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 37189 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 37196 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplyAdd_FRC1_Rc1(cpu *processor,
                                     instruction_word instruction,
                                     unsigned_word cia,
                                     idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC1_Rc1
#line 3965 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Add\n"));
#line 37215 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003a)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 1 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3965 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 37254 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplyAdd_FRC1_Rc1;

    /* semantic routine */
#line 3965 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 37264 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3965 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product + *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 37317 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 37324 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplySubtract_FRC1_Rc0(cpu *processor,
                                                   instruction_word instruction,
                                                   unsigned_word cia,
                                                   idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC1_Rc0
#line 4247 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Subtract\n"));
#line 37343 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 1 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4247 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 37382 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplySubtract_FRC1_Rc0;

    /* semantic routine */
#line 4247 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 37392 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4247 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product - *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 37445 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 37452 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplySubtract_FRC1_Rc1(cpu *processor,
                                                   instruction_word instruction,
                                                   unsigned_word cia,
                                                   idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC1_Rc1
#line 4247 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Subtract\n"));
#line 37471 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 1 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4247 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 37510 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplySubtract_FRC1_Rc1;

    /* semantic routine */
#line 4247 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 37520 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4247 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product - *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 37573 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 37580 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplyAdd_FRC1_Rc0(cpu *processor,
                                              instruction_word instruction,
                                              unsigned_word cia,
                                              idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC1_Rc0
#line 4153 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Add\n"));
#line 37599 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 1 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4153 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 37638 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplyAdd_FRC1_Rc0;

    /* semantic routine */
#line 4153 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 37648 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4153 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product + *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 37701 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 37708 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplyAdd_FRC1_Rc1(cpu *processor,
                                              instruction_word instruction,
                                              unsigned_word cia,
                                              idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC1_Rc1
#line 4153 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Add\n"));
#line 37727 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 1 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4153 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 37766 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplyAdd_FRC1_Rc1;

    /* semantic routine */
#line 4153 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 37776 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4153 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product + *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 37829 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 37836 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Move_to_Condition_Register_from_FPSCR(cpu *processor,
                                             instruction_word instruction,
                                             unsigned_word cia,
                                             idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Move_to_Condition_Register_from_FPSCR
#undef MY_PREFIX
#define MY_PREFIX Move_to_Condition_Register_from_FPSCR
#line 4677 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Move to Condition Register from FPSCR\n"));
#line 37855 "icache.c"

  /* validate: 0.63,6.BF,9./,11.BFA,14./,16./,21.64,31./ */
  if (WITH_RESERVED_BITS && (instruction & 0xfc63ffff) != 0xfc000080)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.BF,9./,11.BFA,14./,16./,21.64,31./ #define get-values-from-icache|put-values-in-icache */
#line 67 "../../../sim/ppc/powerpc.igen"
    unsigned const BF ATTRIBUTE_UNUSED = cache_entry->crack.X.BF = EXTRACTED32(instruction, 6, 8); /* in icache - extraction */
#line 68 "../../../sim/ppc/powerpc.igen"
    uint32_t const BF_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.BF_BITMASK = (1 << BF); /* in icache - extraction */
#line 4677 "../../../sim/ppc/powerpc.igen"
    unsigned const BFA ATTRIBUTE_UNUSED = cache_entry->crack.X.BFA = EXTRACTED32(instruction, 11, 13); /* default in icache - extraction */
#line 37878 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Move_to_Condition_Register_from_FPSCR;

    /* semantic routine */
#line 4677 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Move to Condition Register from FPSCR\n"));
#line 37888 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Move_to_Condition_Register_from_FPSCR, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4677 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      unsigned field = FPSCR_FIELD(BFA);
      CR_SET(BF, field);
      FPSCR_SET(BFA, 0); /* FPSCR_END fixes up FEX/VX */
      FPSCR_END(0);
    }
#line 37905 "icache.c"
    return nia;
    /* extraction: 0.63,6.BF,9./,11.BFA,14./,16./,21.64,31./ #undef get-values-from-icache|put-values-in-icache */
#line 37908 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Move_To_FPSCR_Bit_0_Rc0(cpu *processor,
                               instruction_word instruction,
                               unsigned_word cia,
                               idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Move_To_FPSCR_Bit_0
#undef MY_PREFIX
#define MY_PREFIX Move_To_FPSCR_Bit_0_Rc0
#line 4700 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Move To FPSCR Bit 0\n"));
#line 37927 "icache.c"

  /* validate: 0.63,6.BT,11./,16./,21.70,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc1ffffe) != 0xfc00008c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.BT,11./,16./,21.70,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 75 "../../../sim/ppc/powerpc.igen"
    unsigned const BT ATTRIBUTE_UNUSED = cache_entry->crack.X.BT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 76 "../../../sim/ppc/powerpc.igen"
    uint32_t const BT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.BT_BITMASK = (1 << BT); /* in icache - extraction */
#line 4700 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 37950 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Move_To_FPSCR_Bit_0_Rc0;

    /* semantic routine */
#line 4700 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Move To FPSCR Bit 0\n"));
#line 37960 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Move_To_FPSCR_Bit_0, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4700 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      uint32_t bit = BIT32(BT);
      FPSCR &= ~bit;
      FPSCR_END(Rc);
    }
#line 37976 "icache.c"
    return nia;
    /* extraction: 0.63,6.BT,11./,16./,21.70,31.Rc #undef get-values-from-icache|put-values-in-icache */
#line 37979 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Move_To_FPSCR_Bit_0_Rc1(cpu *processor,
                               instruction_word instruction,
                               unsigned_word cia,
                               idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Move_To_FPSCR_Bit_0
#undef MY_PREFIX
#define MY_PREFIX Move_To_FPSCR_Bit_0_Rc1
#line 4700 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Move To FPSCR Bit 0\n"));
#line 37998 "icache.c"

  /* validate: 0.63,6.BT,11./,16./,21.70,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc1ffffe) != 0xfc00008c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.BT,11./,16./,21.70,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 75 "../../../sim/ppc/powerpc.igen"
    unsigned const BT ATTRIBUTE_UNUSED = cache_entry->crack.X.BT = EXTRACTED32(instruction, 6, 10); /* in icache - extraction */
#line 76 "../../../sim/ppc/powerpc.igen"
    uint32_t const BT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.BT_BITMASK = (1 << BT); /* in icache - extraction */
#line 4700 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 38021 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Move_To_FPSCR_Bit_0_Rc1;

    /* semantic routine */
#line 4700 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Move To FPSCR Bit 0\n"));
#line 38031 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Move_To_FPSCR_Bit_0, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4700 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      uint32_t bit = BIT32(BT);
      FPSCR &= ~bit;
      FPSCR_END(Rc);
    }
#line 38047 "icache.c"
    return nia;
    /* extraction: 0.63,6.BT,11./,16./,21.70,31.Rc #undef get-values-from-icache|put-values-in-icache */
#line 38050 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Move_Register_Rc0(cpu *processor,
                                  instruction_word instruction,
                                  unsigned_word cia,
                                  idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Move_Register
#undef MY_PREFIX
#define MY_PREFIX Floating_Move_Register_Rc0
#line 3702 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Move Register\n"));
#line 38069 "icache.c"

  /* validate: 0.63,6.FRT,11./,16.FRB,21.72,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc1f07fe) != 0xfc000090)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11./,16.FRB,21.72,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.X.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.X.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#line 3702 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 38098 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Move_Register_Rc0;

    /* semantic routine */
#line 3702 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Move Register\n"));
#line 38108 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Move_Register, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3702 "../../../sim/ppc/powerpc.igen"
    {
      *frT = *frB;
      CR1_UPDATE(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRB_BITMASK, Rc);
    }
#line 38123 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11./,16.FRB,21.72,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRB
#line 38128 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Move_Register_Rc1(cpu *processor,
                                  instruction_word instruction,
                                  unsigned_word cia,
                                  idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Move_Register
#undef MY_PREFIX
#define MY_PREFIX Floating_Move_Register_Rc1
#line 3702 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Move Register\n"));
#line 38147 "icache.c"

  /* validate: 0.63,6.FRT,11./,16.FRB,21.72,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc1f07fe) != 0xfc000090)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11./,16.FRB,21.72,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.X.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.X.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#line 3702 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 38176 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Move_Register_Rc1;

    /* semantic routine */
#line 3702 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Move Register\n"));
#line 38186 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Move_Register, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3702 "../../../sim/ppc/powerpc.igen"
    {
      *frT = *frB;
      CR1_UPDATE(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRB_BITMASK, Rc);
    }
#line 38201 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11./,16.FRB,21.72,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRB
#line 38206 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Select_FRC2_Rc0(cpu *processor,
                                instruction_word instruction,
                                unsigned_word cia,
                                idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC2_Rc0
#line 4743 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Select\n"));
#line 38225 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00002e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 2 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4743 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 38264 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Select_FRC2_Rc0;

    /* semantic routine */
#line 4743 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 38274 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Select, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4743 "../../../sim/ppc/powerpc.igen"
    {
      if (CURRENT_MODEL == MODEL_ppc601) {
        program_interrupt(processor, cia, optional_instruction_program_interrupt);
      } else {
        uint64_t zero = 0;
        FPSCR_BEGIN;
        if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
        else						    *frT = *frC;
        FPSCR_END(Rc);
        PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
      }
    }
#line 38296 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 38303 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Select_FRC2_Rc1(cpu *processor,
                                instruction_word instruction,
                                unsigned_word cia,
                                idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC2_Rc1
#line 4743 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Select\n"));
#line 38322 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00002e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 2 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4743 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 38361 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Select_FRC2_Rc1;

    /* semantic routine */
#line 4743 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 38371 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Select, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4743 "../../../sim/ppc/powerpc.igen"
    {
      if (CURRENT_MODEL == MODEL_ppc601) {
        program_interrupt(processor, cia, optional_instruction_program_interrupt);
      } else {
        uint64_t zero = 0;
        FPSCR_BEGIN;
        if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
        else						    *frT = *frC;
        FPSCR_END(Rc);
        PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
      }
    }
#line 38393 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 38400 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Multiply_FRC2_Rc0(cpu *processor,
                                  instruction_word instruction,
                                  unsigned_word cia,
                                  idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC2_Rc0
#line 3847 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply\n"));
#line 38419 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00f83e) != 0xfc000032)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRC 2 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3847 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 38453 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Multiply_FRC2_Rc0;

    /* semantic routine */
#line 3847 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 38463 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Multiply, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3847 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = *(double*)frA * *(double*)frC;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
    }
#line 38495 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRC
#line 38501 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Multiply_FRC2_Rc1(cpu *processor,
                                  instruction_word instruction,
                                  unsigned_word cia,
                                  idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC2_Rc1
#line 3847 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply\n"));
#line 38520 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00f83e) != 0xfc000032)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRC 2 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3847 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 38554 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Multiply_FRC2_Rc1;

    /* semantic routine */
#line 3847 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 38564 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Multiply, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3847 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = *(double*)frA * *(double*)frC;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
    }
#line 38596 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRC
#line 38602 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplySubtract_FRC2_Rc0(cpu *processor,
                                          instruction_word instruction,
                                          unsigned_word cia,
                                          idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC2_Rc0
#line 4059 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Subtract\n"));
#line 38621 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc000038)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 2 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4059 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 38660 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplySubtract_FRC2_Rc0;

    /* semantic routine */
#line 4059 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 38670 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4059 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product - *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 38723 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 38730 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplySubtract_FRC2_Rc1(cpu *processor,
                                          instruction_word instruction,
                                          unsigned_word cia,
                                          idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC2_Rc1
#line 4059 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Subtract\n"));
#line 38749 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc000038)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 2 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4059 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 38788 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplySubtract_FRC2_Rc1;

    /* semantic routine */
#line 4059 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 38798 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4059 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product - *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 38851 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 38858 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplyAdd_FRC2_Rc0(cpu *processor,
                                     instruction_word instruction,
                                     unsigned_word cia,
                                     idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC2_Rc0
#line 3965 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Add\n"));
#line 38877 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003a)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 2 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3965 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 38916 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplyAdd_FRC2_Rc0;

    /* semantic routine */
#line 3965 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 38926 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3965 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product + *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 38979 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 38986 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplyAdd_FRC2_Rc1(cpu *processor,
                                     instruction_word instruction,
                                     unsigned_word cia,
                                     idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC2_Rc1
#line 3965 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Add\n"));
#line 39005 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003a)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 2 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3965 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 39044 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplyAdd_FRC2_Rc1;

    /* semantic routine */
#line 3965 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 39054 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3965 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product + *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 39107 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 39114 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplySubtract_FRC2_Rc0(cpu *processor,
                                                   instruction_word instruction,
                                                   unsigned_word cia,
                                                   idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC2_Rc0
#line 4247 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Subtract\n"));
#line 39133 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 2 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4247 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 39172 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplySubtract_FRC2_Rc0;

    /* semantic routine */
#line 4247 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 39182 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4247 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product - *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 39235 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 39242 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplySubtract_FRC2_Rc1(cpu *processor,
                                                   instruction_word instruction,
                                                   unsigned_word cia,
                                                   idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC2_Rc1
#line 4247 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Subtract\n"));
#line 39261 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 2 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4247 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 39300 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplySubtract_FRC2_Rc1;

    /* semantic routine */
#line 4247 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 39310 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4247 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product - *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 39363 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 39370 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplyAdd_FRC2_Rc0(cpu *processor,
                                              instruction_word instruction,
                                              unsigned_word cia,
                                              idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC2_Rc0
#line 4153 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Add\n"));
#line 39389 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 2 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4153 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 39428 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplyAdd_FRC2_Rc0;

    /* semantic routine */
#line 4153 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 39438 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4153 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product + *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 39491 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 39498 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplyAdd_FRC2_Rc1(cpu *processor,
                                              instruction_word instruction,
                                              unsigned_word cia,
                                              idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC2_Rc1
#line 4153 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Add\n"));
#line 39517 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 2 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4153 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 39556 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplyAdd_FRC2_Rc1;

    /* semantic routine */
#line 4153 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 39566 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4153 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product + *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 39619 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 39626 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Select_FRC3_Rc0(cpu *processor,
                                instruction_word instruction,
                                unsigned_word cia,
                                idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC3_Rc0
#line 4743 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Select\n"));
#line 39645 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00002e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 3 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4743 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 39684 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Select_FRC3_Rc0;

    /* semantic routine */
#line 4743 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 39694 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Select, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4743 "../../../sim/ppc/powerpc.igen"
    {
      if (CURRENT_MODEL == MODEL_ppc601) {
        program_interrupt(processor, cia, optional_instruction_program_interrupt);
      } else {
        uint64_t zero = 0;
        FPSCR_BEGIN;
        if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
        else						    *frT = *frC;
        FPSCR_END(Rc);
        PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
      }
    }
#line 39716 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 39723 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Select_FRC3_Rc1(cpu *processor,
                                instruction_word instruction,
                                unsigned_word cia,
                                idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC3_Rc1
#line 4743 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Select\n"));
#line 39742 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00002e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 3 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4743 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 39781 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Select_FRC3_Rc1;

    /* semantic routine */
#line 4743 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 39791 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Select, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4743 "../../../sim/ppc/powerpc.igen"
    {
      if (CURRENT_MODEL == MODEL_ppc601) {
        program_interrupt(processor, cia, optional_instruction_program_interrupt);
      } else {
        uint64_t zero = 0;
        FPSCR_BEGIN;
        if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
        else						    *frT = *frC;
        FPSCR_END(Rc);
        PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
      }
    }
#line 39813 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 39820 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Multiply_FRC3_Rc0(cpu *processor,
                                  instruction_word instruction,
                                  unsigned_word cia,
                                  idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC3_Rc0
#line 3847 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply\n"));
#line 39839 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00f83e) != 0xfc000032)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRC 3 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3847 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 39873 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Multiply_FRC3_Rc0;

    /* semantic routine */
#line 3847 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 39883 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Multiply, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3847 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = *(double*)frA * *(double*)frC;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
    }
#line 39915 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRC
#line 39921 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Multiply_FRC3_Rc1(cpu *processor,
                                  instruction_word instruction,
                                  unsigned_word cia,
                                  idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC3_Rc1
#line 3847 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply\n"));
#line 39940 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00f83e) != 0xfc000032)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRC 3 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3847 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 39974 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Multiply_FRC3_Rc1;

    /* semantic routine */
#line 3847 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 39984 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Multiply, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3847 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = *(double*)frA * *(double*)frC;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
    }
#line 40016 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRC
#line 40022 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplySubtract_FRC3_Rc0(cpu *processor,
                                          instruction_word instruction,
                                          unsigned_word cia,
                                          idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC3_Rc0
#line 4059 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Subtract\n"));
#line 40041 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc000038)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 3 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4059 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 40080 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplySubtract_FRC3_Rc0;

    /* semantic routine */
#line 4059 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 40090 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4059 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product - *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 40143 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 40150 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplySubtract_FRC3_Rc1(cpu *processor,
                                          instruction_word instruction,
                                          unsigned_word cia,
                                          idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC3_Rc1
#line 4059 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Subtract\n"));
#line 40169 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc000038)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 3 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4059 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 40208 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplySubtract_FRC3_Rc1;

    /* semantic routine */
#line 4059 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 40218 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4059 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product - *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 40271 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 40278 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplyAdd_FRC3_Rc0(cpu *processor,
                                     instruction_word instruction,
                                     unsigned_word cia,
                                     idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC3_Rc0
#line 3965 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Add\n"));
#line 40297 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003a)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 3 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3965 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 40336 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplyAdd_FRC3_Rc0;

    /* semantic routine */
#line 3965 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 40346 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3965 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product + *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 40399 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 40406 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplyAdd_FRC3_Rc1(cpu *processor,
                                     instruction_word instruction,
                                     unsigned_word cia,
                                     idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC3_Rc1
#line 3965 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Add\n"));
#line 40425 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003a)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 3 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3965 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 40464 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplyAdd_FRC3_Rc1;

    /* semantic routine */
#line 3965 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 40474 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3965 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product + *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 40527 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 40534 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplySubtract_FRC3_Rc0(cpu *processor,
                                                   instruction_word instruction,
                                                   unsigned_word cia,
                                                   idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC3_Rc0
#line 4247 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Subtract\n"));
#line 40553 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 3 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4247 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 40592 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplySubtract_FRC3_Rc0;

    /* semantic routine */
#line 4247 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 40602 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4247 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product - *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 40655 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 40662 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplySubtract_FRC3_Rc1(cpu *processor,
                                                   instruction_word instruction,
                                                   unsigned_word cia,
                                                   idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC3_Rc1
#line 4247 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Subtract\n"));
#line 40681 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 3 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4247 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 40720 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplySubtract_FRC3_Rc1;

    /* semantic routine */
#line 4247 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 40730 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4247 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product - *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 40783 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 40790 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplyAdd_FRC3_Rc0(cpu *processor,
                                              instruction_word instruction,
                                              unsigned_word cia,
                                              idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC3_Rc0
#line 4153 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Add\n"));
#line 40809 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 3 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4153 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 40848 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplyAdd_FRC3_Rc0;

    /* semantic routine */
#line 4153 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 40858 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4153 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product + *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 40911 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 40918 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplyAdd_FRC3_Rc1(cpu *processor,
                                              instruction_word instruction,
                                              unsigned_word cia,
                                              idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC3_Rc1
#line 4153 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Add\n"));
#line 40937 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 3 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4153 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 40976 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplyAdd_FRC3_Rc1;

    /* semantic routine */
#line 4153 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 40986 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4153 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product + *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 41039 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 41046 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Move_To_FPSCR_Field_Immediate_Rc0(cpu *processor,
                                         instruction_word instruction,
                                         unsigned_word cia,
                                         idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Move_To_FPSCR_Field_Immediate
#undef MY_PREFIX
#define MY_PREFIX Move_To_FPSCR_Field_Immediate_Rc0
#line 4684 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Move To FPSCR Field Immediate\n"));
#line 41065 "icache.c"

  /* validate: 0.63,6.BF,9./,11./,16.U,20./,21.134,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc7f0ffe) != 0xfc00010c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.BF,9./,11./,16.U,20./,21.134,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 67 "../../../sim/ppc/powerpc.igen"
    unsigned const BF ATTRIBUTE_UNUSED = cache_entry->crack.X.BF = EXTRACTED32(instruction, 6, 8); /* in icache - extraction */
#line 68 "../../../sim/ppc/powerpc.igen"
    uint32_t const BF_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.BF_BITMASK = (1 << BF); /* in icache - extraction */
#line 4684 "../../../sim/ppc/powerpc.igen"
    unsigned const U ATTRIBUTE_UNUSED = cache_entry->crack.X.U = EXTRACTED32(instruction, 16, 19); /* default in icache - extraction */
#line 4684 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 41090 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Move_To_FPSCR_Field_Immediate_Rc0;

    /* semantic routine */
#line 4684 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Move To FPSCR Field Immediate\n"));
#line 41100 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Move_To_FPSCR_Field_Immediate, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4684 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      FPSCR_SET(BF, U);
      FPSCR_END(Rc);
    }
#line 41115 "icache.c"
    return nia;
    /* extraction: 0.63,6.BF,9./,11./,16.U,20./,21.134,31.Rc #undef get-values-from-icache|put-values-in-icache */
#line 41118 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Move_To_FPSCR_Field_Immediate_Rc1(cpu *processor,
                                         instruction_word instruction,
                                         unsigned_word cia,
                                         idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Move_To_FPSCR_Field_Immediate
#undef MY_PREFIX
#define MY_PREFIX Move_To_FPSCR_Field_Immediate_Rc1
#line 4684 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Move To FPSCR Field Immediate\n"));
#line 41137 "icache.c"

  /* validate: 0.63,6.BF,9./,11./,16.U,20./,21.134,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc7f0ffe) != 0xfc00010c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.BF,9./,11./,16.U,20./,21.134,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 67 "../../../sim/ppc/powerpc.igen"
    unsigned const BF ATTRIBUTE_UNUSED = cache_entry->crack.X.BF = EXTRACTED32(instruction, 6, 8); /* in icache - extraction */
#line 68 "../../../sim/ppc/powerpc.igen"
    uint32_t const BF_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.BF_BITMASK = (1 << BF); /* in icache - extraction */
#line 4684 "../../../sim/ppc/powerpc.igen"
    unsigned const U ATTRIBUTE_UNUSED = cache_entry->crack.X.U = EXTRACTED32(instruction, 16, 19); /* default in icache - extraction */
#line 4684 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 41162 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Move_To_FPSCR_Field_Immediate_Rc1;

    /* semantic routine */
#line 4684 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Move To FPSCR Field Immediate\n"));
#line 41172 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Move_To_FPSCR_Field_Immediate, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4684 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      FPSCR_SET(BF, U);
      FPSCR_END(Rc);
    }
#line 41187 "icache.c"
    return nia;
    /* extraction: 0.63,6.BF,9./,11./,16.U,20./,21.134,31.Rc #undef get-values-from-icache|put-values-in-icache */
#line 41190 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_Absolute_Value_Rc0(cpu *processor,
                                            instruction_word instruction,
                                            unsigned_word cia,
                                            idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_Absolute_Value
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_Absolute_Value_Rc0
#line 3729 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Absolute Value\n"));
#line 41209 "icache.c"

  /* validate: 0.63,6.FRT,11./,16.FRB,21.136,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc1f07fe) != 0xfc000110)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11./,16.FRB,21.136,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.X.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.X.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#line 3729 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 41238 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_Absolute_Value_Rc0;

    /* semantic routine */
#line 3729 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Absolute Value\n"));
#line 41248 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_Absolute_Value, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3729 "../../../sim/ppc/powerpc.igen"
    {
      *frT = *frB | BIT64(0);
      CR1_UPDATE(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRB_BITMASK, Rc);
    }
#line 41263 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11./,16.FRB,21.136,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRB
#line 41268 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_Absolute_Value_Rc1(cpu *processor,
                                            instruction_word instruction,
                                            unsigned_word cia,
                                            idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_Absolute_Value
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_Absolute_Value_Rc1
#line 3729 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Absolute Value\n"));
#line 41287 "icache.c"

  /* validate: 0.63,6.FRT,11./,16.FRB,21.136,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc1f07fe) != 0xfc000110)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11./,16.FRB,21.136,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.X.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.X.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#line 3729 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 41316 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_Absolute_Value_Rc1;

    /* semantic routine */
#line 3729 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Absolute Value\n"));
#line 41326 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_Absolute_Value, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3729 "../../../sim/ppc/powerpc.igen"
    {
      *frT = *frB | BIT64(0);
      CR1_UPDATE(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRB_BITMASK, Rc);
    }
#line 41341 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11./,16.FRB,21.136,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRB
#line 41346 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Select_FRC4_Rc0(cpu *processor,
                                instruction_word instruction,
                                unsigned_word cia,
                                idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC4_Rc0
#line 4743 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Select\n"));
#line 41365 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00002e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 4 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4743 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 41404 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Select_FRC4_Rc0;

    /* semantic routine */
#line 4743 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 41414 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Select, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4743 "../../../sim/ppc/powerpc.igen"
    {
      if (CURRENT_MODEL == MODEL_ppc601) {
        program_interrupt(processor, cia, optional_instruction_program_interrupt);
      } else {
        uint64_t zero = 0;
        FPSCR_BEGIN;
        if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
        else						    *frT = *frC;
        FPSCR_END(Rc);
        PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
      }
    }
#line 41436 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 41443 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Select_FRC4_Rc1(cpu *processor,
                                instruction_word instruction,
                                unsigned_word cia,
                                idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC4_Rc1
#line 4743 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Select\n"));
#line 41462 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00002e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 4 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4743 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 41501 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Select_FRC4_Rc1;

    /* semantic routine */
#line 4743 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 41511 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Select, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4743 "../../../sim/ppc/powerpc.igen"
    {
      if (CURRENT_MODEL == MODEL_ppc601) {
        program_interrupt(processor, cia, optional_instruction_program_interrupt);
      } else {
        uint64_t zero = 0;
        FPSCR_BEGIN;
        if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
        else						    *frT = *frC;
        FPSCR_END(Rc);
        PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
      }
    }
#line 41533 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 41540 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Multiply_FRC4_Rc0(cpu *processor,
                                  instruction_word instruction,
                                  unsigned_word cia,
                                  idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC4_Rc0
#line 3847 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply\n"));
#line 41559 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00f83e) != 0xfc000032)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRC 4 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3847 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 41593 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Multiply_FRC4_Rc0;

    /* semantic routine */
#line 3847 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 41603 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Multiply, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3847 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = *(double*)frA * *(double*)frC;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
    }
#line 41635 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRC
#line 41641 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Multiply_FRC4_Rc1(cpu *processor,
                                  instruction_word instruction,
                                  unsigned_word cia,
                                  idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC4_Rc1
#line 3847 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply\n"));
#line 41660 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00f83e) != 0xfc000032)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRC 4 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3847 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 41694 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Multiply_FRC4_Rc1;

    /* semantic routine */
#line 3847 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 41704 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Multiply, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3847 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = *(double*)frA * *(double*)frC;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
    }
#line 41736 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRC
#line 41742 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplySubtract_FRC4_Rc0(cpu *processor,
                                          instruction_word instruction,
                                          unsigned_word cia,
                                          idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC4_Rc0
#line 4059 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Subtract\n"));
#line 41761 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc000038)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 4 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4059 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 41800 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplySubtract_FRC4_Rc0;

    /* semantic routine */
#line 4059 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 41810 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4059 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product - *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 41863 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 41870 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplySubtract_FRC4_Rc1(cpu *processor,
                                          instruction_word instruction,
                                          unsigned_word cia,
                                          idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC4_Rc1
#line 4059 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Subtract\n"));
#line 41889 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc000038)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 4 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4059 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 41928 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplySubtract_FRC4_Rc1;

    /* semantic routine */
#line 4059 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 41938 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4059 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product - *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 41991 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 41998 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplyAdd_FRC4_Rc0(cpu *processor,
                                     instruction_word instruction,
                                     unsigned_word cia,
                                     idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC4_Rc0
#line 3965 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Add\n"));
#line 42017 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003a)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 4 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3965 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 42056 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplyAdd_FRC4_Rc0;

    /* semantic routine */
#line 3965 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 42066 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3965 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product + *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 42119 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 42126 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplyAdd_FRC4_Rc1(cpu *processor,
                                     instruction_word instruction,
                                     unsigned_word cia,
                                     idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC4_Rc1
#line 3965 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Add\n"));
#line 42145 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003a)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 4 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3965 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 42184 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplyAdd_FRC4_Rc1;

    /* semantic routine */
#line 3965 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 42194 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3965 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product + *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 42247 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 42254 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplySubtract_FRC4_Rc0(cpu *processor,
                                                   instruction_word instruction,
                                                   unsigned_word cia,
                                                   idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC4_Rc0
#line 4247 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Subtract\n"));
#line 42273 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 4 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4247 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 42312 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplySubtract_FRC4_Rc0;

    /* semantic routine */
#line 4247 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 42322 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4247 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product - *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 42375 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 42382 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplySubtract_FRC4_Rc1(cpu *processor,
                                                   instruction_word instruction,
                                                   unsigned_word cia,
                                                   idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC4_Rc1
#line 4247 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Subtract\n"));
#line 42401 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 4 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4247 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 42440 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplySubtract_FRC4_Rc1;

    /* semantic routine */
#line 4247 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 42450 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4247 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product - *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 42503 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 42510 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplyAdd_FRC4_Rc0(cpu *processor,
                                              instruction_word instruction,
                                              unsigned_word cia,
                                              idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC4_Rc0
#line 4153 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Add\n"));
#line 42529 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 4 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4153 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 42568 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplyAdd_FRC4_Rc0;

    /* semantic routine */
#line 4153 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 42578 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4153 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product + *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 42631 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 42638 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplyAdd_FRC4_Rc1(cpu *processor,
                                              instruction_word instruction,
                                              unsigned_word cia,
                                              idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC4_Rc1
#line 4153 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Add\n"));
#line 42657 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 4 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4153 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 42696 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplyAdd_FRC4_Rc1;

    /* semantic routine */
#line 4153 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 42706 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4153 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product + *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 42759 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 42766 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Select_FRC5_Rc0(cpu *processor,
                                instruction_word instruction,
                                unsigned_word cia,
                                idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC5_Rc0
#line 4743 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Select\n"));
#line 42785 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00002e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 5 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4743 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 42824 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Select_FRC5_Rc0;

    /* semantic routine */
#line 4743 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 42834 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Select, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4743 "../../../sim/ppc/powerpc.igen"
    {
      if (CURRENT_MODEL == MODEL_ppc601) {
        program_interrupt(processor, cia, optional_instruction_program_interrupt);
      } else {
        uint64_t zero = 0;
        FPSCR_BEGIN;
        if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
        else						    *frT = *frC;
        FPSCR_END(Rc);
        PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
      }
    }
#line 42856 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 42863 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Select_FRC5_Rc1(cpu *processor,
                                instruction_word instruction,
                                unsigned_word cia,
                                idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC5_Rc1
#line 4743 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Select\n"));
#line 42882 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00002e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 5 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4743 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 42921 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Select_FRC5_Rc1;

    /* semantic routine */
#line 4743 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 42931 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Select, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4743 "../../../sim/ppc/powerpc.igen"
    {
      if (CURRENT_MODEL == MODEL_ppc601) {
        program_interrupt(processor, cia, optional_instruction_program_interrupt);
      } else {
        uint64_t zero = 0;
        FPSCR_BEGIN;
        if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
        else						    *frT = *frC;
        FPSCR_END(Rc);
        PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
      }
    }
#line 42953 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 42960 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Multiply_FRC5_Rc0(cpu *processor,
                                  instruction_word instruction,
                                  unsigned_word cia,
                                  idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC5_Rc0
#line 3847 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply\n"));
#line 42979 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00f83e) != 0xfc000032)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRC 5 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3847 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 43013 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Multiply_FRC5_Rc0;

    /* semantic routine */
#line 3847 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 43023 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Multiply, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3847 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = *(double*)frA * *(double*)frC;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
    }
#line 43055 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRC
#line 43061 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Multiply_FRC5_Rc1(cpu *processor,
                                  instruction_word instruction,
                                  unsigned_word cia,
                                  idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC5_Rc1
#line 3847 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply\n"));
#line 43080 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00f83e) != 0xfc000032)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRC 5 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3847 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 43114 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Multiply_FRC5_Rc1;

    /* semantic routine */
#line 3847 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 43124 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Multiply, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3847 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = *(double*)frA * *(double*)frC;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
    }
#line 43156 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRC
#line 43162 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplySubtract_FRC5_Rc0(cpu *processor,
                                          instruction_word instruction,
                                          unsigned_word cia,
                                          idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC5_Rc0
#line 4059 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Subtract\n"));
#line 43181 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc000038)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 5 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4059 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 43220 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplySubtract_FRC5_Rc0;

    /* semantic routine */
#line 4059 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 43230 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4059 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product - *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 43283 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 43290 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplySubtract_FRC5_Rc1(cpu *processor,
                                          instruction_word instruction,
                                          unsigned_word cia,
                                          idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC5_Rc1
#line 4059 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Subtract\n"));
#line 43309 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc000038)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 5 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4059 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 43348 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplySubtract_FRC5_Rc1;

    /* semantic routine */
#line 4059 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 43358 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4059 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product - *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 43411 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 43418 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplyAdd_FRC5_Rc0(cpu *processor,
                                     instruction_word instruction,
                                     unsigned_word cia,
                                     idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC5_Rc0
#line 3965 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Add\n"));
#line 43437 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003a)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 5 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3965 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 43476 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplyAdd_FRC5_Rc0;

    /* semantic routine */
#line 3965 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 43486 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3965 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product + *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 43539 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 43546 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplyAdd_FRC5_Rc1(cpu *processor,
                                     instruction_word instruction,
                                     unsigned_word cia,
                                     idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC5_Rc1
#line 3965 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Add\n"));
#line 43565 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003a)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 5 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3965 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 43604 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplyAdd_FRC5_Rc1;

    /* semantic routine */
#line 3965 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 43614 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3965 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product + *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 43667 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 43674 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplySubtract_FRC5_Rc0(cpu *processor,
                                                   instruction_word instruction,
                                                   unsigned_word cia,
                                                   idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC5_Rc0
#line 4247 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Subtract\n"));
#line 43693 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 5 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4247 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 43732 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplySubtract_FRC5_Rc0;

    /* semantic routine */
#line 4247 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 43742 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4247 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product - *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 43795 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 43802 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplySubtract_FRC5_Rc1(cpu *processor,
                                                   instruction_word instruction,
                                                   unsigned_word cia,
                                                   idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC5_Rc1
#line 4247 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Subtract\n"));
#line 43821 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 5 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4247 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 43860 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplySubtract_FRC5_Rc1;

    /* semantic routine */
#line 4247 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 43870 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4247 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product - *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 43923 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 43930 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplyAdd_FRC5_Rc0(cpu *processor,
                                              instruction_word instruction,
                                              unsigned_word cia,
                                              idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC5_Rc0
#line 4153 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Add\n"));
#line 43949 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 5 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4153 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 43988 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplyAdd_FRC5_Rc0;

    /* semantic routine */
#line 4153 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 43998 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4153 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product + *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 44051 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 44058 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplyAdd_FRC5_Rc1(cpu *processor,
                                              instruction_word instruction,
                                              unsigned_word cia,
                                              idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC5_Rc1
#line 4153 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Add\n"));
#line 44077 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 5 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4153 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 44116 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplyAdd_FRC5_Rc1;

    /* semantic routine */
#line 4153 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 44126 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4153 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product + *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 44179 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 44186 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Select_FRC6_Rc0(cpu *processor,
                                instruction_word instruction,
                                unsigned_word cia,
                                idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC6_Rc0
#line 4743 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Select\n"));
#line 44205 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00002e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 6 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4743 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 44244 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Select_FRC6_Rc0;

    /* semantic routine */
#line 4743 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 44254 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Select, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4743 "../../../sim/ppc/powerpc.igen"
    {
      if (CURRENT_MODEL == MODEL_ppc601) {
        program_interrupt(processor, cia, optional_instruction_program_interrupt);
      } else {
        uint64_t zero = 0;
        FPSCR_BEGIN;
        if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
        else						    *frT = *frC;
        FPSCR_END(Rc);
        PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
      }
    }
#line 44276 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 44283 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Select_FRC6_Rc1(cpu *processor,
                                instruction_word instruction,
                                unsigned_word cia,
                                idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC6_Rc1
#line 4743 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Select\n"));
#line 44302 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00002e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 6 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4743 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 44341 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Select_FRC6_Rc1;

    /* semantic routine */
#line 4743 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 44351 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Select, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4743 "../../../sim/ppc/powerpc.igen"
    {
      if (CURRENT_MODEL == MODEL_ppc601) {
        program_interrupt(processor, cia, optional_instruction_program_interrupt);
      } else {
        uint64_t zero = 0;
        FPSCR_BEGIN;
        if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
        else						    *frT = *frC;
        FPSCR_END(Rc);
        PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
      }
    }
#line 44373 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 44380 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Multiply_FRC6_Rc0(cpu *processor,
                                  instruction_word instruction,
                                  unsigned_word cia,
                                  idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC6_Rc0
#line 3847 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply\n"));
#line 44399 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00f83e) != 0xfc000032)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRC 6 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3847 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 44433 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Multiply_FRC6_Rc0;

    /* semantic routine */
#line 3847 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 44443 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Multiply, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3847 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = *(double*)frA * *(double*)frC;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
    }
#line 44475 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRC
#line 44481 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Multiply_FRC6_Rc1(cpu *processor,
                                  instruction_word instruction,
                                  unsigned_word cia,
                                  idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC6_Rc1
#line 3847 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply\n"));
#line 44500 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00f83e) != 0xfc000032)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRC 6 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3847 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 44534 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Multiply_FRC6_Rc1;

    /* semantic routine */
#line 3847 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 44544 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Multiply, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3847 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = *(double*)frA * *(double*)frC;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
    }
#line 44576 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRC
#line 44582 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplySubtract_FRC6_Rc0(cpu *processor,
                                          instruction_word instruction,
                                          unsigned_word cia,
                                          idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC6_Rc0
#line 4059 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Subtract\n"));
#line 44601 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc000038)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 6 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4059 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 44640 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplySubtract_FRC6_Rc0;

    /* semantic routine */
#line 4059 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 44650 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4059 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product - *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 44703 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 44710 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplySubtract_FRC6_Rc1(cpu *processor,
                                          instruction_word instruction,
                                          unsigned_word cia,
                                          idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC6_Rc1
#line 4059 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Subtract\n"));
#line 44729 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc000038)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 6 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4059 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 44768 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplySubtract_FRC6_Rc1;

    /* semantic routine */
#line 4059 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 44778 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4059 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product - *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 44831 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 44838 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplyAdd_FRC6_Rc0(cpu *processor,
                                     instruction_word instruction,
                                     unsigned_word cia,
                                     idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC6_Rc0
#line 3965 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Add\n"));
#line 44857 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003a)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 6 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3965 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 44896 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplyAdd_FRC6_Rc0;

    /* semantic routine */
#line 3965 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 44906 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3965 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product + *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 44959 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 44966 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplyAdd_FRC6_Rc1(cpu *processor,
                                     instruction_word instruction,
                                     unsigned_word cia,
                                     idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC6_Rc1
#line 3965 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Add\n"));
#line 44985 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003a)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 6 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3965 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 45024 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplyAdd_FRC6_Rc1;

    /* semantic routine */
#line 3965 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 45034 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3965 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product + *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 45087 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 45094 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplySubtract_FRC6_Rc0(cpu *processor,
                                                   instruction_word instruction,
                                                   unsigned_word cia,
                                                   idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC6_Rc0
#line 4247 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Subtract\n"));
#line 45113 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 6 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4247 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 45152 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplySubtract_FRC6_Rc0;

    /* semantic routine */
#line 4247 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 45162 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4247 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product - *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 45215 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 45222 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplySubtract_FRC6_Rc1(cpu *processor,
                                                   instruction_word instruction,
                                                   unsigned_word cia,
                                                   idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC6_Rc1
#line 4247 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Subtract\n"));
#line 45241 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 6 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4247 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 45280 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplySubtract_FRC6_Rc1;

    /* semantic routine */
#line 4247 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 45290 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4247 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product - *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 45343 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 45350 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplyAdd_FRC6_Rc0(cpu *processor,
                                              instruction_word instruction,
                                              unsigned_word cia,
                                              idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC6_Rc0
#line 4153 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Add\n"));
#line 45369 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 6 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4153 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 45408 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplyAdd_FRC6_Rc0;

    /* semantic routine */
#line 4153 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 45418 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4153 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product + *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 45471 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 45478 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplyAdd_FRC6_Rc1(cpu *processor,
                                              instruction_word instruction,
                                              unsigned_word cia,
                                              idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC6_Rc1
#line 4153 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Add\n"));
#line 45497 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 6 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4153 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 45536 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplyAdd_FRC6_Rc1;

    /* semantic routine */
#line 4153 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 45546 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4153 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product + *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 45599 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 45606 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Select_FRC7_Rc0(cpu *processor,
                                instruction_word instruction,
                                unsigned_word cia,
                                idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC7_Rc0
#line 4743 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Select\n"));
#line 45625 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00002e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 7 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4743 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 45664 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Select_FRC7_Rc0;

    /* semantic routine */
#line 4743 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 45674 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Select, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4743 "../../../sim/ppc/powerpc.igen"
    {
      if (CURRENT_MODEL == MODEL_ppc601) {
        program_interrupt(processor, cia, optional_instruction_program_interrupt);
      } else {
        uint64_t zero = 0;
        FPSCR_BEGIN;
        if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
        else						    *frT = *frC;
        FPSCR_END(Rc);
        PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
      }
    }
#line 45696 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 45703 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Select_FRC7_Rc1(cpu *processor,
                                instruction_word instruction,
                                unsigned_word cia,
                                idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC7_Rc1
#line 4743 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Select\n"));
#line 45722 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00002e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 7 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4743 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 45761 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Select_FRC7_Rc1;

    /* semantic routine */
#line 4743 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 45771 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Select, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4743 "../../../sim/ppc/powerpc.igen"
    {
      if (CURRENT_MODEL == MODEL_ppc601) {
        program_interrupt(processor, cia, optional_instruction_program_interrupt);
      } else {
        uint64_t zero = 0;
        FPSCR_BEGIN;
        if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
        else						    *frT = *frC;
        FPSCR_END(Rc);
        PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
      }
    }
#line 45793 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 45800 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Multiply_FRC7_Rc0(cpu *processor,
                                  instruction_word instruction,
                                  unsigned_word cia,
                                  idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC7_Rc0
#line 3847 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply\n"));
#line 45819 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00f83e) != 0xfc000032)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRC 7 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3847 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 45853 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Multiply_FRC7_Rc0;

    /* semantic routine */
#line 3847 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 45863 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Multiply, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3847 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = *(double*)frA * *(double*)frC;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
    }
#line 45895 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRC
#line 45901 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Multiply_FRC7_Rc1(cpu *processor,
                                  instruction_word instruction,
                                  unsigned_word cia,
                                  idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC7_Rc1
#line 3847 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply\n"));
#line 45920 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00f83e) != 0xfc000032)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRC 7 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3847 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 45954 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Multiply_FRC7_Rc1;

    /* semantic routine */
#line 3847 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 45964 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Multiply, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3847 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = *(double*)frA * *(double*)frC;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
    }
#line 45996 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRC
#line 46002 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplySubtract_FRC7_Rc0(cpu *processor,
                                          instruction_word instruction,
                                          unsigned_word cia,
                                          idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC7_Rc0
#line 4059 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Subtract\n"));
#line 46021 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc000038)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 7 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4059 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 46060 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplySubtract_FRC7_Rc0;

    /* semantic routine */
#line 4059 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 46070 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4059 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product - *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 46123 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 46130 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplySubtract_FRC7_Rc1(cpu *processor,
                                          instruction_word instruction,
                                          unsigned_word cia,
                                          idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC7_Rc1
#line 4059 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Subtract\n"));
#line 46149 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc000038)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 7 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4059 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 46188 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplySubtract_FRC7_Rc1;

    /* semantic routine */
#line 4059 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 46198 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4059 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product - *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 46251 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 46258 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplyAdd_FRC7_Rc0(cpu *processor,
                                     instruction_word instruction,
                                     unsigned_word cia,
                                     idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC7_Rc0
#line 3965 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Add\n"));
#line 46277 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003a)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 7 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3965 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 46316 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplyAdd_FRC7_Rc0;

    /* semantic routine */
#line 3965 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 46326 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3965 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product + *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 46379 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 46386 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplyAdd_FRC7_Rc1(cpu *processor,
                                     instruction_word instruction,
                                     unsigned_word cia,
                                     idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC7_Rc1
#line 3965 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Add\n"));
#line 46405 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003a)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 7 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3965 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 46444 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplyAdd_FRC7_Rc1;

    /* semantic routine */
#line 3965 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 46454 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3965 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product + *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 46507 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 46514 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplySubtract_FRC7_Rc0(cpu *processor,
                                                   instruction_word instruction,
                                                   unsigned_word cia,
                                                   idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC7_Rc0
#line 4247 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Subtract\n"));
#line 46533 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 7 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4247 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 46572 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplySubtract_FRC7_Rc0;

    /* semantic routine */
#line 4247 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 46582 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4247 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product - *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 46635 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 46642 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplySubtract_FRC7_Rc1(cpu *processor,
                                                   instruction_word instruction,
                                                   unsigned_word cia,
                                                   idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC7_Rc1
#line 4247 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Subtract\n"));
#line 46661 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 7 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4247 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 46700 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplySubtract_FRC7_Rc1;

    /* semantic routine */
#line 4247 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 46710 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4247 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product - *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 46763 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 46770 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplyAdd_FRC7_Rc0(cpu *processor,
                                              instruction_word instruction,
                                              unsigned_word cia,
                                              idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC7_Rc0
#line 4153 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Add\n"));
#line 46789 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 7 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4153 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 46828 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplyAdd_FRC7_Rc0;

    /* semantic routine */
#line 4153 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 46838 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4153 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product + *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 46891 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 46898 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplyAdd_FRC7_Rc1(cpu *processor,
                                              instruction_word instruction,
                                              unsigned_word cia,
                                              idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC7_Rc1
#line 4153 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Add\n"));
#line 46917 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 7 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4153 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 46956 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplyAdd_FRC7_Rc1;

    /* semantic routine */
#line 4153 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 46966 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4153 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product + *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 47019 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 47026 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Absolute_Value_Rc0(cpu *processor,
                                   instruction_word instruction,
                                   unsigned_word cia,
                                   idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Absolute_Value
#undef MY_PREFIX
#define MY_PREFIX Floating_Absolute_Value_Rc0
#line 3720 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Absolute Value\n"));
#line 47045 "icache.c"

  /* validate: 0.63,6.FRT,11./,16.FRB,21.264,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc1f07fe) != 0xfc000210)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11./,16.FRB,21.264,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.X.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.X.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#line 3720 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 47074 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Absolute_Value_Rc0;

    /* semantic routine */
#line 3720 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Absolute Value\n"));
#line 47084 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Absolute_Value, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3720 "../../../sim/ppc/powerpc.igen"
    {
      *frT = *frB & ~BIT64(0);
      CR1_UPDATE(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRB_BITMASK, Rc);
    }
#line 47099 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11./,16.FRB,21.264,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRB
#line 47104 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Absolute_Value_Rc1(cpu *processor,
                                   instruction_word instruction,
                                   unsigned_word cia,
                                   idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Absolute_Value
#undef MY_PREFIX
#define MY_PREFIX Floating_Absolute_Value_Rc1
#line 3720 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Absolute Value\n"));
#line 47123 "icache.c"

  /* validate: 0.63,6.FRT,11./,16.FRB,21.264,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc1f07fe) != 0xfc000210)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11./,16.FRB,21.264,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.X.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.X.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#line 3720 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 47152 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Absolute_Value_Rc1;

    /* semantic routine */
#line 3720 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Absolute Value\n"));
#line 47162 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Absolute_Value, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3720 "../../../sim/ppc/powerpc.igen"
    {
      *frT = *frB & ~BIT64(0);
      CR1_UPDATE(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRB_BITMASK, Rc);
    }
#line 47177 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11./,16.FRB,21.264,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRB
#line 47182 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Select_FRC8_Rc0(cpu *processor,
                                instruction_word instruction,
                                unsigned_word cia,
                                idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC8_Rc0
#line 4743 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Select\n"));
#line 47201 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00002e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 8 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4743 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 47240 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Select_FRC8_Rc0;

    /* semantic routine */
#line 4743 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 47250 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Select, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4743 "../../../sim/ppc/powerpc.igen"
    {
      if (CURRENT_MODEL == MODEL_ppc601) {
        program_interrupt(processor, cia, optional_instruction_program_interrupt);
      } else {
        uint64_t zero = 0;
        FPSCR_BEGIN;
        if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
        else						    *frT = *frC;
        FPSCR_END(Rc);
        PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
      }
    }
#line 47272 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 47279 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Select_FRC8_Rc1(cpu *processor,
                                instruction_word instruction,
                                unsigned_word cia,
                                idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC8_Rc1
#line 4743 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Select\n"));
#line 47298 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00002e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 8 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4743 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 47337 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Select_FRC8_Rc1;

    /* semantic routine */
#line 4743 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 47347 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Select, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4743 "../../../sim/ppc/powerpc.igen"
    {
      if (CURRENT_MODEL == MODEL_ppc601) {
        program_interrupt(processor, cia, optional_instruction_program_interrupt);
      } else {
        uint64_t zero = 0;
        FPSCR_BEGIN;
        if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
        else						    *frT = *frC;
        FPSCR_END(Rc);
        PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
      }
    }
#line 47369 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 47376 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Multiply_FRC8_Rc0(cpu *processor,
                                  instruction_word instruction,
                                  unsigned_word cia,
                                  idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC8_Rc0
#line 3847 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply\n"));
#line 47395 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00f83e) != 0xfc000032)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRC 8 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3847 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 47429 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Multiply_FRC8_Rc0;

    /* semantic routine */
#line 3847 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 47439 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Multiply, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3847 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = *(double*)frA * *(double*)frC;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
    }
#line 47471 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRC
#line 47477 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Multiply_FRC8_Rc1(cpu *processor,
                                  instruction_word instruction,
                                  unsigned_word cia,
                                  idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC8_Rc1
#line 3847 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply\n"));
#line 47496 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00f83e) != 0xfc000032)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRC 8 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3847 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 47530 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Multiply_FRC8_Rc1;

    /* semantic routine */
#line 3847 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 47540 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Multiply, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3847 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = *(double*)frA * *(double*)frC;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
    }
#line 47572 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRC
#line 47578 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplySubtract_FRC8_Rc0(cpu *processor,
                                          instruction_word instruction,
                                          unsigned_word cia,
                                          idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC8_Rc0
#line 4059 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Subtract\n"));
#line 47597 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc000038)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 8 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4059 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 47636 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplySubtract_FRC8_Rc0;

    /* semantic routine */
#line 4059 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 47646 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4059 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product - *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 47699 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 47706 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplySubtract_FRC8_Rc1(cpu *processor,
                                          instruction_word instruction,
                                          unsigned_word cia,
                                          idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC8_Rc1
#line 4059 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Subtract\n"));
#line 47725 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc000038)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 8 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4059 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 47764 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplySubtract_FRC8_Rc1;

    /* semantic routine */
#line 4059 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 47774 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4059 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product - *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 47827 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 47834 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplyAdd_FRC8_Rc0(cpu *processor,
                                     instruction_word instruction,
                                     unsigned_word cia,
                                     idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC8_Rc0
#line 3965 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Add\n"));
#line 47853 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003a)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 8 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3965 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 47892 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplyAdd_FRC8_Rc0;

    /* semantic routine */
#line 3965 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 47902 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3965 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product + *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 47955 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 47962 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplyAdd_FRC8_Rc1(cpu *processor,
                                     instruction_word instruction,
                                     unsigned_word cia,
                                     idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC8_Rc1
#line 3965 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Add\n"));
#line 47981 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003a)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 8 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3965 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 48020 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplyAdd_FRC8_Rc1;

    /* semantic routine */
#line 3965 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 48030 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3965 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product + *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 48083 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 48090 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplySubtract_FRC8_Rc0(cpu *processor,
                                                   instruction_word instruction,
                                                   unsigned_word cia,
                                                   idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC8_Rc0
#line 4247 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Subtract\n"));
#line 48109 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 8 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4247 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 48148 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplySubtract_FRC8_Rc0;

    /* semantic routine */
#line 4247 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 48158 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4247 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product - *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 48211 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 48218 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplySubtract_FRC8_Rc1(cpu *processor,
                                                   instruction_word instruction,
                                                   unsigned_word cia,
                                                   idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC8_Rc1
#line 4247 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Subtract\n"));
#line 48237 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 8 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4247 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 48276 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplySubtract_FRC8_Rc1;

    /* semantic routine */
#line 4247 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 48286 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4247 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product - *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 48339 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 48346 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplyAdd_FRC8_Rc0(cpu *processor,
                                              instruction_word instruction,
                                              unsigned_word cia,
                                              idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC8_Rc0
#line 4153 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Add\n"));
#line 48365 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 8 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4153 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 48404 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplyAdd_FRC8_Rc0;

    /* semantic routine */
#line 4153 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 48414 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4153 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product + *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 48467 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 48474 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplyAdd_FRC8_Rc1(cpu *processor,
                                              instruction_word instruction,
                                              unsigned_word cia,
                                              idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC8_Rc1
#line 4153 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Add\n"));
#line 48493 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 8 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4153 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 48532 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplyAdd_FRC8_Rc1;

    /* semantic routine */
#line 4153 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 48542 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4153 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product + *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 48595 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 48602 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Select_FRC9_Rc0(cpu *processor,
                                instruction_word instruction,
                                unsigned_word cia,
                                idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC9_Rc0
#line 4743 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Select\n"));
#line 48621 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00002e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 9 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4743 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 48660 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Select_FRC9_Rc0;

    /* semantic routine */
#line 4743 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 48670 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Select, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4743 "../../../sim/ppc/powerpc.igen"
    {
      if (CURRENT_MODEL == MODEL_ppc601) {
        program_interrupt(processor, cia, optional_instruction_program_interrupt);
      } else {
        uint64_t zero = 0;
        FPSCR_BEGIN;
        if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
        else						    *frT = *frC;
        FPSCR_END(Rc);
        PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
      }
    }
#line 48692 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 48699 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Select_FRC9_Rc1(cpu *processor,
                                instruction_word instruction,
                                unsigned_word cia,
                                idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC9_Rc1
#line 4743 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Select\n"));
#line 48718 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00002e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 9 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4743 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 48757 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Select_FRC9_Rc1;

    /* semantic routine */
#line 4743 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 48767 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Select, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4743 "../../../sim/ppc/powerpc.igen"
    {
      if (CURRENT_MODEL == MODEL_ppc601) {
        program_interrupt(processor, cia, optional_instruction_program_interrupt);
      } else {
        uint64_t zero = 0;
        FPSCR_BEGIN;
        if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
        else						    *frT = *frC;
        FPSCR_END(Rc);
        PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
      }
    }
#line 48789 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 48796 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Multiply_FRC9_Rc0(cpu *processor,
                                  instruction_word instruction,
                                  unsigned_word cia,
                                  idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC9_Rc0
#line 3847 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply\n"));
#line 48815 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00f83e) != 0xfc000032)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRC 9 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3847 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 48849 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Multiply_FRC9_Rc0;

    /* semantic routine */
#line 3847 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 48859 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Multiply, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3847 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = *(double*)frA * *(double*)frC;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
    }
#line 48891 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRC
#line 48897 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Multiply_FRC9_Rc1(cpu *processor,
                                  instruction_word instruction,
                                  unsigned_word cia,
                                  idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC9_Rc1
#line 3847 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply\n"));
#line 48916 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00f83e) != 0xfc000032)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRC 9 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3847 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 48950 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Multiply_FRC9_Rc1;

    /* semantic routine */
#line 3847 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 48960 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Multiply, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3847 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = *(double*)frA * *(double*)frC;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
    }
#line 48992 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRC
#line 48998 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplySubtract_FRC9_Rc0(cpu *processor,
                                          instruction_word instruction,
                                          unsigned_word cia,
                                          idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC9_Rc0
#line 4059 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Subtract\n"));
#line 49017 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc000038)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 9 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4059 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 49056 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplySubtract_FRC9_Rc0;

    /* semantic routine */
#line 4059 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 49066 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4059 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product - *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 49119 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 49126 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplySubtract_FRC9_Rc1(cpu *processor,
                                          instruction_word instruction,
                                          unsigned_word cia,
                                          idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC9_Rc1
#line 4059 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Subtract\n"));
#line 49145 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc000038)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 9 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4059 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 49184 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplySubtract_FRC9_Rc1;

    /* semantic routine */
#line 4059 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 49194 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4059 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product - *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 49247 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 49254 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplyAdd_FRC9_Rc0(cpu *processor,
                                     instruction_word instruction,
                                     unsigned_word cia,
                                     idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC9_Rc0
#line 3965 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Add\n"));
#line 49273 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003a)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 9 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3965 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 49312 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplyAdd_FRC9_Rc0;

    /* semantic routine */
#line 3965 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 49322 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3965 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product + *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 49375 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 49382 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplyAdd_FRC9_Rc1(cpu *processor,
                                     instruction_word instruction,
                                     unsigned_word cia,
                                     idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC9_Rc1
#line 3965 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Add\n"));
#line 49401 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003a)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 9 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3965 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 49440 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplyAdd_FRC9_Rc1;

    /* semantic routine */
#line 3965 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 49450 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3965 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product + *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 49503 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 49510 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplySubtract_FRC9_Rc0(cpu *processor,
                                                   instruction_word instruction,
                                                   unsigned_word cia,
                                                   idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC9_Rc0
#line 4247 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Subtract\n"));
#line 49529 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 9 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4247 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 49568 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplySubtract_FRC9_Rc0;

    /* semantic routine */
#line 4247 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 49578 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4247 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product - *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 49631 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 49638 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplySubtract_FRC9_Rc1(cpu *processor,
                                                   instruction_word instruction,
                                                   unsigned_word cia,
                                                   idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC9_Rc1
#line 4247 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Subtract\n"));
#line 49657 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 9 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4247 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 49696 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplySubtract_FRC9_Rc1;

    /* semantic routine */
#line 4247 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 49706 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4247 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product - *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 49759 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 49766 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplyAdd_FRC9_Rc0(cpu *processor,
                                              instruction_word instruction,
                                              unsigned_word cia,
                                              idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC9_Rc0
#line 4153 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Add\n"));
#line 49785 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 9 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4153 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 49824 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplyAdd_FRC9_Rc0;

    /* semantic routine */
#line 4153 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 49834 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4153 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product + *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 49887 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 49894 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplyAdd_FRC9_Rc1(cpu *processor,
                                              instruction_word instruction,
                                              unsigned_word cia,
                                              idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC9_Rc1
#line 4153 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Add\n"));
#line 49913 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 9 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4153 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 49952 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplyAdd_FRC9_Rc1;

    /* semantic routine */
#line 4153 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 49962 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4153 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product + *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 50015 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 50022 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Select_FRC10_Rc0(cpu *processor,
                                 instruction_word instruction,
                                 unsigned_word cia,
                                 idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC10_Rc0
#line 4743 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Select\n"));
#line 50041 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00002e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 10 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4743 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 50080 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Select_FRC10_Rc0;

    /* semantic routine */
#line 4743 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 50090 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Select, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4743 "../../../sim/ppc/powerpc.igen"
    {
      if (CURRENT_MODEL == MODEL_ppc601) {
        program_interrupt(processor, cia, optional_instruction_program_interrupt);
      } else {
        uint64_t zero = 0;
        FPSCR_BEGIN;
        if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
        else						    *frT = *frC;
        FPSCR_END(Rc);
        PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
      }
    }
#line 50112 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 50119 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Select_FRC10_Rc1(cpu *processor,
                                 instruction_word instruction,
                                 unsigned_word cia,
                                 idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC10_Rc1
#line 4743 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Select\n"));
#line 50138 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00002e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 10 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4743 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 50177 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Select_FRC10_Rc1;

    /* semantic routine */
#line 4743 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 50187 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Select, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4743 "../../../sim/ppc/powerpc.igen"
    {
      if (CURRENT_MODEL == MODEL_ppc601) {
        program_interrupt(processor, cia, optional_instruction_program_interrupt);
      } else {
        uint64_t zero = 0;
        FPSCR_BEGIN;
        if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
        else						    *frT = *frC;
        FPSCR_END(Rc);
        PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
      }
    }
#line 50209 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 50216 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Multiply_FRC10_Rc0(cpu *processor,
                                   instruction_word instruction,
                                   unsigned_word cia,
                                   idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC10_Rc0
#line 3847 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply\n"));
#line 50235 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00f83e) != 0xfc000032)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRC 10 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3847 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 50269 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Multiply_FRC10_Rc0;

    /* semantic routine */
#line 3847 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 50279 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Multiply, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3847 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = *(double*)frA * *(double*)frC;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
    }
#line 50311 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRC
#line 50317 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Multiply_FRC10_Rc1(cpu *processor,
                                   instruction_word instruction,
                                   unsigned_word cia,
                                   idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC10_Rc1
#line 3847 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply\n"));
#line 50336 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00f83e) != 0xfc000032)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRC 10 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3847 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 50370 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Multiply_FRC10_Rc1;

    /* semantic routine */
#line 3847 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 50380 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Multiply, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3847 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = *(double*)frA * *(double*)frC;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
    }
#line 50412 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRC
#line 50418 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplySubtract_FRC10_Rc0(cpu *processor,
                                           instruction_word instruction,
                                           unsigned_word cia,
                                           idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC10_Rc0
#line 4059 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Subtract\n"));
#line 50437 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc000038)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 10 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4059 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 50476 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplySubtract_FRC10_Rc0;

    /* semantic routine */
#line 4059 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 50486 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4059 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product - *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 50539 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 50546 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplySubtract_FRC10_Rc1(cpu *processor,
                                           instruction_word instruction,
                                           unsigned_word cia,
                                           idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC10_Rc1
#line 4059 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Subtract\n"));
#line 50565 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc000038)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 10 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4059 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 50604 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplySubtract_FRC10_Rc1;

    /* semantic routine */
#line 4059 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 50614 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4059 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product - *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 50667 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 50674 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplyAdd_FRC10_Rc0(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC10_Rc0
#line 3965 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Add\n"));
#line 50693 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003a)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 10 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3965 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 50732 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplyAdd_FRC10_Rc0;

    /* semantic routine */
#line 3965 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 50742 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3965 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product + *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 50795 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 50802 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplyAdd_FRC10_Rc1(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC10_Rc1
#line 3965 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Add\n"));
#line 50821 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003a)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 10 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3965 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 50860 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplyAdd_FRC10_Rc1;

    /* semantic routine */
#line 3965 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 50870 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3965 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product + *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 50923 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 50930 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplySubtract_FRC10_Rc0(cpu *processor,
                                                    instruction_word instruction,
                                                    unsigned_word cia,
                                                    idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC10_Rc0
#line 4247 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Subtract\n"));
#line 50949 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 10 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4247 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 50988 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplySubtract_FRC10_Rc0;

    /* semantic routine */
#line 4247 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 50998 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4247 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product - *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 51051 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 51058 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplySubtract_FRC10_Rc1(cpu *processor,
                                                    instruction_word instruction,
                                                    unsigned_word cia,
                                                    idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC10_Rc1
#line 4247 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Subtract\n"));
#line 51077 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 10 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4247 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 51116 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplySubtract_FRC10_Rc1;

    /* semantic routine */
#line 4247 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 51126 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4247 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product - *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 51179 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 51186 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplyAdd_FRC10_Rc0(cpu *processor,
                                               instruction_word instruction,
                                               unsigned_word cia,
                                               idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC10_Rc0
#line 4153 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Add\n"));
#line 51205 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 10 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4153 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 51244 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplyAdd_FRC10_Rc0;

    /* semantic routine */
#line 4153 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 51254 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4153 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product + *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 51307 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 51314 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplyAdd_FRC10_Rc1(cpu *processor,
                                               instruction_word instruction,
                                               unsigned_word cia,
                                               idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC10_Rc1
#line 4153 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Add\n"));
#line 51333 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 10 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4153 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 51372 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplyAdd_FRC10_Rc1;

    /* semantic routine */
#line 4153 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 51382 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4153 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product + *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 51435 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 51442 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Select_FRC11_Rc0(cpu *processor,
                                 instruction_word instruction,
                                 unsigned_word cia,
                                 idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC11_Rc0
#line 4743 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Select\n"));
#line 51461 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00002e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 11 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4743 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 51500 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Select_FRC11_Rc0;

    /* semantic routine */
#line 4743 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 51510 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Select, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4743 "../../../sim/ppc/powerpc.igen"
    {
      if (CURRENT_MODEL == MODEL_ppc601) {
        program_interrupt(processor, cia, optional_instruction_program_interrupt);
      } else {
        uint64_t zero = 0;
        FPSCR_BEGIN;
        if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
        else						    *frT = *frC;
        FPSCR_END(Rc);
        PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
      }
    }
#line 51532 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 51539 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Select_FRC11_Rc1(cpu *processor,
                                 instruction_word instruction,
                                 unsigned_word cia,
                                 idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC11_Rc1
#line 4743 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Select\n"));
#line 51558 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00002e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 11 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4743 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 51597 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Select_FRC11_Rc1;

    /* semantic routine */
#line 4743 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 51607 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Select, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4743 "../../../sim/ppc/powerpc.igen"
    {
      if (CURRENT_MODEL == MODEL_ppc601) {
        program_interrupt(processor, cia, optional_instruction_program_interrupt);
      } else {
        uint64_t zero = 0;
        FPSCR_BEGIN;
        if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
        else						    *frT = *frC;
        FPSCR_END(Rc);
        PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
      }
    }
#line 51629 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 51636 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Multiply_FRC11_Rc0(cpu *processor,
                                   instruction_word instruction,
                                   unsigned_word cia,
                                   idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC11_Rc0
#line 3847 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply\n"));
#line 51655 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00f83e) != 0xfc000032)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRC 11 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3847 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 51689 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Multiply_FRC11_Rc0;

    /* semantic routine */
#line 3847 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 51699 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Multiply, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3847 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = *(double*)frA * *(double*)frC;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
    }
#line 51731 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRC
#line 51737 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Multiply_FRC11_Rc1(cpu *processor,
                                   instruction_word instruction,
                                   unsigned_word cia,
                                   idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC11_Rc1
#line 3847 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply\n"));
#line 51756 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00f83e) != 0xfc000032)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRC 11 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3847 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 51790 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Multiply_FRC11_Rc1;

    /* semantic routine */
#line 3847 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 51800 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Multiply, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3847 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = *(double*)frA * *(double*)frC;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
    }
#line 51832 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRC
#line 51838 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplySubtract_FRC11_Rc0(cpu *processor,
                                           instruction_word instruction,
                                           unsigned_word cia,
                                           idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC11_Rc0
#line 4059 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Subtract\n"));
#line 51857 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc000038)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 11 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4059 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 51896 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplySubtract_FRC11_Rc0;

    /* semantic routine */
#line 4059 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 51906 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4059 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product - *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 51959 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 51966 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplySubtract_FRC11_Rc1(cpu *processor,
                                           instruction_word instruction,
                                           unsigned_word cia,
                                           idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC11_Rc1
#line 4059 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Subtract\n"));
#line 51985 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc000038)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 11 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4059 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 52024 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplySubtract_FRC11_Rc1;

    /* semantic routine */
#line 4059 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 52034 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4059 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product - *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 52087 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 52094 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplyAdd_FRC11_Rc0(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC11_Rc0
#line 3965 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Add\n"));
#line 52113 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003a)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 11 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3965 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 52152 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplyAdd_FRC11_Rc0;

    /* semantic routine */
#line 3965 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 52162 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3965 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product + *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 52215 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 52222 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplyAdd_FRC11_Rc1(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC11_Rc1
#line 3965 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Add\n"));
#line 52241 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003a)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 11 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3965 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 52280 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplyAdd_FRC11_Rc1;

    /* semantic routine */
#line 3965 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 52290 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3965 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product + *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 52343 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 52350 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplySubtract_FRC11_Rc0(cpu *processor,
                                                    instruction_word instruction,
                                                    unsigned_word cia,
                                                    idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC11_Rc0
#line 4247 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Subtract\n"));
#line 52369 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 11 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4247 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 52408 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplySubtract_FRC11_Rc0;

    /* semantic routine */
#line 4247 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 52418 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4247 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product - *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 52471 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 52478 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplySubtract_FRC11_Rc1(cpu *processor,
                                                    instruction_word instruction,
                                                    unsigned_word cia,
                                                    idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC11_Rc1
#line 4247 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Subtract\n"));
#line 52497 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 11 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4247 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 52536 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplySubtract_FRC11_Rc1;

    /* semantic routine */
#line 4247 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 52546 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4247 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product - *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 52599 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 52606 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplyAdd_FRC11_Rc0(cpu *processor,
                                               instruction_word instruction,
                                               unsigned_word cia,
                                               idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC11_Rc0
#line 4153 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Add\n"));
#line 52625 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 11 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4153 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 52664 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplyAdd_FRC11_Rc0;

    /* semantic routine */
#line 4153 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 52674 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4153 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product + *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 52727 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 52734 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplyAdd_FRC11_Rc1(cpu *processor,
                                               instruction_word instruction,
                                               unsigned_word cia,
                                               idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC11_Rc1
#line 4153 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Add\n"));
#line 52753 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 11 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4153 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 52792 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplyAdd_FRC11_Rc1;

    /* semantic routine */
#line 4153 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 52802 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4153 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product + *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 52855 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 52862 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Select_FRC12_Rc0(cpu *processor,
                                 instruction_word instruction,
                                 unsigned_word cia,
                                 idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC12_Rc0
#line 4743 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Select\n"));
#line 52881 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00002e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 12 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4743 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 52920 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Select_FRC12_Rc0;

    /* semantic routine */
#line 4743 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 52930 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Select, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4743 "../../../sim/ppc/powerpc.igen"
    {
      if (CURRENT_MODEL == MODEL_ppc601) {
        program_interrupt(processor, cia, optional_instruction_program_interrupt);
      } else {
        uint64_t zero = 0;
        FPSCR_BEGIN;
        if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
        else						    *frT = *frC;
        FPSCR_END(Rc);
        PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
      }
    }
#line 52952 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 52959 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Select_FRC12_Rc1(cpu *processor,
                                 instruction_word instruction,
                                 unsigned_word cia,
                                 idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC12_Rc1
#line 4743 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Select\n"));
#line 52978 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00002e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 12 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4743 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 53017 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Select_FRC12_Rc1;

    /* semantic routine */
#line 4743 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 53027 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Select, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4743 "../../../sim/ppc/powerpc.igen"
    {
      if (CURRENT_MODEL == MODEL_ppc601) {
        program_interrupt(processor, cia, optional_instruction_program_interrupt);
      } else {
        uint64_t zero = 0;
        FPSCR_BEGIN;
        if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
        else						    *frT = *frC;
        FPSCR_END(Rc);
        PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
      }
    }
#line 53049 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 53056 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Multiply_FRC12_Rc0(cpu *processor,
                                   instruction_word instruction,
                                   unsigned_word cia,
                                   idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC12_Rc0
#line 3847 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply\n"));
#line 53075 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00f83e) != 0xfc000032)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRC 12 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3847 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 53109 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Multiply_FRC12_Rc0;

    /* semantic routine */
#line 3847 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 53119 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Multiply, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3847 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = *(double*)frA * *(double*)frC;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
    }
#line 53151 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRC
#line 53157 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Multiply_FRC12_Rc1(cpu *processor,
                                   instruction_word instruction,
                                   unsigned_word cia,
                                   idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC12_Rc1
#line 3847 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply\n"));
#line 53176 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00f83e) != 0xfc000032)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRC 12 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3847 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 53210 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Multiply_FRC12_Rc1;

    /* semantic routine */
#line 3847 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 53220 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Multiply, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3847 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = *(double*)frA * *(double*)frC;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
    }
#line 53252 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRC
#line 53258 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplySubtract_FRC12_Rc0(cpu *processor,
                                           instruction_word instruction,
                                           unsigned_word cia,
                                           idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC12_Rc0
#line 4059 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Subtract\n"));
#line 53277 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc000038)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 12 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4059 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 53316 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplySubtract_FRC12_Rc0;

    /* semantic routine */
#line 4059 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 53326 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4059 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product - *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 53379 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 53386 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplySubtract_FRC12_Rc1(cpu *processor,
                                           instruction_word instruction,
                                           unsigned_word cia,
                                           idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC12_Rc1
#line 4059 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Subtract\n"));
#line 53405 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc000038)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 12 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4059 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 53444 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplySubtract_FRC12_Rc1;

    /* semantic routine */
#line 4059 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 53454 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4059 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product - *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 53507 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 53514 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplyAdd_FRC12_Rc0(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC12_Rc0
#line 3965 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Add\n"));
#line 53533 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003a)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 12 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3965 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 53572 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplyAdd_FRC12_Rc0;

    /* semantic routine */
#line 3965 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 53582 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3965 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product + *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 53635 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 53642 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplyAdd_FRC12_Rc1(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC12_Rc1
#line 3965 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Add\n"));
#line 53661 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003a)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 12 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3965 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 53700 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplyAdd_FRC12_Rc1;

    /* semantic routine */
#line 3965 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 53710 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3965 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product + *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 53763 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 53770 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplySubtract_FRC12_Rc0(cpu *processor,
                                                    instruction_word instruction,
                                                    unsigned_word cia,
                                                    idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC12_Rc0
#line 4247 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Subtract\n"));
#line 53789 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 12 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4247 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 53828 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplySubtract_FRC12_Rc0;

    /* semantic routine */
#line 4247 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 53838 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4247 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product - *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 53891 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 53898 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplySubtract_FRC12_Rc1(cpu *processor,
                                                    instruction_word instruction,
                                                    unsigned_word cia,
                                                    idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC12_Rc1
#line 4247 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Subtract\n"));
#line 53917 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 12 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4247 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 53956 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplySubtract_FRC12_Rc1;

    /* semantic routine */
#line 4247 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 53966 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4247 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product - *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 54019 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 54026 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplyAdd_FRC12_Rc0(cpu *processor,
                                               instruction_word instruction,
                                               unsigned_word cia,
                                               idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC12_Rc0
#line 4153 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Add\n"));
#line 54045 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 12 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4153 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 54084 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplyAdd_FRC12_Rc0;

    /* semantic routine */
#line 4153 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 54094 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4153 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product + *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 54147 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 54154 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplyAdd_FRC12_Rc1(cpu *processor,
                                               instruction_word instruction,
                                               unsigned_word cia,
                                               idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC12_Rc1
#line 4153 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Add\n"));
#line 54173 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 12 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4153 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 54212 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplyAdd_FRC12_Rc1;

    /* semantic routine */
#line 4153 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 54222 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4153 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product + *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 54275 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 54282 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Select_FRC13_Rc0(cpu *processor,
                                 instruction_word instruction,
                                 unsigned_word cia,
                                 idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC13_Rc0
#line 4743 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Select\n"));
#line 54301 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00002e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 13 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4743 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 54340 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Select_FRC13_Rc0;

    /* semantic routine */
#line 4743 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 54350 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Select, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4743 "../../../sim/ppc/powerpc.igen"
    {
      if (CURRENT_MODEL == MODEL_ppc601) {
        program_interrupt(processor, cia, optional_instruction_program_interrupt);
      } else {
        uint64_t zero = 0;
        FPSCR_BEGIN;
        if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
        else						    *frT = *frC;
        FPSCR_END(Rc);
        PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
      }
    }
#line 54372 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 54379 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Select_FRC13_Rc1(cpu *processor,
                                 instruction_word instruction,
                                 unsigned_word cia,
                                 idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC13_Rc1
#line 4743 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Select\n"));
#line 54398 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00002e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 13 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4743 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 54437 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Select_FRC13_Rc1;

    /* semantic routine */
#line 4743 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 54447 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Select, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4743 "../../../sim/ppc/powerpc.igen"
    {
      if (CURRENT_MODEL == MODEL_ppc601) {
        program_interrupt(processor, cia, optional_instruction_program_interrupt);
      } else {
        uint64_t zero = 0;
        FPSCR_BEGIN;
        if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
        else						    *frT = *frC;
        FPSCR_END(Rc);
        PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
      }
    }
#line 54469 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 54476 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Multiply_FRC13_Rc0(cpu *processor,
                                   instruction_word instruction,
                                   unsigned_word cia,
                                   idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC13_Rc0
#line 3847 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply\n"));
#line 54495 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00f83e) != 0xfc000032)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRC 13 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3847 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 54529 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Multiply_FRC13_Rc0;

    /* semantic routine */
#line 3847 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 54539 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Multiply, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3847 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = *(double*)frA * *(double*)frC;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
    }
#line 54571 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRC
#line 54577 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Multiply_FRC13_Rc1(cpu *processor,
                                   instruction_word instruction,
                                   unsigned_word cia,
                                   idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC13_Rc1
#line 3847 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply\n"));
#line 54596 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00f83e) != 0xfc000032)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRC 13 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3847 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 54630 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Multiply_FRC13_Rc1;

    /* semantic routine */
#line 3847 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 54640 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Multiply, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3847 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = *(double*)frA * *(double*)frC;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
    }
#line 54672 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRC
#line 54678 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplySubtract_FRC13_Rc0(cpu *processor,
                                           instruction_word instruction,
                                           unsigned_word cia,
                                           idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC13_Rc0
#line 4059 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Subtract\n"));
#line 54697 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc000038)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 13 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4059 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 54736 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplySubtract_FRC13_Rc0;

    /* semantic routine */
#line 4059 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 54746 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4059 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product - *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 54799 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 54806 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplySubtract_FRC13_Rc1(cpu *processor,
                                           instruction_word instruction,
                                           unsigned_word cia,
                                           idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC13_Rc1
#line 4059 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Subtract\n"));
#line 54825 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc000038)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 13 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4059 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 54864 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplySubtract_FRC13_Rc1;

    /* semantic routine */
#line 4059 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 54874 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4059 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product - *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 54927 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 54934 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplyAdd_FRC13_Rc0(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC13_Rc0
#line 3965 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Add\n"));
#line 54953 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003a)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 13 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3965 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 54992 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplyAdd_FRC13_Rc0;

    /* semantic routine */
#line 3965 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 55002 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3965 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product + *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 55055 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 55062 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplyAdd_FRC13_Rc1(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC13_Rc1
#line 3965 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Add\n"));
#line 55081 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003a)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 13 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3965 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 55120 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplyAdd_FRC13_Rc1;

    /* semantic routine */
#line 3965 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 55130 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3965 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product + *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 55183 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 55190 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplySubtract_FRC13_Rc0(cpu *processor,
                                                    instruction_word instruction,
                                                    unsigned_word cia,
                                                    idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC13_Rc0
#line 4247 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Subtract\n"));
#line 55209 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 13 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4247 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 55248 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplySubtract_FRC13_Rc0;

    /* semantic routine */
#line 4247 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 55258 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4247 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product - *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 55311 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 55318 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplySubtract_FRC13_Rc1(cpu *processor,
                                                    instruction_word instruction,
                                                    unsigned_word cia,
                                                    idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC13_Rc1
#line 4247 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Subtract\n"));
#line 55337 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 13 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4247 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 55376 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplySubtract_FRC13_Rc1;

    /* semantic routine */
#line 4247 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 55386 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4247 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product - *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 55439 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 55446 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplyAdd_FRC13_Rc0(cpu *processor,
                                               instruction_word instruction,
                                               unsigned_word cia,
                                               idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC13_Rc0
#line 4153 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Add\n"));
#line 55465 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 13 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4153 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 55504 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplyAdd_FRC13_Rc0;

    /* semantic routine */
#line 4153 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 55514 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4153 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product + *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 55567 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 55574 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplyAdd_FRC13_Rc1(cpu *processor,
                                               instruction_word instruction,
                                               unsigned_word cia,
                                               idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC13_Rc1
#line 4153 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Add\n"));
#line 55593 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 13 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4153 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 55632 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplyAdd_FRC13_Rc1;

    /* semantic routine */
#line 4153 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 55642 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4153 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product + *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 55695 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 55702 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Select_FRC14_Rc0(cpu *processor,
                                 instruction_word instruction,
                                 unsigned_word cia,
                                 idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC14_Rc0
#line 4743 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Select\n"));
#line 55721 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00002e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 14 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4743 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 55760 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Select_FRC14_Rc0;

    /* semantic routine */
#line 4743 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 55770 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Select, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4743 "../../../sim/ppc/powerpc.igen"
    {
      if (CURRENT_MODEL == MODEL_ppc601) {
        program_interrupt(processor, cia, optional_instruction_program_interrupt);
      } else {
        uint64_t zero = 0;
        FPSCR_BEGIN;
        if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
        else						    *frT = *frC;
        FPSCR_END(Rc);
        PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
      }
    }
#line 55792 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 55799 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Select_FRC14_Rc1(cpu *processor,
                                 instruction_word instruction,
                                 unsigned_word cia,
                                 idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC14_Rc1
#line 4743 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Select\n"));
#line 55818 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00002e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 14 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4743 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 55857 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Select_FRC14_Rc1;

    /* semantic routine */
#line 4743 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 55867 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Select, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4743 "../../../sim/ppc/powerpc.igen"
    {
      if (CURRENT_MODEL == MODEL_ppc601) {
        program_interrupt(processor, cia, optional_instruction_program_interrupt);
      } else {
        uint64_t zero = 0;
        FPSCR_BEGIN;
        if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
        else						    *frT = *frC;
        FPSCR_END(Rc);
        PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
      }
    }
#line 55889 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 55896 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Multiply_FRC14_Rc0(cpu *processor,
                                   instruction_word instruction,
                                   unsigned_word cia,
                                   idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC14_Rc0
#line 3847 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply\n"));
#line 55915 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00f83e) != 0xfc000032)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRC 14 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3847 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 55949 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Multiply_FRC14_Rc0;

    /* semantic routine */
#line 3847 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 55959 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Multiply, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3847 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = *(double*)frA * *(double*)frC;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
    }
#line 55991 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRC
#line 55997 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Multiply_FRC14_Rc1(cpu *processor,
                                   instruction_word instruction,
                                   unsigned_word cia,
                                   idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC14_Rc1
#line 3847 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply\n"));
#line 56016 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00f83e) != 0xfc000032)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRC 14 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3847 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 56050 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Multiply_FRC14_Rc1;

    /* semantic routine */
#line 3847 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 56060 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Multiply, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3847 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = *(double*)frA * *(double*)frC;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
    }
#line 56092 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRC
#line 56098 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplySubtract_FRC14_Rc0(cpu *processor,
                                           instruction_word instruction,
                                           unsigned_word cia,
                                           idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC14_Rc0
#line 4059 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Subtract\n"));
#line 56117 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc000038)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 14 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4059 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 56156 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplySubtract_FRC14_Rc0;

    /* semantic routine */
#line 4059 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 56166 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4059 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product - *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 56219 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 56226 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplySubtract_FRC14_Rc1(cpu *processor,
                                           instruction_word instruction,
                                           unsigned_word cia,
                                           idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC14_Rc1
#line 4059 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Subtract\n"));
#line 56245 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc000038)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 14 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4059 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 56284 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplySubtract_FRC14_Rc1;

    /* semantic routine */
#line 4059 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 56294 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4059 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product - *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 56347 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 56354 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplyAdd_FRC14_Rc0(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC14_Rc0
#line 3965 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Add\n"));
#line 56373 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003a)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 14 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3965 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 56412 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplyAdd_FRC14_Rc0;

    /* semantic routine */
#line 3965 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 56422 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3965 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product + *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 56475 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 56482 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplyAdd_FRC14_Rc1(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC14_Rc1
#line 3965 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Add\n"));
#line 56501 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003a)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 14 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3965 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 56540 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplyAdd_FRC14_Rc1;

    /* semantic routine */
#line 3965 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 56550 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3965 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product + *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 56603 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 56610 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplySubtract_FRC14_Rc0(cpu *processor,
                                                    instruction_word instruction,
                                                    unsigned_word cia,
                                                    idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC14_Rc0
#line 4247 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Subtract\n"));
#line 56629 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 14 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4247 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 56668 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplySubtract_FRC14_Rc0;

    /* semantic routine */
#line 4247 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 56678 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4247 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product - *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 56731 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 56738 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplySubtract_FRC14_Rc1(cpu *processor,
                                                    instruction_word instruction,
                                                    unsigned_word cia,
                                                    idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC14_Rc1
#line 4247 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Subtract\n"));
#line 56757 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 14 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4247 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 56796 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplySubtract_FRC14_Rc1;

    /* semantic routine */
#line 4247 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 56806 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4247 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product - *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 56859 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 56866 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplyAdd_FRC14_Rc0(cpu *processor,
                                               instruction_word instruction,
                                               unsigned_word cia,
                                               idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC14_Rc0
#line 4153 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Add\n"));
#line 56885 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 14 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4153 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 56924 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplyAdd_FRC14_Rc0;

    /* semantic routine */
#line 4153 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 56934 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4153 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product + *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 56987 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 56994 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplyAdd_FRC14_Rc1(cpu *processor,
                                               instruction_word instruction,
                                               unsigned_word cia,
                                               idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC14_Rc1
#line 4153 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Add\n"));
#line 57013 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 14 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4153 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 57052 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplyAdd_FRC14_Rc1;

    /* semantic routine */
#line 4153 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 57062 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4153 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product + *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 57115 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 57122 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Select_FRC15_Rc0(cpu *processor,
                                 instruction_word instruction,
                                 unsigned_word cia,
                                 idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC15_Rc0
#line 4743 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Select\n"));
#line 57141 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00002e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 15 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4743 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 57180 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Select_FRC15_Rc0;

    /* semantic routine */
#line 4743 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 57190 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Select, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4743 "../../../sim/ppc/powerpc.igen"
    {
      if (CURRENT_MODEL == MODEL_ppc601) {
        program_interrupt(processor, cia, optional_instruction_program_interrupt);
      } else {
        uint64_t zero = 0;
        FPSCR_BEGIN;
        if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
        else						    *frT = *frC;
        FPSCR_END(Rc);
        PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
      }
    }
#line 57212 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 57219 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Select_FRC15_Rc1(cpu *processor,
                                 instruction_word instruction,
                                 unsigned_word cia,
                                 idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC15_Rc1
#line 4743 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Select\n"));
#line 57238 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00002e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 15 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4743 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 57277 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Select_FRC15_Rc1;

    /* semantic routine */
#line 4743 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 57287 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Select, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4743 "../../../sim/ppc/powerpc.igen"
    {
      if (CURRENT_MODEL == MODEL_ppc601) {
        program_interrupt(processor, cia, optional_instruction_program_interrupt);
      } else {
        uint64_t zero = 0;
        FPSCR_BEGIN;
        if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
        else						    *frT = *frC;
        FPSCR_END(Rc);
        PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
      }
    }
#line 57309 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 57316 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Multiply_FRC15_Rc0(cpu *processor,
                                   instruction_word instruction,
                                   unsigned_word cia,
                                   idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC15_Rc0
#line 3847 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply\n"));
#line 57335 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00f83e) != 0xfc000032)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRC 15 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3847 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 57369 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Multiply_FRC15_Rc0;

    /* semantic routine */
#line 3847 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 57379 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Multiply, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3847 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = *(double*)frA * *(double*)frC;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
    }
#line 57411 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRC
#line 57417 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Multiply_FRC15_Rc1(cpu *processor,
                                   instruction_word instruction,
                                   unsigned_word cia,
                                   idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC15_Rc1
#line 3847 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply\n"));
#line 57436 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00f83e) != 0xfc000032)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRC 15 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3847 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 57470 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Multiply_FRC15_Rc1;

    /* semantic routine */
#line 3847 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 57480 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Multiply, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3847 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = *(double*)frA * *(double*)frC;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
    }
#line 57512 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRC
#line 57518 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplySubtract_FRC15_Rc0(cpu *processor,
                                           instruction_word instruction,
                                           unsigned_word cia,
                                           idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC15_Rc0
#line 4059 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Subtract\n"));
#line 57537 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc000038)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 15 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4059 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 57576 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplySubtract_FRC15_Rc0;

    /* semantic routine */
#line 4059 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 57586 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4059 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product - *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 57639 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 57646 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplySubtract_FRC15_Rc1(cpu *processor,
                                           instruction_word instruction,
                                           unsigned_word cia,
                                           idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC15_Rc1
#line 4059 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Subtract\n"));
#line 57665 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc000038)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 15 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4059 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 57704 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplySubtract_FRC15_Rc1;

    /* semantic routine */
#line 4059 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 57714 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4059 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product - *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 57767 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 57774 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplyAdd_FRC15_Rc0(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC15_Rc0
#line 3965 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Add\n"));
#line 57793 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003a)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 15 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3965 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 57832 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplyAdd_FRC15_Rc0;

    /* semantic routine */
#line 3965 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 57842 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3965 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product + *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 57895 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 57902 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplyAdd_FRC15_Rc1(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC15_Rc1
#line 3965 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Add\n"));
#line 57921 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003a)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 15 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3965 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 57960 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplyAdd_FRC15_Rc1;

    /* semantic routine */
#line 3965 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 57970 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3965 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product + *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 58023 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 58030 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplySubtract_FRC15_Rc0(cpu *processor,
                                                    instruction_word instruction,
                                                    unsigned_word cia,
                                                    idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC15_Rc0
#line 4247 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Subtract\n"));
#line 58049 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 15 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4247 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 58088 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplySubtract_FRC15_Rc0;

    /* semantic routine */
#line 4247 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 58098 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4247 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product - *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 58151 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 58158 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplySubtract_FRC15_Rc1(cpu *processor,
                                                    instruction_word instruction,
                                                    unsigned_word cia,
                                                    idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC15_Rc1
#line 4247 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Subtract\n"));
#line 58177 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 15 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4247 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 58216 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplySubtract_FRC15_Rc1;

    /* semantic routine */
#line 4247 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 58226 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4247 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product - *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 58279 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 58286 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplyAdd_FRC15_Rc0(cpu *processor,
                                               instruction_word instruction,
                                               unsigned_word cia,
                                               idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC15_Rc0
#line 4153 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Add\n"));
#line 58305 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 15 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4153 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 58344 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplyAdd_FRC15_Rc0;

    /* semantic routine */
#line 4153 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 58354 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4153 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product + *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 58407 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 58414 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplyAdd_FRC15_Rc1(cpu *processor,
                                               instruction_word instruction,
                                               unsigned_word cia,
                                               idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC15_Rc1
#line 4153 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Add\n"));
#line 58433 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 15 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4153 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 58472 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplyAdd_FRC15_Rc1;

    /* semantic routine */
#line 4153 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 58482 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4153 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product + *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 58535 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 58542 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Select_FRC16_Rc0(cpu *processor,
                                 instruction_word instruction,
                                 unsigned_word cia,
                                 idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC16_Rc0
#line 4743 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Select\n"));
#line 58561 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00002e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 16 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4743 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 58600 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Select_FRC16_Rc0;

    /* semantic routine */
#line 4743 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 58610 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Select, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4743 "../../../sim/ppc/powerpc.igen"
    {
      if (CURRENT_MODEL == MODEL_ppc601) {
        program_interrupt(processor, cia, optional_instruction_program_interrupt);
      } else {
        uint64_t zero = 0;
        FPSCR_BEGIN;
        if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
        else						    *frT = *frC;
        FPSCR_END(Rc);
        PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
      }
    }
#line 58632 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 58639 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Select_FRC16_Rc1(cpu *processor,
                                 instruction_word instruction,
                                 unsigned_word cia,
                                 idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC16_Rc1
#line 4743 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Select\n"));
#line 58658 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00002e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 16 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4743 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 58697 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Select_FRC16_Rc1;

    /* semantic routine */
#line 4743 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 58707 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Select, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4743 "../../../sim/ppc/powerpc.igen"
    {
      if (CURRENT_MODEL == MODEL_ppc601) {
        program_interrupt(processor, cia, optional_instruction_program_interrupt);
      } else {
        uint64_t zero = 0;
        FPSCR_BEGIN;
        if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
        else						    *frT = *frC;
        FPSCR_END(Rc);
        PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
      }
    }
#line 58729 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 58736 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Multiply_FRC16_Rc0(cpu *processor,
                                   instruction_word instruction,
                                   unsigned_word cia,
                                   idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC16_Rc0
#line 3847 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply\n"));
#line 58755 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00f83e) != 0xfc000032)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRC 16 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3847 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 58789 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Multiply_FRC16_Rc0;

    /* semantic routine */
#line 3847 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 58799 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Multiply, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3847 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = *(double*)frA * *(double*)frC;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
    }
#line 58831 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRC
#line 58837 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Multiply_FRC16_Rc1(cpu *processor,
                                   instruction_word instruction,
                                   unsigned_word cia,
                                   idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC16_Rc1
#line 3847 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply\n"));
#line 58856 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00f83e) != 0xfc000032)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRC 16 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3847 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 58890 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Multiply_FRC16_Rc1;

    /* semantic routine */
#line 3847 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 58900 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Multiply, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3847 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = *(double*)frA * *(double*)frC;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
    }
#line 58932 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRC
#line 58938 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplySubtract_FRC16_Rc0(cpu *processor,
                                           instruction_word instruction,
                                           unsigned_word cia,
                                           idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC16_Rc0
#line 4059 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Subtract\n"));
#line 58957 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc000038)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 16 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4059 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 58996 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplySubtract_FRC16_Rc0;

    /* semantic routine */
#line 4059 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 59006 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4059 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product - *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 59059 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 59066 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplySubtract_FRC16_Rc1(cpu *processor,
                                           instruction_word instruction,
                                           unsigned_word cia,
                                           idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC16_Rc1
#line 4059 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Subtract\n"));
#line 59085 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc000038)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 16 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4059 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 59124 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplySubtract_FRC16_Rc1;

    /* semantic routine */
#line 4059 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 59134 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4059 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product - *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 59187 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 59194 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplyAdd_FRC16_Rc0(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC16_Rc0
#line 3965 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Add\n"));
#line 59213 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003a)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 16 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3965 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 59252 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplyAdd_FRC16_Rc0;

    /* semantic routine */
#line 3965 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 59262 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3965 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product + *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 59315 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 59322 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplyAdd_FRC16_Rc1(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC16_Rc1
#line 3965 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Add\n"));
#line 59341 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003a)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 16 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3965 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 59380 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplyAdd_FRC16_Rc1;

    /* semantic routine */
#line 3965 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 59390 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3965 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product + *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 59443 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 59450 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplySubtract_FRC16_Rc0(cpu *processor,
                                                    instruction_word instruction,
                                                    unsigned_word cia,
                                                    idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC16_Rc0
#line 4247 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Subtract\n"));
#line 59469 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 16 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4247 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 59508 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplySubtract_FRC16_Rc0;

    /* semantic routine */
#line 4247 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 59518 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4247 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product - *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 59571 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 59578 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplySubtract_FRC16_Rc1(cpu *processor,
                                                    instruction_word instruction,
                                                    unsigned_word cia,
                                                    idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC16_Rc1
#line 4247 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Subtract\n"));
#line 59597 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 16 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4247 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 59636 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplySubtract_FRC16_Rc1;

    /* semantic routine */
#line 4247 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 59646 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4247 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product - *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 59699 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 59706 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplyAdd_FRC16_Rc0(cpu *processor,
                                               instruction_word instruction,
                                               unsigned_word cia,
                                               idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC16_Rc0
#line 4153 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Add\n"));
#line 59725 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 16 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4153 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 59764 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplyAdd_FRC16_Rc0;

    /* semantic routine */
#line 4153 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 59774 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4153 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product + *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 59827 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 59834 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplyAdd_FRC16_Rc1(cpu *processor,
                                               instruction_word instruction,
                                               unsigned_word cia,
                                               idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC16_Rc1
#line 4153 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Add\n"));
#line 59853 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 16 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4153 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 59892 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplyAdd_FRC16_Rc1;

    /* semantic routine */
#line 4153 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 59902 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4153 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product + *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 59955 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 59962 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Select_FRC17_Rc0(cpu *processor,
                                 instruction_word instruction,
                                 unsigned_word cia,
                                 idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC17_Rc0
#line 4743 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Select\n"));
#line 59981 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00002e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 17 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4743 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 60020 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Select_FRC17_Rc0;

    /* semantic routine */
#line 4743 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 60030 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Select, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4743 "../../../sim/ppc/powerpc.igen"
    {
      if (CURRENT_MODEL == MODEL_ppc601) {
        program_interrupt(processor, cia, optional_instruction_program_interrupt);
      } else {
        uint64_t zero = 0;
        FPSCR_BEGIN;
        if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
        else						    *frT = *frC;
        FPSCR_END(Rc);
        PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
      }
    }
#line 60052 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 60059 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Select_FRC17_Rc1(cpu *processor,
                                 instruction_word instruction,
                                 unsigned_word cia,
                                 idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC17_Rc1
#line 4743 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Select\n"));
#line 60078 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00002e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 17 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4743 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 60117 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Select_FRC17_Rc1;

    /* semantic routine */
#line 4743 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 60127 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Select, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4743 "../../../sim/ppc/powerpc.igen"
    {
      if (CURRENT_MODEL == MODEL_ppc601) {
        program_interrupt(processor, cia, optional_instruction_program_interrupt);
      } else {
        uint64_t zero = 0;
        FPSCR_BEGIN;
        if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
        else						    *frT = *frC;
        FPSCR_END(Rc);
        PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
      }
    }
#line 60149 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 60156 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Multiply_FRC17_Rc0(cpu *processor,
                                   instruction_word instruction,
                                   unsigned_word cia,
                                   idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC17_Rc0
#line 3847 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply\n"));
#line 60175 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00f83e) != 0xfc000032)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRC 17 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3847 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 60209 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Multiply_FRC17_Rc0;

    /* semantic routine */
#line 3847 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 60219 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Multiply, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3847 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = *(double*)frA * *(double*)frC;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
    }
#line 60251 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRC
#line 60257 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Multiply_FRC17_Rc1(cpu *processor,
                                   instruction_word instruction,
                                   unsigned_word cia,
                                   idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC17_Rc1
#line 3847 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply\n"));
#line 60276 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00f83e) != 0xfc000032)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRC 17 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3847 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 60310 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Multiply_FRC17_Rc1;

    /* semantic routine */
#line 3847 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 60320 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Multiply, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3847 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = *(double*)frA * *(double*)frC;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
    }
#line 60352 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRC
#line 60358 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplySubtract_FRC17_Rc0(cpu *processor,
                                           instruction_word instruction,
                                           unsigned_word cia,
                                           idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC17_Rc0
#line 4059 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Subtract\n"));
#line 60377 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc000038)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 17 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4059 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 60416 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplySubtract_FRC17_Rc0;

    /* semantic routine */
#line 4059 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 60426 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4059 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product - *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 60479 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 60486 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplySubtract_FRC17_Rc1(cpu *processor,
                                           instruction_word instruction,
                                           unsigned_word cia,
                                           idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC17_Rc1
#line 4059 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Subtract\n"));
#line 60505 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc000038)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 17 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4059 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 60544 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplySubtract_FRC17_Rc1;

    /* semantic routine */
#line 4059 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 60554 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4059 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product - *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 60607 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 60614 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplyAdd_FRC17_Rc0(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC17_Rc0
#line 3965 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Add\n"));
#line 60633 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003a)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 17 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3965 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 60672 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplyAdd_FRC17_Rc0;

    /* semantic routine */
#line 3965 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 60682 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3965 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product + *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 60735 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 60742 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplyAdd_FRC17_Rc1(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC17_Rc1
#line 3965 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Add\n"));
#line 60761 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003a)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 17 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3965 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 60800 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplyAdd_FRC17_Rc1;

    /* semantic routine */
#line 3965 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 60810 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3965 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product + *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 60863 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 60870 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplySubtract_FRC17_Rc0(cpu *processor,
                                                    instruction_word instruction,
                                                    unsigned_word cia,
                                                    idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC17_Rc0
#line 4247 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Subtract\n"));
#line 60889 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 17 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4247 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 60928 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplySubtract_FRC17_Rc0;

    /* semantic routine */
#line 4247 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 60938 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4247 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product - *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 60991 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 60998 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplySubtract_FRC17_Rc1(cpu *processor,
                                                    instruction_word instruction,
                                                    unsigned_word cia,
                                                    idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC17_Rc1
#line 4247 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Subtract\n"));
#line 61017 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 17 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4247 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 61056 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplySubtract_FRC17_Rc1;

    /* semantic routine */
#line 4247 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 61066 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4247 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product - *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 61119 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 61126 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplyAdd_FRC17_Rc0(cpu *processor,
                                               instruction_word instruction,
                                               unsigned_word cia,
                                               idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC17_Rc0
#line 4153 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Add\n"));
#line 61145 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 17 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4153 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 61184 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplyAdd_FRC17_Rc0;

    /* semantic routine */
#line 4153 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 61194 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4153 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product + *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 61247 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 61254 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplyAdd_FRC17_Rc1(cpu *processor,
                                               instruction_word instruction,
                                               unsigned_word cia,
                                               idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC17_Rc1
#line 4153 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Add\n"));
#line 61273 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 17 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4153 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 61312 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplyAdd_FRC17_Rc1;

    /* semantic routine */
#line 4153 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 61322 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4153 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product + *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 61375 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 61382 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Move_From_FPSCR_Rc0(cpu *processor,
                           instruction_word instruction,
                           unsigned_word cia,
                           idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Move_From_FPSCR
#undef MY_PREFIX
#define MY_PREFIX Move_From_FPSCR_Rc0
#line 4672 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Move From FPSCR\n"));
#line 61401 "icache.c"

  /* validate: 0.63,6.FRT,11./,16./,21.583,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc1ffffe) != 0xfc00048e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11./,16./,21.583,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.X.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#line 4672 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 61425 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Move_From_FPSCR_Rc0;

    /* semantic routine */
#line 4672 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Move From FPSCR\n"));
#line 61435 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Move_From_FPSCR, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4672 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      *frT = FPSCR;
      FPSCR_END(Rc);
    }
#line 61450 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11./,16./,21.583,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#line 61454 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Move_From_FPSCR_Rc1(cpu *processor,
                           instruction_word instruction,
                           unsigned_word cia,
                           idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Move_From_FPSCR
#undef MY_PREFIX
#define MY_PREFIX Move_From_FPSCR_Rc1
#line 4672 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Move From FPSCR\n"));
#line 61473 "icache.c"

  /* validate: 0.63,6.FRT,11./,16./,21.583,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc1ffffe) != 0xfc00048e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11./,16./,21.583,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.X.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.X.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#line 4672 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 61497 "icache.c"

#define insn cache_entry->crack.X.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Move_From_FPSCR_Rc1;

    /* semantic routine */
#line 4672 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Move From FPSCR\n"));
#line 61507 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Move_From_FPSCR, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4672 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      *frT = FPSCR;
      FPSCR_END(Rc);
    }
#line 61522 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11./,16./,21.583,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#line 61526 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Select_FRC18_Rc0(cpu *processor,
                                 instruction_word instruction,
                                 unsigned_word cia,
                                 idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC18_Rc0
#line 4743 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Select\n"));
#line 61545 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00002e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 18 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4743 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 61584 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Select_FRC18_Rc0;

    /* semantic routine */
#line 4743 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 61594 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Select, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4743 "../../../sim/ppc/powerpc.igen"
    {
      if (CURRENT_MODEL == MODEL_ppc601) {
        program_interrupt(processor, cia, optional_instruction_program_interrupt);
      } else {
        uint64_t zero = 0;
        FPSCR_BEGIN;
        if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
        else						    *frT = *frC;
        FPSCR_END(Rc);
        PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
      }
    }
#line 61616 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 61623 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Select_FRC18_Rc1(cpu *processor,
                                 instruction_word instruction,
                                 unsigned_word cia,
                                 idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC18_Rc1
#line 4743 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Select\n"));
#line 61642 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00002e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 18 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4743 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 61681 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Select_FRC18_Rc1;

    /* semantic routine */
#line 4743 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 61691 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Select, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4743 "../../../sim/ppc/powerpc.igen"
    {
      if (CURRENT_MODEL == MODEL_ppc601) {
        program_interrupt(processor, cia, optional_instruction_program_interrupt);
      } else {
        uint64_t zero = 0;
        FPSCR_BEGIN;
        if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
        else						    *frT = *frC;
        FPSCR_END(Rc);
        PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
      }
    }
#line 61713 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 61720 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Multiply_FRC18_Rc0(cpu *processor,
                                   instruction_word instruction,
                                   unsigned_word cia,
                                   idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC18_Rc0
#line 3847 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply\n"));
#line 61739 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00f83e) != 0xfc000032)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRC 18 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3847 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 61773 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Multiply_FRC18_Rc0;

    /* semantic routine */
#line 3847 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 61783 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Multiply, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3847 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = *(double*)frA * *(double*)frC;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
    }
#line 61815 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRC
#line 61821 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Multiply_FRC18_Rc1(cpu *processor,
                                   instruction_word instruction,
                                   unsigned_word cia,
                                   idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC18_Rc1
#line 3847 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply\n"));
#line 61840 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00f83e) != 0xfc000032)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRC 18 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3847 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 61874 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Multiply_FRC18_Rc1;

    /* semantic routine */
#line 3847 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 61884 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Multiply, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3847 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = *(double*)frA * *(double*)frC;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
    }
#line 61916 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRC
#line 61922 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplySubtract_FRC18_Rc0(cpu *processor,
                                           instruction_word instruction,
                                           unsigned_word cia,
                                           idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC18_Rc0
#line 4059 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Subtract\n"));
#line 61941 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc000038)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 18 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4059 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 61980 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplySubtract_FRC18_Rc0;

    /* semantic routine */
#line 4059 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 61990 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4059 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product - *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 62043 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 62050 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplySubtract_FRC18_Rc1(cpu *processor,
                                           instruction_word instruction,
                                           unsigned_word cia,
                                           idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC18_Rc1
#line 4059 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Subtract\n"));
#line 62069 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc000038)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 18 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4059 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 62108 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplySubtract_FRC18_Rc1;

    /* semantic routine */
#line 4059 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 62118 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4059 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product - *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 62171 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 62178 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplyAdd_FRC18_Rc0(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC18_Rc0
#line 3965 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Add\n"));
#line 62197 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003a)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 18 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3965 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 62236 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplyAdd_FRC18_Rc0;

    /* semantic routine */
#line 3965 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 62246 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3965 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product + *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 62299 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 62306 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplyAdd_FRC18_Rc1(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC18_Rc1
#line 3965 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Add\n"));
#line 62325 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003a)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 18 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3965 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 62364 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplyAdd_FRC18_Rc1;

    /* semantic routine */
#line 3965 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 62374 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3965 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product + *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 62427 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 62434 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplySubtract_FRC18_Rc0(cpu *processor,
                                                    instruction_word instruction,
                                                    unsigned_word cia,
                                                    idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC18_Rc0
#line 4247 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Subtract\n"));
#line 62453 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 18 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4247 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 62492 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplySubtract_FRC18_Rc0;

    /* semantic routine */
#line 4247 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 62502 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4247 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product - *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 62555 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 62562 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplySubtract_FRC18_Rc1(cpu *processor,
                                                    instruction_word instruction,
                                                    unsigned_word cia,
                                                    idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC18_Rc1
#line 4247 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Subtract\n"));
#line 62581 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 18 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4247 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 62620 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplySubtract_FRC18_Rc1;

    /* semantic routine */
#line 4247 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 62630 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4247 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product - *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 62683 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 62690 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplyAdd_FRC18_Rc0(cpu *processor,
                                               instruction_word instruction,
                                               unsigned_word cia,
                                               idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC18_Rc0
#line 4153 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Add\n"));
#line 62709 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 18 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4153 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 62748 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplyAdd_FRC18_Rc0;

    /* semantic routine */
#line 4153 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 62758 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4153 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product + *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 62811 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 62818 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplyAdd_FRC18_Rc1(cpu *processor,
                                               instruction_word instruction,
                                               unsigned_word cia,
                                               idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC18_Rc1
#line 4153 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Add\n"));
#line 62837 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 18 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4153 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 62876 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplyAdd_FRC18_Rc1;

    /* semantic routine */
#line 4153 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 62886 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4153 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product + *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 62939 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 62946 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Select_FRC19_Rc0(cpu *processor,
                                 instruction_word instruction,
                                 unsigned_word cia,
                                 idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC19_Rc0
#line 4743 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Select\n"));
#line 62965 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00002e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 19 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4743 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 63004 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Select_FRC19_Rc0;

    /* semantic routine */
#line 4743 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 63014 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Select, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4743 "../../../sim/ppc/powerpc.igen"
    {
      if (CURRENT_MODEL == MODEL_ppc601) {
        program_interrupt(processor, cia, optional_instruction_program_interrupt);
      } else {
        uint64_t zero = 0;
        FPSCR_BEGIN;
        if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
        else						    *frT = *frC;
        FPSCR_END(Rc);
        PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
      }
    }
#line 63036 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 63043 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Select_FRC19_Rc1(cpu *processor,
                                 instruction_word instruction,
                                 unsigned_word cia,
                                 idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC19_Rc1
#line 4743 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Select\n"));
#line 63062 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00002e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 19 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4743 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 63101 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Select_FRC19_Rc1;

    /* semantic routine */
#line 4743 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 63111 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Select, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4743 "../../../sim/ppc/powerpc.igen"
    {
      if (CURRENT_MODEL == MODEL_ppc601) {
        program_interrupt(processor, cia, optional_instruction_program_interrupt);
      } else {
        uint64_t zero = 0;
        FPSCR_BEGIN;
        if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
        else						    *frT = *frC;
        FPSCR_END(Rc);
        PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
      }
    }
#line 63133 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 63140 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Multiply_FRC19_Rc0(cpu *processor,
                                   instruction_word instruction,
                                   unsigned_word cia,
                                   idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC19_Rc0
#line 3847 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply\n"));
#line 63159 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00f83e) != 0xfc000032)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRC 19 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3847 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 63193 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Multiply_FRC19_Rc0;

    /* semantic routine */
#line 3847 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 63203 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Multiply, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3847 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = *(double*)frA * *(double*)frC;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
    }
#line 63235 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRC
#line 63241 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Multiply_FRC19_Rc1(cpu *processor,
                                   instruction_word instruction,
                                   unsigned_word cia,
                                   idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC19_Rc1
#line 3847 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply\n"));
#line 63260 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00f83e) != 0xfc000032)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRC 19 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3847 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 63294 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Multiply_FRC19_Rc1;

    /* semantic routine */
#line 3847 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 63304 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Multiply, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3847 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = *(double*)frA * *(double*)frC;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
    }
#line 63336 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRC
#line 63342 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplySubtract_FRC19_Rc0(cpu *processor,
                                           instruction_word instruction,
                                           unsigned_word cia,
                                           idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC19_Rc0
#line 4059 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Subtract\n"));
#line 63361 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc000038)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 19 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4059 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 63400 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplySubtract_FRC19_Rc0;

    /* semantic routine */
#line 4059 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 63410 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4059 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product - *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 63463 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 63470 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplySubtract_FRC19_Rc1(cpu *processor,
                                           instruction_word instruction,
                                           unsigned_word cia,
                                           idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC19_Rc1
#line 4059 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Subtract\n"));
#line 63489 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc000038)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 19 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4059 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 63528 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplySubtract_FRC19_Rc1;

    /* semantic routine */
#line 4059 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 63538 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4059 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product - *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 63591 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 63598 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplyAdd_FRC19_Rc0(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC19_Rc0
#line 3965 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Add\n"));
#line 63617 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003a)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 19 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3965 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 63656 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplyAdd_FRC19_Rc0;

    /* semantic routine */
#line 3965 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 63666 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3965 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product + *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 63719 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 63726 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplyAdd_FRC19_Rc1(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC19_Rc1
#line 3965 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Add\n"));
#line 63745 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003a)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 19 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3965 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 63784 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplyAdd_FRC19_Rc1;

    /* semantic routine */
#line 3965 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 63794 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3965 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product + *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 63847 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 63854 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplySubtract_FRC19_Rc0(cpu *processor,
                                                    instruction_word instruction,
                                                    unsigned_word cia,
                                                    idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC19_Rc0
#line 4247 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Subtract\n"));
#line 63873 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 19 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4247 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 63912 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplySubtract_FRC19_Rc0;

    /* semantic routine */
#line 4247 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 63922 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4247 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product - *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 63975 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 63982 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplySubtract_FRC19_Rc1(cpu *processor,
                                                    instruction_word instruction,
                                                    unsigned_word cia,
                                                    idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC19_Rc1
#line 4247 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Subtract\n"));
#line 64001 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 19 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4247 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 64040 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplySubtract_FRC19_Rc1;

    /* semantic routine */
#line 4247 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 64050 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4247 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product - *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 64103 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 64110 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplyAdd_FRC19_Rc0(cpu *processor,
                                               instruction_word instruction,
                                               unsigned_word cia,
                                               idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC19_Rc0
#line 4153 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Add\n"));
#line 64129 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 19 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4153 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 64168 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplyAdd_FRC19_Rc0;

    /* semantic routine */
#line 4153 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 64178 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4153 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product + *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 64231 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 64238 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplyAdd_FRC19_Rc1(cpu *processor,
                                               instruction_word instruction,
                                               unsigned_word cia,
                                               idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC19_Rc1
#line 4153 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Add\n"));
#line 64257 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 19 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4153 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 64296 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplyAdd_FRC19_Rc1;

    /* semantic routine */
#line 4153 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 64306 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4153 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product + *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 64359 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 64366 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Select_FRC20_Rc0(cpu *processor,
                                 instruction_word instruction,
                                 unsigned_word cia,
                                 idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC20_Rc0
#line 4743 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Select\n"));
#line 64385 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00002e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 20 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4743 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 64424 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Select_FRC20_Rc0;

    /* semantic routine */
#line 4743 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 64434 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Select, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4743 "../../../sim/ppc/powerpc.igen"
    {
      if (CURRENT_MODEL == MODEL_ppc601) {
        program_interrupt(processor, cia, optional_instruction_program_interrupt);
      } else {
        uint64_t zero = 0;
        FPSCR_BEGIN;
        if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
        else						    *frT = *frC;
        FPSCR_END(Rc);
        PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
      }
    }
#line 64456 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 64463 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Select_FRC20_Rc1(cpu *processor,
                                 instruction_word instruction,
                                 unsigned_word cia,
                                 idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC20_Rc1
#line 4743 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Select\n"));
#line 64482 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00002e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 20 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4743 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 64521 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Select_FRC20_Rc1;

    /* semantic routine */
#line 4743 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 64531 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Select, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4743 "../../../sim/ppc/powerpc.igen"
    {
      if (CURRENT_MODEL == MODEL_ppc601) {
        program_interrupt(processor, cia, optional_instruction_program_interrupt);
      } else {
        uint64_t zero = 0;
        FPSCR_BEGIN;
        if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
        else						    *frT = *frC;
        FPSCR_END(Rc);
        PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
      }
    }
#line 64553 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 64560 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Multiply_FRC20_Rc0(cpu *processor,
                                   instruction_word instruction,
                                   unsigned_word cia,
                                   idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC20_Rc0
#line 3847 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply\n"));
#line 64579 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00f83e) != 0xfc000032)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRC 20 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3847 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 64613 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Multiply_FRC20_Rc0;

    /* semantic routine */
#line 3847 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 64623 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Multiply, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3847 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = *(double*)frA * *(double*)frC;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
    }
#line 64655 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRC
#line 64661 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Multiply_FRC20_Rc1(cpu *processor,
                                   instruction_word instruction,
                                   unsigned_word cia,
                                   idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC20_Rc1
#line 3847 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply\n"));
#line 64680 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00f83e) != 0xfc000032)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRC 20 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3847 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 64714 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Multiply_FRC20_Rc1;

    /* semantic routine */
#line 3847 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 64724 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Multiply, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3847 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = *(double*)frA * *(double*)frC;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
    }
#line 64756 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRC
#line 64762 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplySubtract_FRC20_Rc0(cpu *processor,
                                           instruction_word instruction,
                                           unsigned_word cia,
                                           idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC20_Rc0
#line 4059 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Subtract\n"));
#line 64781 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc000038)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 20 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4059 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 64820 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplySubtract_FRC20_Rc0;

    /* semantic routine */
#line 4059 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 64830 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4059 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product - *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 64883 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 64890 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplySubtract_FRC20_Rc1(cpu *processor,
                                           instruction_word instruction,
                                           unsigned_word cia,
                                           idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC20_Rc1
#line 4059 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Subtract\n"));
#line 64909 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc000038)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 20 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4059 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 64948 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplySubtract_FRC20_Rc1;

    /* semantic routine */
#line 4059 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 64958 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4059 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product - *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 65011 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 65018 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplyAdd_FRC20_Rc0(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC20_Rc0
#line 3965 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Add\n"));
#line 65037 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003a)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 20 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3965 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 65076 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplyAdd_FRC20_Rc0;

    /* semantic routine */
#line 3965 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 65086 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3965 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product + *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 65139 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 65146 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplyAdd_FRC20_Rc1(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC20_Rc1
#line 3965 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Add\n"));
#line 65165 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003a)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 20 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3965 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 65204 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplyAdd_FRC20_Rc1;

    /* semantic routine */
#line 3965 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 65214 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3965 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product + *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 65267 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 65274 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplySubtract_FRC20_Rc0(cpu *processor,
                                                    instruction_word instruction,
                                                    unsigned_word cia,
                                                    idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC20_Rc0
#line 4247 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Subtract\n"));
#line 65293 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 20 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4247 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 65332 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplySubtract_FRC20_Rc0;

    /* semantic routine */
#line 4247 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 65342 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4247 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product - *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 65395 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 65402 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplySubtract_FRC20_Rc1(cpu *processor,
                                                    instruction_word instruction,
                                                    unsigned_word cia,
                                                    idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC20_Rc1
#line 4247 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Subtract\n"));
#line 65421 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 20 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4247 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 65460 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplySubtract_FRC20_Rc1;

    /* semantic routine */
#line 4247 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 65470 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4247 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product - *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 65523 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 65530 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplyAdd_FRC20_Rc0(cpu *processor,
                                               instruction_word instruction,
                                               unsigned_word cia,
                                               idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC20_Rc0
#line 4153 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Add\n"));
#line 65549 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 20 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4153 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 65588 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplyAdd_FRC20_Rc0;

    /* semantic routine */
#line 4153 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 65598 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4153 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product + *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 65651 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 65658 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplyAdd_FRC20_Rc1(cpu *processor,
                                               instruction_word instruction,
                                               unsigned_word cia,
                                               idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC20_Rc1
#line 4153 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Add\n"));
#line 65677 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 20 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4153 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 65716 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplyAdd_FRC20_Rc1;

    /* semantic routine */
#line 4153 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 65726 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4153 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product + *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 65779 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 65786 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Select_FRC21_Rc0(cpu *processor,
                                 instruction_word instruction,
                                 unsigned_word cia,
                                 idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC21_Rc0
#line 4743 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Select\n"));
#line 65805 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00002e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 21 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4743 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 65844 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Select_FRC21_Rc0;

    /* semantic routine */
#line 4743 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 65854 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Select, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4743 "../../../sim/ppc/powerpc.igen"
    {
      if (CURRENT_MODEL == MODEL_ppc601) {
        program_interrupt(processor, cia, optional_instruction_program_interrupt);
      } else {
        uint64_t zero = 0;
        FPSCR_BEGIN;
        if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
        else						    *frT = *frC;
        FPSCR_END(Rc);
        PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
      }
    }
#line 65876 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 65883 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Select_FRC21_Rc1(cpu *processor,
                                 instruction_word instruction,
                                 unsigned_word cia,
                                 idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC21_Rc1
#line 4743 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Select\n"));
#line 65902 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00002e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 21 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4743 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 65941 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Select_FRC21_Rc1;

    /* semantic routine */
#line 4743 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 65951 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Select, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4743 "../../../sim/ppc/powerpc.igen"
    {
      if (CURRENT_MODEL == MODEL_ppc601) {
        program_interrupt(processor, cia, optional_instruction_program_interrupt);
      } else {
        uint64_t zero = 0;
        FPSCR_BEGIN;
        if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
        else						    *frT = *frC;
        FPSCR_END(Rc);
        PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
      }
    }
#line 65973 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 65980 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Multiply_FRC21_Rc0(cpu *processor,
                                   instruction_word instruction,
                                   unsigned_word cia,
                                   idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC21_Rc0
#line 3847 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply\n"));
#line 65999 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00f83e) != 0xfc000032)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRC 21 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3847 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 66033 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Multiply_FRC21_Rc0;

    /* semantic routine */
#line 3847 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 66043 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Multiply, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3847 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = *(double*)frA * *(double*)frC;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
    }
#line 66075 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRC
#line 66081 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Multiply_FRC21_Rc1(cpu *processor,
                                   instruction_word instruction,
                                   unsigned_word cia,
                                   idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC21_Rc1
#line 3847 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply\n"));
#line 66100 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00f83e) != 0xfc000032)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRC 21 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3847 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 66134 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Multiply_FRC21_Rc1;

    /* semantic routine */
#line 3847 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 66144 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Multiply, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3847 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = *(double*)frA * *(double*)frC;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
    }
#line 66176 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRC
#line 66182 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplySubtract_FRC21_Rc0(cpu *processor,
                                           instruction_word instruction,
                                           unsigned_word cia,
                                           idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC21_Rc0
#line 4059 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Subtract\n"));
#line 66201 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc000038)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 21 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4059 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 66240 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplySubtract_FRC21_Rc0;

    /* semantic routine */
#line 4059 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 66250 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4059 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product - *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 66303 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 66310 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplySubtract_FRC21_Rc1(cpu *processor,
                                           instruction_word instruction,
                                           unsigned_word cia,
                                           idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC21_Rc1
#line 4059 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Subtract\n"));
#line 66329 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc000038)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 21 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4059 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 66368 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplySubtract_FRC21_Rc1;

    /* semantic routine */
#line 4059 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 66378 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4059 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product - *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 66431 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 66438 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplyAdd_FRC21_Rc0(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC21_Rc0
#line 3965 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Add\n"));
#line 66457 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003a)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 21 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3965 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 66496 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplyAdd_FRC21_Rc0;

    /* semantic routine */
#line 3965 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 66506 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3965 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product + *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 66559 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 66566 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplyAdd_FRC21_Rc1(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC21_Rc1
#line 3965 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Add\n"));
#line 66585 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003a)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 21 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3965 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 66624 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplyAdd_FRC21_Rc1;

    /* semantic routine */
#line 3965 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 66634 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3965 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product + *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 66687 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 66694 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplySubtract_FRC21_Rc0(cpu *processor,
                                                    instruction_word instruction,
                                                    unsigned_word cia,
                                                    idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC21_Rc0
#line 4247 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Subtract\n"));
#line 66713 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 21 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4247 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 66752 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplySubtract_FRC21_Rc0;

    /* semantic routine */
#line 4247 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 66762 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4247 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product - *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 66815 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 66822 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplySubtract_FRC21_Rc1(cpu *processor,
                                                    instruction_word instruction,
                                                    unsigned_word cia,
                                                    idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC21_Rc1
#line 4247 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Subtract\n"));
#line 66841 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 21 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4247 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 66880 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplySubtract_FRC21_Rc1;

    /* semantic routine */
#line 4247 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 66890 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4247 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product - *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 66943 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 66950 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplyAdd_FRC21_Rc0(cpu *processor,
                                               instruction_word instruction,
                                               unsigned_word cia,
                                               idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC21_Rc0
#line 4153 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Add\n"));
#line 66969 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 21 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4153 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 67008 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplyAdd_FRC21_Rc0;

    /* semantic routine */
#line 4153 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 67018 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4153 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product + *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 67071 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 67078 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplyAdd_FRC21_Rc1(cpu *processor,
                                               instruction_word instruction,
                                               unsigned_word cia,
                                               idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC21_Rc1
#line 4153 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Add\n"));
#line 67097 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 21 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4153 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 67136 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplyAdd_FRC21_Rc1;

    /* semantic routine */
#line 4153 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 67146 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4153 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product + *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 67199 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 67206 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Move_To_FPSCR_Fields_Rc0(cpu *processor,
                                instruction_word instruction,
                                unsigned_word cia,
                                idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Move_To_FPSCR_Fields
#undef MY_PREFIX
#define MY_PREFIX Move_To_FPSCR_Fields_Rc0
#line 4689 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Move To FPSCR Fields\n"));
#line 67225 "icache.c"

  /* validate: 0.63,6./,7.FLM,15./,16.FRB,21.711,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfe0107fe) != 0xfc00058e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6./,7.FLM,15./,16.FRB,21.711,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 4689 "../../../sim/ppc/powerpc.igen"
    unsigned const FLM ATTRIBUTE_UNUSED = cache_entry->crack.XFL.FLM = EXTRACTED32(instruction, 7, 14); /* default in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.XFL.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XFL.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#line 4689 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 67251 "icache.c"

#define insn cache_entry->crack.XFL.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Move_To_FPSCR_Fields_Rc0;

    /* semantic routine */
#line 4689 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Move To FPSCR Fields\n"));
#line 67261 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Move_To_FPSCR_Fields, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4689 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      int i;
      for (i = 0; i < 8; i++) {
        if ((FLM & BIT8(i))) {
          FPSCR &= ~MASK32(i*4, i*4+3);
          FPSCR |= MASKED32(*frB, i*4, i*4+3);
        }
      }
      FPSCR_END(Rc);
    }
#line 67282 "icache.c"
    return nia;
    /* extraction: 0.63,6./,7.FLM,15./,16.FRB,21.711,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRB
#line 67286 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Move_To_FPSCR_Fields_Rc1(cpu *processor,
                                instruction_word instruction,
                                unsigned_word cia,
                                idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Move_To_FPSCR_Fields
#undef MY_PREFIX
#define MY_PREFIX Move_To_FPSCR_Fields_Rc1
#line 4689 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Move To FPSCR Fields\n"));
#line 67305 "icache.c"

  /* validate: 0.63,6./,7.FLM,15./,16.FRB,21.711,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfe0107fe) != 0xfc00058e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6./,7.FLM,15./,16.FRB,21.711,31.Rc #define get-values-from-icache|put-values-in-icache */
#line 4689 "../../../sim/ppc/powerpc.igen"
    unsigned const FLM ATTRIBUTE_UNUSED = cache_entry->crack.XFL.FLM = EXTRACTED32(instruction, 7, 14); /* default in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.XFL.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.XFL.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#line 4689 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 67331 "icache.c"

#define insn cache_entry->crack.XFL.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Move_To_FPSCR_Fields_Rc1;

    /* semantic routine */
#line 4689 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Move To FPSCR Fields\n"));
#line 67341 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Move_To_FPSCR_Fields, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4689 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      int i;
      for (i = 0; i < 8; i++) {
        if ((FLM & BIT8(i))) {
          FPSCR &= ~MASK32(i*4, i*4+3);
          FPSCR |= MASKED32(*frB, i*4, i*4+3);
        }
      }
      FPSCR_END(Rc);
    }
#line 67362 "icache.c"
    return nia;
    /* extraction: 0.63,6./,7.FLM,15./,16.FRB,21.711,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRB
#line 67366 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Select_FRC22_Rc0(cpu *processor,
                                 instruction_word instruction,
                                 unsigned_word cia,
                                 idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC22_Rc0
#line 4743 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Select\n"));
#line 67385 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00002e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 22 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4743 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 67424 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Select_FRC22_Rc0;

    /* semantic routine */
#line 4743 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 67434 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Select, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4743 "../../../sim/ppc/powerpc.igen"
    {
      if (CURRENT_MODEL == MODEL_ppc601) {
        program_interrupt(processor, cia, optional_instruction_program_interrupt);
      } else {
        uint64_t zero = 0;
        FPSCR_BEGIN;
        if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
        else						    *frT = *frC;
        FPSCR_END(Rc);
        PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
      }
    }
#line 67456 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 67463 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Select_FRC22_Rc1(cpu *processor,
                                 instruction_word instruction,
                                 unsigned_word cia,
                                 idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC22_Rc1
#line 4743 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Select\n"));
#line 67482 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00002e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 22 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4743 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 67521 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Select_FRC22_Rc1;

    /* semantic routine */
#line 4743 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 67531 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Select, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4743 "../../../sim/ppc/powerpc.igen"
    {
      if (CURRENT_MODEL == MODEL_ppc601) {
        program_interrupt(processor, cia, optional_instruction_program_interrupt);
      } else {
        uint64_t zero = 0;
        FPSCR_BEGIN;
        if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
        else						    *frT = *frC;
        FPSCR_END(Rc);
        PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
      }
    }
#line 67553 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 67560 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Multiply_FRC22_Rc0(cpu *processor,
                                   instruction_word instruction,
                                   unsigned_word cia,
                                   idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC22_Rc0
#line 3847 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply\n"));
#line 67579 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00f83e) != 0xfc000032)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRC 22 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3847 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 67613 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Multiply_FRC22_Rc0;

    /* semantic routine */
#line 3847 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 67623 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Multiply, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3847 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = *(double*)frA * *(double*)frC;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
    }
#line 67655 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRC
#line 67661 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Multiply_FRC22_Rc1(cpu *processor,
                                   instruction_word instruction,
                                   unsigned_word cia,
                                   idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC22_Rc1
#line 3847 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply\n"));
#line 67680 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00f83e) != 0xfc000032)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRC 22 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3847 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 67714 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Multiply_FRC22_Rc1;

    /* semantic routine */
#line 3847 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 67724 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Multiply, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3847 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = *(double*)frA * *(double*)frC;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
    }
#line 67756 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRC
#line 67762 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplySubtract_FRC22_Rc0(cpu *processor,
                                           instruction_word instruction,
                                           unsigned_word cia,
                                           idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC22_Rc0
#line 4059 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Subtract\n"));
#line 67781 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc000038)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 22 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4059 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 67820 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplySubtract_FRC22_Rc0;

    /* semantic routine */
#line 4059 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 67830 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4059 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product - *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 67883 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 67890 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplySubtract_FRC22_Rc1(cpu *processor,
                                           instruction_word instruction,
                                           unsigned_word cia,
                                           idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC22_Rc1
#line 4059 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Subtract\n"));
#line 67909 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc000038)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 22 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4059 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 67948 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplySubtract_FRC22_Rc1;

    /* semantic routine */
#line 4059 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 67958 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4059 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product - *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 68011 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 68018 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplyAdd_FRC22_Rc0(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC22_Rc0
#line 3965 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Add\n"));
#line 68037 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003a)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 22 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3965 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 68076 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplyAdd_FRC22_Rc0;

    /* semantic routine */
#line 3965 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 68086 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3965 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product + *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 68139 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 68146 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplyAdd_FRC22_Rc1(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC22_Rc1
#line 3965 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Add\n"));
#line 68165 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003a)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 22 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3965 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 68204 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplyAdd_FRC22_Rc1;

    /* semantic routine */
#line 3965 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 68214 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3965 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product + *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 68267 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 68274 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplySubtract_FRC22_Rc0(cpu *processor,
                                                    instruction_word instruction,
                                                    unsigned_word cia,
                                                    idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC22_Rc0
#line 4247 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Subtract\n"));
#line 68293 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 22 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4247 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 68332 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplySubtract_FRC22_Rc0;

    /* semantic routine */
#line 4247 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 68342 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4247 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product - *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 68395 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 68402 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplySubtract_FRC22_Rc1(cpu *processor,
                                                    instruction_word instruction,
                                                    unsigned_word cia,
                                                    idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC22_Rc1
#line 4247 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Subtract\n"));
#line 68421 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 22 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4247 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 68460 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplySubtract_FRC22_Rc1;

    /* semantic routine */
#line 4247 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 68470 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4247 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product - *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 68523 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 68530 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplyAdd_FRC22_Rc0(cpu *processor,
                                               instruction_word instruction,
                                               unsigned_word cia,
                                               idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC22_Rc0
#line 4153 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Add\n"));
#line 68549 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 22 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4153 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 68588 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplyAdd_FRC22_Rc0;

    /* semantic routine */
#line 4153 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 68598 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4153 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product + *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 68651 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 68658 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplyAdd_FRC22_Rc1(cpu *processor,
                                               instruction_word instruction,
                                               unsigned_word cia,
                                               idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC22_Rc1
#line 4153 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Add\n"));
#line 68677 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 22 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4153 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 68716 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplyAdd_FRC22_Rc1;

    /* semantic routine */
#line 4153 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 68726 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4153 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product + *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 68779 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 68786 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Select_FRC23_Rc0(cpu *processor,
                                 instruction_word instruction,
                                 unsigned_word cia,
                                 idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC23_Rc0
#line 4743 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Select\n"));
#line 68805 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00002e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 23 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4743 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 68844 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Select_FRC23_Rc0;

    /* semantic routine */
#line 4743 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 68854 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Select, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4743 "../../../sim/ppc/powerpc.igen"
    {
      if (CURRENT_MODEL == MODEL_ppc601) {
        program_interrupt(processor, cia, optional_instruction_program_interrupt);
      } else {
        uint64_t zero = 0;
        FPSCR_BEGIN;
        if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
        else						    *frT = *frC;
        FPSCR_END(Rc);
        PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
      }
    }
#line 68876 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 68883 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Select_FRC23_Rc1(cpu *processor,
                                 instruction_word instruction,
                                 unsigned_word cia,
                                 idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC23_Rc1
#line 4743 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Select\n"));
#line 68902 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00002e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 23 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4743 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 68941 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Select_FRC23_Rc1;

    /* semantic routine */
#line 4743 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 68951 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Select, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4743 "../../../sim/ppc/powerpc.igen"
    {
      if (CURRENT_MODEL == MODEL_ppc601) {
        program_interrupt(processor, cia, optional_instruction_program_interrupt);
      } else {
        uint64_t zero = 0;
        FPSCR_BEGIN;
        if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
        else						    *frT = *frC;
        FPSCR_END(Rc);
        PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
      }
    }
#line 68973 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 68980 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Multiply_FRC23_Rc0(cpu *processor,
                                   instruction_word instruction,
                                   unsigned_word cia,
                                   idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC23_Rc0
#line 3847 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply\n"));
#line 68999 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00f83e) != 0xfc000032)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRC 23 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3847 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 69033 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Multiply_FRC23_Rc0;

    /* semantic routine */
#line 3847 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 69043 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Multiply, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3847 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = *(double*)frA * *(double*)frC;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
    }
#line 69075 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRC
#line 69081 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Multiply_FRC23_Rc1(cpu *processor,
                                   instruction_word instruction,
                                   unsigned_word cia,
                                   idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC23_Rc1
#line 3847 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply\n"));
#line 69100 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00f83e) != 0xfc000032)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRC 23 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3847 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 69134 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Multiply_FRC23_Rc1;

    /* semantic routine */
#line 3847 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 69144 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Multiply, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3847 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = *(double*)frA * *(double*)frC;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
    }
#line 69176 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRC
#line 69182 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplySubtract_FRC23_Rc0(cpu *processor,
                                           instruction_word instruction,
                                           unsigned_word cia,
                                           idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC23_Rc0
#line 4059 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Subtract\n"));
#line 69201 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc000038)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 23 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4059 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 69240 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplySubtract_FRC23_Rc0;

    /* semantic routine */
#line 4059 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 69250 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4059 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product - *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 69303 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 69310 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplySubtract_FRC23_Rc1(cpu *processor,
                                           instruction_word instruction,
                                           unsigned_word cia,
                                           idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC23_Rc1
#line 4059 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Subtract\n"));
#line 69329 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc000038)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 23 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4059 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 69368 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplySubtract_FRC23_Rc1;

    /* semantic routine */
#line 4059 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 69378 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4059 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product - *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 69431 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 69438 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplyAdd_FRC23_Rc0(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC23_Rc0
#line 3965 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Add\n"));
#line 69457 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003a)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 23 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3965 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 69496 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplyAdd_FRC23_Rc0;

    /* semantic routine */
#line 3965 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 69506 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3965 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product + *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 69559 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 69566 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplyAdd_FRC23_Rc1(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC23_Rc1
#line 3965 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Add\n"));
#line 69585 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003a)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 23 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3965 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 69624 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplyAdd_FRC23_Rc1;

    /* semantic routine */
#line 3965 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 69634 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3965 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product + *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 69687 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 69694 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplySubtract_FRC23_Rc0(cpu *processor,
                                                    instruction_word instruction,
                                                    unsigned_word cia,
                                                    idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC23_Rc0
#line 4247 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Subtract\n"));
#line 69713 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 23 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4247 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 69752 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplySubtract_FRC23_Rc0;

    /* semantic routine */
#line 4247 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 69762 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4247 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product - *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 69815 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 69822 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplySubtract_FRC23_Rc1(cpu *processor,
                                                    instruction_word instruction,
                                                    unsigned_word cia,
                                                    idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC23_Rc1
#line 4247 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Subtract\n"));
#line 69841 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 23 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4247 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 69880 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplySubtract_FRC23_Rc1;

    /* semantic routine */
#line 4247 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 69890 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4247 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product - *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 69943 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 69950 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplyAdd_FRC23_Rc0(cpu *processor,
                                               instruction_word instruction,
                                               unsigned_word cia,
                                               idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC23_Rc0
#line 4153 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Add\n"));
#line 69969 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 23 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4153 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 70008 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplyAdd_FRC23_Rc0;

    /* semantic routine */
#line 4153 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 70018 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4153 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product + *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 70071 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 70078 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplyAdd_FRC23_Rc1(cpu *processor,
                                               instruction_word instruction,
                                               unsigned_word cia,
                                               idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC23_Rc1
#line 4153 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Add\n"));
#line 70097 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 23 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4153 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 70136 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplyAdd_FRC23_Rc1;

    /* semantic routine */
#line 4153 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 70146 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4153 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product + *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 70199 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 70206 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Select_FRC24_Rc0(cpu *processor,
                                 instruction_word instruction,
                                 unsigned_word cia,
                                 idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC24_Rc0
#line 4743 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Select\n"));
#line 70225 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00002e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 24 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4743 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 70264 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Select_FRC24_Rc0;

    /* semantic routine */
#line 4743 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 70274 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Select, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4743 "../../../sim/ppc/powerpc.igen"
    {
      if (CURRENT_MODEL == MODEL_ppc601) {
        program_interrupt(processor, cia, optional_instruction_program_interrupt);
      } else {
        uint64_t zero = 0;
        FPSCR_BEGIN;
        if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
        else						    *frT = *frC;
        FPSCR_END(Rc);
        PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
      }
    }
#line 70296 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 70303 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Select_FRC24_Rc1(cpu *processor,
                                 instruction_word instruction,
                                 unsigned_word cia,
                                 idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC24_Rc1
#line 4743 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Select\n"));
#line 70322 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00002e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 24 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4743 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 70361 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Select_FRC24_Rc1;

    /* semantic routine */
#line 4743 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 70371 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Select, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4743 "../../../sim/ppc/powerpc.igen"
    {
      if (CURRENT_MODEL == MODEL_ppc601) {
        program_interrupt(processor, cia, optional_instruction_program_interrupt);
      } else {
        uint64_t zero = 0;
        FPSCR_BEGIN;
        if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
        else						    *frT = *frC;
        FPSCR_END(Rc);
        PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
      }
    }
#line 70393 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 70400 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Multiply_FRC24_Rc0(cpu *processor,
                                   instruction_word instruction,
                                   unsigned_word cia,
                                   idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC24_Rc0
#line 3847 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply\n"));
#line 70419 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00f83e) != 0xfc000032)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRC 24 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3847 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 70453 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Multiply_FRC24_Rc0;

    /* semantic routine */
#line 3847 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 70463 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Multiply, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3847 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = *(double*)frA * *(double*)frC;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
    }
#line 70495 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRC
#line 70501 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Multiply_FRC24_Rc1(cpu *processor,
                                   instruction_word instruction,
                                   unsigned_word cia,
                                   idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC24_Rc1
#line 3847 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply\n"));
#line 70520 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00f83e) != 0xfc000032)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRC 24 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3847 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 70554 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Multiply_FRC24_Rc1;

    /* semantic routine */
#line 3847 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 70564 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Multiply, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3847 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = *(double*)frA * *(double*)frC;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
    }
#line 70596 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRC
#line 70602 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplySubtract_FRC24_Rc0(cpu *processor,
                                           instruction_word instruction,
                                           unsigned_word cia,
                                           idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC24_Rc0
#line 4059 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Subtract\n"));
#line 70621 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc000038)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 24 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4059 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 70660 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplySubtract_FRC24_Rc0;

    /* semantic routine */
#line 4059 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 70670 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4059 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product - *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 70723 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 70730 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplySubtract_FRC24_Rc1(cpu *processor,
                                           instruction_word instruction,
                                           unsigned_word cia,
                                           idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC24_Rc1
#line 4059 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Subtract\n"));
#line 70749 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc000038)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 24 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4059 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 70788 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplySubtract_FRC24_Rc1;

    /* semantic routine */
#line 4059 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 70798 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4059 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product - *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 70851 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 70858 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplyAdd_FRC24_Rc0(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC24_Rc0
#line 3965 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Add\n"));
#line 70877 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003a)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 24 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3965 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 70916 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplyAdd_FRC24_Rc0;

    /* semantic routine */
#line 3965 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 70926 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3965 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product + *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 70979 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 70986 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplyAdd_FRC24_Rc1(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC24_Rc1
#line 3965 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Add\n"));
#line 71005 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003a)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 24 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3965 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 71044 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplyAdd_FRC24_Rc1;

    /* semantic routine */
#line 3965 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 71054 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3965 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product + *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 71107 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 71114 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplySubtract_FRC24_Rc0(cpu *processor,
                                                    instruction_word instruction,
                                                    unsigned_word cia,
                                                    idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC24_Rc0
#line 4247 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Subtract\n"));
#line 71133 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 24 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4247 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 71172 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplySubtract_FRC24_Rc0;

    /* semantic routine */
#line 4247 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 71182 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4247 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product - *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 71235 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 71242 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplySubtract_FRC24_Rc1(cpu *processor,
                                                    instruction_word instruction,
                                                    unsigned_word cia,
                                                    idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC24_Rc1
#line 4247 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Subtract\n"));
#line 71261 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 24 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4247 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 71300 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplySubtract_FRC24_Rc1;

    /* semantic routine */
#line 4247 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 71310 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4247 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product - *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 71363 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 71370 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplyAdd_FRC24_Rc0(cpu *processor,
                                               instruction_word instruction,
                                               unsigned_word cia,
                                               idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC24_Rc0
#line 4153 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Add\n"));
#line 71389 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 24 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4153 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 71428 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplyAdd_FRC24_Rc0;

    /* semantic routine */
#line 4153 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 71438 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4153 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product + *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 71491 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 71498 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplyAdd_FRC24_Rc1(cpu *processor,
                                               instruction_word instruction,
                                               unsigned_word cia,
                                               idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC24_Rc1
#line 4153 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Add\n"));
#line 71517 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 24 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4153 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 71556 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplyAdd_FRC24_Rc1;

    /* semantic routine */
#line 4153 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 71566 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4153 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product + *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 71619 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 71626 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Select_FRC25_Rc0(cpu *processor,
                                 instruction_word instruction,
                                 unsigned_word cia,
                                 idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC25_Rc0
#line 4743 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Select\n"));
#line 71645 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00002e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 25 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4743 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 71684 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Select_FRC25_Rc0;

    /* semantic routine */
#line 4743 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 71694 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Select, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4743 "../../../sim/ppc/powerpc.igen"
    {
      if (CURRENT_MODEL == MODEL_ppc601) {
        program_interrupt(processor, cia, optional_instruction_program_interrupt);
      } else {
        uint64_t zero = 0;
        FPSCR_BEGIN;
        if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
        else						    *frT = *frC;
        FPSCR_END(Rc);
        PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
      }
    }
#line 71716 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 71723 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Select_FRC25_Rc1(cpu *processor,
                                 instruction_word instruction,
                                 unsigned_word cia,
                                 idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC25_Rc1
#line 4743 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Select\n"));
#line 71742 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00002e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 25 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4743 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 71781 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Select_FRC25_Rc1;

    /* semantic routine */
#line 4743 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 71791 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Select, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4743 "../../../sim/ppc/powerpc.igen"
    {
      if (CURRENT_MODEL == MODEL_ppc601) {
        program_interrupt(processor, cia, optional_instruction_program_interrupt);
      } else {
        uint64_t zero = 0;
        FPSCR_BEGIN;
        if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
        else						    *frT = *frC;
        FPSCR_END(Rc);
        PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
      }
    }
#line 71813 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 71820 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Multiply_FRC25_Rc0(cpu *processor,
                                   instruction_word instruction,
                                   unsigned_word cia,
                                   idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC25_Rc0
#line 3847 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply\n"));
#line 71839 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00f83e) != 0xfc000032)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRC 25 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3847 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 71873 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Multiply_FRC25_Rc0;

    /* semantic routine */
#line 3847 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 71883 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Multiply, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3847 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = *(double*)frA * *(double*)frC;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
    }
#line 71915 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRC
#line 71921 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Multiply_FRC25_Rc1(cpu *processor,
                                   instruction_word instruction,
                                   unsigned_word cia,
                                   idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC25_Rc1
#line 3847 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply\n"));
#line 71940 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00f83e) != 0xfc000032)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRC 25 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3847 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 71974 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Multiply_FRC25_Rc1;

    /* semantic routine */
#line 3847 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 71984 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Multiply, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3847 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = *(double*)frA * *(double*)frC;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
    }
#line 72016 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRC
#line 72022 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplySubtract_FRC25_Rc0(cpu *processor,
                                           instruction_word instruction,
                                           unsigned_word cia,
                                           idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC25_Rc0
#line 4059 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Subtract\n"));
#line 72041 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc000038)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 25 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4059 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 72080 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplySubtract_FRC25_Rc0;

    /* semantic routine */
#line 4059 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 72090 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4059 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product - *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 72143 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 72150 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplySubtract_FRC25_Rc1(cpu *processor,
                                           instruction_word instruction,
                                           unsigned_word cia,
                                           idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC25_Rc1
#line 4059 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Subtract\n"));
#line 72169 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc000038)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 25 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4059 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 72208 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplySubtract_FRC25_Rc1;

    /* semantic routine */
#line 4059 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 72218 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4059 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product - *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 72271 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 72278 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplyAdd_FRC25_Rc0(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC25_Rc0
#line 3965 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Add\n"));
#line 72297 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003a)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 25 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3965 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 72336 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplyAdd_FRC25_Rc0;

    /* semantic routine */
#line 3965 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 72346 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3965 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product + *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 72399 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 72406 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplyAdd_FRC25_Rc1(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC25_Rc1
#line 3965 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Add\n"));
#line 72425 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003a)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 25 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3965 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 72464 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplyAdd_FRC25_Rc1;

    /* semantic routine */
#line 3965 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 72474 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3965 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product + *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 72527 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 72534 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplySubtract_FRC25_Rc0(cpu *processor,
                                                    instruction_word instruction,
                                                    unsigned_word cia,
                                                    idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC25_Rc0
#line 4247 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Subtract\n"));
#line 72553 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 25 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4247 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 72592 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplySubtract_FRC25_Rc0;

    /* semantic routine */
#line 4247 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 72602 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4247 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product - *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 72655 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 72662 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplySubtract_FRC25_Rc1(cpu *processor,
                                                    instruction_word instruction,
                                                    unsigned_word cia,
                                                    idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC25_Rc1
#line 4247 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Subtract\n"));
#line 72681 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 25 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4247 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 72720 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplySubtract_FRC25_Rc1;

    /* semantic routine */
#line 4247 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 72730 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4247 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product - *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 72783 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 72790 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplyAdd_FRC25_Rc0(cpu *processor,
                                               instruction_word instruction,
                                               unsigned_word cia,
                                               idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC25_Rc0
#line 4153 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Add\n"));
#line 72809 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 25 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4153 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 72848 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplyAdd_FRC25_Rc0;

    /* semantic routine */
#line 4153 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 72858 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4153 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product + *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 72911 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 72918 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplyAdd_FRC25_Rc1(cpu *processor,
                                               instruction_word instruction,
                                               unsigned_word cia,
                                               idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC25_Rc1
#line 4153 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Add\n"));
#line 72937 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 25 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4153 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 72976 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplyAdd_FRC25_Rc1;

    /* semantic routine */
#line 4153 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 72986 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4153 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product + *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 73039 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 73046 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Select_FRC26_Rc0(cpu *processor,
                                 instruction_word instruction,
                                 unsigned_word cia,
                                 idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC26_Rc0
#line 4743 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Select\n"));
#line 73065 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00002e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 26 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4743 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 73104 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Select_FRC26_Rc0;

    /* semantic routine */
#line 4743 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 73114 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Select, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4743 "../../../sim/ppc/powerpc.igen"
    {
      if (CURRENT_MODEL == MODEL_ppc601) {
        program_interrupt(processor, cia, optional_instruction_program_interrupt);
      } else {
        uint64_t zero = 0;
        FPSCR_BEGIN;
        if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
        else						    *frT = *frC;
        FPSCR_END(Rc);
        PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
      }
    }
#line 73136 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 73143 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Select_FRC26_Rc1(cpu *processor,
                                 instruction_word instruction,
                                 unsigned_word cia,
                                 idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC26_Rc1
#line 4743 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Select\n"));
#line 73162 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00002e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 26 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4743 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 73201 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Select_FRC26_Rc1;

    /* semantic routine */
#line 4743 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 73211 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Select, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4743 "../../../sim/ppc/powerpc.igen"
    {
      if (CURRENT_MODEL == MODEL_ppc601) {
        program_interrupt(processor, cia, optional_instruction_program_interrupt);
      } else {
        uint64_t zero = 0;
        FPSCR_BEGIN;
        if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
        else						    *frT = *frC;
        FPSCR_END(Rc);
        PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
      }
    }
#line 73233 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 73240 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Multiply_FRC26_Rc0(cpu *processor,
                                   instruction_word instruction,
                                   unsigned_word cia,
                                   idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC26_Rc0
#line 3847 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply\n"));
#line 73259 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00f83e) != 0xfc000032)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRC 26 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3847 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 73293 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Multiply_FRC26_Rc0;

    /* semantic routine */
#line 3847 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 73303 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Multiply, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3847 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = *(double*)frA * *(double*)frC;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
    }
#line 73335 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRC
#line 73341 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Multiply_FRC26_Rc1(cpu *processor,
                                   instruction_word instruction,
                                   unsigned_word cia,
                                   idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC26_Rc1
#line 3847 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply\n"));
#line 73360 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00f83e) != 0xfc000032)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRC 26 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3847 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 73394 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Multiply_FRC26_Rc1;

    /* semantic routine */
#line 3847 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 73404 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Multiply, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3847 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = *(double*)frA * *(double*)frC;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
    }
#line 73436 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRC
#line 73442 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplySubtract_FRC26_Rc0(cpu *processor,
                                           instruction_word instruction,
                                           unsigned_word cia,
                                           idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC26_Rc0
#line 4059 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Subtract\n"));
#line 73461 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc000038)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 26 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4059 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 73500 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplySubtract_FRC26_Rc0;

    /* semantic routine */
#line 4059 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 73510 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4059 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product - *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 73563 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 73570 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplySubtract_FRC26_Rc1(cpu *processor,
                                           instruction_word instruction,
                                           unsigned_word cia,
                                           idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC26_Rc1
#line 4059 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Subtract\n"));
#line 73589 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc000038)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 26 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4059 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 73628 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplySubtract_FRC26_Rc1;

    /* semantic routine */
#line 4059 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 73638 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4059 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product - *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 73691 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 73698 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplyAdd_FRC26_Rc0(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC26_Rc0
#line 3965 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Add\n"));
#line 73717 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003a)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 26 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3965 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 73756 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplyAdd_FRC26_Rc0;

    /* semantic routine */
#line 3965 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 73766 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3965 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product + *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 73819 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 73826 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplyAdd_FRC26_Rc1(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC26_Rc1
#line 3965 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Add\n"));
#line 73845 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003a)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 26 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3965 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 73884 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplyAdd_FRC26_Rc1;

    /* semantic routine */
#line 3965 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 73894 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3965 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product + *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 73947 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 73954 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplySubtract_FRC26_Rc0(cpu *processor,
                                                    instruction_word instruction,
                                                    unsigned_word cia,
                                                    idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC26_Rc0
#line 4247 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Subtract\n"));
#line 73973 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 26 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4247 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 74012 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplySubtract_FRC26_Rc0;

    /* semantic routine */
#line 4247 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 74022 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4247 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product - *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 74075 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 74082 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplySubtract_FRC26_Rc1(cpu *processor,
                                                    instruction_word instruction,
                                                    unsigned_word cia,
                                                    idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC26_Rc1
#line 4247 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Subtract\n"));
#line 74101 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 26 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4247 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 74140 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplySubtract_FRC26_Rc1;

    /* semantic routine */
#line 4247 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 74150 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4247 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product - *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 74203 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 74210 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplyAdd_FRC26_Rc0(cpu *processor,
                                               instruction_word instruction,
                                               unsigned_word cia,
                                               idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC26_Rc0
#line 4153 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Add\n"));
#line 74229 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 26 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4153 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 74268 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplyAdd_FRC26_Rc0;

    /* semantic routine */
#line 4153 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 74278 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4153 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product + *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 74331 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 74338 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplyAdd_FRC26_Rc1(cpu *processor,
                                               instruction_word instruction,
                                               unsigned_word cia,
                                               idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC26_Rc1
#line 4153 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Add\n"));
#line 74357 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 26 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4153 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 74396 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplyAdd_FRC26_Rc1;

    /* semantic routine */
#line 4153 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 74406 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4153 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product + *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 74459 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 74466 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Select_FRC27_Rc0(cpu *processor,
                                 instruction_word instruction,
                                 unsigned_word cia,
                                 idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC27_Rc0
#line 4743 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Select\n"));
#line 74485 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00002e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 27 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4743 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 74524 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Select_FRC27_Rc0;

    /* semantic routine */
#line 4743 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 74534 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Select, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4743 "../../../sim/ppc/powerpc.igen"
    {
      if (CURRENT_MODEL == MODEL_ppc601) {
        program_interrupt(processor, cia, optional_instruction_program_interrupt);
      } else {
        uint64_t zero = 0;
        FPSCR_BEGIN;
        if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
        else						    *frT = *frC;
        FPSCR_END(Rc);
        PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
      }
    }
#line 74556 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 74563 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Select_FRC27_Rc1(cpu *processor,
                                 instruction_word instruction,
                                 unsigned_word cia,
                                 idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC27_Rc1
#line 4743 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Select\n"));
#line 74582 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00002e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 27 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4743 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 74621 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Select_FRC27_Rc1;

    /* semantic routine */
#line 4743 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 74631 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Select, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4743 "../../../sim/ppc/powerpc.igen"
    {
      if (CURRENT_MODEL == MODEL_ppc601) {
        program_interrupt(processor, cia, optional_instruction_program_interrupt);
      } else {
        uint64_t zero = 0;
        FPSCR_BEGIN;
        if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
        else						    *frT = *frC;
        FPSCR_END(Rc);
        PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
      }
    }
#line 74653 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 74660 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Multiply_FRC27_Rc0(cpu *processor,
                                   instruction_word instruction,
                                   unsigned_word cia,
                                   idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC27_Rc0
#line 3847 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply\n"));
#line 74679 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00f83e) != 0xfc000032)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRC 27 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3847 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 74713 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Multiply_FRC27_Rc0;

    /* semantic routine */
#line 3847 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 74723 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Multiply, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3847 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = *(double*)frA * *(double*)frC;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
    }
#line 74755 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRC
#line 74761 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Multiply_FRC27_Rc1(cpu *processor,
                                   instruction_word instruction,
                                   unsigned_word cia,
                                   idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC27_Rc1
#line 3847 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply\n"));
#line 74780 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00f83e) != 0xfc000032)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRC 27 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3847 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 74814 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Multiply_FRC27_Rc1;

    /* semantic routine */
#line 3847 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 74824 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Multiply, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3847 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = *(double*)frA * *(double*)frC;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
    }
#line 74856 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRC
#line 74862 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplySubtract_FRC27_Rc0(cpu *processor,
                                           instruction_word instruction,
                                           unsigned_word cia,
                                           idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC27_Rc0
#line 4059 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Subtract\n"));
#line 74881 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc000038)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 27 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4059 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 74920 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplySubtract_FRC27_Rc0;

    /* semantic routine */
#line 4059 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 74930 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4059 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product - *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 74983 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 74990 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplySubtract_FRC27_Rc1(cpu *processor,
                                           instruction_word instruction,
                                           unsigned_word cia,
                                           idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC27_Rc1
#line 4059 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Subtract\n"));
#line 75009 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc000038)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 27 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4059 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 75048 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplySubtract_FRC27_Rc1;

    /* semantic routine */
#line 4059 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 75058 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4059 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product - *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 75111 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 75118 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplyAdd_FRC27_Rc0(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC27_Rc0
#line 3965 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Add\n"));
#line 75137 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003a)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 27 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3965 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 75176 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplyAdd_FRC27_Rc0;

    /* semantic routine */
#line 3965 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 75186 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3965 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product + *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 75239 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 75246 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplyAdd_FRC27_Rc1(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC27_Rc1
#line 3965 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Add\n"));
#line 75265 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003a)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 27 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3965 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 75304 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplyAdd_FRC27_Rc1;

    /* semantic routine */
#line 3965 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 75314 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3965 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product + *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 75367 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 75374 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplySubtract_FRC27_Rc0(cpu *processor,
                                                    instruction_word instruction,
                                                    unsigned_word cia,
                                                    idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC27_Rc0
#line 4247 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Subtract\n"));
#line 75393 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 27 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4247 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 75432 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplySubtract_FRC27_Rc0;

    /* semantic routine */
#line 4247 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 75442 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4247 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product - *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 75495 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 75502 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplySubtract_FRC27_Rc1(cpu *processor,
                                                    instruction_word instruction,
                                                    unsigned_word cia,
                                                    idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC27_Rc1
#line 4247 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Subtract\n"));
#line 75521 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 27 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4247 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 75560 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplySubtract_FRC27_Rc1;

    /* semantic routine */
#line 4247 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 75570 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4247 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product - *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 75623 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 75630 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplyAdd_FRC27_Rc0(cpu *processor,
                                               instruction_word instruction,
                                               unsigned_word cia,
                                               idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC27_Rc0
#line 4153 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Add\n"));
#line 75649 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 27 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4153 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 75688 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplyAdd_FRC27_Rc0;

    /* semantic routine */
#line 4153 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 75698 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4153 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product + *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 75751 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 75758 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplyAdd_FRC27_Rc1(cpu *processor,
                                               instruction_word instruction,
                                               unsigned_word cia,
                                               idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC27_Rc1
#line 4153 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Add\n"));
#line 75777 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 27 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4153 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 75816 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplyAdd_FRC27_Rc1;

    /* semantic routine */
#line 4153 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 75826 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4153 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product + *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 75879 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 75886 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Select_FRC28_Rc0(cpu *processor,
                                 instruction_word instruction,
                                 unsigned_word cia,
                                 idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC28_Rc0
#line 4743 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Select\n"));
#line 75905 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00002e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 28 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4743 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 75944 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Select_FRC28_Rc0;

    /* semantic routine */
#line 4743 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 75954 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Select, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4743 "../../../sim/ppc/powerpc.igen"
    {
      if (CURRENT_MODEL == MODEL_ppc601) {
        program_interrupt(processor, cia, optional_instruction_program_interrupt);
      } else {
        uint64_t zero = 0;
        FPSCR_BEGIN;
        if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
        else						    *frT = *frC;
        FPSCR_END(Rc);
        PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
      }
    }
#line 75976 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 75983 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Select_FRC28_Rc1(cpu *processor,
                                 instruction_word instruction,
                                 unsigned_word cia,
                                 idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC28_Rc1
#line 4743 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Select\n"));
#line 76002 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00002e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 28 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4743 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 76041 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Select_FRC28_Rc1;

    /* semantic routine */
#line 4743 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 76051 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Select, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4743 "../../../sim/ppc/powerpc.igen"
    {
      if (CURRENT_MODEL == MODEL_ppc601) {
        program_interrupt(processor, cia, optional_instruction_program_interrupt);
      } else {
        uint64_t zero = 0;
        FPSCR_BEGIN;
        if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
        else						    *frT = *frC;
        FPSCR_END(Rc);
        PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
      }
    }
#line 76073 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 76080 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Multiply_FRC28_Rc0(cpu *processor,
                                   instruction_word instruction,
                                   unsigned_word cia,
                                   idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC28_Rc0
#line 3847 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply\n"));
#line 76099 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00f83e) != 0xfc000032)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRC 28 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3847 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 76133 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Multiply_FRC28_Rc0;

    /* semantic routine */
#line 3847 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 76143 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Multiply, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3847 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = *(double*)frA * *(double*)frC;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
    }
#line 76175 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRC
#line 76181 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Multiply_FRC28_Rc1(cpu *processor,
                                   instruction_word instruction,
                                   unsigned_word cia,
                                   idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC28_Rc1
#line 3847 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply\n"));
#line 76200 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00f83e) != 0xfc000032)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRC 28 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3847 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 76234 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Multiply_FRC28_Rc1;

    /* semantic routine */
#line 3847 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 76244 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Multiply, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3847 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = *(double*)frA * *(double*)frC;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
    }
#line 76276 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRC
#line 76282 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplySubtract_FRC28_Rc0(cpu *processor,
                                           instruction_word instruction,
                                           unsigned_word cia,
                                           idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC28_Rc0
#line 4059 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Subtract\n"));
#line 76301 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc000038)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 28 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4059 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 76340 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplySubtract_FRC28_Rc0;

    /* semantic routine */
#line 4059 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 76350 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4059 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product - *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 76403 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 76410 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplySubtract_FRC28_Rc1(cpu *processor,
                                           instruction_word instruction,
                                           unsigned_word cia,
                                           idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC28_Rc1
#line 4059 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Subtract\n"));
#line 76429 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc000038)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 28 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4059 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 76468 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplySubtract_FRC28_Rc1;

    /* semantic routine */
#line 4059 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 76478 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4059 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product - *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 76531 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 76538 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplyAdd_FRC28_Rc0(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC28_Rc0
#line 3965 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Add\n"));
#line 76557 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003a)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 28 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3965 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 76596 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplyAdd_FRC28_Rc0;

    /* semantic routine */
#line 3965 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 76606 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3965 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product + *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 76659 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 76666 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplyAdd_FRC28_Rc1(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC28_Rc1
#line 3965 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Add\n"));
#line 76685 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003a)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 28 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3965 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 76724 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplyAdd_FRC28_Rc1;

    /* semantic routine */
#line 3965 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 76734 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3965 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product + *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 76787 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 76794 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplySubtract_FRC28_Rc0(cpu *processor,
                                                    instruction_word instruction,
                                                    unsigned_word cia,
                                                    idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC28_Rc0
#line 4247 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Subtract\n"));
#line 76813 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 28 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4247 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 76852 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplySubtract_FRC28_Rc0;

    /* semantic routine */
#line 4247 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 76862 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4247 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product - *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 76915 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 76922 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplySubtract_FRC28_Rc1(cpu *processor,
                                                    instruction_word instruction,
                                                    unsigned_word cia,
                                                    idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC28_Rc1
#line 4247 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Subtract\n"));
#line 76941 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 28 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4247 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 76980 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplySubtract_FRC28_Rc1;

    /* semantic routine */
#line 4247 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 76990 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4247 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product - *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 77043 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 77050 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplyAdd_FRC28_Rc0(cpu *processor,
                                               instruction_word instruction,
                                               unsigned_word cia,
                                               idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC28_Rc0
#line 4153 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Add\n"));
#line 77069 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 28 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4153 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 77108 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplyAdd_FRC28_Rc0;

    /* semantic routine */
#line 4153 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 77118 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4153 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product + *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 77171 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 77178 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplyAdd_FRC28_Rc1(cpu *processor,
                                               instruction_word instruction,
                                               unsigned_word cia,
                                               idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC28_Rc1
#line 4153 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Add\n"));
#line 77197 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 28 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4153 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 77236 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplyAdd_FRC28_Rc1;

    /* semantic routine */
#line 4153 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 77246 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4153 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product + *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 77299 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 77306 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Select_FRC29_Rc0(cpu *processor,
                                 instruction_word instruction,
                                 unsigned_word cia,
                                 idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC29_Rc0
#line 4743 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Select\n"));
#line 77325 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00002e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 29 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4743 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 77364 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Select_FRC29_Rc0;

    /* semantic routine */
#line 4743 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 77374 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Select, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4743 "../../../sim/ppc/powerpc.igen"
    {
      if (CURRENT_MODEL == MODEL_ppc601) {
        program_interrupt(processor, cia, optional_instruction_program_interrupt);
      } else {
        uint64_t zero = 0;
        FPSCR_BEGIN;
        if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
        else						    *frT = *frC;
        FPSCR_END(Rc);
        PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
      }
    }
#line 77396 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 77403 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Select_FRC29_Rc1(cpu *processor,
                                 instruction_word instruction,
                                 unsigned_word cia,
                                 idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC29_Rc1
#line 4743 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Select\n"));
#line 77422 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00002e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 29 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4743 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 77461 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Select_FRC29_Rc1;

    /* semantic routine */
#line 4743 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 77471 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Select, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4743 "../../../sim/ppc/powerpc.igen"
    {
      if (CURRENT_MODEL == MODEL_ppc601) {
        program_interrupt(processor, cia, optional_instruction_program_interrupt);
      } else {
        uint64_t zero = 0;
        FPSCR_BEGIN;
        if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
        else						    *frT = *frC;
        FPSCR_END(Rc);
        PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
      }
    }
#line 77493 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 77500 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Multiply_FRC29_Rc0(cpu *processor,
                                   instruction_word instruction,
                                   unsigned_word cia,
                                   idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC29_Rc0
#line 3847 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply\n"));
#line 77519 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00f83e) != 0xfc000032)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRC 29 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3847 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 77553 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Multiply_FRC29_Rc0;

    /* semantic routine */
#line 3847 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 77563 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Multiply, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3847 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = *(double*)frA * *(double*)frC;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
    }
#line 77595 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRC
#line 77601 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Multiply_FRC29_Rc1(cpu *processor,
                                   instruction_word instruction,
                                   unsigned_word cia,
                                   idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC29_Rc1
#line 3847 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply\n"));
#line 77620 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00f83e) != 0xfc000032)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRC 29 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3847 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 77654 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Multiply_FRC29_Rc1;

    /* semantic routine */
#line 3847 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 77664 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Multiply, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3847 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = *(double*)frA * *(double*)frC;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
    }
#line 77696 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRC
#line 77702 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplySubtract_FRC29_Rc0(cpu *processor,
                                           instruction_word instruction,
                                           unsigned_word cia,
                                           idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC29_Rc0
#line 4059 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Subtract\n"));
#line 77721 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc000038)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 29 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4059 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 77760 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplySubtract_FRC29_Rc0;

    /* semantic routine */
#line 4059 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 77770 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4059 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product - *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 77823 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 77830 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplySubtract_FRC29_Rc1(cpu *processor,
                                           instruction_word instruction,
                                           unsigned_word cia,
                                           idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC29_Rc1
#line 4059 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Subtract\n"));
#line 77849 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc000038)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 29 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4059 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 77888 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplySubtract_FRC29_Rc1;

    /* semantic routine */
#line 4059 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 77898 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4059 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product - *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 77951 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 77958 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplyAdd_FRC29_Rc0(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC29_Rc0
#line 3965 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Add\n"));
#line 77977 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003a)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 29 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3965 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 78016 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplyAdd_FRC29_Rc0;

    /* semantic routine */
#line 3965 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 78026 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3965 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product + *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 78079 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 78086 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplyAdd_FRC29_Rc1(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC29_Rc1
#line 3965 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Add\n"));
#line 78105 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003a)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 29 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3965 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 78144 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplyAdd_FRC29_Rc1;

    /* semantic routine */
#line 3965 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 78154 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3965 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product + *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 78207 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 78214 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplySubtract_FRC29_Rc0(cpu *processor,
                                                    instruction_word instruction,
                                                    unsigned_word cia,
                                                    idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC29_Rc0
#line 4247 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Subtract\n"));
#line 78233 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 29 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4247 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 78272 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplySubtract_FRC29_Rc0;

    /* semantic routine */
#line 4247 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 78282 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4247 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product - *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 78335 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 78342 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplySubtract_FRC29_Rc1(cpu *processor,
                                                    instruction_word instruction,
                                                    unsigned_word cia,
                                                    idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC29_Rc1
#line 4247 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Subtract\n"));
#line 78361 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 29 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4247 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 78400 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplySubtract_FRC29_Rc1;

    /* semantic routine */
#line 4247 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 78410 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4247 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product - *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 78463 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 78470 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplyAdd_FRC29_Rc0(cpu *processor,
                                               instruction_word instruction,
                                               unsigned_word cia,
                                               idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC29_Rc0
#line 4153 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Add\n"));
#line 78489 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 29 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4153 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 78528 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplyAdd_FRC29_Rc0;

    /* semantic routine */
#line 4153 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 78538 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4153 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product + *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 78591 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 78598 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplyAdd_FRC29_Rc1(cpu *processor,
                                               instruction_word instruction,
                                               unsigned_word cia,
                                               idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC29_Rc1
#line 4153 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Add\n"));
#line 78617 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 29 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4153 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 78656 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplyAdd_FRC29_Rc1;

    /* semantic routine */
#line 4153 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 78666 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4153 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product + *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 78719 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 78726 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Select_FRC30_Rc0(cpu *processor,
                                 instruction_word instruction,
                                 unsigned_word cia,
                                 idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC30_Rc0
#line 4743 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Select\n"));
#line 78745 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00002e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 30 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4743 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 78784 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Select_FRC30_Rc0;

    /* semantic routine */
#line 4743 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 78794 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Select, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4743 "../../../sim/ppc/powerpc.igen"
    {
      if (CURRENT_MODEL == MODEL_ppc601) {
        program_interrupt(processor, cia, optional_instruction_program_interrupt);
      } else {
        uint64_t zero = 0;
        FPSCR_BEGIN;
        if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
        else						    *frT = *frC;
        FPSCR_END(Rc);
        PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
      }
    }
#line 78816 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 78823 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Select_FRC30_Rc1(cpu *processor,
                                 instruction_word instruction,
                                 unsigned_word cia,
                                 idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC30_Rc1
#line 4743 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Select\n"));
#line 78842 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00002e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 30 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4743 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 78881 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Select_FRC30_Rc1;

    /* semantic routine */
#line 4743 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 78891 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Select, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4743 "../../../sim/ppc/powerpc.igen"
    {
      if (CURRENT_MODEL == MODEL_ppc601) {
        program_interrupt(processor, cia, optional_instruction_program_interrupt);
      } else {
        uint64_t zero = 0;
        FPSCR_BEGIN;
        if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
        else						    *frT = *frC;
        FPSCR_END(Rc);
        PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
      }
    }
#line 78913 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 78920 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Multiply_FRC30_Rc0(cpu *processor,
                                   instruction_word instruction,
                                   unsigned_word cia,
                                   idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC30_Rc0
#line 3847 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply\n"));
#line 78939 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00f83e) != 0xfc000032)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRC 30 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3847 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 78973 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Multiply_FRC30_Rc0;

    /* semantic routine */
#line 3847 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 78983 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Multiply, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3847 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = *(double*)frA * *(double*)frC;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
    }
#line 79015 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRC
#line 79021 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Multiply_FRC30_Rc1(cpu *processor,
                                   instruction_word instruction,
                                   unsigned_word cia,
                                   idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC30_Rc1
#line 3847 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply\n"));
#line 79040 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00f83e) != 0xfc000032)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRC 30 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3847 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 79074 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Multiply_FRC30_Rc1;

    /* semantic routine */
#line 3847 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 79084 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Multiply, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3847 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = *(double*)frA * *(double*)frC;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
    }
#line 79116 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRC
#line 79122 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplySubtract_FRC30_Rc0(cpu *processor,
                                           instruction_word instruction,
                                           unsigned_word cia,
                                           idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC30_Rc0
#line 4059 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Subtract\n"));
#line 79141 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc000038)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 30 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4059 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 79180 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplySubtract_FRC30_Rc0;

    /* semantic routine */
#line 4059 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 79190 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4059 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product - *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 79243 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 79250 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplySubtract_FRC30_Rc1(cpu *processor,
                                           instruction_word instruction,
                                           unsigned_word cia,
                                           idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC30_Rc1
#line 4059 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Subtract\n"));
#line 79269 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc000038)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 30 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4059 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 79308 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplySubtract_FRC30_Rc1;

    /* semantic routine */
#line 4059 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 79318 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4059 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product - *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 79371 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 79378 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplyAdd_FRC30_Rc0(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC30_Rc0
#line 3965 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Add\n"));
#line 79397 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003a)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 30 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3965 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 79436 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplyAdd_FRC30_Rc0;

    /* semantic routine */
#line 3965 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 79446 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3965 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product + *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 79499 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 79506 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplyAdd_FRC30_Rc1(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC30_Rc1
#line 3965 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Add\n"));
#line 79525 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003a)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 30 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3965 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 79564 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplyAdd_FRC30_Rc1;

    /* semantic routine */
#line 3965 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 79574 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3965 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product + *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 79627 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 79634 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplySubtract_FRC30_Rc0(cpu *processor,
                                                    instruction_word instruction,
                                                    unsigned_word cia,
                                                    idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC30_Rc0
#line 4247 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Subtract\n"));
#line 79653 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 30 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4247 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 79692 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplySubtract_FRC30_Rc0;

    /* semantic routine */
#line 4247 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 79702 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4247 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product - *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 79755 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 79762 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplySubtract_FRC30_Rc1(cpu *processor,
                                                    instruction_word instruction,
                                                    unsigned_word cia,
                                                    idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC30_Rc1
#line 4247 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Subtract\n"));
#line 79781 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 30 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4247 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 79820 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplySubtract_FRC30_Rc1;

    /* semantic routine */
#line 4247 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 79830 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4247 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product - *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 79883 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 79890 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplyAdd_FRC30_Rc0(cpu *processor,
                                               instruction_word instruction,
                                               unsigned_word cia,
                                               idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC30_Rc0
#line 4153 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Add\n"));
#line 79909 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 30 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4153 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 79948 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplyAdd_FRC30_Rc0;

    /* semantic routine */
#line 4153 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 79958 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4153 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product + *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 80011 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 80018 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplyAdd_FRC30_Rc1(cpu *processor,
                                               instruction_word instruction,
                                               unsigned_word cia,
                                               idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC30_Rc1
#line 4153 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Add\n"));
#line 80037 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 30 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4153 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 80076 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplyAdd_FRC30_Rc1;

    /* semantic routine */
#line 4153 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 80086 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4153 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product + *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 80139 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 80146 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Select_FRC31_Rc0(cpu *processor,
                                 instruction_word instruction,
                                 unsigned_word cia,
                                 idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC31_Rc0
#line 4743 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Select\n"));
#line 80165 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00002e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 31 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4743 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 80204 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Select_FRC31_Rc0;

    /* semantic routine */
#line 4743 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 80214 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Select, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4743 "../../../sim/ppc/powerpc.igen"
    {
      if (CURRENT_MODEL == MODEL_ppc601) {
        program_interrupt(processor, cia, optional_instruction_program_interrupt);
      } else {
        uint64_t zero = 0;
        FPSCR_BEGIN;
        if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
        else						    *frT = *frC;
        FPSCR_END(Rc);
        PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
      }
    }
#line 80236 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 80243 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Select_FRC31_Rc1(cpu *processor,
                                 instruction_word instruction,
                                 unsigned_word cia,
                                 idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC31_Rc1
#line 4743 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Select\n"));
#line 80262 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00002e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 31 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4743 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 80301 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Select_FRC31_Rc1;

    /* semantic routine */
#line 4743 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 80311 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Select, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4743 "../../../sim/ppc/powerpc.igen"
    {
      if (CURRENT_MODEL == MODEL_ppc601) {
        program_interrupt(processor, cia, optional_instruction_program_interrupt);
      } else {
        uint64_t zero = 0;
        FPSCR_BEGIN;
        if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
        else						    *frT = *frC;
        FPSCR_END(Rc);
        PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
      }
    }
#line 80333 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 80340 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Multiply_FRC31_Rc0(cpu *processor,
                                   instruction_word instruction,
                                   unsigned_word cia,
                                   idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC31_Rc0
#line 3847 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply\n"));
#line 80359 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00f83e) != 0xfc000032)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRC 31 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3847 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 80393 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Multiply_FRC31_Rc0;

    /* semantic routine */
#line 3847 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 80403 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Multiply, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3847 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = *(double*)frA * *(double*)frC;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
    }
#line 80435 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRC
#line 80441 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Multiply_FRC31_Rc1(cpu *processor,
                                   instruction_word instruction,
                                   unsigned_word cia,
                                   idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC31_Rc1
#line 3847 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply\n"));
#line 80460 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00f83e) != 0xfc000032)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRC 31 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3847 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 80494 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Multiply_FRC31_Rc1;

    /* semantic routine */
#line 3847 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 80504 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Multiply, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3847 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = *(double*)frA * *(double*)frC;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
    }
#line 80536 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRC
#line 80542 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplySubtract_FRC31_Rc0(cpu *processor,
                                           instruction_word instruction,
                                           unsigned_word cia,
                                           idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC31_Rc0
#line 4059 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Subtract\n"));
#line 80561 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc000038)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 31 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4059 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 80600 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplySubtract_FRC31_Rc0;

    /* semantic routine */
#line 4059 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 80610 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4059 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product - *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 80663 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 80670 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplySubtract_FRC31_Rc1(cpu *processor,
                                           instruction_word instruction,
                                           unsigned_word cia,
                                           idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC31_Rc1
#line 4059 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Subtract\n"));
#line 80689 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc000038)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 31 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4059 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 80728 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplySubtract_FRC31_Rc1;

    /* semantic routine */
#line 4059 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 80738 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4059 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product - *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 80791 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 80798 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplyAdd_FRC31_Rc0(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC31_Rc0
#line 3965 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Add\n"));
#line 80817 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003a)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 31 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3965 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 80856 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplyAdd_FRC31_Rc0;

    /* semantic routine */
#line 3965 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 80866 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3965 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product + *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 80919 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 80926 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_MultiplyAdd_FRC31_Rc1(cpu *processor,
                                      instruction_word instruction,
                                      unsigned_word cia,
                                      idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC31_Rc1
#line 3965 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Multiply-Add\n"));
#line 80945 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003a)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 31 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 3965 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 80984 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_MultiplyAdd_FRC31_Rc1;

    /* semantic routine */
#line 3965 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 80994 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 3965 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = product + *(double*)frB;
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 81047 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 81054 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplySubtract_FRC31_Rc0(cpu *processor,
                                                    instruction_word instruction,
                                                    unsigned_word cia,
                                                    idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC31_Rc0
#line 4247 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Subtract\n"));
#line 81073 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 31 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4247 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 81112 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplySubtract_FRC31_Rc0;

    /* semantic routine */
#line 4247 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 81122 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4247 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product - *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 81175 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 81182 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplySubtract_FRC31_Rc1(cpu *processor,
                                                    instruction_word instruction,
                                                    unsigned_word cia,
                                                    idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC31_Rc1
#line 4247 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Subtract\n"));
#line 81201 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003c)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 31 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4247 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 81240 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplySubtract_FRC31_Rc1;

    /* semantic routine */
#line 4247 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 81250 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4247 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the subtract */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product - *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 81303 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 81310 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplyAdd_FRC31_Rc0(cpu *processor,
                                               instruction_word instruction,
                                               unsigned_word cia,
                                               idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC31_Rc0
#line 4153 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Add\n"));
#line 81329 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 31 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4153 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 0; /* default in icache - constant field */
#line 81368 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplyAdd_FRC31_Rc0;

    /* semantic routine */
#line 4153 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 81378 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4153 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product + *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 81431 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 81438 "icache.c"

#undef insn
  }
}

EXTERN_ICACHE\
(unsigned_word)
icache_Floating_Negative_MultiplyAdd_FRC31_Rc1(cpu *processor,
                                               instruction_word instruction,
                                               unsigned_word cia,
                                               idecode_cache *cache_entry)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC31_Rc1
#line 4153 "../../../sim/ppc/powerpc.igen"
  ITRACE(trace_idecode, ("idecode Floating Negative Multiply-Add\n"));
#line 81457 "icache.c"

  /* validate: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc */
  if (WITH_RESERVED_BITS && (instruction & 0xfc00003e) != 0xfc00003e)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP hardware exists */
  if (CURRENT_FLOATING_POINT != HARD_FLOATING_POINT)
    return icache_illegal(processor, instruction, cia, cache_entry);

  /* Validate: FP available according to MSR[FP] */
  if (!IS_FP_AVAILABLE(processor))
    return icache_floating_point_unavailable(processor, instruction, cia, cache_entry);

  {
    unsigned_word nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache|put-values-in-icache */
#define FRT EXTRACTED32(instruction, 6, 10) /* icache scratch - extraction */
#line 62 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frT ATTRIBUTE_UNUSED = cache_entry->crack.A.frT = (cpu_registers(processor)->fpr + FRT); /* in icache - extraction */
#line 63 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRT_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRT_BITMASK = (1 << FRT); /* in icache - extraction */
#define FRA EXTRACTED32(instruction, 11, 15) /* icache scratch - extraction */
#line 50 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frA ATTRIBUTE_UNUSED = cache_entry->crack.A.frA = (cpu_registers(processor)->fpr + FRA); /* in icache - extraction */
#line 51 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRA_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRA_BITMASK = (1 << FRA); /* in icache - extraction */
#define FRB EXTRACTED32(instruction, 16, 20) /* icache scratch - extraction */
#line 53 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frB ATTRIBUTE_UNUSED = cache_entry->crack.A.frB = (cpu_registers(processor)->fpr + FRB); /* in icache - extraction */
#line 54 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRB_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRB_BITMASK = (1 << FRB); /* in icache - extraction */
#define FRC 31 /* icache scratch - constant field */
#line 56 "../../../sim/ppc/powerpc.igen"
    uint64_t * const frC ATTRIBUTE_UNUSED = cache_entry->crack.A.frC = (cpu_registers(processor)->fpr + FRC); /* in icache - extraction */
#line 57 "../../../sim/ppc/powerpc.igen"
    uint32_t const FRC_BITMASK ATTRIBUTE_UNUSED = cache_entry->crack.A.FRC_BITMASK = (1 << FRC); /* in icache - extraction */
#line 4153 "../../../sim/ppc/powerpc.igen"
    unsigned const Rc ATTRIBUTE_UNUSED = 1; /* default in icache - constant field */
#line 81496 "icache.c"

#define insn cache_entry->crack.A.insn = instruction

    cache_entry->address = cia;
    cache_entry->semantic = semantic_Floating_Negative_MultiplyAdd_FRC31_Rc1;

    /* semantic routine */
#line 4153 "../../../sim/ppc/powerpc.igen"
    ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 81506 "icache.c"

    /* monitoring: */
    if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
      mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
    }

    /* semantics: */
    nia = cia + 4;
#line 4153 "../../../sim/ppc/powerpc.igen"
    {
      FPSCR_BEGIN;
      double product; /*HACK! - incorrectly loosing precision ... */
      /* compute the multiply */
      if (is_invalid_operation(processor, cia,
                               *frA, *frC,
                               fpscr_vxsnan | fpscr_vximz,
                               0, /*single?*/
                               0) /*negate?*/) {
        union { double d; uint64_t u; } tmp;
        invalid_arithemetic_operation(processor, cia,
                                      &tmp.u, *frA, 0, *frC,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
        product = tmp.d;
      }
      else {
        /*HACK!*/
        product = *(double*)frA * *(double*)frC;
      }
      /* compute the add */
      if (is_invalid_operation(processor, cia,
                               product, *frB,
                               fpscr_vxsnan | fpscr_vxisi,
                               0, /*single?*/
                               0) /*negate?*/) {
        invalid_arithemetic_operation(processor, cia,
                                      frT, product, *frB, 0,
                                      0, /*instruction_is_frsp*/
                                      0, /*instruction_is_convert_to_64bit*/
                                      0, /*instruction_is_convert_to_32bit*/
                                      0); /*single-precision*/
      }
      else {
        /*HACK!*/
        double s = -(product + *(double*)frB);
        *(double*)frT = s;
      }
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
#line 81559 "icache.c"
    return nia;
    /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache|put-values-in-icache */
#undef FRT
#undef FRA
#undef FRB
#undef FRC
#line 81566 "icache.c"

#undef insn
  }
}

#endif /* _ICACHE_C_*/
